Package: anndataR
Title: AnnData interoperability in R
Version: 1.1.3
Authors@R: c(
    person("Robrecht", "Cannoodt", , "rcannood@gmail.com", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0003-3641-729X", github = "rcannood")),
    person("Luke", "Zappia", , "luke@lazappi.id.au", role = "aut",
           comment = c(ORCID = "0000-0001-7744-8565", github = "lazappi")),
    person("Martin", "Morgan", , "mtmorgan.bioc@gmail.com", role = "aut",
           comment = c(ORCID = "0000-0002-5874-8148", github = "mtmorgan")),
    person("Louise", "Deconinck", , "louise.deconinck@gmail.com", role = "aut",
           comment = c(ORCID = "0000-0001-8100-6823", github = "LouiseDck")),
    person("Danila", "Bredikhin", , "danila.bredikhin@embl.de", role = "ctb",
           comment = c(ORCID = "0000-0001-8089-6983", github = "gtca")),
    person("Isaac", "Virshup", role = "ctb",
           comment = c(ORCID = "0000-0002-1710-8945", github = "ivirshup")),
    person("Brian", "Schilder", , "brian_schilder@alumni.brown.edu", role = "ctb",
           comment = c(ORCID = "0000-0001-5949-2191", github = "bschilder")),
    person("Chananchida", "Sang-aram", role = "ctb",
           comment = c(ORCID = "0000-0002-0922-0822", github = "csangara")),
    person("Artür", "Manukyan", role = "ctb",
           comment = c(ORCID = "0000-0002-0441-9517", github = "Artur-man")),
    person("Hugo", "Gruson", role = "ctb",
           comment = c(ORCID = "0000-0002-4094-1476", github = "Bisaloo")),
    person("Data Intuitive", , , "info@data-intuitive.com", role = "fnd"),
    person("Chan Zuckerberg Initiative", role = "fnd"),
    person("scverse consortium", role = "spn")
  )
Description: Bring the power and flexibility of AnnData to the R
    ecosystem, allowing you to effortlessly manipulate and analyse your
    single-cell data. This package lets you work with backed h5ad and zarr
    files, directly access various slots (e.g. X, obs, var), or convert
    the data into SingleCellExperiment and Seurat objects.
License: MIT + file LICENSE
URL: https://anndataR.scverse.org/, https://github.com/scverse/anndataR
BugReports: https://github.com/scverse/anndataR/issues
Depends: R (>= 4.5.0)
Imports: cli, lifecycle, Matrix, methods, purrr, R6 (>= 2.4.0),
        reticulate (>= 1.41.1), rlang, stats
Suggests: BiocFileCache, BiocStyle, knitr, processx, rhdf5 (>= 2.52.1),
        Rarr (>= 1.11.12), rmarkdown, S4Vectors, Seurat, SeuratObject,
        SingleCellExperiment, spelling, SummarizedExperiment, testthat
        (>= 3.0.0), vctrs, withr, yaml
VignetteBuilder: knitr
biocViews: SingleCell, DataImport, DataRepresentation
Config/Needs/website: pkgdown, tibble, knitr, rprojroot, stringr,
        readr, purrr, dplyr, tidyr, rmarkdown
Config/testthat/edition: 3
Encoding: UTF-8
Roxygen: list(markdown = TRUE, r6 = TRUE)
RoxygenNote: 7.3.3
Language: en-GB
git_url: https://git.bioconductor.org/packages/anndataR
git_branch: devel
git_last_commit: b050bbe
git_last_commit_date: 2026-04-24
Repository: Bioconductor 3.23
Date/Publication: 2026-04-24
NeedsCompilation: no
Packaged: 2026-04-24 20:16:45 UTC; biocbuild
Author: Robrecht Cannoodt [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-3641-729X>, github: rcannood),
  Luke Zappia [aut] (ORCID: <https://orcid.org/0000-0001-7744-8565>,
    github: lazappi),
  Martin Morgan [aut] (ORCID: <https://orcid.org/0000-0002-5874-8148>,
    github: mtmorgan),
  Louise Deconinck [aut] (ORCID: <https://orcid.org/0000-0001-8100-6823>,
    github: LouiseDck),
  Danila Bredikhin [ctb] (ORCID: <https://orcid.org/0000-0001-8089-6983>,
    github: gtca),
  Isaac Virshup [ctb] (ORCID: <https://orcid.org/0000-0002-1710-8945>,
    github: ivirshup),
  Brian Schilder [ctb] (ORCID: <https://orcid.org/0000-0001-5949-2191>,
    github: bschilder),
  Chananchida Sang-aram [ctb] (ORCID:
    <https://orcid.org/0000-0002-0922-0822>, github: csangara),
  Artür Manukyan [ctb] (ORCID: <https://orcid.org/0000-0002-0441-9517>,
    github: Artur-man),
  Hugo Gruson [ctb] (ORCID: <https://orcid.org/0000-0002-4094-1476>,
    github: Bisaloo),
  Data Intuitive [fnd],
  Chan Zuckerberg Initiative [fnd],
  scverse consortium [spn]
Maintainer: Robrecht Cannoodt <rcannood@gmail.com>

# {anndataR}: An R package for working with AnnData objects <img src="man/figures/logo.png" align="right" alt="anndataR logo" width=120 />

<!-- badges: start -->
[![Lifecycle: stable](https://img.shields.io/badge/lifecycle-stable-brightgreen.svg)](https://lifecycle.r-lib.org/articles/stages.html#stable)
[![R-CMD-check-bioc](https://github.com/scverse/anndataR/actions/workflows/R-CMD-check-bioc.yaml/badge.svg)](https://github.com/scverse/anndataR/actions/workflows/R-CMD-check-bioc.yaml)
[![Codecov test coverage](https://codecov.io/gh/scverse/anndataR/graph/badge.svg)](https://app.codecov.io/gh/scverse/anndataR)
[![Bioc release status](http://www.bioconductor.org/shields/build/release/bioc/anndataR.svg)](https://bioconductor.org/checkResults/release/bioc-LATEST/anndataR)
[![Bioc devel status](http://www.bioconductor.org/shields/build/devel/bioc/anndataR.svg)](https://bioconductor.org/checkResults/devel/bioc-LATEST/anndataR)
[![Bioc downloads rank](https://bioconductor.org/shields/downloads/release/anndataR.svg)](http://bioconductor.org/packages/stats/bioc/anndataR/)
[![Bioc support](https://bioconductor.org/shields/posts/anndataR.svg)](https://support.bioconductor.org/tag/anndataR)
[![Bioc history](https://bioconductor.org/shields/years-in-bioc/anndataR.svg)](https://bioconductor.org/packages/release/bioc/html/anndataR.html#since)
[![Bioc last commit](https://bioconductor.org/shields/lastcommit/devel/bioc/anndataR.svg)](http://bioconductor.org/checkResults/devel/bioc-LATEST/anndataR/)
[![Bioc dependencies](https://bioconductor.org/shields/dependencies/release/anndataR.svg)](https://bioconductor.org/packages/release/bioc/html/anndataR.html#since)
<!-- badges: end -->

**{anndataR}** aims to make the `AnnData` format a first-class citizen in the R ecosystem, and to make it easy to work with AnnData files in R, either directly or by converting them to a `SingleCellExperiment` or `Seurat` object.

**{anndataR}** is a an scverse® community project fiscally sponsored by the [Chan Zuckerberg Initiative](https://chanzuckerberg.com/).

## Features of {anndataR}

- Provide an `R6` class to work with `AnnData` objects in R (either in-memory or on-disk)
- Read/write `*.h5ad` files and `*.zarr` stores natively
- Convert to/from `SingleCellExperiment` objects
- Convert to/from `Seurat` objects

Please [report](https://github.com/scverse/anndataR/issues) any issues you encounter.

## Installation

You can install **{anndataR}** from Bioconductor using **BiocManager**:

```r
if (!requireNamespace("BiocManager", quietly = TRUE)) {
  install.packages("BiocManager")
}
BiocManager::install("anndataR")
```

Or you can install the development version of **{anndataR}** from GitHub like so:

``` r
# install.packages("pak")
pak::pak("scverse/anndataR")
```

You will need to install additional dependencies, depending on
the task you want to perform.

- To read/write `*.h5ad` files, install [rhdf5](https://www.bioconductor.org/packages/rhdf5):  
  `BiocManager::install("rhdf5")`
- To read/write `*.zarr` stores, install [Rarr](https://www.bioconductor.org/packages/Rarr):  
  `BiocManager::install("Rarr")`
- To convert to/from `SingleCellExperiment` objects, install [SingleCellExperiment](https://bioconductor.org/packages/release/bioc/html/SingleCellExperiment.html):  
  `BiocManager::install("SingleCellExperiment")`
- To convert to/from `Seurat` objects, install [SeuratObject](https://cran.r-project.org/package=SeuratObject):  
  `install.packages("SeuratObject")`

Alternatively, you can install all suggested dependencies at once:

``` r
pak::pak("scverse/anndataR", dependencies = TRUE)
```

## Getting started

The best way to get started with **{anndataR}** is to explore the package vignettes (available at https://anndataR.scverse.org/articles/).

In order to browse these vignettes locally, you need to build them during installation:

``` r
options(pkg.build_vignettes = TRUE)
pak::pak("scverse/anndataR")
```

Take note that you need all suggested dependencies available, and that building them can take some time.

- [**Getting started**](https://anndataR.scverse.org/articles/anndataR.html): An introduction to the package and its features.  
  `vignette("anndataR", package = "anndataR")`
- [**Read/write `Seurat` objects**](https://anndataR.scverse.org/articles/usage_seurat.html): How to convert between `AnnData` and `Seurat` objects.  
  `vignette("usage_seurat", package = "anndataR")`
- [**Read/write `SingleCellExperiment` objects**](https://anndataR.scverse.org/articles/usage_singlecellexperiment.html): How to convert between `AnnData` and `SingleCellExperiment` objects  
  `vignette("usage_singlecellexperiment", package = "anndataR")`
- [**Software Design**](https://anndataR.scverse.org/articles/software_design.html): An overview of the design of the package
- [**Development Status**](https://anndataR.scverse.org/articles/development_status.html): An overview of the development status of the package

## Citing **{anndataR}**

If you use **{anndataR}** in your work, please cite [_"anndataR improves interoperability between R and Python in single-cell transcriptomics"_](https://doi.org/10.1101/2025.08.18.669052):

```r
citation("anndataR")
```

    Deconinck L, Zappia L, Cannoodt R, Morgan M, scverse core, Virshup I, Sang-aram C, Bredikhin D, Seurinck R, Saeys Y (2025).
    “anndataR improves interoperability between R and Python in single-cell transcriptomics.” _bioRxiv_, 2025.08.18.669052.
    doi:10.1101/2025.08.18.669052 <https://doi.org/10.1101/2025.08.18.669052>.

    A BibTeX entry for LaTeX users is

      @Article{,
        title = {{anndataR} improves interoperability between R and Python in single-cell transcriptomics},
        author = {Louise Deconinck and Luke Zappia and Robrecht Cannoodt and Martin Morgan and {scverse core} and Isaac Virshup and Chananchida Sang-aram and Danila Bredikhin and Ruth Seurinck and Yvan Saeys},
        journal = {bioRxiv},
        year = {2025},
        pages = {2025.08.18.669052},
        doi = {10.1101/2025.08.18.669052},
      }

# helper function to skip tests if we don't have the Python 'anndata' module
# or the R {anndata} package
skip_if_no_dummy_anndata <- function() {
  testthat::skip_if_not_installed("reticulate")
  reticulate::py_require("dummy_anndata")
  testthat::skip_if_not(
    reticulate::py_module_available("dummy_anndata"),
    message = "Python dummy_anndata module not available for testing"
  )
}

#' AnnData structure and usage
#'
#' @description
#' The `AnnData` object stores a data matrix `X` together with annotations of
#' observations `obs` (`obsm`, `obsp`) and variables `var` (`varm`, `varp`).
#' Additional layers of data can be stored in `layers` and unstructured
#' annotations in `uns`.
#'
#' ## Back ends
#'
#' There are different back ends for `AnnData` objects that inherit from the
#' abstract [AbstractAnnData] class and store and access data in different ways:
#'
#' - [InMemoryAnnData] stores data in memory
#' - [HDF5AnnData] provides an interface to a H5AD file
#' - [ZarrAnnData] provides an interface to a Zarr store
#' - [ReticulateAnnData] wraps a Python `AnnData` object via \pkg{reticulate}
#'
#' See the class documentation for details.
#'
#' ## Usage
#'
#' The items listed as **"Slots"** are elements of the `AnnData` object that
#' contain data and can be accessed or set. **"Fields"** return information
#' about the `AnnData` object but cannot be set directly. Both, as well as
#' methods, can be accessed using the `$` operator
#'
#' For example:
#'
#' - `adata$X` returns the `X` matrix
#' - `adata$X <- x` sets the `X` matrix
#' - `adata$method()` calls a method
#'
#' @slot X The main data matrix. Either `NULL` or an observation x variable
#'   matrix (without dimnames) with dimensions consistent with `n_obs` and
#'   `n_vars`.
#' @slot layers Additional data layers. Must be `NULL` or a named list of
#'   matrices having dimensions consistent with `n_obs` and `n_vars`.
#' @slot obs Observation annotations. A `data.frame` with columns containing
#'   information about observations. The number of rows of `obs` defines the
#'   observation dimension of the `AnnData` object (`n_obs`). If `NULL`, an
#'   `n_obs` × 0 `data.frame` will automatically be generated.
#' @slot var Variable annotations. A `data.frame` with columns containing
#'   information about variables. The number of rows of `var` defines the
#'   variable dimension of the `AnnData` object (`n_vars`). If `NULL`, an
#'   `n_vars` × 0 `data.frame` will automatically be generated.
#' @slot obs_names Observation names. Either `NULL` or a vector of unique
#'   identifiers used to identify each row of `obs` and to act as an index into
#'   the observation dimension of the `AnnData` object. For compatibility with
#'   _R_ representations, `obs_names` should be a unique character vector.
#' @slot var_names Variable names. Either `NULL` or a vector of unique
#'   identifiers used to identify each row of `var` and to act as an index into
#'   the variable dimension of the `AnnData` object. For compatibility with _R_
#'   representations, `var_names` should be a unique character vector.
#' @slot obsm Multi-dimensional observation annotation. Must be `NULL` or a
#'   named list of array-like elements with number of rows equal to `n_obs`.
#' @slot varm Multi-dimensional variable annotations. Must be `NULL` or a named
#'   list of array-like elements with number of rows equal to `n_vars`.
#' @slot obsp Observation pairs. Must be `NULL` or a named list of array-like
#'   elements with number of rows and columns equal to `n_obs`.
#' @slot varp Variable pairs. Must be `NULL` or a named list of array-like
#'   elements with number of rows and columns equal to `n_vars`.
#' @slot uns Unstructured annotations. Must be `NULL` or a named list.
#'
#' @field shape Dimensions (observations x variables) of the `AnnData` object
#' @field n_obs Number of observations
#' @field n_vars Number of variables
#' @field obs_keys Keys (column names) of `obs`
#' @field var_keys Keys (column names) of `var`
#' @field layers_keys Keys (element names) of `layers`
#' @field obsm_keys Keys (element names) of `obsm`
#' @field varm_keys Keys (element names) of `varm`
#' @field obsp_keys Keys (element names) of `obsp`
#' @field varp_keys Keys (element names) of `varp`
#' @field uns_keys Keys (element names) of `uns`
#'
#' @return An `AnnData` object inheriting from [`AbstractAnnData`]
#'
#' @section Methods:
#'
#' ## Conversion methods:
#'
#' \describe{
#'   \item{
#'     `as_SingleCellExperiment()`
#'   }{
#'     Convert to [`SingleCellExperiment::SingleCellExperiment`], see
#'     [as_SingleCellExperiment()]
#'   }
#'   \item{`as_Seurat()`}{Convert to [`SeuratObject::Seurat`], see [as_Seurat()]}
#'   \item{`as_InMemoryAnnData()`}{Convert to [`InMemoryAnnData`], as [as_InMemoryAnnData()]}
#'   \item{`as_HDF5AnnData()`}{Convert to [`HDF5AnnData`], see [as_HDF5AnnData()]}
#'   \item{`as_ZarrAnnData()`}{Convert to [`ZarrAnnData`], see [as_ZarrAnnData()]}
#'   \item{`as_ReticulateAnnData()`}{Convert to [`ReticulateAnnData`], see [as_ReticulateAnnData()]}
#' }
#'
#' ## Output methods:
#'
#' \describe{
#'   \item{
#'     `write_h5ad()`
#'   }{
#'     Write the `AnnData` object to an HDF5 file, see [write_h5ad()]
#'   }
#' }
#'
#' \describe{
#'   \item{
#'     `write_zarr()`
#'   }{
#'     Write the `AnnData` object to a Zarr store, see [write_zarr()]
#'   }
#' }
#'
#' ## General methods:
#'
#' \describe{
#'   \item{`print()`}{Print a summary of the `AnnData` object}
#' }
#'
#' @section Functions that can be used to create AnnData objects:
#'
#' \describe{
#'   \item{[AnnData()]}{Create an [InMemoryAnnData] object}
#'   \item{[read_h5ad()]}{Read an `AnnData` from a H5AD file}
#'   \item{[read_zarr()]}{Read an `AnnData` from a Zarr store}
#'   \item{[as_AnnData()]}{Convert other objects to an `AnnData` object}
#' }
#'
#' @seealso The documentation for the Python `anndata` package
#'   <https://anndata.readthedocs.io/en/stable/>
#' @seealso [AbstractAnnData] for the abstract class that all `AnnData` objects
#'   inherit from
#' @seealso [InMemoryAnnData] for the in-memory implementation of `AnnData`
#' @seealso [HDF5AnnData] for the HDF5-backed implementation of `AnnData`
#' @seealso [ZarrAnnData] for the Zarr-backed implementation of `AnnData`
#' @seealso [ReticulateAnnData] for the reticulate-based implementation that wraps Python AnnData objects
#'
#' @name AnnData-usage
NULL

#' Generate a dataframe
#'
#' Generate a dataframe with different types of columns
#'
#' @param num_rows Number of rows to generate
#' @param types Types of columns to generate
#'
#' @return A dataframe with the generated columns
#'
#' @noRd
#'
#' @examples
#' generate_dataframe(10L)
generate_dataframe <- function(num_rows, types = names(vector_generators)) {
  if (rlang::is_empty(types)) {
    return(data.frame()[seq_len(num_rows), ])
  }

  data <- lapply(types, generate_vector, n = num_rows)
  names(data) <- types
  as.data.frame(data)
}

#' List the available AnnData generators.
#'
#' @noRd
anndata_constructors <- function() {
  list(
    "HDF5AnnData" = HDF5AnnData,
    "InMemoryAnnData" = InMemoryAnnData,
    "ZarrAnnData" = ZarrAnnData,
    "ReticulateAnnData" = ReticulateAnnData
  )
}

#' Retrieve the AnnData constructor for a given class.
#'
#' @param class Name of the AnnData class. Must be one of `"HDF5AnnData"`,
#' `"InMemoryAnnData"`, or `"ReticulateAnnData"`.
#'
#' @noRd
get_anndata_constructor <- function(
  class = c(
    "HDF5AnnData",
    "InMemoryAnnData",
    "ZarrAnnData",
    "ReticulateAnnData"
  )
) {
  # TODO: also support directly passing the correct class?
  class <- match.arg(class)
  anndata_constructors()[[class]]
}

#' @description
#' Use `get_generator_types()` to get the available types for each slot.
#'
#' @param slot Which slot to return types for, if `NULL` a named list of all
#'   slots is returned
#'
#' @details
#' Use `get_generator_types()` to get a list of the available types for each
#' slot, or for a specific slot by setting `slot`. If `example = TRUE`, only the
#' example types are returned.
#'
#' @returns For `get_generator_types()`, a named list of character vectors or a
#'   single character vector if `slot` is not `NULL`
#' @export
#' @rdname generate_dataset
#'
#' @examples
#' # Get all available generator types
#' get_generator_types()
#'
#' # Get generator types for a specific slot
#' get_generator_types(slot = "obs")
#'
#' # Get generator types used when example = TRUE
#' get_generator_types(example = TRUE)
get_generator_types <- function(example = FALSE, slot = NULL) {
  if (example) {
    types <- .example_generator_types
  } else {
    types <- .generator_types
  }

  if (!is.null(slot)) {
    if (!(slot %in% names(types))) {
      cli_abort(c(
        "Invalid slot: {.val {slot}}",
        "i" = "Must be one of {.or {.val {names(types)}}}"
      ))
    }
    types <- types[[slot]]
  }

  types
}

.generator_types <- list(
  X = names(matrix_generators),
  layers = names(matrix_generators),
  obs = names(vector_generators),
  var = names(vector_generators),
  obsm = c(names(matrix_generators), names(vector_generators)),
  varm = c(names(matrix_generators), names(vector_generators)),
  obsp = names(matrix_generators),
  varp = names(matrix_generators),
  uns = c(
    paste0("scalar_", names(vector_generators)),
    paste0("vec_", names(vector_generators)),
    paste0("df_", names(vector_generators)),
    paste0("mat_", names(matrix_generators)),
    "list"
  )
)

.example_generator_types <- list(
  X = "numeric_matrix",
  layers = c("numeric_matrix", "numeric_dense", "numeric_csparse"),
  obs = c("character", "integer", "factor"),
  var = c("character", "integer", "factor"),
  obsm = c("numeric_matrix", "numeric_dense", "numeric_csparse"),
  varm = c("numeric_matrix", "numeric_dense", "numeric_csparse"),
  obsp = c("numeric_matrix", "numeric_dense", "numeric_csparse"),
  varp = c("numeric_matrix", "numeric_dense", "numeric_csparse"),
  uns = c(
    "scalar_character",
    "vec_integer",
    "df_logical",
    "mat_numeric_matrix"
  )
)

test_that("get_generator_types() works", {
  types <- get_generator_types()

  expect_type(types, "list")
  expect_true(all(.anndata_slots %in% names(types)))
  expect_true(all(sapply(types, is.character)))
})

test_that("get_generator_types(example = TRUE) works", {
  types <- get_generator_types(example = TRUE)

  expect_type(types, "list")
  expect_true(all(.anndata_slots %in% names(types)))
  expect_true(all(sapply(types, is.character)))

  for (slot in names(types)) {
    expect_true(all(types[[slot]] %in% .example_generator_types[[slot]]))
  }
})

test_that("get_generator_types(slot = ...) works", {
  for (slot in .anndata_slots) {
    types <- get_generator_types(slot = slot)

    expect_type(types, "character")
    expect_true(all(types %in% .generator_types[[slot]]))
  }
})

## ----include = FALSE----------------------------------------------------------
# Set up reticulate and check for required Python packages.
reticulate::py_require("mudata")
reticulate::py_require("scanpy")

# Check if required Python packages are available.
python_available <- reticulate::py_module_available("scanpy") &&
  reticulate::py_module_available("mudata")

# On CI, fail the vignette build if Python packages are not available
if (!python_available && nzchar(Sys.getenv("CI"))) {
  conf <- reticulate::py_config()
  conf_str <- paste(capture.output(print(conf)), collapse = "\n")
  stop(
    "Python packages scanpy/mudata are not available. ",
    "The usage_python vignette cannot be rendered on CI without them.",
    "\n\nPython configuration:\n", conf_str
  )
}

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  # Set eval based on Python package availability
  eval = python_available
)

## ----python_unavailable, eval=!python_available-------------------------------
# message(
#   "Python packages scanpy and mudata are required to run this vignette. Code chunks will not be evaluated."
# )

## ----python_setup, eval=FALSE-------------------------------------------------
# reticulate::py_require("scanpy")

## ----load_libraries-----------------------------------------------------------
library(anndataR)
library(reticulate)
sc <- import("scanpy")

## ----load_python_data---------------------------------------------------------
adata <- sc$datasets$pbmc3k_processed()
adata

## ----apply_python_functions---------------------------------------------------
sc$pp$filter_cells(adata, min_genes = 200L)
sc$pp$normalize_total(adata, target_sum = 1e4)
sc$pp$log1p(adata)

## ----convert_to_sce-----------------------------------------------------------
sce_obj <- adata$as_SingleCellExperiment()
sce_obj

## ----convert_to_seurat--------------------------------------------------------
seurat_obj <- adata$as_Seurat()
seurat_obj

## ----mudata_setup, eval=FALSE-------------------------------------------------
# reticulate::py_install("mudata")

## ----load_mudata--------------------------------------------------------------
md <- import("mudata")

## ----load_mudata_example, eval = python_available && requireNamespace("BiocFileCache", quietly = TRUE)----
cache <- BiocFileCache::BiocFileCache(ask = FALSE)
h5mu_file <- BiocFileCache::bfcrpath(
  cache,
  "https://github.com/gtca/h5xx-datasets/raw/b1177ac8877c89d8bb355b072164384b4e9cc81d/datasets/minipbcite.h5mu"
)

mdata <- md$read_h5mu(h5mu_file)

## ----access_modalities--------------------------------------------------------
rna_mod <- mdata$mod[["rna"]]

rna_seurat <- rna_mod$as_Seurat()
print(rna_seurat)

rna_sce <- rna_mod$as_SingleCellExperiment()
print(rna_sce)

## ----r-sessioninfo------------------------------------------------------------
sessionInfo()

## ----python-sessioninfo-------------------------------------------------------
reticulate::py_config()

reticulate::py_list_packages()

#' @title ZarrAnnData
#'
#' @description
#' Implementation of a Zarr-backed `AnnData` object. This class provides an
#' interface to a Zarr file and minimal data is stored in memory until it is
#' requested by the user. It is primarily designed as an intermediate object
#' when reading/writing Zarr files but can be useful for accessing parts of
#' large files.
#'
#' See [AnnData-usage] for details on creating and using `AnnData` objects.
#'
#' @return A `ZarrAnnData` object
#'
#' @seealso [AnnData-usage] for details on creating and using `AnnData` objects
#'
#' @family AnnData classes
ZarrAnnData <- R6::R6Class(
  "ZarrAnnData", # nolint
  inherit = AbstractAnnData,
  cloneable = FALSE,
  private = list(
    .zarrobj = NULL,
    .compression = NULL,
    .readonly = NULL,

    .check_file_valid = function() {
      if (!zarr_path_exists(private$.zarrobj, "/")) {
        cli_abort(
          "The Zarr path does not exist or is not a valid Zarr store"
        )
      }
    },

    .check_writeable = function() {
      if (isTRUE(private$.readonly)) {
        cli_abort(
          "Cannot write to a Zarr store opened in read-only mode.",
          call = rlang::caller_env()
        )
      }
    }
  ),
  active = list(
    #' @field X See [AnnData-usage]
    X = function(value) {
      private$.check_file_valid()

      if (missing(value)) {
        # trackstatus: class=ZarrAnnData, feature=get_X, status=done
        read_zarr_element(private$.zarrobj, "X") |>
          private$.add_matrix_dimnames("X")
      } else {
        private$.check_writeable()
        # trackstatus: class=ZarrAnnData, feature=set_X, status=done
        private$.validate_aligned_array(
          value,
          "X",
          shape = c(self$n_obs(), self$n_vars()),
          expected_rownames = self$obs_names,
          expected_colnames = self$var_names
        ) |>
          write_zarr_element(
            private$.zarrobj,
            "X",
            private$.compression
          )
      }
    },
    #' @field layers See [AnnData-usage]
    layers = function(value) {
      private$.check_file_valid()

      if (missing(value)) {
        # trackstatus: class=ZarrAnnData, feature=get_layers, status=done
        read_zarr_element(private$.zarrobj, "layers") |>
          private$.add_mapping_dimnames("layers")
      } else {
        private$.check_writeable()
        # trackstatus: class=ZarrAnnData, feature=set_layers, status=done
        private$.validate_aligned_mapping(
          value,
          "layers",
          c(self$n_obs(), self$n_vars()),
          expected_rownames = self$obs_names,
          expected_colnames = self$var_names
        ) |>
          write_zarr_element(
            private$.zarrobj,
            "layers",
            private$.compression
          )
      }
    },
    #' @field obsm See [AnnData-usage]
    obsm = function(value) {
      private$.check_file_valid()

      if (missing(value)) {
        # trackstatus: class=ZarrAnnData, feature=get_obsm, status=done
        read_zarr_element(private$.zarrobj, "obsm") |>
          private$.add_mapping_dimnames("obsm")
      } else {
        private$.check_writeable()
        # trackstatus: class=ZarrAnnData, feature=set_obsm, status=done
        private$.validate_aligned_mapping(
          value,
          "obsm",
          c(self$n_obs()),
          expected_rownames = self$obs_names,
          strip_rownames = TRUE,
          strip_colnames = FALSE,
          warn_colnames = TRUE
        ) |>
          write_zarr_element(
            private$.zarrobj,
            "obsm",
            private$.compression
          )
      }
    },
    #' @field varm See [AnnData-usage]
    varm = function(value) {
      private$.check_file_valid()

      if (missing(value)) {
        # trackstatus: class=ZarrAnnData, feature=get_varm, status=done
        read_zarr_element(private$.zarrobj, "varm") |>
          private$.add_mapping_dimnames("varm")
      } else {
        private$.check_writeable()
        # trackstatus: class=ZarrAnnData, feature=set_varm, status=done
        private$.validate_aligned_mapping(
          value,
          "varm",
          c(self$n_vars()),
          expected_rownames = self$var_names,
          strip_rownames = TRUE,
          strip_colnames = FALSE,
          warn_colnames = TRUE
        ) |>
          write_zarr_element(
            private$.zarrobj,
            "varm",
            private$.compression
          )
      }
    },
    #' @field obsp See [AnnData-usage]
    obsp = function(value) {
      private$.check_file_valid()

      if (missing(value)) {
        # trackstatus: class=ZarrAnnData, feature=get_obsp, status=done
        read_zarr_element(private$.zarrobj, "obsp") |>
          private$.add_mapping_dimnames("obsp")
      } else {
        private$.check_writeable()
        # trackstatus: class=ZarrAnnData, feature=set_obsp, status=done
        private$.validate_aligned_mapping(
          value,
          "obsp",
          c(self$n_obs(), self$n_obs()),
          expected_rownames = self$obs_names,
          expected_colnames = self$obs_names
        ) |>
          write_zarr_element(
            private$.zarrobj,
            "obsp",
            private$.compression
          )
      }
    },
    #' @field varp See [AnnData-usage]
    varp = function(value) {
      private$.check_file_valid()

      if (missing(value)) {
        # trackstatus: class=ZarrAnnData, feature=get_varp, status=done
        read_zarr_element(private$.zarrobj, "varp") |>
          private$.add_mapping_dimnames("varp")
      } else {
        private$.check_writeable()
        # trackstatus: class=ZarrAnnData, feature=set_varp, status=done
        private$.validate_aligned_mapping(
          value,
          "varp",
          c(self$n_vars(), self$n_vars()),
          expected_rownames = self$var_names,
          expected_colnames = self$var_names
        ) |>
          write_zarr_element(
            private$.zarrobj,
            "varp",
            private$.compression
          )
      }
    },
    #' @field obs See [AnnData-usage]
    obs = function(value) {
      private$.check_file_valid()

      if (missing(value)) {
        # trackstatus: class=ZarrAnnData, feature=get_obs, status=done
        read_zarr_element(private$.zarrobj, "obs")
      } else {
        private$.check_writeable()
        # trackstatus: class=ZarrAnnData, feature=set_obs, status=done
        private$.validate_obsvar_dataframe(value, "obs") |>
          write_zarr_element(
            private$.zarrobj,
            "obs",
            private$.compression
          )
      }
    },
    #' @field var See [AnnData-usage]
    var = function(value) {
      private$.check_file_valid()

      if (missing(value)) {
        # trackstatus: class=ZarrAnnData, feature=get_var, status=done
        read_zarr_element(private$.zarrobj, "var")
      } else {
        private$.check_writeable()
        # trackstatus: class=ZarrAnnData, feature=set_var, status=done
        private$.validate_obsvar_dataframe(value, "var") |>
          write_zarr_element(
            private$.zarrobj,
            "var",
            private$.compression
          )
      }
    },
    #' @field obs_names See [AnnData-usage]
    obs_names = function(value) {
      private$.check_file_valid()

      if (missing(value)) {
        # trackstatus: class=ZarrAnnData, feature=get_obs_names, status=done
        read_zarr_element_keys(private$.zarrobj, "obs", dim = "rows")
      } else {
        private$.check_writeable()
        # trackstatus: class=ZarrAnnData, feature=set_obs_names, status=done
        rownames(self$obs) <- value
      }
    },
    #' @field var_names See [AnnData-usage]
    var_names = function(value) {
      private$.check_file_valid()

      if (missing(value)) {
        # trackstatus: class=ZarrAnnData, feature=get_var_names, status=done
        read_zarr_element_keys(private$.zarrobj, "var", dim = "rows")
      } else {
        private$.check_writeable()
        # trackstatus: class=ZarrAnnData, feature=set_var_names, status=done
        rownames(self$var) <- value
      }
    },
    #' @field uns See [AnnData-usage]
    uns = function(value) {
      private$.check_file_valid()

      if (missing(value)) {
        # trackstatus: class=ZarrAnnData, feature=get_uns, status=done
        read_zarr_element(private$.zarrobj, "uns")
      } else {
        private$.check_writeable()
        # trackstatus: class=ZarrAnnData, feature=set_uns, status=done
        private$.validate_named_list(
          value,
          "uns",
          warn_matrix_dimnames = TRUE
        ) |>
          write_zarr_element(
            private$.zarrobj,
            "uns",
            private$.compression
          )
      }
    }
  ),
  public = list(
    #' @description
    #' `ZarrAnnData` constructor
    #'
    #' @param file The file name (character) of the `.zarr` file. If this file
    #'   already exits, other arguments must be `NULL`.
    #' @param X See the `X` slot in [AnnData-usage]
    #' @param layers See the `layers` slot in [AnnData-usage]
    #' @param obs See the `obs` slot in [AnnData-usage]
    #' @param var See the `var` slot in [AnnData-usage]
    #' @param obsm See the `obsm` slot in [AnnData-usage]
    #' @param varm See the `varm` slot in [AnnData-usage]
    #' @param obsp See the `obsp` slot in [AnnData-usage]
    #' @param varp See the `varp` slot in [AnnData-usage]
    #' @param uns See the `uns` slot in [AnnData-usage]
    #' @param shape Shape tuple (e.g. `c(n_obs, n_vars)`). Can be provided if
    #'   both `X` or `obs` and `var` are not provided.
    #' @param mode The mode to open the Zarr file. See [as_ZarrAnnData()] for
    #'   details
    #' @param compression The compression algorithm to use. See
    #'   [as_ZarrAnnData()] for details
    #'
    #' @details
    #' The constructor creates a new Zarr `AnnData` interface object. This can
    #' either be used to either connect to an existing `.zarr` file or to
    #' create a new one. If any additional slot arguments are set an existing
    #' file will be overwritten.
    initialize = function(
      file,
      X = NULL,
      obs = NULL,
      var = NULL,
      layers = NULL,
      obsm = NULL,
      varm = NULL,
      obsp = NULL,
      varp = NULL,
      uns = NULL,
      shape = NULL,
      mode = c("a", "r", "r+", "w", "w-", "x"),
      compression = c(
        "none",
        "gzip",
        "blosc",
        "zstd",
        "lzma",
        "bz2",
        "zlib",
        "lz4"
      )
    ) {
      check_requires("ZarrAnnData", "Rarr", where = "Bioc")

      compression <- match.arg(compression)
      mode <- match.arg(mode)

      private$.compression <- compression

      is_readonly <- FALSE

      if (is.character(file)) {
        if (mode == "a") {
          if (dir.exists(file)) {
            mode <- "r+"
          } else {
            mode <- "w-"
          }
        }

        if (!dir.exists(file) && mode %in% c("r", "r+")) {
          cli_abort(
            paste(
              "File {.file {file}} does not exist but mode is set to {.val {mode}}.",
              "If you want to create a new file, use a different mode (e.g. 'w-').",
              "See {.help read_zarr} or {.help write_zarr} for more information."
            ),
            call = rlang::caller_env()
          )
        }

        if (dir.exists(file) && mode %in% c("w-", "x")) {
          cli_abort(
            paste(
              "File {.file {file}} already exists but mode is set to {.val {mode}}.",
              "If you want to overwrite the file, use a different mode (e.g. 'w').",
              "See {.help read_zarr} or {.help write_zarr} for more information."
            ),
            call = rlang::caller_env()
          )
        }

        if (mode %in% c("w", "w-", "x")) {
          create_zarr(file)
        } else if (mode == "r") {
          is_readonly <- TRUE
        }
      } else {
        cli_abort(
          paste(
            "{.arg file} must be a {.cls character}"
          )
        )
      }

      if (!zarr_path_exists(file, "/")) {
        cli_abort(
          paste(
            "{.arg file} must be a valid zarr store/file"
          )
        )
      }

      is_empty <- is_zarr_empty(file)

      if (!is_readonly) {
        if (!is_empty) {
          cli_warn(
            paste(
              "An non-empty file is opened in read/write mode.",
              "Use with caution, as this can lead to data corruption."
            )
          )
        } else {
          shape <- get_shape(obs, var, X, shape)
          obs <- get_initial_obs(obs, X, shape)
          var <- get_initial_var(var, X, shape)
          write_empty_zarr(file, obs, var, compression)
        }
      }

      # File is supposed to exist by now. Check if it is a valid Zarr file
      attrs <- Rarr::read_zarr_attributes(file)
      if (!all(c("encoding-type", "encoding-version") %in% names(attrs))) {
        cli_abort(c(
          "File {.file {file}} is not a valid AnnData-Zarr file."
        ))
      }

      # Set the file path
      private$.zarrobj <- file
      private$.readonly <- is_readonly

      if (is_readonly) {
        # if any of these variables are not NULL, throw an error
        are_null <- vapply(
          .anndata_slots,
          function(x) is.null(get(x)),
          logical(1)
        )
        if (!all(are_null)) {
          cli_abort(
            paste0(
              "Error trying to write data (",
              paste(.anndata_slots[!are_null], collapse = ", "),
              ") to a Zarr file opened in read-only mode."
            )
          )
        }
      } else {
        for (slot in .anndata_slots) {
          value <- get(slot)
          if (!is.null(value)) {
            self[[slot]] <- value
          }
        }
      }

      self
    },

    #' @description See the `n_obs` field in [AnnData-usage]
    n_obs = function() {
      length(self$obs_names)
    },

    #' @description See the `n_vars` field in [AnnData-usage]
    n_vars = function() {
      length(self$var_names)
    },

    #' @description See [AnnData-usage]
    obs_keys = function() {
      read_zarr_element_keys(private$.zarrobj, "obs", dim = "cols")
    },
    #' @description See [AnnData-usage]
    var_keys = function() {
      read_zarr_element_keys(private$.zarrobj, "var", dim = "cols")
    },
    #' @description See [AnnData-usage]
    layers_keys = function() {
      read_zarr_element_keys(private$.zarrobj, "layers")
    },
    #' @description See [AnnData-usage]
    obsm_keys = function() {
      read_zarr_element_keys(private$.zarrobj, "obsm")
    },
    #' @description See [AnnData-usage]
    varm_keys = function() {
      read_zarr_element_keys(private$.zarrobj, "varm")
    },
    #' @description See [AnnData-usage]
    obsp_keys = function() {
      read_zarr_element_keys(private$.zarrobj, "obsp")
    },
    #' @description See [AnnData-usage]
    varp_keys = function() {
      read_zarr_element_keys(private$.zarrobj, "varp")
    },
    #' @description See [AnnData-usage]
    uns_keys = function() {
      read_zarr_element_keys(private$.zarrobj, "uns")
    }
  )
)

#' Convert an `AnnData` to an `ZarrAnnData`
#'
#' Convert another `AnnData` object to an [`ZarrAnnData`] object
#'
#' @param adata An `AnnData` object to be converted to [`ZarrAnnData`]
#' @param file The file name (character) of the `.zarr` file
#' @param compression The compression algorithm to use when writing the
#'   Zarr file. Can be one of `"none"`, `"gzip"`, `"blosc"`, `"zstd"`,
#'   `"lzma"`, `"bz2"`, `"zlib"` or `"lz4"`. Defaults to `"none"`.
#' @param mode The mode to open the Zarr file:
#'
#'   * `a` creates a new file or opens an existing one for read/write
#'   * `r` opens an existing file for reading
#'   * `r+` opens an existing file for read/write
#'   * `w` creates a file, truncating any existing ones
#'   * `w-`/`x` are synonyms, creating a file and failing if it already exists
#'
#' @return A [`ZarrAnnData`] object with the same data as the input `AnnData`
#'   object.
#' @keywords internal
#'
#' @family object converters
#'
# nolint start: object_name_linter
as_ZarrAnnData <- function(
  # nolint end: object_name_linter
  adata,
  file,
  compression = c(
    "none",
    "gzip",
    "blosc",
    "zstd",
    "lzma",
    "bz2",
    "zlib",
    "lz4"
  ),
  mode = c("w-", "r", "r+", "a", "w", "x")
) {
  if (!(inherits(adata, "AbstractAnnData"))) {
    cli_abort(
      "{.arg adata} must be a {.cls AbstractAnnData} but has class {.cls {class(adata)}}"
    )
  }

  mode <- match.arg(mode)
  ZarrAnnData$new(
    file = file,
    X = adata$X,
    obs = adata$obs,
    var = adata$var,
    obsm = adata$obsm,
    varm = adata$varm,
    layers = adata$layers,
    obsp = adata$obsp,
    varp = adata$varp,
    uns = adata$uns,
    shape = adata$shape(),
    mode = mode,
    compression = compression
  )
}

skip_if_not_installed("Rarr")

file <- system.file("extdata", "example_v2.zarr.zip", package = "anndataR")
td <- tempdir(check = TRUE)
unzip(file, exdir = td)
store <- file.path(td, "example_v2.zarr")

test_that("opening Zarr works", {
  adata <- ZarrAnnData$new(store, mode = "r")
  expect_true(inherits(adata, "ZarrAnnData"))
})

adata <- ZarrAnnData$new(store, mode = "r")

# GETTERS ----------------------------------------------------------------
# trackstatus: class=ZarrAnnData, feature=test_get_X, status=done
test_that("reading X works", {
  X <- adata$X
  expect_s4_class(X, "dgRMatrix")
  expect_equal(dim(X), c(50, 100))
})

# trackstatus: class=ZarrAnnData, feature=test_get_layers, status=done
test_that("reading layers works", {
  layers <- adata$layers
  expect_true(is.list(layers), "list")
  expect_equal(
    names(layers),
    c("counts", "csc_counts", "dense_X", "dense_counts")
  )
})

test_that("reading obsm works", {
  obsm <- adata$obsm
  expect_true(is.list(obsm), "list")
  expect_equal(
    names(obsm),
    c("X_pca", "X_umap")
  )
})

test_that("reading varm works", {
  varm <- adata$varm
  expect_true(is.list(varm), "list")
  expect_equal(
    names(varm),
    c("PCs")
  )
})

# trackstatus: class=ZarrAnnData, feature=test_get_obsp, status=done
test_that("reading obsp works", {
  obsp <- adata$obsp
  expect_true(is.list(obsp), "list")
  expect_equal(
    names(obsp),
    c("connectivities", "distances")
  )
})

# trackstatus: class=ZarrAnnData, feature=test_get_varp, status=done
test_that("reading varp works", {
  varp <- adata$varp
  expect_true(is.list(varp), "list")
  expect_equal(
    names(varp),
    c("test_varp")
  )
})

# trackstatus: class=ZarrAnnData, feature=test_get_obs, status=done
test_that("reading obs works", {
  obs <- adata$obs
  expect_s3_class(obs, "data.frame")
  expect_equal(
    colnames(obs),
    c(
      "Float",
      "FloatNA",
      "Int",
      "IntNA",
      "Bool",
      "BoolNA",
      "n_genes_by_counts",
      "log1p_n_genes_by_counts",
      "total_counts",
      "log1p_total_counts",
      "leiden"
    )
  )
})

# trackstatus: class=ZarrAnnData, feature=test_get_var, status=done
test_that("reading var works", {
  var <- adata$var
  expect_s3_class(var, "data.frame")
  expect_equal(
    colnames(var),
    c(
      "String",
      "n_cells_by_counts",
      "mean_counts",
      "log1p_mean_counts",
      "pct_dropout_by_counts",
      "total_counts",
      "log1p_total_counts",
      "highly_variable",
      "means",
      "dispersions",
      "dispersions_norm"
    )
  )
})

# trackstatus: class=ZarrAnnData, feature=test_get_obs_names, status=done
test_that("reading obs names works", {
  obs_names <- adata$obs_names
  expect_vector(obs_names, ptype = character(), size = 50)
})

# trackstatus: class=ZarrAnnData, feature=test_get_var_names, status=done
test_that("reading var names works", {
  var_names <- adata$var_names
  expect_vector(var_names, ptype = character(), size = 100)
})

# SETTERS ----------------------------------------------------------------
test_that("creating empty Zarr works", {
  empty_store <- tempfile(fileext = ".zarr")
  expect_silent(ZarrAnnData$new(empty_store))
  unlink(empty_store, recursive = TRUE)
})

# trackstatus: class=ZarrAnnData, feature=test_set_X, status=done
test_that("writing X works", {
  store <- tempfile(fileext = ".zarr")
  create_zarr(store = store)
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  zarr <- ZarrAnnData$new(store, obs = obs, var = var)

  X <- matrix(rnorm(10 * 20), nrow = 10, ncol = 20)
  expect_silent(zarr$X <- X)
  unlink(store, recursive = TRUE)
})

# trackstatus: class=ZarrAnnData, feature=test_set_layers, status=done
test_that("writing layers works", {
  store <- tempfile(fileext = ".zarr")
  create_zarr(store = store)
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  zarr <- ZarrAnnData$new(store, obs = obs, var = var)

  X <- matrix(rnorm(10 * 20), nrow = 10, ncol = 20)
  expect_silent(zarr$layers <- list(layer1 = X, layer2 = X))
  unlink(store, recursive = TRUE)
})

# trackstatus: class=ZarrAnnData, feature=test_set_obs, status=done
test_that("writing obs works", {
  store <- tempfile(fileext = ".zarr")
  create_zarr(store = store)
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  zarr <- ZarrAnnData$new(store, obs = obs, var = var)

  obs <- data.frame(
    Letters = LETTERS[1:10],
    Numbers = 1:10,
    row.names = paste0("Row", 1:10)
  )
  zarr$obs <- obs
  expect_identical(zarr$obs_names, paste0("Row", 1:10))
  unlink(store, recursive = TRUE)
})

# trackstatus: class=ZarrAnnData, feature=test_set_var, status=done
test_that("writing var works", {
  store <- tempfile(fileext = ".zarr")
  create_zarr(store = store)
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  zarr <- ZarrAnnData$new(store, obs = obs, var = var)

  var <- data.frame(
    Letters = LETTERS[1:20],
    Numbers = 1:20,
    row.names = paste0("Row", 1:20)
  )
  zarr$var <- var
  expect_identical(zarr$var_names, paste0("Row", 1:20))
  unlink(store, recursive = TRUE)
})

# trackstatus: class=ZarrAnnData, feature=test_set_obs_names, status=done
test_that("writing obs names works", {
  store <- tempfile(fileext = ".zarr")
  create_zarr(store = store)
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  zarr <- ZarrAnnData$new(store, obs = obs, var = var)

  zarr$obs_names <- LETTERS[1:10]
  expect_identical(zarr$obs_names, LETTERS[1:10])
  unlink(store, recursive = TRUE)
})

# trackstatus: class=ZarrAnnData, feature=test_set_var_names, status=done
test_that("writing var names works", {
  store <- tempfile(fileext = ".zarr")
  create_zarr(store = store)
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  zarr <- ZarrAnnData$new(store, obs = obs, var = var)

  zarr$var_names <- LETTERS[1:20]
  expect_identical(zarr$var_names, LETTERS[1:20])
  unlink(store, recursive = TRUE)
})

# trackstatus: class=ZarrAnnData, feature=test_set_obsm, status=done
test_that("writing obsm works", {
  store <- tempfile(fileext = ".zarr")
  create_zarr(store = store)
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  zarr <- ZarrAnnData$new(store, obs = obs, var = var)
  obsm_x <- matrix(rnorm(10 * 5), nrow = 10, ncol = 5)
  zarr$obsm <- list(X = obsm_x)
  # obsm should now have rownames added on-the-fly
  expected_obsm_x <- obsm_x
  rownames(expected_obsm_x) <- zarr$obs_names
  expect_identical(zarr$obsm$X, expected_obsm_x)
})

# trackstatus: class=ZarrAnnData, feature=test_set_varm, status=done
test_that("writing varm works", {
  store <- tempfile(fileext = ".zarr")
  create_zarr(store = store)
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  zarr <- ZarrAnnData$new(store, obs = obs, var = var)

  varm_x <- matrix(rnorm(20 * 5), nrow = 20, ncol = 5)
  zarr$varm <- list(PCs = varm_x)
  # varm should now have rownames added on-the-fly
  expected_varm_x <- varm_x
  rownames(expected_varm_x) <- zarr$var_names
  expect_identical(zarr$varm$PCs, expected_varm_x)
})

# trackstatus: class=ZarrAnnData, feature=test_set_obsp, status=done
test_that("writing obsp works", {
  store <- tempfile(fileext = ".zarr")
  create_zarr(store = store)
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  zarr <- ZarrAnnData$new(store, obs = obs, var = var)

  obsp_x <- matrix(rnorm(10 * 10), nrow = 10, ncol = 10)
  zarr$obsp <- list(connectivities = obsp_x)
  # obsp should now have dimnames added on-the-fly
  expected_obsp_x <- obsp_x
  dimnames(expected_obsp_x) <- list(zarr$obs_names, zarr$obs_names)
  expect_identical(zarr$obsp$connectivities, expected_obsp_x)
})

# trackstatus: class=ZarrAnnData, feature=test_set_varp, status=done
test_that("writing varp works", {
  store <- tempfile(fileext = ".zarr")
  create_zarr(store = store)
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  zarr <- ZarrAnnData$new(store, obs = obs, var = var)
  varp_x <- matrix(rnorm(20 * 20), nrow = 20, ncol = 20)
  zarr$varp <- list(connectivities = varp_x)
  # varp should now have dimnames added on-the-fly
  expected_varp_x <- varp_x
  dimnames(expected_varp_x) <- list(zarr$var_names, zarr$var_names)
  expect_identical(zarr$varp$connectivities, expected_varp_x)
})

# trackstatus: class=ZarrAnnData, feature=test_set_uns, status=done
test_that("writing uns works", {
  store <- tempfile(fileext = ".zarr")
  create_zarr(store = store)
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  zarr <- ZarrAnnData$new(store, obs = obs, var = var)
  zarr$uns <- list(
    foo = "bar",
    baz = c(1, 2, 3),
    nested = list(
      nested_foo = "nested_bar",
      nested_baz = c(4L, 5L, 6L)
    )
  )
  expect_identical(zarr$uns$foo, "bar")
  expect_equal(zarr$uns$baz, c(1, 2, 3), ignore_attr = TRUE)
  expect_identical(zarr$uns$nested$nested_foo, "nested_bar")
  expect_equal(zarr$uns$nested$nested_baz, c(4L, 5L, 6L), ignore_attr = TRUE)
})

# ERROR HANDLING ---------------------------------------------------------
test_that("opening a non-existent path in read mode errors", {
  expect_error(
    ZarrAnnData$new(tempfile(fileext = ".zarr"), mode = "r"),
    "does not exist"
  )
})

test_that("opening a non-existent path in r+ mode errors", {
  expect_error(
    ZarrAnnData$new(tempfile(fileext = ".zarr"), mode = "r+"),
    "does not exist"
  )
})

test_that("opening an existing file in exclusive-create mode errors", {
  store <- tempfile(fileext = ".zarr")
  create_zarr(store)
  on.exit(unlink(store, recursive = TRUE))
  expect_error(
    ZarrAnnData$new(store, mode = "w-"),
    "already exists"
  )
})

test_that("writing to a read-only store errors", {
  store <- tempfile(fileext = ".zarr")
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  ZarrAnnData$new(store, obs = obs, var = var)
  on.exit(unlink(store, recursive = TRUE))

  zarr_ro <- ZarrAnnData$new(store, mode = "r")
  expect_error(
    zarr_ro$X <- matrix(rnorm(10 * 20), nrow = 10, ncol = 20),
    "read-only"
  )
})

# CONVERSION -------------------------------------------------------------
test_that("as_ZarrAnnData() round-trip from InMemoryAnnData works", {
  mem <- AnnData(
    X = matrix(1:20, nrow = 4, ncol = 5),
    obs = data.frame(a = 1:4, row.names = paste0("obs", 1:4)),
    var = data.frame(b = 1:5, row.names = paste0("var", 1:5)),
    layers = list(counts = matrix(21:40, nrow = 4, ncol = 5)),
    uns = list(foo = "bar")
  )

  store <- tempfile(fileext = ".zarr")
  on.exit(unlink(store, recursive = TRUE))

  zarr <- as_ZarrAnnData(mem, file = store)
  expect_true(inherits(zarr, "ZarrAnnData"))
  expect_equal(zarr$obs_names, mem$obs_names)
  expect_equal(zarr$var_names, mem$var_names)
  expect_equal(as.matrix(zarr$X), mem$X, ignore_attr = TRUE)
  expect_equal(
    as.matrix(zarr$layers$counts),
    mem$layers$counts,
    ignore_attr = TRUE
  )
  expect_equal(zarr$uns$foo, mem$uns$foo)
})

#' Write H5AD
#'
#' Write an H5AD file
#'
#' @param object The object to write, either a
#'   [`SingleCellExperiment::SingleCellExperiment`] or a
#'   [`SeuratObject::Seurat`] object
#' @param path Path of the file to write to
#' @param compression The compression algorithm to use when writing the HDF5
#'   file. Can be one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param chunk_size The target chunk size in bytes to use when writing HDF5
#'   datasets. When `"auto"` (default), the chunk size is determined
#'   automatically using an algorithm that mimics h5py's auto-chunking
#'   behaviour. Set to `NULL` to disable chunking (contiguous storage,
#'   the rhdf5 default), or a number to use a specific target size in bytes.
#'   This only affects array-like datasets; scalar values are unaffected.
#' @param mode The mode to open the HDF5 file.
#'
#'   * `a` creates a new file or opens an existing one for read/write
#'   * `r+` opens an existing file for read/write
#'   * `w` creates a file, truncating any existing ones
#'   * `w-`/`x` are synonyms creating a file and failing if it already exists
#' @param ... Additional arguments passed to [as_AnnData()]
#'
#' @details
#'
#' ## Compression
#'
#' Compression is currently not supported for Boolean arrays, they will be
#' written uncompressed.
#'
#' ## `NULL` values
#'
#' For compatibility with changes in Python **anndata** 0.12.0, `NULL` values
#' in `uns` are written to H5AD files as a `NULL` dataset (instead of not being
#' written at all). To disable this behaviour, set
#' `option(anndataR.write_null = FALSE)`. This may be required to allow the file
#' to be read by older versions of Python **anndata**.
#'
#' @return `path` invisibly
#' @export
#'
#' @examples
#' adata <- AnnData(
#'   X = matrix(1:5, 3L, 5L),
#'   layers = list(
#'     A = matrix(5:1, 3L, 5L),
#'     B = matrix(letters[1:5], 3L, 5L)
#'   ),
#'   obs = data.frame(row.names = LETTERS[1:3], cell = 1:3),
#'   var = data.frame(row.names = letters[1:5], gene = 1:5)
#' )
#' h5ad_file <- tempfile(fileext = ".h5ad")
#' adata$write_h5ad(h5ad_file)
#'
#' # Write a SingleCellExperiment as an H5AD
#' if (requireNamespace("SingleCellExperiment", quietly = TRUE)) {
#'   ncells <- 100
#'   counts <- matrix(rpois(20000, 5), ncol = ncells)
#'   logcounts <- log2(counts + 1)
#'
#'   pca <- matrix(runif(ncells * 5), ncells)
#'   tsne <- matrix(rnorm(ncells * 2), ncells)
#'
#'   sce <- SingleCellExperiment::SingleCellExperiment(
#'     assays = list(counts = counts, logcounts = logcounts),
#'     reducedDims = list(PCA = pca, tSNE = tsne)
#'   )
#'
#'   adata <- as_AnnData(sce)
#'   h5ad_file <- tempfile(fileext = ".h5ad")
#'   adata$write_h5ad(h5ad_file)
#' }
#'
#' # Write a Seurat as a H5AD
#' if (requireNamespace("Seurat", quietly = TRUE)) {
#'   library(Seurat)
#'
#'   counts <- matrix(1:15, 5L, 3L)
#'   dimnames(counts) <- list(
#'     LETTERS[1:5],
#'     letters[1:3]
#'   )
#'   cell.metadata <- data.frame(
#'     row.names = letters[1:3],
#'     cell = 1:3
#'   )
#'   obj <- CreateSeuratObject(counts, meta.data = cell.metadata)
#'   gene.metadata <- data.frame(
#'     row.names = LETTERS[1:5],
#'     gene = 1:5
#'   )
#'   obj[["RNA"]] <- AddMetaData(GetAssay(obj), gene.metadata)
#'
#'   adata <- as_AnnData(obj)
#'   h5ad_file <- tempfile(fileext = ".h5ad")
#'   adata$write_h5ad(h5ad_file)
#' }
write_h5ad <- function(
  object,
  path,
  compression = c("none", "gzip", "lzf"),
  chunk_size = "auto",
  mode = c("w-", "r", "r+", "a", "w", "x"),
  ...
) {
  mode <- match.arg(mode)
  adata <- if (inherits(object, "AbstractAnnData")) {
    object$as_HDF5AnnData(
      path,
      compression = compression,
      chunk_size = chunk_size,
      mode = mode
    )
  } else {
    as_AnnData(
      object,
      output_class = "HDF5AnnData",
      file = path,
      compression = compression,
      chunk_size = chunk_size,
      mode = mode,
      ...
    )
  }

  rm(adata)
  gc()

  invisible(path)
}

skip_if_not_installed("rhdf5")

requireNamespace("vctrs")

file <- tempfile(pattern = "hdf5_write_", fileext = ".h5ad")
if (file.exists(file)) {
  file.remove(file)
}

file <- rhdf5::H5Fcreate(file)

test_that("Writing H5AD dense arrays works", {
  value <- matrix(rnorm(20), nrow = 5, ncol = 4)

  expect_silent(
    write_h5ad_element(value, file, "dense_array", compression = "none")
  )
  expect_true(hdf5_path_exists(file, "/dense_array"))
  attrs <- rhdf5::h5readAttributes(file, "dense_array", native = FALSE)
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "array")
})

test_that("Writing H5AD dense 3D arrays works", {
  value <- array(rnorm(60), dim = c(5, 4, 3))

  expect_silent(
    write_h5ad_element(
      value,
      file,
      "dense_3d_array",
      compression = "none"
    )
  )
  expect_true(hdf5_path_exists(file, "/dense_3d_array"))
  attrs <- rhdf5::h5readAttributes(file, "dense_3d_array", native = FALSE)
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "array")
})

test_that("Writing H5AD sparse arrays works", {
  array <- matrix(rnorm(20), nrow = 5, ncol = 4)

  csc_array <- as(array, "CsparseMatrix")
  expect_silent(
    write_h5ad_element(csc_array, file, "csc_array", compression = "none")
  )
  expect_true(hdf5_path_exists(file, "/csc_array"))
  expect_true(hdf5_path_exists(file, "/csc_array/data"))
  expect_true(hdf5_path_exists(file, "/csc_array/indices"))
  expect_true(hdf5_path_exists(file, "/csc_array/indptr"))
  attrs <- rhdf5::h5readAttributes(file, "csc_array", native = FALSE)
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "csc_matrix")

  csr_array <- as(array, "RsparseMatrix")
  expect_silent(
    write_h5ad_element(csr_array, file, "csr_array", compression = "none")
  )
  expect_true(hdf5_path_exists(file, "/csr_array"))
  expect_true(hdf5_path_exists(file, "/csr_array/data"))
  expect_true(hdf5_path_exists(file, "/csr_array/indices"))
  expect_true(hdf5_path_exists(file, "/csr_array/indptr"))
  attrs <- rhdf5::h5readAttributes(file, "csr_array", native = FALSE)
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "csr_matrix")
})

test_that("Writing dgeMatrix", {
  value <- matrix(rnorm(20), nrow = 5, ncol = 4) |>
    as("dMatrix") |>
    as("generalMatrix") |>
    as("unpackedMatrix")

  expect_silent(
    write_h5ad_element(value, file, "dgematrix", compression = "none")
  )
  expect_true(hdf5_path_exists(file, "/dgematrix"))
  attrs <- rhdf5::h5readAttributes(file, "dgematrix", native = FALSE)
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "array")
})

test_that("Writing H5AD nullable booleans works", {
  nullable <- c(TRUE, TRUE, FALSE, FALSE, FALSE)
  nullable[5] <- NA

  expect_silent(write_h5ad_element(nullable, file, "nullable_bool"))
  expect_true(hdf5_path_exists(file, "/nullable_bool"))
  attrs <- rhdf5::h5readAttributes(file, "nullable_bool", native = FALSE)
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "nullable-boolean")
})

test_that("Writing H5AD nullable integers works", {
  nullable <- as.integer(1:5)
  nullable[5] <- NA

  expect_silent(write_h5ad_element(nullable, file, "nullable_int"))
  expect_true(hdf5_path_exists(file, "/nullable_int"))
  attrs <- rhdf5::h5readAttributes(file, "nullable_int", native = FALSE)
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "nullable-integer")
})

test_that("Writing H5AD string arrays works", {
  string <- LETTERS[1:5]

  expect_silent(write_h5ad_element(string, file, "string_array"))
  expect_true(hdf5_path_exists(file, "/string_array"))
  attrs <- rhdf5::h5readAttributes(file, "string_array", native = FALSE)
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "string-array")

  string2d <- matrix(LETTERS[1:20], nrow = 5, ncol = 4)

  expect_silent(write_h5ad_element(string2d, file, "string_array2D"))
  expect_true(hdf5_path_exists(file, "/string_array2D"))
  attrs <- rhdf5::h5readAttributes(file, "string_array2D", native = FALSE)
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "string-array")
})

test_that("Writing H5AD categoricals works", {
  categorical <- factor(LETTERS[1:5])

  expect_no_error(write_h5ad_element(categorical, file, "categorical"))
  expect_true(hdf5_path_exists(file, "/categorical"))
  expect_true(hdf5_path_exists(file, "/categorical/categories"))
  expect_true(hdf5_path_exists(file, "/categorical/codes"))
  attrs <- rhdf5::h5readAttributes(file, "categorical", native = FALSE)
  expect_equal(names(attrs), c("encoding-type", "encoding-version", "ordered"))
  expect_equal(attrs[["encoding-type"]], "categorical")
})

test_that("Writing H5AD string scalars works", {
  string <- "A"

  expect_silent(write_h5ad_element(string, file, "string_scalar"))
  expect_true(hdf5_path_exists(file, "/string_scalar"))
  attrs <- rhdf5::h5readAttributes(file, "string_scalar", native = FALSE)
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "string")
})

test_that("Writing H5AD numeric scalars works", {
  number <- 1.0

  expect_silent(write_h5ad_element(number, file, "numeric_scalar"))
  expect_true(hdf5_path_exists(file, "/numeric_scalar"))
  attrs <- rhdf5::h5readAttributes(file, "numeric_scalar", native = FALSE)
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "numeric-scalar")
})

test_that("Writing H5AD mappings works", {
  mapping <- list(
    array = matrix(rnorm(20), nrow = 5, ncol = 4),
    sparse = as(matrix(rnorm(20), nrow = 5, ncol = 4), "CsparseMatrix"),
    string = LETTERS[1:5],
    numeric = rnorm(5),
    scalar = 2
  )

  expect_silent(
    write_h5ad_element(mapping, file, "mapping", compression = "none")
  )
  expect_true(hdf5_path_exists(file, "/mapping"))
  expect_true(hdf5_path_exists(file, "/mapping/array"))
  expect_true(hdf5_path_exists(file, "/mapping/sparse"))
  expect_true(hdf5_path_exists(file, "/mapping/sparse/data"))
  expect_true(hdf5_path_exists(file, "/mapping/sparse/indices"))
  expect_true(hdf5_path_exists(file, "/mapping/sparse/indptr"))
  expect_true(hdf5_path_exists(file, "/mapping/string"))
  expect_true(hdf5_path_exists(file, "/mapping/numeric"))
  expect_true(hdf5_path_exists(file, "/mapping/scalar"))
  attrs <- rhdf5::h5readAttributes(file, "mapping", native = FALSE)
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "dict")
})

test_that("Writing H5AD data frames works", {
  df <- data.frame(
    Letters = letters[1:5],
    Numbers = 1:5
  )

  expect_silent(write_h5ad_element(df, file, "dataframe"))
  expect_true(hdf5_path_exists(file, "/dataframe"))
  expect_true(hdf5_path_exists(file, "/dataframe/Letters"))
  expect_true(hdf5_path_exists(file, "/dataframe/Numbers"))
  expect_true(hdf5_path_exists(file, "/dataframe/_index"))
  attrs <- rhdf5::h5readAttributes(file, "dataframe", native = FALSE)
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "dataframe")
  expect_true(all(c("_index", "column-order") %in% names(attrs)))
  expect_equal(attrs[["_index"]], "_index")
  expect_identical(as.vector(attrs[["column-order"]]), c("Letters", "Numbers"))
})

test_that("writing H5AD from SingleCellExperiment works", {
  skip_if_not_installed("SingleCellExperiment")

  file <- withr::local_file(tempfile(fileext = ".h5ad"))

  sce <- generate_dataset(format = "SingleCellExperiment")
  write_h5ad(sce, file)
  expect_true(file.exists(file))
})

test_that("writing H5AD from Seurat works", {
  skip_if_not_installed("SeuratObject")

  file <- withr::local_file(tempfile(fileext = ".h5ad"))

  seurat <- generate_dataset(format = "Seurat")
  write_h5ad(seurat, file)
  expect_true(file.exists(file))
})

test_that("writing gzip compressed files works", {
  dummy <- generate_dataset(100, 200, example = TRUE)
  non_random_X <- matrix(5, 100, 200) # nolint

  adata <- AnnData(
    X = non_random_X,
    obs = dummy$obs,
    var = dummy$var
  )

  h5ad_file_none <- tempfile(pattern = "hdf5_write_none_", fileext = ".h5ad")
  h5ad_file_gzip <- tempfile(pattern = "hdf5_write_gzip_", fileext = ".h5ad")

  write_h5ad(adata, h5ad_file_none, compression = "none")
  write_h5ad(adata, h5ad_file_gzip, compression = "gzip")

  expect_true(file.info(h5ad_file_none)$size > file.info(h5ad_file_gzip)$size)
})

test_that("writing lzf compressed files works", {
  dummy <- generate_dataset(100, 200, example = FALSE)
  non_random_X <- matrix(5, 100, 200) # nolint

  adata <- AnnData(
    X = non_random_X,
    obs = dummy$obs,
    var = dummy$var
  )

  h5ad_file_none <- tempfile(pattern = "hdf5_write_none_", fileext = ".h5ad")
  h5ad_file_lzf <- tempfile(pattern = "hdf5_write_lzf_", fileext = ".h5ad")

  write_h5ad(adata, h5ad_file_none, compression = "none")
  write_h5ad(adata, h5ad_file_lzf, compression = "lzf")

  expect_true(file.info(h5ad_file_none)$size > file.info(h5ad_file_lzf)$size)
})

test_that("write_h5ad() gives consistent hashes", {
  dummy <- generate_dataset(100, 200, example = TRUE, format = "AnnData")

  file <- withr::local_file(tempfile(fileext = ".h5ad"))

  write_h5ad(dummy, file, mode = "w")
  hash1 <- rlang::hash_file(file)

  write_h5ad(dummy, file, mode = "w")
  hash2 <- rlang::hash_file(file)

  expect_identical(hash1, hash2)
})

test_that("write_h5ad() warns about not writing matrix dim names", {
  dummy <- generate_dataset(100, 200, example = TRUE, format = "AnnData")
  file <- withr::local_file(tempfile(fileext = ".h5ad"))

  dummy$obsm$test <- dummy$obsm$numeric_dense
  colnames(dummy$obsm$test) <- paste0("Test", seq_len(ncol(dummy$obsm$test)))

  expect_warning(
    write_h5ad(dummy, file, mode = "w"),
    "Matrix column names cannot be written"
  )

  dummy$obsm$test <- dummy$obsm$numeric_csparse
  colnames(dummy$obsm$test) <- paste0("Test", seq_len(ncol(dummy$obsm$test)))

  expect_warning(
    write_h5ad(dummy, file, mode = "w"),
    "Matrix column names cannot be written"
  )

  dummy$obsm$test <- NULL
  dummy$varm$test <- dummy$varm$numeric_dense
  colnames(dummy$varm$test) <- paste0("Test", seq_len(ncol(dummy$varm$test)))

  expect_warning(
    write_h5ad(dummy, file, mode = "w"),
    "Matrix column names cannot be written"
  )

  dummy$varm$test <- dummy$varm$numeric_csparse
  colnames(dummy$varm$test) <- paste0("Test", seq_len(ncol(dummy$varm$test)))

  expect_warning(
    write_h5ad(dummy, file, mode = "w"),
    "Matrix column names cannot be written"
  )

  dummy$varm$test <- NULL
  dummy$uns$test <- dummy$uns$mat_numeric_matrix
  rownames(dummy$uns$test) <- paste0("Test", seq_len(nrow(dummy$uns$test)))
  colnames(dummy$uns$test) <- paste0("Test", seq_len(ncol(dummy$uns$test)))

  write_h5ad(dummy, file, mode = "w") |>
    expect_warning("Matrix row names cannot be written") |>
    expect_warning("Matrix column names cannot be written")
})

test_that("write_h5ad() chunk_size = NULL disables chunking", {
  dummy <- generate_dataset(50, 100, format = "AnnData")
  file <- withr::local_file(tempfile(fileext = ".h5ad"))

  expect_no_error(write_h5ad(dummy, file, chunk_size = NULL))
  expect_true(file.exists(file))

  # Data should round-trip correctly with no chunking
  result <- read_h5ad(file)
  expect_equal(result$X, dummy$X)
})

test_that("write_h5ad() chunk_size = 'auto' (default) produces a valid file", {
  dummy <- generate_dataset(50, 100, format = "AnnData")
  file <- withr::local_file(tempfile(fileext = ".h5ad"))

  expect_no_error(write_h5ad(dummy, file, chunk_size = "auto"))
  expect_true(file.exists(file))

  result <- read_h5ad(file)
  expect_equal(result$X, dummy$X)
})

test_that("write_h5ad() chunk_size as a number uses it as target byte size", {
  dummy <- generate_dataset(50, 100, format = "AnnData")
  file <- withr::local_file(tempfile(fileext = ".h5ad"))

  # 64 KB target
  expect_no_error(write_h5ad(dummy, file, chunk_size = 64L * 1024L))
  expect_true(file.exists(file))

  result <- read_h5ad(file)
  expect_equal(result$X, dummy$X)
})

dummy <- generate_dataset(
  n_obs = 10L,
  n_vars = 20L,
  format = "AnnData",
)

file <- tempfile(pattern = "h5ad_write_", fileext = ".h5ad")

test_that("writing H5AD works", {
  expect_no_condition({
    write_h5ad(dummy, file, mode = "w")
  })
})

test_that("reading H5AD to InMemoryAnnData closes file", {
  expect_no_condition({
    read_h5ad(file)
    write_h5ad(dummy, file, mode = "w")
  })
})

test_that("closing HDF5AnnData file works", {
  expect_no_condition({
    adata <- read_h5ad(file, as = "HDF5AnnData")
    adata$close()
    write_h5ad(dummy, file, mode = "w")
  })
})

# helper function to skip tests if we don't have the Python 'zarr' module
# or the R {anndata} package
skip_if_no_zarr <- function() {
  testthat::skip_if_not_installed("reticulate")
  reticulate::py_require("zarr")
  testthat::skip_if_not(
    reticulate::py_module_available("zarr"),
    message = "Python zarr module not available for testing"
  )

  # TODO: Remove when this warning is removed from anndata
  wn <- reticulate::import("warnings")
  wn$filterwarnings(
    "ignore",
    message = "Writing zarr v2 data will no longer be the default"
  )
}

#' Get format config for roundtrip tests
#'
#' Get a list of backend-specific values for a given file format
#'
#' @param fmt Either `"h5ad"` or `"zarr"`
#' @return A named list with elements: `backend`, `ext`, `r_read_fun`,
#'   `r_write_fun`, `py_read_method`, `py_write_method`
get_fmt_config <- function(fmt = c("h5ad", "zarr")) {
  fmt <- match.arg(fmt)

  if (fmt == "zarr") {
    skip_if_no_zarr() # nolint: object_usage_linter
    list(
      backend = "ZarrAnnData",
      ext = ".zarr",
      r_read_fun = read_zarr,
      r_write_fun = write_zarr,
      py_read_method = "read_zarr",
      py_write_method = "write_zarr"
    )
  } else {
    list(
      backend = "HDF5AnnData",
      ext = ".h5ad",
      r_read_fun = read_h5ad,
      r_write_fun = write_h5ad,
      py_read_method = "read_h5ad",
      py_write_method = "write_h5ad"
    )
  }
}

#' Expect AnnData print output to match
#'
#' Compares the print output of an R AnnData object with a Python AnnData
#' object, normalising backend class names before comparing.
#'
#' @param adata_r An R AnnData object
#' @param adata_py A Python AnnData object
expect_anndata_print_equal <- function(adata_r, adata_py) {
  str_r <- capture.output(print(adata_r))
  str_py <- capture.output(print(adata_py))

  # Normalise class names in R output to match Python output
  str_r <- gsub("[^ ]*AnnData", "AnnData", str_r)

  testthat::expect_equal(str_r, str_py)
}

#' @title ReticulateAnnData
#'
#' @description
#' Implementation of an `AnnData` object that wraps a Python **anndata**
#' `AnnData` object using \pkg{reticulate}. This allows direct interaction with
#' Python `AnnData` objects while maintaining the R interface. It is useful when
#' you already have a Python `AnnData` or to access functionality that has not
#' yet been implemented in \pkg{anndataR}.
#'
#' See [AnnData-usage] for details on creating and using `AnnData` objects.
#'
#' @return A `ReticulateAnnData` object
#'
#' @seealso [AnnData-usage] for details on creating and using `AnnData` objects
#'
#' @family AnnData classes
ReticulateAnnData <- R6::R6Class(
  "ReticulateAnnData", # nolint
  inherit = AbstractAnnData,
  cloneable = FALSE,
  private = list(
    .py_anndata = NULL,

    .check_py_object_valid = function() {
      if (is.null(private$.py_anndata)) {
        cli_abort("Python AnnData object is not initialized")
      }
    }
  ),
  active = list(
    #' @field X See [AnnData-usage]
    X = function(value) {
      private$.check_py_object_valid()

      if (missing(value)) {
        # trackstatus: class=ReticulateAnnData, feature=get_X, status=done
        py_to_r(reticulate::py_get_attr(private$.py_anndata, "X"))
      } else {
        # trackstatus: class=ReticulateAnnData, feature=set_X, status=done
        value <- private$.validate_aligned_array(
          value,
          "X",
          shape = c(self$n_obs(), self$n_vars()),
          expected_rownames = rownames(self),
          expected_colnames = colnames(self)
        )
        reticulate::py_set_attr(private$.py_anndata, "X", r_to_py(value))
        self
      }
    },

    #' @field layers See [AnnData-usage]
    layers = function(value) {
      private$.check_py_object_valid()

      if (missing(value)) {
        # trackstatus: class=ReticulateAnnData, feature=get_layers, status=done
        bi <- reticulate::import_builtins()
        out <- list()
        keys <- bi$list(reticulate::py_get_attr(
          private$.py_anndata,
          "layers"
        )$keys())
        for (name in keys) {
          out[[name]] <- py_to_r(reticulate::py_get_attr(
            private$.py_anndata,
            "layers"
          )[[name]])
        }
        out
      } else {
        # trackstatus: class=ReticulateAnnData, feature=set_layers, status=done
        value <- private$.validate_aligned_mapping(
          value,
          "layers",
          c(self$n_obs(), self$n_vars()),
          expected_rownames = rownames(self),
          expected_colnames = colnames(self)
        )
        reticulate::py_set_attr(private$.py_anndata, "layers", r_to_py(value))
        self
      }
    },

    #' @field obs See [AnnData-usage]
    obs = function(value) {
      private$.check_py_object_valid()

      if (missing(value)) {
        # trackstatus: class=ReticulateAnnData, feature=get_obs, status=done
        py_to_r(reticulate::py_get_attr(private$.py_anndata, "obs"))
      } else {
        # trackstatus: class=ReticulateAnnData, feature=set_obs, status=done
        value <- private$.validate_obsvar_dataframe(value, "obs")
        reticulate::py_set_attr(private$.py_anndata, "obs", r_to_py(value))
        self
      }
    },

    #' @field var See [AnnData-usage]
    var = function(value) {
      private$.check_py_object_valid()

      if (missing(value)) {
        # trackstatus: class=ReticulateAnnData, feature=get_var, status=done
        py_to_r(reticulate::py_get_attr(private$.py_anndata, "var"))
      } else {
        # trackstatus: class=ReticulateAnnData, feature=set_var, status=done
        value <- private$.validate_obsvar_dataframe(value, "var")
        reticulate::py_set_attr(private$.py_anndata, "var", r_to_py(value))
        self
      }
    },

    #' @field obs_names See [AnnData-usage]
    obs_names = function(value) {
      private$.check_py_object_valid()

      if (missing(value)) {
        # trackstatus: class=ReticulateAnnData, feature=get_obs_names, status=done
        bi <- reticulate::import_builtins()
        reticulate::py_to_r(bi$list(reticulate::py_get_attr(
          private$.py_anndata,
          "obs_names"
        )))
      } else {
        # trackstatus: class=ReticulateAnnData, feature=set_obs_names, status=done
        reticulate::py_set_attr(
          private$.py_anndata,
          "obs_names",
          reticulate::r_to_py(value)
        )
        self
      }
    },

    #' @field var_names See [AnnData-usage]
    var_names = function(value) {
      private$.check_py_object_valid()

      if (missing(value)) {
        # trackstatus: class=ReticulateAnnData, feature=get_var_names, status=done
        bi <- reticulate::import_builtins()
        reticulate::py_to_r(bi$list(reticulate::py_get_attr(
          private$.py_anndata,
          "var_names"
        )))
      } else {
        # trackstatus: class=ReticulateAnnData, feature=set_var_names, status=done
        reticulate::py_set_attr(
          private$.py_anndata,
          "var_names",
          reticulate::r_to_py(value)
        )
        self
      }
    },

    #' @field obsm See [AnnData-usage]
    obsm = function(value) {
      private$.check_py_object_valid()

      if (missing(value)) {
        # trackstatus: class=ReticulateAnnData, feature=get_obsm, status=done
        py_to_r(reticulate::py_get_attr(private$.py_anndata, "obsm"))
      } else {
        # trackstatus: class=ReticulateAnnData, feature=set_obsm, status=done
        value <- private$.validate_aligned_mapping(
          value,
          "obsm",
          c(self$n_obs()),
          expected_rownames = rownames(self)
        )
        reticulate::py_set_attr(private$.py_anndata, "obsm", r_to_py(value))
        self
      }
    },

    #' @field varm See [AnnData-usage]
    varm = function(value) {
      private$.check_py_object_valid()

      if (missing(value)) {
        # trackstatus: class=ReticulateAnnData, feature=get_varm, status=done
        py_to_r(reticulate::py_get_attr(private$.py_anndata, "varm"))
      } else {
        # trackstatus: class=ReticulateAnnData, feature=set_varm, status=done
        value <- private$.validate_aligned_mapping(
          value,
          "varm",
          c(self$n_vars()),
          expected_rownames = colnames(self)
        )
        reticulate::py_set_attr(private$.py_anndata, "varm", r_to_py(value))
        self
      }
    },

    #' @field obsp See [AnnData-usage]
    obsp = function(value) {
      private$.check_py_object_valid()

      if (missing(value)) {
        # trackstatus: class=ReticulateAnnData, feature=get_obsp, status=done
        py_to_r(reticulate::py_get_attr(private$.py_anndata, "obsp"))
      } else {
        # trackstatus: class=ReticulateAnnData, feature=set_obsp, status=done
        value <- private$.validate_aligned_mapping(
          value,
          "obsp",
          c(self$n_obs(), self$n_obs()),
          expected_rownames = rownames(self),
          expected_colnames = rownames(self)
        )
        reticulate::py_set_attr(private$.py_anndata, "obsp", r_to_py(value))
        self
      }
    },

    #' @field varp See [AnnData-usage]
    varp = function(value) {
      private$.check_py_object_valid()

      if (missing(value)) {
        # trackstatus: class=ReticulateAnnData, feature=get_varp, status=done
        py_to_r(reticulate::py_get_attr(private$.py_anndata, "varp"))
      } else {
        # trackstatus: class=ReticulateAnnData, feature=set_varp, status=done
        value <- private$.validate_aligned_mapping(
          value,
          "varp",
          c(self$n_vars(), self$n_vars()),
          expected_rownames = colnames(self),
          expected_colnames = colnames(self)
        )
        reticulate::py_set_attr(private$.py_anndata, "varp", r_to_py(value))
        self
      }
    },

    #' @field uns See [AnnData-usage]
    uns = function(value) {
      private$.check_py_object_valid()

      if (missing(value)) {
        # trackstatus: class=ReticulateAnnData, feature=get_uns, status=done
        py_to_r(reticulate::py_get_attr(private$.py_anndata, "uns"))
      } else {
        # trackstatus: class=ReticulateAnnData, feature=set_uns, status=done
        value <- private$.validate_named_list(value, "uns")
        reticulate::py_set_attr(private$.py_anndata, "uns", r_to_py(value))
        self
      }
    }
  ),
  public = list(
    #' @description
    #' `ReticulateAnnData` constructor
    #'
    #' @param py_anndata A Python AnnData object created using reticulate, or
    #'   NULL to create a new empty Python AnnData object
    #' @param X See the `X` slot in [AnnData-usage] (only used if py_anndata is NULL)
    #' @param layers See the `layers` slot in [AnnData-usage] (only used if py_anndata is NULL)
    #' @param obs See the `obs` slot in [AnnData-usage] (only used if py_anndata is NULL)
    #' @param var See the `var` slot in [AnnData-usage] (only used if py_anndata is NULL)
    #' @param obsm See the `obsm` slot in [AnnData-usage] (only used if py_anndata is NULL)
    #' @param varm See the `varm` slot in [AnnData-usage] (only used if py_anndata is NULL)
    #' @param obsp See the `obsp` slot in [AnnData-usage] (only used if py_anndata is NULL)
    #' @param varp See the `varp` slot in [AnnData-usage] (only used if py_anndata is NULL)
    #' @param uns See the `uns` slot in [AnnData-usage] (only used if py_anndata is NULL)
    #' @param shape Shape tuple (e.g. `c(n_obs, n_vars)`). Can be provided if
    #'   both `X` or `obs` and `var` are not provided. (only used if py_anndata is NULL)
    #'
    #' @details
    #' The constructor creates a new ReticulateAnnData interface object that
    #' wraps a Python AnnData object. If `py_anndata` is provided, it must be
    #' a valid Python AnnData object. If NULL, a new Python AnnData object
    #' will be created using the other provided arguments.
    initialize = function(
      py_anndata = NULL,
      X = NULL,
      obs = NULL,
      var = NULL,
      layers = NULL,
      obsm = NULL,
      varm = NULL,
      obsp = NULL,
      varp = NULL,
      uns = NULL,
      shape = NULL
    ) {
      check_requires("ReticulateAnnData", "reticulate", where = "CRAN")
      check_requires("ReticulateAnnData", "anndata", where = "Python")

      if (!is.null(py_anndata)) {
        # Use existing Python AnnData object
        if (!inherits(py_anndata, "anndata._core.anndata.AnnData")) {
          cli_abort(
            "{.arg py_anndata} must be a Python AnnData object from {.pkg reticulate}"
          )
        }

        private$.py_anndata <- py_anndata
      } else {
        # Create new Python AnnData object
        anndata <- reticulate::import("anndata", convert = FALSE)

        if (!is.null(X)) {
          # Convert X to Python and create AnnData with proper obs/var names
          py_x <- r_to_py(X)

          # Create obs and var DataFrames with proper row names
          n_obs <- nrow(X)
          n_vars <- ncol(X)

          # Get row and column names, or create defaults
          obs_names <- if (!is.null(rownames(X))) {
            rownames(X)
          } else {
            paste0("cell", seq_len(n_obs))
          }
          var_names <- if (!is.null(colnames(X))) {
            colnames(X)
          } else {
            paste0("gene", seq_len(n_vars))
          }

          # Create DataFrames
          pandas <- reticulate::import("pandas", convert = FALSE)
          py_obs <- pandas$DataFrame(index = reticulate::r_to_py(obs_names))
          py_var <- pandas$DataFrame(index = reticulate::r_to_py(var_names))

          private$.py_anndata <- anndata$AnnData(
            X = py_x,
            obs = py_obs,
            var = py_var
          )
        } else {
          shape <- get_shape(obs, var, X, shape)
          obs <- get_initial_obs(obs, X, shape)
          var <- get_initial_var(var, X, shape)

          # Create empty AnnData with specified obs and var
          pandas <- reticulate::import("pandas", convert = FALSE)

          # For Python AnnData, we need proper index names
          py_obs <- r_to_py(obs)
          py_var <- r_to_py(var)

          # Set proper index names if they don't exist or are auto-generated
          if (
            is.null(rownames(obs)) ||
              all(rownames(obs) == "") ||
              all(rownames(obs) == as.character(seq_len(nrow(obs))))
          ) {
            py_obs$index <- reticulate::r_to_py(paste0(
              "obs",
              seq_len(nrow(obs))
            ))
          }
          if (
            is.null(rownames(var)) ||
              all(rownames(var) == "") ||
              all(rownames(var) == as.character(seq_len(nrow(var))))
          ) {
            py_var$index <- reticulate::r_to_py(paste0(
              "var",
              seq_len(nrow(var))
            ))
          }

          private$.py_anndata <- anndata$AnnData(
            obs = py_obs,
            var = py_var
          )
        }

        # Set other slots if provided (but not obs/var since they're already set)
        if (!is.null(layers)) {
          self$layers <- layers
        }
        if (!is.null(obsm)) {
          self$obsm <- obsm
        }
        if (!is.null(varm)) {
          self$varm <- varm
        }
        if (!is.null(obsp)) {
          self$obsp <- obsp
        }
        if (!is.null(varp)) {
          self$varp <- varp
        }
        if (!is.null(uns)) self$uns <- uns
      }

      self
    },

    #' @description See the `n_obs` field in [AnnData-usage]
    n_obs = function() {
      private$.check_py_object_valid()
      as.integer(reticulate::py_to_r(reticulate::py_get_attr(
        private$.py_anndata,
        "n_obs"
      )))
    },

    #' @description See the `n_vars` field in [AnnData-usage]
    n_vars = function() {
      private$.check_py_object_valid()
      as.integer(reticulate::py_to_r(reticulate::py_get_attr(
        private$.py_anndata,
        "n_vars"
      )))
    },

    #' @description Get the underlying Python AnnData object
    #' @return The Python AnnData object wrapped by this ReticulateAnnData
    py_anndata = function() {
      private$.check_py_object_valid()
      private$.py_anndata
    }
  )
)

#' Convert an `AnnData` to a `ReticulateAnnData`
#'
#' Convert another `AnnData` object to a [`ReticulateAnnData`] object
#'
#' @param adata An `AnnData` object to be converted to [`ReticulateAnnData`]
#'
#' @return A [`ReticulateAnnData`] object with the same data as the input
#'   `AnnData` object
#' @keywords internal
#'
#' @family object converters
#'
#' @examples
#' \donttest{
#' # Requires Python anndata to be installed
#' if (requireNamespace("reticulate", quietly = TRUE) &&
#'       reticulate::py_module_available("anndata")) {
#'   ad <- AnnData(
#'     X = matrix(1:5, 3L, 5L),
#'     layers = list(
#'       A = matrix(5:1, 3L, 5L),
#'       B = matrix(letters[1:5], 3L, 5L)
#'     ),
#'     obs = data.frame(row.names = LETTERS[1:3], cell = 1:3),
#'     var = data.frame(row.names = letters[1:5], gene = 1:5)
#'   )
#'   ad$as_ReticulateAnnData()
#' }
#' }
# nolint start: object_name_linter
as_ReticulateAnnData <- function(adata) {
  # nolint end: object_name_linter
  if (!(inherits(adata, "AbstractAnnData"))) {
    cli_abort(
      "{.arg adata} must be a {.cls AbstractAnnData} but has class {.cls {class(adata)}}"
    )
  }

  ReticulateAnnData$new(
    X = adata$X,
    obs = adata$obs,
    var = adata$var,
    layers = adata$layers,
    obsm = adata$obsm,
    varm = adata$varm,
    obsp = adata$obsp,
    varp = adata$varp,
    uns = adata$uns,
    shape = adata$shape()
  )
}

#' Convert an `AnnData` to a `Seurat`
#'
#' Convert an `AnnData` object to a `Seurat` object
#'
#' @param adata The `AnnData` object to convert.
#' @param assay_name Name of the assay to be created in the new `Seurat` object
#' @param x_mapping A string specifying the name of the layer in the resulting
#'   `Seurat` object where the data in the `X` slot of `adata` will be mapped to
#' @param layers_mapping A named vector where names are names of `Layers` in the
#'   resulting `Seurat` object and values are keys of `layers` in `adata`. See
#'   below for details.
#' @param object_metadata_mapping A named vector where names are cell metadata
#'   columns in the resulting `Seurat` object and values are columns of `obs` in
#'   `adata`. See below for details.
#' @param assay_metadata_mapping A named vector where names are variable
#'   metadata columns in the assay of the resulting `Seurat` object and values
#'   are columns of `var` in `adata`. See below for details.
#' @param reduction_mapping A named vector where names are names of `Embeddings`
#'   in the resulting `Seurat` object and values are keys of `obsm` in `adata`.
#'   Alternatively, a named list where names are names of `Embeddings` in the
#'   resulting `Seurat` object and values are vectors with the items `"key"`,
#'   `"embeddings"` and (optionally) `"loadings"`. See below for details.
#' @param graph_mapping  A named vector where names are names of `Graphs` in the
#'   resulting `Seurat` object and values are keys of `obsp` in `adata`. See
#'   below for details.
#' @param misc_mapping A named vector where names are names of `Misc` in the
#'   resulting `Seurat` object and values are keys of `uns` in `adata`. See
#'   below for details.
#'
#' @details
#'
#' ## Mapping arguments
#'
#' All mapping arguments expect a named character vector where names are the
#' names of the slot in the `Seurat` object and values are the keys of the
#' corresponding slot of `adata`. If `TRUE`, the conversion function will guess
#' which items to copy as described in the conversion table below. In most
#' cases, the default is to copy all items using the same names except where the
#' correspondence between objects is unclear. The `reduction_mapping` argument
#' can also accept a more complex list format, see below for details. To avoid
#' copying anything to a slot, set the mapping argument to `FALSE`. Empty
#' mapping arguments (`NULL`, `c()`, `list()`) will be treated as `FALSE` with
#' a warning. If an unnamed vector is provided, the values will be used as
#' names.
#'
#' ### Examples:
#'
#' - `TRUE` will guess which items to copy as described in the conversion
#'   table
#' - `c(seurat_item = "adata_item")` will copy `adata_item` from the slot in
#'   `adata` to `seurat_item` in the corresponding slot of the new `Seurat`
#'   object
#' - `FALSE` will avoid copying anything to the slot
#' - `c("adata_item")` is equivalent to `c(adata_item = "adata_item")`
#'
#' ## Conversion table
#'
# nolint start: line_length_linter
#'
#' | **From `AnnData`** | **To `Seurat`** | **Example mapping argument** | **Default** |
#' |--------------------|-------------------------------|------------------------------|-----------------------|
#' | `adata$X` | `Layers(seurat)` | `x_mapping = "counts"` _OR_ `layers_mapping = c(counts = NA)` | The data in `adata$X` is copied to a layer named `X` |
#' | `adata$layers` | `Layers(seurat)` | `layers_mapping = c(counts = "counts")` | All items are copied by name |
#' | `adata$obs` | `seurat[[]]` | `object_metadata_mapping = c(n_counts = "n_counts", cell_type = "CellType")` | All columns are copied by name |
#' | `adata$var` | `seurat[[assay_name]][[]]` | `assay_metadata_mapping = c(n_cells = "n_cells", pct_zero = "PctZero")` | All columns are copied by name |
#' | `adata$obsm` | `Reductions(seurat)` | `reduction_mapping = c(pca = "X_pca")` **OR** `reduction_mapping = list(pca = c(key = "PC_", embeddings = "X_pca", loadings = "PCs"))`  | All items that can be coerced to a numeric matrix are copied by name without loadings except for `"X_pca"` for which loadings are added from `"PCs"` |
#' | `adata$obsp` | `Graphs(seurat)` | `graph_mapping = c(nn = "connectivities")` | All items are copied by name |
#' | `adata$varp` | _NA_  | _NA_ | There is no corresponding slot for `varp` |
#' | `adata$uns` | `Misc(seurat)` | `misc_mapping = c(project_metadata = "metadata")` | All items are copied by name |
#'
# nolint end: line_length_linter
#'
#' ## The `reduction_mapping` argument
#'
#' For the simpler named vector format, the names should be the names of
#' `Embeddings` in the resulting `Seurat` object, and the values
#' should be the keys of `obsm` in `adata`. A key will created from the `obsm`
#' key.
#'
#' For more advanced mapping, use the list format where each item is a vector
#' with the following names defining arguments to
#' [SeuratObject::CreateDimReducObject()]:
#'
#' - `key`: the key of the resulting [`SeuratObject::DimReduc`] object, passed
#'   to the `key` argument after processing with [SeuratObject::Key()]
#' - `embeddings`: a key of the `obsm` slot in `adata`,
#'   `adata$obsm[[embeddings]]` is passed to the `embeddings` argument
#' - `loadings`: a key of the `varm` slot in `adata` (optional),
#'   `adata$varm[[loadings]]` is passed to the `loadings` argument
#'
#' ## The `x_mapping` and `layers_mapping` arguments
#'
#' In order to specify where the data in `adata$X` will be stored in the
#' `Layers(seurat)` slot of the resulting object, you can use either the `x_mapping`
#' argument or the `layers_mapping` argument.
#' If you use `x_mapping`, it should be a string specifying the name of the layer
#' in `Layers(seurat)` where the data in `adata$X` will be stored.
#' If you use `layers_mapping`, it should be a named vector where names are names
#' of `Layers(seurat)` and values are keys of `layers` in `adata`.
#' In order to indicate the `adata$X` slot, you use `NA` as the value in the vector.
#' The name you provide for `x_mapping` may not be a name in `layers_mapping`.
#'
#' @return A `Seurat` object containing the requested data from `adata`
#'
#' @family object converters
#'
#' @examplesIf rlang::is_installed("Seurat")
#'   ad <- AnnData(
#'     X = matrix(1:5, 3L, 5L),
#'     obs = data.frame(row.names = LETTERS[1:3], cell = 1:3),
#'     var = data.frame(row.names = letters[1:5], gene = 1:5)
#'   )
#'
#'   # Default usage
#'   seurat <- ad$as_Seurat(
#'     assay_name = "RNA",
#'     x_mapping = "counts",
#'     layers_mapping = TRUE,
#'     object_metadata_mapping = TRUE,
#'     assay_metadata_mapping = TRUE,
#'     reduction_mapping = TRUE,
#'     graph_mapping = TRUE,
#'     misc_mapping = TRUE
#'   )
#'
#' @importFrom Matrix t
# nolint start: object_name_linter
as_Seurat <- function(
  adata,
  assay_name = "RNA",
  x_mapping = NULL,
  layers_mapping = TRUE,
  object_metadata_mapping = TRUE,
  assay_metadata_mapping = TRUE,
  reduction_mapping = TRUE,
  graph_mapping = TRUE,
  misc_mapping = TRUE
) {
  # nolint end: object_name_linter
  check_requires("Converting AnnData to Seurat", c("Seurat", "SeuratObject"))

  if (!(inherits(adata, "AbstractAnnData"))) {
    cli_abort(
      "{.arg adata} must be a {.cls AbstractAnnData} but has class {.cls {class(adata)}}"
    )
  }

  if (any(dim(adata) == 0)) {
    cli_abort(c(
      paste(
        "{.arg adata} must have non-zero dimensions in both axes",
        "to be converted to a {.cls Seurat} object"
      ),
      "i" = "Dimensions are: [{adata$n_obs()}, {adata$n_vars()}]"
    ))
  }

  object_metadata_mapping <- get_mapping(
    object_metadata_mapping,
    .as_Seurat_guess_object_metadata,
    adata,
    "object_metadata_mapping"
  )
  layers_mapping <- get_mapping(
    layers_mapping,
    .as_Seurat_guess_layers,
    adata,
    "layers_mapping"
  )
  assay_metadata_mapping <- get_mapping(
    assay_metadata_mapping,
    .as_Seurat_guess_assay_metadata,
    adata,
    "assay_metadata_mapping"
  )
  reduction_mapping <- get_mapping(
    reduction_mapping,
    .as_Seurat_guess_reductions,
    adata,
    "reduction_mapping"
  )
  graph_mapping <- get_mapping(
    graph_mapping,
    .as_Seurat_guess_graphs,
    adata,
    "graph_mapping"
  )
  misc_mapping <- get_mapping(
    misc_mapping,
    .as_Seurat_guess_misc,
    adata,
    "misc_mapping"
  )

  if (length(adata$layers) == 0 && is.null(adata$X)) {
    cli_abort(
      "{.arg adata} must have a valid {.field X} or at least one {.field layer}"
    )
  }

  # store obs and var names
  obs_names <- adata$obs_names
  var_names <- adata$var_names

  # check seurat layers (which includes the X mapping)
  if (!is.null(x_mapping)) {
    layers_mapping <- setNames(
      c(NA, layers_mapping),
      c(x_mapping, names(layers_mapping))
    )
  } else if (!is.null(adata$X)) {
    layers_mapping[["X"]] <- NA
  }
  if (any(duplicated(names(layers_mapping)))) {
    cli_abort(
      "{.arg layers_mapping} or {.arg x_mapping} must not contain any duplicate names",
      "i" = "Found duplicate names: {.val {names(layers_mapping)[duplicated(names(layers_mapping))]}}"
    )
  }

  # trackstatus: class=Seurat, feature=get_obs, status=done
  object_metadata <- .as_Seurat_process_metadata(
    adata,
    object_metadata_mapping,
    "obs"
  )

  # trackstatus: class=Seurat, feature=get_X, status=done
  # trackstatus: class=Seurat, feature=get_layers, status=done
  obj <- .as_Seurat_create_object_with_layers(
    adata,
    layers_mapping,
    object_metadata,
    assay_name
  )

  # trackstatus: class=Seurat, feature=get_var, status=done
  assay_metadata <- .as_Seurat_process_metadata(
    adata,
    assay_metadata_mapping,
    "var"
  )

  if (ncol(assay_metadata) != 0) {
    obj[[assay_name]] <- SeuratObject::AddMetaData(
      obj[[assay_name]],
      metadata = assay_metadata
    )
  }

  # make sure obs and var names are set properly
  # trackstatus: class=Seurat, feature=get_obs_names, status=done
  # trackstatus: class=Seurat, feature=get_var_names, status=done
  colnames(obj) <- obs_names
  rownames(obj) <- var_names

  if (!rlang::is_empty(reduction_mapping)) {
    reductions <- .as_Seurat_process_reduction_mapping(
      adata,
      reduction_mapping,
      assay_name
    )
    for (.red in names(reductions)) {
      obj[[.red]] <- reductions[[.red]]
    }
  }

  # trackstatus: class=Seurat, feature=get_obsp, status=done
  if (!rlang::is_empty(graph_mapping)) {
    for (i in seq_along(graph_mapping)) {
      graph_name <- names(graph_mapping)[[i]]
      graph <- graph_mapping[[i]]

      if (!(graph %in% adata$obsp_keys())) {
        cli_abort(c(
          "The requested item {.val {graph}} does not exist in {.code adata$obsp}",
          "i" = "{.code adata$obsp_keys()}: {.val {adata$obsp_keys()}}"
        ))
      }

      obsp <- adata$obsp[[graph]]
      dimnames(obsp) <- list(obs_names, obs_names)
      obsp_gr <- Seurat::as.Graph(obsp)
      SeuratObject::DefaultAssay(obsp_gr) <- assay_name
      obj[[paste0(assay_name, "_", graph_name)]] <- obsp_gr
    }
  }

  # trackstatus: class=Seurat, feature=get_uns, status=done
  if (!rlang::is_empty(misc_mapping)) {
    misc_names <- names(misc_mapping)

    for (i in seq_along(misc_names)) {
      misc_name <- misc_names[[i]]
      uns_key <- misc_mapping[[i]]

      if (!(uns_key %in% adata$uns_keys())) {
        cli_abort(c(
          "The requested item {.val {uns_key}} does not exist in {.code adata$uns}",
          "i" = "{.code adata$uns_keys()}: {.val {adata$uns_keys()}}"
        ))
      }

      SeuratObject::Misc(obj, misc_name) <- adata$uns[[uns_key]]
    }
  }

  obj
}

# nolint start: object_name_linter
.as_Seurat_is_atomic_character <- function(x) {
  # nolint end: object_name_linter
  is.character(x) && length(x) == 1 && !is.na(x)
}

# nolint start: object_name_linter
.as_Seurat_get_matrix_by_key <- function(adata, mapping, key) {
  # nolint end: object_name_linter
  if (!key %in% names(mapping)) {
    return(NULL)
  }
  layer_name <- mapping[[key]]

  .as_Seurat_get_matrix(adata, layer_name)
}

# nolint start: object_name_linter
.as_Seurat_get_matrix <- function(adata, layer_name) {
  # nolint end: object_name_linter
  if (is.na(layer_name)) {
    return(to_R_matrix(adata$X))
  }

  if (!.as_Seurat_is_atomic_character(layer_name)) {
    cli_abort(
      "{.arg layer_name} must be a {.cls character} vector of length 1",
      call = rlang::caller_env()
    )
  }

  if (!layer_name %in% names(adata$layers)) {
    cli_abort(
      "{.arg layer_name} must be the name of a layer or {.val NULL}",
    )
  }

  # check if dgRMatrix and convert to dgCMatrix
  to_R_matrix(adata$layers[[layer_name]])
}

# nolint start: object_name_linter
.as_Seurat_create_object_with_layers <- function(
  # nolint end: object_name_linter
  adata,
  layers_mapping,
  object_metadata,
  assay_name
) {
  if (
    !"counts" %in% names(layers_mapping) &&
      !"data" %in% names(layers_mapping)
  ) {
    cli_warn(paste(
      "No {.val counts} or {.val data} layer found in {.arg names(layers_mapping)},",
      "this may lead to unexpected results when using the resulting {.cls Seurat} object."
    ))
  }

  if (!"counts" %in% names(layers_mapping)) {
    # If there's no counts in the layers_mapping,
    # we will consider the first layer as "dummy counts"
    # And use it temporarily as the counts layer
    dummy_counts <- names(layers_mapping)[[1]]
  } else {
    dummy_counts <- "counts"
  }

  counts <- .as_Seurat_get_matrix_by_key(adata, layers_mapping, dummy_counts)
  dimnames(counts) <- list(adata$var_names, adata$obs_names)

  obj <- SeuratObject::CreateSeuratObject(
    meta.data = object_metadata,
    assay = assay_name,
    counts = counts
  )

  # If we have used the dummy counts layer,
  # we need to add the actual dummy counts layer to the object
  # and remove the counts layer
  if (!"counts" %in% names(layers_mapping)) {
    SeuratObject::LayerData(obj, layer = dummy_counts) <- counts
    SeuratObject::DefaultLayer(obj[[assay_name]]) <- dummy_counts
    obj[[assay_name]]$counts <- NULL
  }

  # Add all other layers to the object
  for (i in seq_along(layers_mapping)) {
    layer_name <- names(layers_mapping)[i]
    if (layer_name != dummy_counts) {
      SeuratObject::LayerData(
        obj,
        layer = layer_name,
      ) <- .as_Seurat_get_matrix_by_key(adata, layers_mapping, layer_name)
    }
  }

  obj
}

# nolint start: object_name_linter
.as_Seurat_process_reduction <- function(
  # nolint end: object_name_linter
  adata,
  assay_name,
  key,
  obsm_embedding,
  varm_loadings
) {
  if (!.as_Seurat_is_atomic_character(key)) {
    cli_abort(
      "{.arg key} must be a {.cls character} vector of length 1",
      call = rlang::caller_env()
    )
  }

  if (!.as_Seurat_is_atomic_character(obsm_embedding)) {
    cli_abort(
      "{.arg obsm_embedding} must be a {.cls character} vector of length 1",
      call = rlang::caller_env()
    )
  }

  if (
    !is.null(varm_loadings) && !.as_Seurat_is_atomic_character(varm_loadings)
  ) {
    cli_abort(
      paste(
        "{.arg varm_loadings} must be a {.cls character} vector of length 1 or",
        "{.val NULL}, but is a {.cls {class(varm_loadings)[1]}}"
      ),
      call = rlang::caller_env()
    )
  }

  if (!(obsm_embedding %in% adata$obsm_keys())) {
    cli_abort(
      c(
        "The requested item {.val {obsm_embedding}} does not exist in {.code adata$obsm}",
        "i" = "{.code adata$obsm_keys()}: {.val {adata$obsm_keys()}}"
      ),
      call = rlang::caller_env()
    )
  }

  embed <- as.matrix(adata$obsm[[obsm_embedding]])
  rownames(embed) <- adata$obs_names

  if (!is.numeric(embed)) {
    cli_abort(
      "Embedding matrix for key {.val {key}} must be {.cls numeric} but is {.cls {typeof(embed)}}"
    )
  }

  loadings <-
    if (is.null(varm_loadings)) {
      new(Class = "matrix")
    } else if (!(varm_loadings %in% adata$varm_keys())) {
      cli_abort(
        c(
          "The requested item {.val {varm_loadings}} does not exist in {.code adata$varm}",
          "i" = "{.code adata$varm_keys()}: {.val {adata$varm_keys()}}"
        ),
        call = rlang::caller_env()
      )
    } else {
      load <- as.matrix(adata$varm[[varm_loadings]])
      rownames(load) <- adata$var_names
      load
    }

  if (!grepl(SeuratObject::.KeyPattern(), key)) {
    new_key <- SeuratObject::Key(key, quiet = TRUE)
    cli_warn(paste(
      "Key {.val {key}} does not match the expected pattern,",
      "it has been replaced with {.val {new_key}}"
    ))
    key <- new_key
  }

  allowed_colnames <- paste0(key, seq_len(ncol(embed)))
  if (!identical(colnames(embed), allowed_colnames)) {
    if (!rlang::is_empty(colnames(embed))) {
      cli_warn(paste(
        "Embedding column names do not match what is allowed for key {.val {key}},",
        "setting them to the allowed column names"
      ))
    }
    colnames(embed) <- allowed_colnames
  }

  SeuratObject::CreateDimReducObject(
    embeddings = embed,
    loadings = loadings,
    key = key,
    assay = assay_name,
    global = TRUE
  )
}

# trackstatus: class=Seurat, feature=get_obsm, status=done
# trackstatus: class=Seurat, feature=get_varm, status=done
# nolint start: object_length_linter object_name_linter
.as_Seurat_process_reduction_mapping <- function(
  adata,
  reduction_mapping,
  assay_name
) {
  # nolint end: object_length_linter object_name_linter

  # If reduction_mapping is a vector convert it to the list format
  if (is.atomic(reduction_mapping)) {
    reduction_mapping <- purrr::map(reduction_mapping, function(.obsm) {
      c(
        key = SeuratObject::Key(.obsm, quiet = TRUE),
        embeddings = .obsm
      )
    })
  }

  reductions <- list()

  # Process each reduction
  for (i in seq_along(reduction_mapping)) {
    reduction_name <- names(reduction_mapping)[[i]]
    reduction <- reduction_mapping[[i]]

    if (
      is.null(names(reduction)) ||
        !all(names(reduction) %in% c("key", "embeddings", "loadings")) ||
        !all(c("key", "embeddings") %in% names(reduction))
    ) {
      cli_abort(c(
        paste(
          "Each item in {.arg reduction_mapping} must be a {.cls character} vector",
          "with names {style_vec(c('key', 'embeddings', 'loadings'),",
          "last = ' and (optionally) ')}"
        ),
        "i" = "Item {.val {i}} has names: {.val {names(reduction)}}"
      ))
    }

    varm_loadings <- reduction["loadings"]
    if (is.na(varm_loadings)) {
      varm_loadings <- NULL
    }

    dr <- .as_Seurat_process_reduction(
      adata = adata,
      assay_name = assay_name,
      key = reduction["key"],
      obsm_embedding = reduction["embeddings"],
      varm_loadings = varm_loadings
    )

    if (!is.null(dr)) {
      reductions[[reduction_name]] <- dr
    }
  }

  reductions
}

# nolint start: object_name_linter
.as_Seurat_process_metadata <- function(adata, mapping, slot) {
  # nolint end: object_name_linter
  mapped <- adata[[slot]][unlist(mapping)]
  names(mapped) <- names(mapping)
  mapped
}

# nolint start: object_name_linter object_length_linter
.as_Seurat_guess_layers <- function(adata) {
  # nolint end: object_name_linter object_length_linter
  self_name(adata$layers_keys())
}


# nolint start: object_name_linter
.as_Seurat_process_metadata <- function(adata, mapping, slot) {
  # nolint end: object_name_linter
  mapped <- adata[[slot]][unlist(mapping)]
  names(mapped) <- names(mapping)
  mapped
}


# nolint start: object_name_linter object_length_linter
.as_Seurat_guess_reductions <- function(adata) {
  # nolint end: object_name_linter object_length_linter
  purrr::map(adata$obsm_keys(), function(.obsm) {
    if (!is.numeric(as.matrix(adata$obsm[[.obsm]]))) {
      return(NULL)
    }

    mapping <- c(
      # Make sure we have valid keys here to avoid warnings later
      key = SeuratObject::Key(.obsm, quiet = TRUE),
      embeddings = .obsm
    )
    if (.obsm == "X_pca" && "PCs" %in% names(adata$varm)) {
      mapping["loadings"] <- "PCs"
    }

    mapping
  }) |>
    setNames(adata$obsm_keys()) |>
    purrr::compact()
}

# nolint start: object_name_linter object_length_linter
.as_Seurat_guess_graphs <- function(adata) {
  # nolint end: object_name_linter object_length_linter
  self_name(adata$obsp_keys())
}

# nolint start: object_name_linter object_length_linter
.as_Seurat_guess_misc <- function(adata) {
  # nolint end: object_name_linter object_length_linter
  self_name(adata$uns_keys())
}

# nolint start: object_name_linter object_length_linter
.as_Seurat_guess_object_metadata <- function(adata) {
  # nolint end: object_name_linter object_length_linter
  self_name(adata$obs_keys())
}

# nolint start: object_name_linter object_length_linter
.as_Seurat_guess_assay_metadata <- function(adata) {
  # nolint end: object_name_linter object_length_linter
  self_name(adata$var_keys())
}

test_that("as_Seurat() fails gracefully", {
  expect_error(as_Seurat(), regexp = "adata.*is missing")
  expect_error(as_Seurat("foo"), regexp = "must be a <AbstractAnnData>")
})

skip_if_not_installed("Seurat")
library(Seurat)

known_issues <- read_known_issues()

ad <- generate_dataset(n_obs = 10L, n_vars = 20L, format = "AnnData")
ad$obsm[["X_pca"]] <- matrix(1:50, 10, 5)
ad$varm[["PCs"]] <- matrix(1:100, 20, 5)
ad$layers["counts"] <- ad$layers["numeric_csparse"]

# Remove column names to avoid warnings
for (name in c("integer", "numeric", "integer_with_nas", "numeric_with_nas")) {
  colnames(ad$obsm[[name]]) <- NULL
}

seu <- ad$as_Seurat()

test_that("as_Seurat retains number of observations and features", {
  expect_equal(nrow(seu), 20)
  expect_equal(ncol(seu), 10)

  # trackstatus: class=Seurat, feature=test_get_var_names, status=done
  expect_equal(rownames(seu), rownames(ad$var))
  # trackstatus: class=Seurat, feature=test_get_obs_names, status=done
  expect_equal(colnames(seu), rownames(ad$obs))
})

# trackstatus: class=Seurat, feature=test_get_obs, status=done
for (obs_key in colnames(ad$obs)) {
  test_that(paste0("as_Seurat retains obs key: ", obs_key), {
    msg <- message_if_known(
      backend = "to_Seurat",
      slot = c("obs"),
      dtype = obs_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(obs_key %in% colnames(seu[[]]))
    expect_equal(
      seu[[]][[obs_key]],
      ad$obs[[obs_key]],
      info = paste0("obs_key: ", obs_key),
      ignore_attr = TRUE
    )
  })
}

# trackstatus: class=Seurat, feature=test_get_var, status=done
for (var_key in colnames(ad$var)) {
  test_that(paste0("as_Seurat retains var key: ", var_key), {
    msg <- message_if_known(
      backend = "to_Seurat",
      slot = c("var"),
      dtype = var_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    active_assay <- seu[[DefaultAssay(seu)]]
    expect_true(var_key %in% colnames(active_assay[[]]))
    expect_equal(active_assay[[var_key]][[1]], ad$var[[var_key]])
  })
}


# trackstatus: class=Seurat, feature=test_get_layers, status=done
for (layer_key in names(ad$layers)) {
  test_that(paste0("as_Seurat retains layer: ", layer_key), {
    msg <- message_if_known(
      backend = "to_Seurat",
      slot = c("layers"),
      dtype = layer_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    active_assay <- seu[[DefaultAssay(seu)]]
    expect_true(layer_key %in% active_assay[])
    expect_true(
      all.equal(
        as.matrix(t(active_assay[layer_key])),
        as.matrix(ad$layers[[layer_key]]),
        check.attributes = FALSE
      ),
      info = paste0("layer_key: ", layer_key)
    )
  })
}

# trackstatus: class=Seurat, feature=test_get_uns, status=done
for (uns_key in names(ad$uns)) {
  test_that(paste0("as_Seurat retains uns key: ", uns_key), {
    msg <- message_if_known(
      backend = "to_Seurat",
      slot = c("uns"),
      dtype = uns_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(uns_key %in% names(Misc(seu)))
    expect_equal(Misc(seu)[[uns_key]], ad$uns[[uns_key]], ignore_attr = TRUE)
  })
}

test_that("as_Seurat retains pca dimred", {
  msg <- message_if_known(
    backend = "to_Seurat",
    slot = c("obsm"),
    dtype = "pca",
    process = "convert",
    known_issues = known_issues
  )

  skip_if(!is.null(msg), message = msg)

  # trackstatus: class=Seurat, feature=test_get_obsm, status=wip
  expect_true("X_pca" %in% Reductions(seu))
  expect_equal(
    Embeddings(seu, reduction = "X_pca"),
    ad$obsm[["X_pca"]],
    ignore_attr = TRUE
  )

  # trackstatus: class=Seurat, feature=test_get_varm, status=wip
  expect_equal(
    Loadings(seu, reduction = "X_pca"),
    ad$varm[["PCs"]],
    ignore_attr = TRUE
  )
})

test_that("as_Seurat works with list mappings", {
  expect_no_error(
    ad$as_Seurat(
      object_metadata_mapping = as.list(.as_Seurat_guess_object_metadata(ad)),
      layers_mapping = as.list(.as_Seurat_guess_layers(ad)),
      assay_metadata_mapping = as.list(.as_Seurat_guess_assay_metadata(ad)),
      reduction_mapping = as.list(.as_Seurat_guess_reductions(ad)),
      graph_mapping = as.list(.as_Seurat_guess_graphs(ad)),
      misc_mapping = as.list(.as_Seurat_guess_misc(ad))
    )
  )

  expect_error(
    ad$as_Seurat(
      reduction_mapping = list(numeric = "numeric_matrix")
    )
  )
})

test_that("as_Seurat works with a vector reduction_mapping", {
  expect_no_error(
    ad$as_Seurat(reduction_mapping = c(numeric = "numeric_matrix"))
  )
})

test_that("as_Seurat works with unnamed mappings", {
  expect_no_error(
    ad$as_Seurat(
      object_metadata_mapping = unname(.as_Seurat_guess_object_metadata(ad)),
      layers_mapping = c(
        na.omit(unname(.as_Seurat_guess_layers(ad))),
        data = NA
      ),
      assay_metadata_mapping = unname(.as_Seurat_guess_assay_metadata(ad)),
      graph_mapping = unname(.as_Seurat_guess_graphs(ad)),
      misc_mapping = unname(.as_Seurat_guess_misc(ad))
    )
  )
})

test_that("as_Seurat works with a 0 dim AnnData", {
  adata <- AnnData(X = as(matrix(nrow = 10, ncol = 0), "dgCMatrix"))

  expect_error(
    adata$as_Seurat(layers_mapping = c(counts = NA)),
    "must have non-zero dimensions"
  )
})

vector_generators <- list(
  character = function(n) paste0("value_", seq(from = 0, to = n - 1)),
  integer = function(n) seq(from = 0, to = n - 1),
  factor = function(n) factor(rep(c("Value1", "Value2"), length.out = n)),
  factor_ordered = function(n) {
    factor(rep(c("Value1", "Value2"), length.out = n), ordered = TRUE)
  },
  logical = function(n) rep(c(TRUE, FALSE), length.out = n),
  numeric = function(n) seq(from = 0.5, to = n),
  character_with_nas = function(n) {
    x <- paste0("value", seq_len(n))
    x[seq(1, n, by = 2)] <- NA_character_
    x
  },
  integer_with_nas = function(n) {
    x <- seq(from = 0, to = n - 1)
    x[1] <- NA_integer_
    x
  },
  factor_with_nas = function(n) {
    x <- factor(rep(c("Value1", "Value2"), length.out = n))
    x[1] <- NA_character_
    x
  },
  factor_ordered_with_nas = function(n) {
    x <- factor(rep(c("Value1", "Value2"), length.out = n), ordered = TRUE)
    x[1] <- NA_character_
    x
  },
  logical_with_nas = function(n) {
    x <- rep(c(TRUE, FALSE), length.out = n)
    x[1] <- NA
    x
  },
  numeric_with_nas = function(n) {
    x <- runif(n)
    x[seq(1, n, by = 2)] <- NA_real_
    x
  }
)

#' Generate a vector
#'
#' Generate a vector of a given type
#'
#' @param n Number of elements to generate
#' @param type Type of vector to generate
#'
#' @return A vector of the given type
#'
#' @noRd
#'
#' @examples
#' generate_vector(10L)
generate_vector <- function(n, type = names(vector_generators)) {
  type <- match.arg(type)
  vector_generators[[type]](n)
}

skip_if_not_installed("rhdf5")

requireNamespace("vctrs")

file <- system.file("extdata", "example.h5ad", package = "anndataR")

test_that("opening H5AD works", {
  adata <- HDF5AnnData$new(file, mode = "r")
  expect_true(inherits(adata, "HDF5AnnData"))
  adata$close()
})

adata <- HDF5AnnData$new(file, mode = "r")

# GETTERS ----------------------------------------------------------------
# trackstatus: class=HDF5AnnData, feature=test_get_X, status=done
test_that("reading X works", {
  X <- adata$X
  expect_s4_class(X, "dgRMatrix")
  expect_equal(dim(X), c(50, 100))
})

# trackstatus: class=HDF5AnnData, feature=test_get_layers, status=done
test_that("reading layers works", {
  layers <- adata$layers
  expect_true(is.list(layers), "list")
  expect_equal(
    names(layers),
    c("counts", "csc_counts", "dense_X", "dense_counts")
  )
})

# trackstatus: class=HDF5AnnData, feature=test_get_obsm, status=done
test_that("reading obsm works", {
  obsm <- adata$obsm
  expect_true(is.list(obsm), "list")
  expect_equal(
    names(obsm),
    c("X_pca", "X_umap")
  )
})

# trackstatus: class=HDF5AnnData, feature=test_get_varm, status=done
test_that("reading varm works", {
  varm <- adata$varm
  expect_true(is.list(varm), "list")
  expect_equal(
    names(varm),
    c("PCs")
  )
})

# trackstatus: class=HDF5AnnData, feature=test_get_obsp, status=done
test_that("reading obsp works", {
  obsp <- adata$obsp
  expect_true(is.list(obsp), "list")
  expect_equal(
    names(obsp),
    c("connectivities", "distances")
  )
})

# trackstatus: class=HDF5AnnData, feature=test_get_varp, status=done
test_that("reading varp works", {
  varp <- adata$varp
  expect_true(is.list(varp), "list")
  expect_equal(
    names(varp),
    c("test_varp")
  )
})

# trackstatus: class=HDF5AnnData, feature=test_get_obs, status=done
test_that("reading obs works", {
  obs <- adata$obs
  expect_s3_class(obs, "data.frame")
  expect_equal(
    colnames(obs),
    c(
      "Float",
      "FloatNA",
      "Int",
      "IntNA",
      "Bool",
      "BoolNA",
      "n_genes_by_counts",
      "log1p_n_genes_by_counts",
      "total_counts",
      "log1p_total_counts",
      "leiden"
    )
  )
})

# trackstatus: class=HDF5AnnData, feature=test_get_var, status=done
test_that("reading var works", {
  var <- adata$var
  expect_s3_class(var, "data.frame")
  expect_equal(
    colnames(var),
    c(
      "String",
      "n_cells_by_counts",
      "mean_counts",
      "log1p_mean_counts",
      "pct_dropout_by_counts",
      "total_counts",
      "log1p_total_counts",
      "highly_variable",
      "means",
      "dispersions",
      "dispersions_norm"
    )
  )
})

# trackstatus: class=HDF5AnnData, feature=test_get_obs_names, status=done
test_that("reading obs names works", {
  obs_names <- adata$obs_names
  expect_vector(obs_names, ptype = character(), size = 50)
})

# trackstatus: class=HDF5AnnData, feature=test_get_var_names, status=done
test_that("reading var names works", {
  var_names <- adata$var_names
  expect_vector(var_names, ptype = character(), size = 100)
})

# SETTERS ----------------------------------------------------------------
test_that("creating empty H5AD works", {
  h5ad_file <- withr::local_tempfile(fileext = ".h5ad")
  expect_silent(HDF5AnnData$new(file = h5ad_file))
})

# trackstatus: class=HDF5AnnData, feature=test_set_X, status=done
test_that("writing X works", {
  h5ad_file <- withr::local_tempfile(fileext = ".h5ad")
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  h5ad <- HDF5AnnData$new(h5ad_file, obs = obs, var = var)

  X <- matrix(rnorm(10 * 20), nrow = 10, ncol = 20)
  expect_silent(h5ad$X <- X)
})

# trackstatus: class=HDF5AnnData, feature=test_set_layers, status=done
test_that("writing layers works", {
  h5ad_file <- withr::local_tempfile(fileext = ".h5ad")
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  h5ad <- HDF5AnnData$new(h5ad_file, obs = obs, var = var)

  X <- matrix(rnorm(10 * 20), nrow = 10, ncol = 20)
  expect_silent(h5ad$layers <- list(layer1 = X, layer2 = X))
})

# trackstatus: class=HDF5AnnData, feature=test_set_obs, status=done
test_that("writing obs works", {
  h5ad_file <- withr::local_tempfile(fileext = ".h5ad")
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  h5ad <- HDF5AnnData$new(h5ad_file, obs = obs, var = var)

  obs <- data.frame(
    Letters = LETTERS[1:10],
    Numbers = 1:10,
    row.names = paste0("Row", 1:10)
  )
  h5ad$obs <- obs
  expect_identical(h5ad$obs_names, paste0("Row", 1:10))
})

# trackstatus: class=HDF5AnnData, feature=test_set_var, status=done
test_that("writing var works", {
  h5ad_file <- withr::local_tempfile(fileext = ".h5ad")
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  h5ad <- HDF5AnnData$new(h5ad_file, obs = obs, var = var)

  var <- data.frame(
    Letters = LETTERS[1:20],
    Numbers = 1:20,
    row.names = paste0("Row", 1:20)
  )
  h5ad$var <- var
  expect_identical(h5ad$var_names, paste0("Row", 1:20))
})

# trackstatus: class=HDF5AnnData, feature=test_set_obs_names, status=done
test_that("writing obs names works", {
  h5ad_file <- withr::local_tempfile(fileext = ".h5ad")
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  h5ad <- HDF5AnnData$new(h5ad_file, obs = obs, var = var)

  h5ad$obs_names <- LETTERS[1:10]
  expect_identical(h5ad$obs_names, LETTERS[1:10])
})

# trackstatus: class=HDF5AnnData, feature=test_set_var_names, status=done
test_that("writing var names works", {
  h5ad_file <- withr::local_tempfile(fileext = ".h5ad")
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  h5ad <- HDF5AnnData$new(h5ad_file, obs = obs, var = var)

  h5ad$var_names <- LETTERS[1:20]
  expect_identical(h5ad$var_names, LETTERS[1:20])
})

# trackstatus: class=HDF5AnnData, feature=test_set_obsm, status=done
test_that("writing obsm works", {
  h5ad_file <- withr::local_tempfile(fileext = ".h5ad")
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  h5ad <- HDF5AnnData$new(h5ad_file, obs = obs, var = var)

  obsm_x <- matrix(rnorm(10 * 5), nrow = 10, ncol = 5)
  h5ad$obsm <- list(X = obsm_x)
  # obsm should now have rownames added on-the-fly
  expected_obsm_x <- obsm_x
  rownames(expected_obsm_x) <- h5ad$obs_names
  expect_identical(h5ad$obsm$X, expected_obsm_x)
})

# trackstatus: class=HDF5AnnData, feature=test_set_varm, status=done
test_that("writing varm works", {
  h5ad_file <- withr::local_tempfile(fileext = ".h5ad")
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  h5ad <- HDF5AnnData$new(h5ad_file, obs = obs, var = var)
  varm_x <- matrix(rnorm(20 * 5), nrow = 20, ncol = 5)
  h5ad$varm <- list(PCs = varm_x)
  # varm should now have rownames added on-the-fly
  expected_varm_x <- varm_x
  rownames(expected_varm_x) <- h5ad$var_names
  expect_identical(h5ad$varm$PCs, expected_varm_x)
})

# trackstatus: class=HDF5AnnData, feature=test_set_obsp, status=done
test_that("writing obsp works", {
  h5ad_file <- withr::local_tempfile(fileext = ".h5ad")
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  h5ad <- HDF5AnnData$new(h5ad_file, obs = obs, var = var)

  obsp_x <- matrix(rnorm(10 * 10), nrow = 10, ncol = 10)
  h5ad$obsp <- list(connectivities = obsp_x)
  # obsp should now have dimnames added on-the-fly
  expected_obsp_x <- obsp_x
  dimnames(expected_obsp_x) <- list(h5ad$obs_names, h5ad$obs_names)
  expect_identical(h5ad$obsp$connectivities, expected_obsp_x)
})

# trackstatus: class=HDF5AnnData, feature=test_set_varp, status=done
test_that("writing varp works", {
  h5ad_file <- withr::local_tempfile(fileext = ".h5ad")
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  h5ad <- HDF5AnnData$new(h5ad_file, obs = obs, var = var)

  varp_x <- matrix(rnorm(20 * 20), nrow = 20, ncol = 20)
  h5ad$varp <- list(connectivities = varp_x)
  # varp should now have dimnames added on-the-fly
  expected_varp_x <- varp_x
  dimnames(expected_varp_x) <- list(h5ad$var_names, h5ad$var_names)
  expect_identical(h5ad$varp$connectivities, expected_varp_x)
})

# trackstatus: class=HDF5AnnData, feature=test_set_uns, status=done
test_that("writing uns works", {
  h5ad_file <- withr::local_tempfile(fileext = ".h5ad")
  obs <- data.frame(row.names = 1:10)
  var <- data.frame(row.names = 1:20)
  h5ad <- HDF5AnnData$new(h5ad_file, obs = obs, var = var)

  h5ad$uns <- list(
    foo = "bar",
    baz = c(1, 2, 3),
    nested = list(
      nested_foo = "nested_bar",
      nested_baz = c(4L, 5L, 6L)
    )
  )
  expect_identical(h5ad$uns$foo, "bar")
  expect_equal(h5ad$uns$baz, c(1, 2, 3), ignore_attr = TRUE)
  expect_identical(h5ad$uns$nested$nested_foo, "nested_bar")
  expect_equal(h5ad$uns$nested$nested_baz, c(4L, 5L, 6L), ignore_attr = TRUE)
})

#' Convert a SingleCellExperiment object to an AnnData object
#'
#' @param sce See [as_AnnData()]
#' @param x_mapping See [as_AnnData()]
#' @param layers_mapping See [as_AnnData()]
#' @param obs_mapping See [as_AnnData()]
#' @param var_mapping See [as_AnnData()]
#' @param obsm_mapping See [as_AnnData()]
#' @param varm_mapping See [as_AnnData()]
#' @param obsp_mapping See [as_AnnData()]
#' @param varp_mapping See [as_AnnData()]
#' @param uns_mapping See [as_AnnData()]
#' @param output_class See [as_AnnData()]
#' @param ... See [as_AnnData()]
#'
#' @return An `AnnData` object
#' @noRd
# nolint start: object_name_linter
from_SingleCellExperiment <- function(
  # nolint end: object_name_linter
  sce,
  x_mapping = NULL,
  layers_mapping = TRUE,
  obs_mapping = TRUE,
  var_mapping = TRUE,
  obsm_mapping = TRUE,
  varm_mapping = TRUE,
  obsp_mapping = TRUE,
  varp_mapping = TRUE,
  uns_mapping = TRUE,
  output_class = c(
    "InMemory",
    "HDF5AnnData",
    "ZarrAnnData",
    "ReticulateAnnData"
  ),
  ...
) {
  check_requires(
    "Converting SingleCellExperiment to AnnData",
    "SingleCellExperiment",
    "Bioc"
  )

  output_class <- match.arg(output_class)

  if (!(inherits(sce, "SingleCellExperiment"))) {
    cli_abort(
      "{.arg sce} must be a {.cls SingleCellExperiment} but has class {.cls {sce}}"
    )
  }

  assay_names <- SummarizedExperiment::assayNames(sce)
  if (
    length(SummarizedExperiment::assays(sce)) > 0 &&
      (is.null(assay_names) || any(assay_names == ""))
  ) {
    if (is.null(assay_names)) {
      assay_names <- paste0(
        "assay",
        seq_along(SummarizedExperiment::assays(sce))
      )
    } else {
      empty_names <- which(assay_names == "")
      assay_names[empty_names] <- paste0("assay", empty_names)
    }

    cli_warn(c(
      paste(
        "Some {.field assays} in {.arg sce} are missing names.",
        "They will automatically be named for conversion."
      ),
      "!" = "Old assay names: {style_vec(SummarizedExperiment::assayNames(sce))}",
      "i" = "New assay names: {style_vec(assay_names)}"
    ))
    SummarizedExperiment::assayNames(sce) <- assay_names
  }

  layers_mapping <- get_mapping(
    layers_mapping,
    .from_SCE_guess_layers,
    sce,
    "layers_mapping",
    x_mapping = x_mapping
  )
  obs_mapping <- get_mapping(
    obs_mapping,
    .from_SCE_guess_all,
    sce,
    "obs_mapping",
    slot = SingleCellExperiment::colData
  )
  var_mapping <- get_mapping(
    var_mapping,
    .from_SCE_guess_all,
    sce,
    "var_mapping",
    slot = SingleCellExperiment::rowData
  )
  obsm_mapping <- get_mapping(
    obsm_mapping,
    .from_SCE_guess_obsm,
    sce,
    "obsm_mapping"
  )
  varm_mapping <- get_mapping(
    varm_mapping,
    .from_SCE_guess_varm,
    sce,
    "varm_mapping"
  )
  obsp_mapping <- get_mapping(
    obsp_mapping,
    .from_SCE_guess_obspvarp,
    sce,
    "obsp_mapping",
    slot = SingleCellExperiment::colPairs
  )
  varp_mapping <- get_mapping(
    varp_mapping,
    .from_SCE_guess_obspvarp,
    sce,
    "varp_mapping",
    slot = SingleCellExperiment::rowPairs
  )
  uns_mapping <- get_mapping(
    uns_mapping,
    .from_SCE_guess_all,
    sce,
    "uns_mapping",
    slot = S4Vectors::metadata
  )

  generator <- get_anndata_constructor(output_class)
  adata <- generator$new(shape = rev(dim(sce)), ...)

  # Fill in slots in the object
  .from_SCE_process_obs(adata, sce, obs_mapping)

  .from_SCE_process_var(adata, sce, var_mapping)

  # trackstatus: class=SingleCellExperiment, feature=set_X, status=done
  if (!is.null(x_mapping)) {
    adata$X <- .from_SCE_convert(
      SummarizedExperiment::assay(sce, x_mapping, withDimnames = FALSE)
    )
  }

  .from_SCE_process_layers(adata, sce, layers_mapping)

  .from_SCE_process_obsm(adata, sce, obsm_mapping)

  .from_SCE_process_varm(adata, sce, varm_mapping)

  .from_SCE_process_obsp(adata, sce, obsp_mapping)

  .from_SCE_process_varp(adata, sce, varp_mapping)

  .from_SCE_process_uns(adata, sce, uns_mapping)

  adata
}

# nolint start: object_length_linter object_name_linter
.from_SCE_guess_all <- function(sce, slot) {
  # nolint end: object_length_linter object_name_linter
  self_name(names(slot(sce)))
}

# nolint start: object_length_linter object_name_linter
.from_SCE_guess_layers <- function(sce, x_mapping) {
  # nolint end: object_length_linter object_name_linter
  layers_mapping <- self_name(SummarizedExperiment::assayNames(sce))

  if (!is.null(x_mapping)) {
    layers_mapping <- layers_mapping[layers_mapping != x_mapping]
  }

  if (rlang::is_empty(layers_mapping)) {
    c()
  } else {
    layers_mapping
  }
}

# nolint start: object_length_linter object_name_linter
.from_SCE_guess_obsm <- function(sce) {
  # nolint end: object_length_linter object_name_linter
  obsm_mapping <- self_name(SingleCellExperiment::reducedDimNames(sce))

  if (rlang::is_empty(obsm_mapping)) {
    c()
  } else {
    obsm_mapping
  }
}

# nolint start: object_length_linter object_name_linter
.from_SCE_guess_varm <- function(sce) {
  # nolint end: object_length_linter object_name_linter
  varm_mapping <- c()

  for (reduction_name in names(SingleCellExperiment::reducedDims(sce))) {
    reduction <- SingleCellExperiment::reducedDim(sce, reduction_name)
    if (inherits(reduction, "LinearEmbeddingMatrix")) {
      varm_mapping[reduction_name] <- reduction_name
    } else if ("rotation" %in% names(attributes(reduction))) {
      cli_warn(paste(
        "Reduction {.val {reduction_name}} in SCE object has a {.attr rotation} attribute,",
        "but is not a {.cls LinearEmbeddingMatrix}.",
        "To include the {.attr rotation} information in {.code varm},",
        "convert it to a {.cls LinearEmbeddingMatrix} first."
      ))
    }
  }

  varm_mapping
}

# If sce is a SummarizedExperiment, return an empty mapping
# nolint start: object_length_linter object_name_linter
.from_SCE_guess_obspvarp <- function(sce, slot) {
  # nolint end: object_length_linter object_name_linter
  .from_SCE_guess_all(sce, slot)
}

# Convert BioConductor-specific objects to base R objects
# Convert matrices
# Convert dgCMatrix to dgRMatrix
# nolint start: object_length_linter object_name_linter
.from_SCE_convert <- function(object, transpose = TRUE) {
  # nolint end: object_length_linter object_name_linter
  if (inherits(object, "DataFrame")) {
    as.data.frame(object)
  } else if (inherits(object, "SimpleList")) {
    as.list(object)
  } else if (inherits(object, "matrix") || inherits(object, "Matrix")) {
    if (inherits(object, "denseMatrix")) {
      object <- as.matrix(object)
    }
    if (transpose) {
      to_py_matrix(object)
    } else {
      object
    }
  } else {
    if (!is.data.frame(object) && !is.list(object)) {
      cli_warn(c(
        paste(
          "Converting unknown object of class {.cls {class(object)[1]}} from",
          "{.cls SingleCellExperiment}"
        ),
        "!" = "It will be returned as is but this may result in other errors",
        "i" = paste(
          "This may be solved by converting to a {.cls matrix}/{.cls Matrix},",
          "{.cls data.frame}/{.cls DataFrame}, or {.cls list}/{.cls SimpleList}"
        )
      ))
    }

    object
  }
}

# trackstatus: class=SingleCellExperiment, feature=set_obs_names, status=done
# trackstatus: class=SingleCellExperiment, feature=set_obs, status=done
# nolint start: object_name_linter
.from_SCE_process_obs <- function(adata, sce, obs_mapping) {
  # nolint end: object_name_linter

  if (is.null(colnames(sce)) && rlang::is_empty(obs_mapping)) {
    adata$obs <- data.frame(matrix(nrow = ncol(sce), ncol = 0))
  } else {
    adata$obs <- purrr::map(obs_mapping, function(.item) {
      # Check if the column exists
      if (!.item %in% names(SingleCellExperiment::colData(sce))) {
        cli_abort(c(
          "Column {.val {obs_mapping[[.item]]}} not found in SCE object.",
          "i" = "Available columns: {.val {names(SingleCellExperiment::colData(sce))}}"
        ))
      }
      SingleCellExperiment::colData(sce)[[.item]]
    }) |>
      as.data.frame(row.names = colnames(sce)) |>
      setNames(names(obs_mapping))
  }
}

# trackstatus: class=SingleCellExperiment, feature=set_var_names, status=done
# trackstatus: class=SingleCellExperiment, feature=set_var, status=done
# nolint start: object_name_linter
.from_SCE_process_var <- function(adata, sce, var_mapping) {
  # nolint end: object_name_linter

  # store an empty data.frame to keep the var names
  if (is.null(rownames(sce)) && rlang::is_empty(var_mapping)) {
    adata$var <- data.frame(matrix(nrow = nrow(sce), ncol = 0))
  } else {
    adata$var <- purrr::map(var_mapping, function(.item) {
      # Check if the column exists
      if (!.item %in% names(SingleCellExperiment::rowData(sce))) {
        cli_abort(c(
          "Column {.val {var_mapping[[.item]]}} not found in SCE object.",
          "i" = "Available columns: {.val {names(SingleCellExperiment::rowData(sce))}}"
        ))
      }
      SingleCellExperiment::rowData(sce)[[.item]]
    }) |>
      as.data.frame(row.names = rownames(sce)) |>
      setNames(names(var_mapping))
  }
}

# trackstatus: class=SingleCellExperiment, feature=set_layers, status=done
# nolint start: object_length_linter object_name_linter
.from_SCE_process_layers <- function(adata, sce, layers_mapping) {
  # nolint end: object_length_linter object_name_linter
  if (rlang::is_empty(layers_mapping)) {
    return(invisible())
  }

  adata$layers <- purrr::map(layers_mapping, function(.layer) {
    .from_SCE_convert(SummarizedExperiment::assay(sce, .layer))
  })
}

# trackstatus: class=SingleCellExperiment, feature=set_obsm, status=done
# nolint start: object_name_linter
.from_SCE_process_obsm <- function(adata, sce, obsm_mapping) {
  # nolint end: object_name_linter
  if (rlang::is_empty(obsm_mapping)) {
    return(invisible())
  }

  adata$obsm <- purrr::imap(obsm_mapping, function(reduction_name, obsm_key) {
    # Check if the reduction exists
    if (!reduction_name %in% names(SingleCellExperiment::reducedDims(sce))) {
      cli_abort(c(
        "Reduction {.val {reduction_name}} not found in SCE object.",
        "i" = "Available reductions: {.val {names(SingleCellExperiment::reducedDims(sce))}}"
      ))
    }

    reduction <- SingleCellExperiment::reducedDim(sce, reduction_name)
    if (inherits(reduction, "LinearEmbeddingMatrix")) {
      SingleCellExperiment::sampleFactors(reduction)
    } else {
      reduction
    }
  })
}

# trackstatus: class=SingleCellExperiment, feature=set_varm, status=done
# nolint start: object_name_linter
.from_SCE_process_varm <- function(adata, sce, varm_mapping) {
  # nolint end: object_name_linter
  if (rlang::is_empty(varm_mapping)) {
    return(invisible())
  }

  adata$varm <- purrr::map(varm_mapping, function(reduction_name) {
    # Check if the reduction exists
    if (!reduction_name %in% names(SingleCellExperiment::reducedDims(sce))) {
      cli_abort(c(
        "Reduction {.val {reduction_name}} not found in SCE object.",
        "i" = "Available reductions: {.val {names(SingleCellExperiment::reducedDims(sce))}}"
      ))
    }

    reduction <- SingleCellExperiment::reducedDim(sce, reduction_name)
    if (!inherits(reduction, "LinearEmbeddingMatrix")) {
      cli_abort(paste(
        "{.code reducedDim(sce, {.val {reduction_name}}} must be a {.cls LinearEmbeddingMatrix}",
        "but has class {.cls {class(reduction)[1]}}"
      ))
    }

    loadings <- SingleCellExperiment::featureLoadings(reduction)
    if (nrow(loadings) != adata$n_vars()) {
      cli_abort(paste(
        "The number of rows ({.val {nrow(loadings)}}) in the loadings for ",
        "reduction {.val {reduction_name}} does not match {.code adata$n_vars()}",
        "({.val {adata$n_vars()}})"
      ))
    }

    loadings
  })
}

# trackstatus: class=SingleCellExperiment, feature=set_obsp, status=done
# nolint start: object_length_linter object_name_linter
.from_SCE_process_obsp <- function(adata, sce, obsp_mapping) {
  # nolint end: object_length_linter object_name_linter
  if (rlang::is_empty(obsp_mapping)) {
    return(invisible())
  }

  adata$obsp <- purrr::map(obsp_mapping, function(colpair_name) {
    # Check if the colPair exists
    if (!(colpair_name %in% SingleCellExperiment::colPairNames(sce))) {
      cli_abort(c(
        "colPair {.val {colpair_name}} not found in SCE object.",
        "i" = "Available colPairs: {.val {names(SingleCellExperiment::colPairs(sce))}}"
      ))
    }

    .from_SCE_convert(
      SingleCellExperiment::colPair(sce, colpair_name, asSparse = TRUE),
      transpose = FALSE
    )
  })
}

# trackstatus: class=SingleCellExperiment, feature=set_varp, status=done
# nolint start: object_length_linter object_name_linter
.from_SCE_process_varp <- function(adata, sce, varp_mapping) {
  # nolint end: object_length_linter object_name_linter
  if (rlang::is_empty(varp_mapping)) {
    return(invisible())
  }

  adata$varp <- purrr::map(varp_mapping, function(rowpair_name) {
    # Check if the rowPair exists
    if (!(rowpair_name %in% SingleCellExperiment::rowPairNames(sce))) {
      cli_abort(c(
        "rowPair {.val {rowpair_name}} not found in SCE object.",
        "i" = "Available rowPairs: {.val {names(SingleCellExperiment::rowPairs(sce))}}"
      ))
    }

    .from_SCE_convert(
      SingleCellExperiment::rowPair(sce, rowpair_name, asSparse = TRUE),
      transpose = FALSE
    )
  })
}

# trackstatus: class=SingleCellExperiment, feature=set_uns, status=done
# nolint start: object_length_linter object_name_linter
.from_SCE_process_uns <- function(adata, sce, uns_mapping) {
  # nolint end: object_length_linter object_name_linter
  if (rlang::is_empty(uns_mapping)) {
    return(invisible())
  }

  adata$uns <- purrr::map(uns_mapping, function(meta_name) {
    # Check if the metadata exists
    if (!(meta_name %in% names(S4Vectors::metadata(sce)))) {
      cli_abort(c(
        "Metadata {.val {meta_name}} not found in SCE object.",
        "i" = "Available metadata: {.val {names(S4Vectors::metadata(sce))}}"
      ))
    }

    S4Vectors::metadata(sce)[[meta_name]]
  })
}

skip_if_not_installed("SingleCellExperiment")
library(SingleCellExperiment)

known_issues <- read_known_issues()

ad <- generate_dataset(n_obs = 10L, n_vars = 20L, format = "AnnData")
ad$obsm[["X_pca"]] <- matrix(1:50, 10, 5)
ad$varm[["PCs"]] <- matrix(1:100, 20, 5)

# TODO: Build an SCE rather than converting
sce <- ad$as_SingleCellExperiment()
ad <- as_AnnData(sce)

test_that("as_AnnData (SCE) retains observations and features", {
  expect_equal(nrow(sce), 20)
  expect_equal(ncol(sce), 10)

  # trackstatus: class=SingleCellExperiment, feature=test_set_obs_names, status=done
  expect_equal(colnames(sce), rownames(ad$obs))
  # trackstatus: class=SingleCellExperiment, feature=test_set_var_names, status=done
  expect_equal(rownames(sce), rownames(ad$var))
})

# trackstatus: class=SingleCellExperiment, feature=test_set_obs, status=done
for (obs_key in colnames(colData(sce))) {
  test_that(paste0("as_AnnData (SCE) retains obs key: ", obs_key), {
    msg <- message_if_known(
      backend = "from_SCE",
      slot = c("obs"),
      dtype = obs_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(obs_key %in% colnames(ad$obs))
    expect_equal(
      ad$obs[[obs_key]],
      colData(sce)[[obs_key]],
      info = paste0("obs_key: ", obs_key)
    )
  })
}

# trackstatus: class=SingleCellExperiment, feature=test_set_var, status=done
for (var_key in colnames(rowData(sce))) {
  test_that(paste0("as_AnnData (SCE) retains var key: ", var_key), {
    msg <- message_if_known(
      backend = "from_SCE",
      slot = c("var"),
      dtype = var_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(var_key %in% colnames(ad$var))
    expect_equal(
      ad$var[[var_key]],
      rowData(sce)[[var_key]],
      info = paste0("var_key: ", var_key)
    )
  })
}

# trackstatus: class=SingleCellExperiment, feature=test_set_layers, status=done
for (layer_key in assayNames(sce)) {
  test_that(paste0("as_AnnData (SCE) retains layer: ", layer_key), {
    msg <- message_if_known(
      backend = "from_SCE",
      slot = c("layers"),
      dtype = layer_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(layer_key %in% names(ad$layers))
    expect_true(
      all.equal(
        as.matrix(ad$layers[[layer_key]]),
        as.matrix(t(assay(sce, layer_key))),
        ignore_attr = TRUE
      ),
      info = paste0("layer_key: ", layer_key)
    )
  })
}

# trackstatus: class=SingleCellExperiment, feature=test_set_obsp, status=done
for (obsp_key in names(colPairs(sce))) {
  test_that(paste0("as_AnnData (SCE) retains obsp key: ", obsp_key), {
    msg <- message_if_known(
      backend = "from_SCE",
      slot = c("obsp"),
      dtype = obsp_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(obsp_key %in% names(ad$obsp))
    # AnnData now adds dimnames on-the-fly, but SCE doesn't preserve them
    # So we need to strip dimnames for comparison
    actual_mat <- ad$obsp[[obsp_key]]
    expected_mat <- colPairs(sce, asSparse = TRUE)[[obsp_key]]
    dimnames(actual_mat) <- NULL
    dimnames(expected_mat) <- NULL
    expect_equal(
      actual_mat,
      expected_mat,
      ignore_attr = TRUE,
      info = paste0("obsp_key: ", obsp_key)
    )
  })
}

# trackstatus: class=SingleCellExperiment, feature=test_set_varp, status=done
for (varp_key in names(rowPairs(sce))) {
  test_that(paste0("as_AnnData (SCE) retains varp key: ", varp_key), {
    msg <- message_if_known(
      backend = "from_SCE",
      slot = c("varp"),
      dtype = varp_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(varp_key %in% names(ad$varp))
    # AnnData now adds dimnames on-the-fly, but SCE doesn't preserve them
    # So we need to strip dimnames for comparison
    actual_mat <- ad$varp[[varp_key]]
    expected_mat <- rowPairs(sce, asSparse = TRUE)[[varp_key]]
    dimnames(actual_mat) <- NULL
    dimnames(expected_mat) <- NULL
    expect_equal(
      actual_mat,
      expected_mat,
      info = paste0("varp_key: ", varp_key)
    )
  })
}

# trackstatus: class=SingleCellExperiment, feature=test_set_uns, status=done
for (uns_key in names(metadata(sce))) {
  test_that(paste0("as_AnnData (SCE) retains uns key: ", uns_key), {
    msg <- message_if_known(
      backend = "from_SCE",
      slot = c("uns"),
      dtype = uns_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(uns_key %in% names(ad$uns))
    expect_equal(
      ad$uns[[uns_key]],
      metadata(sce)[[uns_key]],
      info = paste0("uns_key: ", uns_key)
    )
  })
}

test_that("as_AnnData (SCE) retains pca dimred", {
  msg <- message_if_known(
    backend = "from_SCE",
    slot = c("obsm", "varm"),
    dtype = "pca",
    process = "convert",
    known_issues = known_issues
  )
  skip_if(!is.null(msg), message = msg)

  # trackstatus: class=SingleCellExperiment, feature=test_set_obsm, status=wip
  expect_true("X_pca" %in% names(ad$obsm))
  expect_equal(
    sampleFactors(reducedDims(sce)$X_pca),
    ad$obsm[["X_pca"]]
  )

  # trackstatus: class=SingleCellExperiment, feature=test_set_varm, status=wip
  expect_true("X_pca" %in% names(ad$varm))
  # AnnData now adds dimnames on-the-fly, but SCE doesn't preserve them
  # So we need to strip dimnames for comparison
  actual_mat <- ad$varm[["X_pca"]]
  expected_mat <- featureLoadings(reducedDims(sce)$X_pca)
  dimnames(actual_mat) <- NULL
  dimnames(expected_mat) <- NULL
  expect_equal(
    expected_mat,
    actual_mat
  )
})

test_that("as_AnnData (SCE) works with list mappings", {
  expect_no_error(
    as_AnnData(
      sce,
      layers_mapping = as.list(.from_SCE_guess_layers(sce, NULL)),
      obs_mapping = as.list(.from_SCE_guess_all(sce, colData)),
      var_mapping = as.list(.from_SCE_guess_all(sce, rowData)),
      obsm_mapping = as.list(.from_SCE_guess_obsm(sce)),
      varm_mapping = as.list(.from_SCE_guess_varm(sce)),
      obsp_mapping = as.list(.from_SCE_guess_obspvarp(sce, colPairs)),
      varp_mapping = as.list(.from_SCE_guess_obspvarp(sce, rowPairs)),
      uns_mapping = as.list(.from_SCE_guess_all(sce, S4Vectors::metadata))
    )
  )
})

test_that("as_AnnData (SCE) works with unnamed mappings", {
  expect_no_error(
    as_AnnData(
      sce,
      layers_mapping = unname(.from_SCE_guess_layers(sce, NULL)),
      obs_mapping = unname(.from_SCE_guess_all(sce, colData)),
      var_mapping = unname(.from_SCE_guess_all(sce, rowData)),
      obsm_mapping = unname(.from_SCE_guess_obsm(sce)),
      varm_mapping = unname(.from_SCE_guess_varm(sce)),
      obsp_mapping = unname(.from_SCE_guess_obspvarp(sce, colPairs)),
      varp_mapping = unname(.from_SCE_guess_obspvarp(sce, rowPairs)),
      uns_mapping = unname(.from_SCE_guess_all(sce, S4Vectors::metadata))
    )
  )
})

test_that("as_AnnData (SCE) works with empty mappings", {
  expect_warning(as_AnnData(sce, layers_mapping = NULL), "argument is empty")
  expect_warning(as_AnnData(sce, layers_mapping = c()), "argument is empty")
})

obs_mapping <- c(obs1 = "character", obs2 = "numeric")
var_mapping <- c(var1 = "character", var2 = "numeric")
layers_mapping <- c(counts = "integer_matrix", data = "numeric_matrix")

ad_partial <- as_AnnData(
  sce,
  layers_mapping = layers_mapping,
  obs_mapping = obs_mapping,
  var_mapping = var_mapping,
  obsm_mapping = FALSE,
  varm_mapping = FALSE,
  obsp_mapping = FALSE,
  varp_mapping = FALSE,
  uns_mapping = FALSE
)

for (obs_key in names(obs_mapping)) {
  obs_from <- obs_mapping[[obs_key]]
  test_that(paste0("as_AnnData (SCE) retains obs key: ", obs_key), {
    msg <- message_if_known(
      backend = "from_SCE",
      slot = c("obs"),
      dtype = obs_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(obs_key %in% colnames(ad_partial$obs))
    expect_equal(
      ad_partial$obs[[obs_key]],
      colData(sce)[[obs_from]],
      info = paste0("obs_key: ", obs_key)
    )
  })
}

for (var_key in names(var_mapping)) {
  var_from <- var_mapping[[var_key]]
  test_that(paste0("as_AnnData (SCE) retains var key: ", var_key), {
    msg <- message_if_known(
      backend = "from_SCE",
      slot = c("var"),
      dtype = var_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(var_key %in% colnames(ad_partial$var))
    expect_equal(
      ad_partial$var[[var_key]],
      rowData(sce)[[var_from]],
      info = paste0("var_key: ", var_key)
    )
  })
}

test_that("as_AnnData (SCE) does not copy unmapped structs", {
  msg <- message_if_known(
    backend = "from_SCE",
    slot = c("obsm", "varm", "obsp", "varp", "uns"),
    dtype = "unmapped",
    process = "convert",
    known_issues = known_issues
  )
  skip_if(!is.null(msg), message = msg)

  expect_true(is.null(ad_partial$obsm))
  expect_true(is.null(ad_partial$varm))
  expect_true(is.null(ad_partial$obsp))
  expect_true(is.null(ad_partial$varp))
  expect_true(is.null(ad_partial$uns))
})

test_that("as_AnnData (SCE) handles unnamed assays", {
  mat <- matrix(1:20, nrow = 5, ncol = 4)
  sce <- SingleCellExperiment(assays = list(mat))

  expect_warning(ad <- as_AnnData(sce), "missing names")
  expect_identical(ad$layers_keys(), "assay1")

  sce <- SingleCellExperiment(assays = list("mat" = mat, mat))
  expect_warning(ad <- as_AnnData(sce), "missing names")
  expect_identical(ad$layers_keys(), c("mat", "assay2"))
})

#' Convert a Seurat object to an AnnData object
#'
#' @param seurat_obj See [as_AnnData()]
#' @param assay_name See [as_AnnData()]
#' @param x_mapping See [as_AnnData()]
#' @param layers_mapping See [as_AnnData()]
#' @param obs_mapping See [as_AnnData()]
#' @param var_mapping See [as_AnnData()]
#' @param obsm_mapping See [as_AnnData()]
#' @param varm_mapping See [as_AnnData()]
#' @param obsp_mapping See [as_AnnData()]
#' @param varp_mapping See [as_AnnData()]
#' @param uns_mapping See [as_AnnData()]
#' @param output_class See [as_AnnData()]
#' @param ... See [as_AnnData()]
#'
#' @return An `AnnData` object
#' @noRd
# nolint start: object_name_linter
from_Seurat <- function(
  # nolint end: object_name_linter
  seurat_obj,
  assay_name = NULL,
  x_mapping = NULL,
  layers_mapping = TRUE,
  obs_mapping = TRUE,
  var_mapping = TRUE,
  obsm_mapping = TRUE,
  varm_mapping = TRUE,
  obsp_mapping = TRUE,
  varp_mapping = TRUE,
  uns_mapping = TRUE,
  output_class = c(
    "InMemory",
    "HDF5AnnData",
    "ZarrAnnData",
    "ReticulateAnnData"
  ),
  ...
) {
  check_requires("Converting Seurat to AnnData", c("SeuratObject", "Seurat"))

  output_class <- match.arg(output_class)

  if (!inherits(seurat_obj, "Seurat")) {
    cli_abort(
      "{.arg seurat_obj} must be a {.cls Seurat} object but has class {.cls {class(seurat_obj)}}"
    )
  }

  if (is.null(assay_name)) {
    assay_name <- SeuratObject::DefaultAssay(seurat_obj)
  }

  if (!(assay_name %in% SeuratObject::Assays(seurat_obj))) {
    cli_abort(c(
      "{.arg assay_name} is not an assay in {.arg seurat_obj}",
      "i" = "{.code Assays(seurat_obj)}: {.val {SeuratObject::Assays(seurat_obj)}}"
    ))
  }

  # Set the default assay so we can easily get the dimensions etc.
  SeuratObject::DefaultAssay(seurat_obj) <- assay_name

  layers_mapping <- get_mapping(
    layers_mapping,
    .from_Seurat_guess_layers,
    seurat_obj,
    "layers_mapping",
    assay_name = assay_name
  )
  obs_mapping <- get_mapping(
    obs_mapping,
    .from_Seurat_guess_obs,
    seurat_obj,
    "obs_mapping",
    assay_name = assay_name
  )
  var_mapping <- get_mapping(
    var_mapping,
    .from_Seurat_guess_var,
    seurat_obj,
    "var_mapping",
    assay_name = assay_name
  )
  obsm_mapping <- get_mapping(
    obsm_mapping,
    .from_Seurat_guess_obsms,
    seurat_obj,
    "obsm_mapping",
    assay_name = assay_name
  )
  varm_mapping <- get_mapping(
    varm_mapping,
    .from_Seurat_guess_varms,
    seurat_obj,
    "varm_mapping",
    assay_name = assay_name
  )
  obsp_mapping <- get_mapping(
    obsp_mapping,
    .from_Seurat_guess_obsps,
    seurat_obj,
    "obsp_mapping",
    assay_name = assay_name
  )
  varp_mapping <- get_mapping(
    varp_mapping,
    .from_Seurat_guess_varps,
    seurat_obj,
    "varp_mapping"
  )
  uns_mapping <- get_mapping(
    uns_mapping,
    .from_Seurat_guess_uns,
    seurat_obj,
    "uns_mapping"
  )

  generator <- get_anndata_constructor(output_class)
  adata <- generator$new(shape = rev(dim(seurat_obj)), ...)

  # Fill in slots in the object
  .from_Seurat_process_obs(
    adata,
    seurat_obj,
    assay_name,
    obs_mapping
  )

  .from_Seurat_process_var(
    adata,
    seurat_obj,
    assay_name,
    var_mapping
  )

  # trackstatus: class=Seurat, feature=set_X, status=done
  if (!is.null(x_mapping)) {
    adata$X <- to_py_matrix(SeuratObject::LayerData(seurat_obj, x_mapping))
  }

  .from_Seurat_process_layers(
    adata,
    seurat_obj,
    assay_name,
    layers_mapping
  )

  .from_Seurat_process_obsm(
    adata,
    seurat_obj,
    assay_name,
    obsm_mapping
  )

  .from_Seurat_process_varm(
    adata,
    seurat_obj,
    assay_name,
    varm_mapping
  )

  .from_Seurat_process_obsp(
    adata,
    seurat_obj,
    assay_name,
    obsp_mapping
  )

  .from_Seurat_process_varp(
    adata,
    seurat_obj,
    assay_name,
    varp_mapping
  )

  .from_Seurat_process_uns(
    adata,
    seurat_obj,
    assay_name,
    uns_mapping
  )

  adata
}

# trackstatus: class=Seurat, feature=set_obs_names, status=done
# trackstatus: class=Seurat, feature=set_obs, status=done
# nolint start: object_name_linter
.from_Seurat_process_obs <- function(
  adata,
  seurat_obj,
  assay_name,
  obs_mapping
) {
  # nolint end: object_name_linter

  if (!rlang::is_empty(obs_mapping)) {
    if (!all(obs_mapping %in% names(seurat_obj[[]]))) {
      missing <- setdiff(obs_mapping, names(seurat_obj[[]])) # nolint object_usage_linter
      cli_abort(paste(
        "The requested obs item(s) {.val {missing}} do not exist in the Seurat",
        "object ({.code names(seurat_obj[[]])})"
      ))
    }
    adata$obs <- seurat_obj[[unlist(obs_mapping)]] |>
      setNames(names(obs_mapping))
  } else {
    # Store an empty data.frame to keep the obs names
    adata$obs <- data.frame(row.names = colnames(seurat_obj))
  }
}

# trackstatus: class=Seurat, feature=set_var_names, status=done
# trackstatus: class=Seurat, feature=set_var, status=done
# nolint start: object_name_linter
.from_Seurat_process_var <- function(
  adata,
  seurat_obj,
  assay_name,
  var_mapping
) {
  # nolint end: object_name_linter
  if (!rlang::is_empty(var_mapping)) {
    if (!all(var_mapping %in% names(seurat_obj[[assay_name]][[]]))) {
      missing <- setdiff(var_mapping, names(seurat_obj[[assay_name]][[]])) # nolint object_usage_linter
      cli_abort(paste(
        "The requested var item(s) {.val {missing}} do not exist in the Seurat",
        "object ({.code names(seurat_obj[[{.val {assay_name}}]][[]])})"
      ))
    }
    adata$var <- seurat_obj[[assay_name]][[unlist(var_mapping)]] |>
      setNames(names(var_mapping))
  } else {
    # Store an empty data.frame to keep the var names
    adata$var <- data.frame(row.names = rownames(seurat_obj))
  }
}

# trackstatus: class=Seurat, feature=set_layers, status=done
# nolint start: object_name_linter
.from_Seurat_process_layers <- function(
  # nolint end: object_name_linter
  adata,
  seurat_obj,
  assay_name,
  layers_mapping
) {
  if (rlang::is_empty(layers_mapping)) {
    return(invisible())
  }

  adata$layers <- purrr::map(layers_mapping, function(.layer) {
    layer_data <- check_dims_and_skip(
      SeuratObject::LayerData(seurat_obj, assay = assay_name, layer = .layer),
      "Layer",
      .layer,
      expected_dims = rev(dim(adata))
    )

    if (is.null(layer_data)) {
      return(NULL)
    }

    to_py_matrix(layer_data)
  })
}

# trackstatus: class=Seurat, feature=set_obsm, status=done
# nolint start: object_name_linter
.from_Seurat_process_obsm <- function(
  adata,
  seurat_obj,
  assay_name,
  obsm_mapping
) {
  # nolint end: object_name_linter
  if (rlang::is_empty(obsm_mapping)) {
    return(invisible())
  }

  adata$obsm <- purrr::map(obsm_mapping, function(.reduction) {
    if (!(.reduction %in% SeuratObject::Reductions(seurat_obj))) {
      cli_abort(c(
        "Reduction {.val {(.reduction)}} not found in Seurat object.",
        "i" = "Available reductions: {.val {SeuratObject::Reductions(seurat_obj)}}"
      ))
    }

    check_dims_and_skip(
      SeuratObject::Embeddings(seurat_obj, .reduction),
      "Reduction",
      .reduction,
      expected_rows = nrow(adata)
    )
  })
}

# trackstatus: class=Seurat, feature=set_varm, status=done
# nolint start: object_name_linter
.from_Seurat_process_varm <- function(
  adata,
  seurat_obj,
  assay_name,
  varm_mapping
) {
  # nolint end: object_name_linter
  if (rlang::is_empty(varm_mapping)) {
    return(invisible())
  }

  adata$varm <- purrr::map(varm_mapping, function(.reduction) {
    if (!(.reduction %in% SeuratObject::Reductions(seurat_obj))) {
      cli_abort(c(
        "Reduction {.val {(.reduction)}} not found in Seurat object.",
        "i" = "Available reductions: {.val {SeuratObject::Reductions(seurat_obj)}}"
      ))
    }
    mat <- SeuratObject::Loadings(seurat_obj, .reduction)

    # NOTE: loadings only contains a subset of the rows that should be in the varm.
    # hence, expand it to all of the varnames in the adata
    if (!identical(rownames(mat), adata$var_names)) {
      cli_warn(c(
        "Row names of {.code Loadings(seurat_obj, {.val {(.reduction)}})} do not match the expected var names",
        "!" = "The matrix will be expanded to include all var names."
      ))

      expanded_mat <- matrix(0, nrow = nrow(adata$var), ncol = ncol(mat))
      rownames(expanded_mat) <- adata$var_names
      colnames(expanded_mat) <- colnames(mat)
      expanded_mat[rownames(mat), ] <- mat

      mat <- expanded_mat
    }
  })
}

# trackstatus: class=Seurat, feature=set_obsp, status=done
# nolint start: object_name_linter
.from_Seurat_process_obsp <- function(
  adata,
  seurat_obj,
  assay_name,
  obsp_mapping
) {
  # nolint end: object_name_linter
  if (rlang::is_empty(obsp_mapping)) {
    return(invisible())
  }

  adata$obsp <- purrr::map(obsp_mapping, function(.graph) {
    if (!(.graph %in% SeuratObject::Graphs(seurat_obj))) {
      cli_abort(c(
        "Graph {.val {graph_name}} not found in Seurat object.",
        "i" = "Available graphs: {.val {SeuratObject::Graphs(seurat_obj)}}"
      ))
    }

    graph_data <- check_dims_and_skip(
      seurat_obj[[.graph]],
      "Graph",
      .graph,
      expected_dims = c(nrow(adata), nrow(adata))
    )

    if (is.null(graph_data)) {
      return(NULL)
    }

    as(graph_data, "sparseMatrix")
  })
}

# trackstatus: class=Seurat, feature=set_varp, status=done
# nolint start: object_name_linter
.from_Seurat_process_varp <- function(
  adata,
  seurat_obj,
  assay_name,
  varp_mapping
) {
  # nolint end: object_name_linter
  if (rlang::is_empty(varp_mapping)) {
    return(invisible())
  }

  adata$varp <- purrr::map(varp_mapping, function(.varp) {
    # Check if the misc data exists
    if (!(.varp %in% names(SeuratObject::Misc(seurat_obj)))) {
      cli_abort(c(
        "Misc data {.val {(.varp)}} not found in Seurat object.",
        "i" = "Available misc data: {.val {names(SeuratObject::Misc(seurat_obj))}}"
      ))
    }

    varp_data <- check_dims_and_skip(
      SeuratObject::Misc(seurat_obj, .varp),
      "Misc",
      .varp,
      expected_dims = c(ncol(adata), ncol(adata))
    )

    if (is.null(varp_data)) {
      return(NULL)
    }

    as(varp_data, "sparseMatrix")
  })
}

# trackstatus: class=Seurat, feature=set_uns, status=done
# nolint start: object_name_linter
.from_Seurat_process_uns <- function(
  adata,
  seurat_obj,
  assay_name,
  uns_mapping
) {
  # nolint end: object_name_linter
  if (rlang::is_empty(uns_mapping)) {
    return(invisible())
  }

  adata$uns <- purrr::map(uns_mapping, function(.misc) {
    if (!(.misc %in% names(SeuratObject::Misc(seurat_obj)))) {
      cli_abort(c(
        "Misc data {.val {(.misc)}} not found in Seurat object.",
        "i" = "Available misc data: {.val {names(SeuratObject::Misc(seurat_obj))}}"
      ))
    }
    SeuratObject::Misc(seurat_obj, .misc)
  })
}

# nolint start: object_name_linter object_length_linter
.from_Seurat_guess_layers <- function(seurat_obj, assay_name) {
  # nolint end: object_name_linter object_length_linter
  seurat_assay <- Seurat::GetAssay(seurat_obj, assay = assay_name)
  layers <- SeuratObject::Layers(seurat_assay)
  setNames(layers, layers)
}

# nolint start: object_name_linter
.from_Seurat_guess_obs <- function(seurat_obj, assay_name) {
  # nolint end: object_name_linter
  setNames(names(seurat_obj[[]]), names(seurat_obj[[]]))
}

# nolint start: object_name_linter
.from_Seurat_guess_var <- function(seurat_obj, assay_name) {
  # nolint end: object_name_linter
  assay <- seurat_obj[[assay_name]]
  setNames(names(assay[[]]), names(assay[[]]))
}

# nolint start: object_name_linter object_length_linter
.from_Seurat_guess_obsms <- function(seurat_obj, assay_name) {
  # nolint end: object_name_linter object_length_linter

  obsm_mapping <- c()

  for (reduction_name in SeuratObject::Reductions(seurat_obj)) {
    # Check if the dimreduc was calculated by the selected assay
    reduction <- seurat_obj[[reduction_name]]
    if (SeuratObject::DefaultAssay(reduction) != assay_name) {
      next
    }

    obsm_mapping[reduction_name] <- reduction_name
  }

  obsm_mapping
}

# nolint start: object_name_linter object_length_linter
.from_Seurat_guess_varms <- function(seurat_obj, assay_name) {
  # nolint end: object_name_linter object_length_linter

  varm_mapping <- c()

  for (reduction_name in SeuratObject::Reductions(seurat_obj)) {
    reduction <- seurat_obj[[reduction_name]]
    loadings <- SeuratObject::Loadings(seurat_obj, reduction_name)

    if (
      !SeuratObject::IsMatrixEmpty(loadings) &&
        nrow(loadings) == nrow(seurat_obj) &&
        SeuratObject::DefaultAssay(reduction) == assay_name
    ) {
      varm_mapping[reduction_name] <- reduction_name
    }
  }

  varm_mapping
}

# nolint start: object_name_linter object_length_linter
.from_Seurat_guess_obsps <- function(seurat_obj, assay_name) {
  # nolint end: object_name_linter object_length_linter

  obsp_mapping <- c()

  for (graph_name in SeuratObject::Graphs(seurat_obj)) {
    graph <- seurat_obj[[graph_name]]
    graph_assay <- SeuratObject::DefaultAssay(graph)

    # Handle graphs with missing assay information
    if (is.null(graph_assay)) {
      # If we are using the default assay, warn and convert
      if (assay_name == SeuratObject::DefaultAssay(seurat_obj)) {
        cli_warn(c(
          "Graph {.val {graph_name}} does not have an associated assay",
          "i" = "Assuming it belongs to the selected default assay ({.val {assay_name}})"
        ))
      } else {
        # If another assay, warn and don't convert
        cli_warn(c(
          "Graph {.val {graph_name}} does not have an associated assay",
          "i" = "Assuming it does not belong to the selected assay ({.val {assay_name}}) and skipping"
        ))
        next
      }
    } else if (graph_assay != assay_name) {
      # Skip graphs from other assays
      next
    }

    dest_name <- gsub(paste0(assay_name, "_"), "", graph_name)

    obsp_mapping[dest_name] <- graph_name
  }

  obsp_mapping
}

# nolint start: object_name_linter object_length_linter
.from_Seurat_guess_varps <- function(seurat_obj) {
  # nolint end: object_name_linter object_length_linter
  c()
}

# nolint start: object_name_linter object_length_linter
.from_Seurat_guess_uns <- function(seurat_obj) {
  # nolint end: object_name_linter object_length_linter
  uns_names <- names(SeuratObject::Misc(seurat_obj))
  setNames(uns_names, uns_names)
}

skip_if_not_installed("Seurat")
library(Seurat)

`%||%` <- rlang::`%||%`

known_issues <- read_known_issues()

counts <- matrix(rbinom(20000, 1000, .001), nrow = 100)
obj <- CreateSeuratObject(counts = as(counts, "CsparseMatrix"))
obj <- NormalizeData(obj, verbose = FALSE)
obj <- FindVariableFeatures(obj, verbose = FALSE)
obj <- ScaleData(obj, verbose = FALSE)
obj <- RunPCA(obj, npcs = 10L, verbose = FALSE)
obj <- FindNeighbors(obj, verbose = FALSE)
# Suppress Seurat UWOT warning
withr::with_options(list("Seurat.warn.umap.uwot" = FALSE), {
  obj <- RunUMAP(obj, dims = 1:10, verbose = FALSE)
})

active_assay <- obj[[DefaultAssay(obj)]]

# converting to anndata produces warning due to hvg subsetting
ad <- suppressWarnings(as_AnnData(obj))

test_that("as_AnnData (Seurat) retains number of observations and features", {
  expect_equal(ad$n_obs(), 200L)
  expect_equal(ad$n_vars(), 100L)

  # trackstatus: class=Seurat, feature=test_set_var_names, status=done
  expect_equal(rownames(ad$var), rownames(obj))
  # trackstatus: class=Seurat, feature=test_set_obs_names, status=done
  expect_equal(rownames(ad$obs), colnames(obj))
})

# trackstatus: class=Seurat, feature=test_set_obs, status=done
for (obs_key in colnames(Misc(obj))) {
  test_that(paste0("as_AnnData (Seurat) retains obs key: ", obs_key), {
    msg <- message_if_known(
      backend = "from_Seurat",
      slot = c("obs"),
      dtype = obs_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(obs_key %in% colnames(ad$obs))
    expect_equal(
      ad$obs[[obs_key]],
      obj[[obs_key]],
      info = paste0("obs_key: ", obs_key)
    )
  })
}

# trackstatus: class=Seurat, feature=test_set_var, status=done
for (var_key in colnames(active_assay[[]])) {
  test_that(paste0("as_AnnData (Seurat) retains var key: ", var_key), {
    msg <- message_if_known(
      backend = "from_Seurat",
      slot = c("var"),
      dtype = var_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(var_key %in% colnames(ad$var))
    expect_equal(ad$var[[var_key]], active_assay[[var_key]][[1]])
  })
}

# trackstatus: class=Seurat, feature=test_set_layers, status=done
for (layer_key in names(active_assay[])) {
  test_that(paste0("as_AnnData (Seurat) retains layer: ", layer_key), {
    msg <- message_if_known(
      backend = "from_Seurat",
      slot = c("layers"),
      dtype = layer_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(layer_key %in% names(ad$layers))
    expect_true(
      all.equal(
        as.matrix(t(active_assay[layer_key])),
        as.matrix(ad$layers[[layer_key]]),
        check.attributes = FALSE
      ),
      info = paste0("layer_key: ", layer_key)
    )
  })
}

# trackstatus: class=Seurat, feature=test_set_uns, status=done
for (uns_key in names(Misc(obj))) {
  test_that(paste0("as_AnnData (Seurat) retains uns key: ", uns_key), {
    msg <- message_if_known(
      backend = "from_Seurat",
      slot = c("uns"),
      dtype = uns_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(uns_key %in% names(ad$uns))
    expect_equal(ad$uns[[uns_key]], Misc(obj)[[uns_key]], ignore_attr = TRUE)
  })
}

test_that("as_AnnData (Seurat) retains pca", {
  msg <- message_if_known(
    backend = "from_Seurat",
    slot = c("obsm"),
    dtype = "pca",
    process = "convert",
    known_issues = known_issues
  )
  skip_if(!is.null(msg), message = msg)

  # trackstatus: class=Seurat, feature=test_set_obsm, status=wip
  expect_equal(
    ad$obsm[["pca"]],
    Embeddings(obj, reduction = "pca"),
    ignore_attr = TRUE
  )

  # trackstatus: class=Seurat, feature=test_set_varm, status=done
  expanded_varm_pca <- ad$varm[["pca"]]
  loadings <- Loadings(obj, reduction = "pca")

  # check whether rows not in loadings are all zero
  should_be_zero <- expanded_varm_pca[
    !rownames(expanded_varm_pca) %in% rownames(loadings),
    ,
    drop = FALSE
  ]
  expect_true(all(should_be_zero == 0))

  # now check the matching rows
  matching_varm_pca <- expanded_varm_pca[rownames(loadings), , drop = FALSE]
  expect_equal(
    matching_varm_pca,
    loadings,
    ignore_attr = TRUE
  )
})

test_that("as_AnnData (Seurat) retains umap", {
  msg <- message_if_known(
    backend = "from_Seurat",
    slot = c("obsm"),
    dtype = "umap",
    process = "convert",
    known_issues = known_issues
  )

  skip_if(!is.null(msg), message = msg)

  expect_equal(
    ad$obsm[["umap"]],
    Embeddings(obj, reduction = "umap"),
    ignore_attr = TRUE
  )
})

# trackstatus: class=Seurat, feature=test_set_obsp, status=done
test_that("as_AnnData (Seurat) retains connectivities", {
  msg <- message_if_known(
    backend = "from_Seurat",
    slot = c("graphs"),
    dtype = "connectivities",
    process = "convert",
    known_issues = known_issues
  )

  skip_if(!is.null(msg), message = msg)

  expect_equal(
    as.matrix(ad$obsp[["nn"]]),
    as.matrix(Graphs(obj, "RNA_nn")),
    ignore_attr = TRUE
  )
  expect_equal(
    as.matrix(ad$obsp[["snn"]]),
    as.matrix(Graphs(obj, "RNA_snn")),
    ignore_attr = TRUE
  )
})

test_that("as_AnnData (Seurat) works with v3 Assays", {
  obj_v3_assay <- obj
  expect_warning(
    obj_v3_assay[["RNA"]] <- as(Seurat::GetAssay(obj, "RNA"), "Assay")
  )

  expect_warning(
    adata_v3_assay <- as_AnnData(obj_v3_assay),
    regexp = "Row names of .* do not match the expected var names"
  )

  expect_identical(
    to_R_matrix(adata_v3_assay$layers$counts),
    SeuratObject::GetAssayData(obj_v3_assay, layer = "counts")
  )
})

test_that("as_AnnData (Seurat) works with list mappings", {
  active_assay <- SeuratObject::DefaultAssay(obj)
  expect_no_error(
    expect_warning(
      as_AnnData(
        obj,
        layers_mapping = as.list(.from_Seurat_guess_layers(obj, active_assay)),
        obs_mapping = as.list(.from_Seurat_guess_obs(obj, active_assay)),
        var_mapping = as.list(.from_Seurat_guess_var(obj, active_assay)),
        obsm_mapping = as.list(.from_Seurat_guess_obsms(obj, active_assay)),
        varm_mapping = as.list(.from_Seurat_guess_varms(obj, active_assay)),
        obsp_mapping = as.list(.from_Seurat_guess_obsps(obj, active_assay)),
        varp_mapping = if (length(as.list(.from_Seurat_guess_varps(obj))) > 0) {
          as.list(.from_Seurat_guess_varps(obj))
        } else {
          FALSE
        },
        uns_mapping = if (length(as.list(.from_Seurat_guess_uns(obj))) > 0) {
          as.list(.from_Seurat_guess_uns(obj))
        } else {
          FALSE
        }
      ),
      regexp = "Row names of .* do not match the expected var names"
    )
  )
})

test_that("as_AnnData (Seurat) works with unnamed mappings", {
  active_assay <- SeuratObject::DefaultAssay(obj)
  expect_no_error(
    expect_warning(
      as_AnnData(
        obj,
        layers_mapping = unname(.from_Seurat_guess_layers(obj, active_assay)),
        obs_mapping = unname(.from_Seurat_guess_obs(obj, active_assay)),
        var_mapping = unname(.from_Seurat_guess_var(obj, active_assay)),
        obsm_mapping = unname(.from_Seurat_guess_obsms(obj, active_assay)),
        varm_mapping = unname(.from_Seurat_guess_varms(obj, active_assay)),
        obsp_mapping = unname(.from_Seurat_guess_obsps(obj, active_assay)),
        varp_mapping = unname(.from_Seurat_guess_varps(obj)) %||% FALSE,
        uns_mapping = unname(.from_Seurat_guess_uns(obj)) %||% FALSE
      ),
      regexp = "Row names of .* do not match the expected var names"
    )
  )
})

test_that("as_AnnData (Seurat) works with empty mappings", {
  expect_warning(
    as_AnnData(obj, varm_mapping = NULL),
    regexp = "argument is empty"
  )
  expect_warning(
    as_AnnData(obj, varm_mapping = c()),
    regexp = "argument is empty"
  )
})

#' Create an in-memory AnnData object.
#'
#' For more information on the functionality of an AnnData object, see [AnnData-usage]
#'
#' @param X See the `X` slot in [AnnData-usage]
#' @param layers See the `layers` slot in [AnnData-usage]
#' @param obs See the `obs` slot in [AnnData-usage]
#' @param var See the `var` slot in [AnnData-usage]
#' @param obsm See the `obsm` slot in [AnnData-usage]
#' @param varm See the `varm` slot in [AnnData-usage]
#' @param obsp See the `obsp` slot in [AnnData-usage]
#' @param varp See the `varp` slot in [AnnData-usage]
#' @param uns See the `uns` slot in [AnnData-usage]
#' @param shape Shape tuple (e.g. `c(n_obs, n_vars)`). Can be provided if both
#'   `X` or `obs` and `var` are not provided.
#'
#' @return An [InMemoryAnnData] object
#' @export
#'
#' @seealso [AnnData-usage] for details of `AnnData` structure and usage
#' @family AnnData creators
#'
#' @examples
#' adata <- AnnData(
#'   X = matrix(1:12, nrow = 3, ncol = 4),
#'   obs = data.frame(
#'     row.names = paste0("obs", 1:3),
#'     n_counts = c(1, 2, 3),
#'     n_cells = c(1, 2, 3)
#'   ),
#'   var = data.frame(
#'     row.names = paste0("var", 1:4),
#'     n_cells = c(1, 2, 3, 4)
#'   )
#' )
#'
#' adata
AnnData <- function(
  X = NULL,
  obs = NULL,
  var = NULL,
  layers = NULL,
  obsm = NULL,
  varm = NULL,
  obsp = NULL,
  varp = NULL,
  uns = NULL,
  shape = NULL
) {
  InMemoryAnnData$new(
    X = X,
    obs = obs,
    var = var,
    layers = layers,
    obsm = obsm,
    varm = varm,
    obsp = obsp,
    varp = varp,
    uns = uns,
    shape = shape
  )
}

test_that("obsm/varm validation works", {
  N_OBS <- 5
  N_VAR <- 3

  mtx <- matrix(
    0,
    N_OBS,
    N_VAR
  )

  adata <- AnnData(
    X = mtx,
    obs = data.frame(row.names = as.character(1:N_OBS)),
    var = data.frame(row.names = as.character(1:N_VAR))
  )

  adata$obsm <- list(PCA = matrix(0, N_OBS, 4))
  adata$varm <- list(PCs = matrix(0, N_VAR, 4))

  expect_error(adata$obsm <- list(PCA = matrix(0, 4, 4)))
  expect_error(adata$varm <- list(PCs = matrix(0, 4, 4)))
})

test_that("obsp/varp validation works", {
  N_OBS <- 5
  N_VAR <- 3

  adata <- AnnData(
    obs = data.frame(row.names = as.character(1:N_OBS)),
    var = data.frame(row.names = as.character(1:N_VAR))
  )

  adata$obsp <- list(graph1 = matrix(0, N_OBS, N_OBS))
  adata$varp <- list(graph1 = matrix(0, N_VAR, N_VAR))

  expect_error(adata$obsp <- list(graph1 = matrix(0, 4, 4)))
  expect_error(adata$varp <- list(graph1 = matrix(0, 4, 4)))
})

#' Reticulate Helper Functions for AnnData Conversion
#'
#' This file contains helper functions that enable seamless conversion between
#' R and Python AnnData objects using the reticulate package. These functions
#' provide automatic S3 method dispatch for converting AnnData objects across
#' the R-Python boundary.
#'
#' The main conversion functions include:
#'
#' * `py_to_r.anndata._core.anndata.AnnData`: Converts Python AnnData
#'   objects to R [ReticulateAnnData] objects
#' * `r_to_py.AbstractAnnData`: Converts R [AbstractAnnData] objects
#'   to Python AnnData objects
#' * `py_to_r.collections.abc.Mapping`: Converts Python mapping
#'   objects to R lists
#'
#' These functions are automatically registered as S3 methods and are called
#' when using `reticulate::py_to_r()` and `reticulate::r_to_py()` on compatible
#' objects.
#'
#' @name reticulate-helpers
#' @family object converters
#'
#' @examples
#' \donttest{
#' # Requires Python anndata to be installed
#' if (requireNamespace("reticulate", quietly = TRUE) &&
#'       reticulate::py_module_available("anndata")) {
#'
#'   library(reticulate)
#'
#'   # Create Python AnnData object
#'   ad_py <- import("anndata", convert = FALSE)
#'   py_adata <- ad_py$AnnData(X = r_to_py(matrix(1:12, 3, 4)))
#'
#'   # Automatic conversion to R (uses py_to_r.anndata._core.anndata.AnnData)
#'   r_adata <- py_to_r(py_adata)
#'
#'   # Automatic conversion back to Python (uses r_to_py.AbstractAnnData)
#'   py_adata2 <- r_to_py(r_adata)
#' }
#' }
NULL


#' @rdname reticulate-helpers
#' @importFrom reticulate py_to_r
#' @method py_to_r collections.abc.Mapping
#' @export
py_to_r.collections.abc.Mapping <- function(x) {
  out <- list()
  bi <- reticulate::import_builtins()
  keys <- bi$list(x$keys())
  for (name in keys) {
    out[[name]] <- reticulate::py_to_r(x[[name]])
  }
  out
}

#' @rdname reticulate-helpers
#' @param x A Python AnnData object
#' @return A [`ReticulateAnnData`] object wrapping the Python object
#' @export
#' @importFrom reticulate py_to_r
#' @method py_to_r anndata._core.anndata.AnnData
py_to_r.anndata._core.anndata.AnnData <- function(x) {
  ReticulateAnnData$new(py_anndata = x)
}

#' @rdname reticulate-helpers
#' @param x An AbstractAnnData object (any anndataR implementation)
#' @param convert Whether to convert the result (passed to reticulate)
#' @return A Python AnnData object
#' @export
#' @importFrom reticulate r_to_py
#' @method r_to_py AbstractAnnData
r_to_py.AbstractAnnData <- function(x, convert = TRUE) {
  if (inherits(x, "ReticulateAnnData")) {
    # If it's already a ReticulateAnnData, return the underlying Python object
    x$py_anndata()
  } else {
    # Convert other AnnData types to ReticulateAnnData first, then extract Python object
    ret_adata <- as_ReticulateAnnData(x)
    ret_adata$py_anndata()
  }
}

wrap_message <- function(...) {
  txt <- paste0(..., collapse = "")
  paste(strwrap(txt, exdent = 2L), collapse = "\n")
}

has_row_names <- function(x) {
  if (is.data.frame(x)) {
    .row_names_info(x) > 0
  } else {
    !is.null(dimnames(x)[[1]])
  }
}

get_shape <- function(obs, var, X, shape) {
  n_obs <-
    if (!is.null(obs)) {
      nrow(obs)
    } else if (!is.null(X)) {
      nrow(X)
    } else if (!is.null(shape)) {
      shape[[1]]
    } else {
      0L
    }
  n_vars <-
    if (!is.null(var)) {
      nrow(var)
    } else if (!is.null(X)) {
      ncol(X)
    } else if (!is.null(shape)) {
      shape[[2]]
    } else {
      0L
    }
  c(n_obs, n_vars)
}

get_initial_obs <- function(obs, X, shape) {
  if (is.null(obs)) {
    obs <- data.frame(matrix(NA, nrow = shape[[1]], ncol = 0))
    if (!is.null(X)) {
      rownames(obs) <- rownames(X)
    }
  }
  obs
}

get_initial_var <- function(var, X, shape) {
  if (is.null(var)) {
    var <- data.frame(matrix(NA, nrow = shape[[2]], ncol = 0))
    if (!is.null(X)) {
      rownames(var) <- colnames(X)
    }
  }
  var
}

to_py_matrix <- function(mat) {
  if (inherits(mat, "dgCMatrix")) {
    mat <- as(mat, "RsparseMatrix")
  } else if (!inherits(mat, "dgRMatrix")) {
    mat <- as.matrix(mat)
  }
  Matrix::t(mat)
}

# nolint start: object_name_linter
to_R_matrix <- function(mat) {
  # nolint end: object_name_linter
  if (inherits(mat, "dgRMatrix")) {
    mat <- as(mat, "CsparseMatrix")
  } else if (!inherits(mat, "dgCMatrix")) {
    mat <- as.matrix(mat)
  }
  Matrix::t(mat)
}

self_name <- function(x) {
  if (is.null(names(x))) {
    x <- setNames(x, x)
  } else if (any(names(x) == "")) {
    is_missing <- names(x) == ""
    names(x)[is_missing] <- x[is_missing]
  }

  x
}

#' Get mapping
#'
#' Get a mapping argument for a conversion function
#'
#' @param mapping The user-supplied mapping argument. Can be a named vector,
#'   `TRUE` or `FALSE`.
#' @param guesser A function that guesses the default mapping from `obj` if
#'   `mapping` is `TRUE`
#' @param obj The object that is being converted and is passed to `guesser`
#'   if needed
#' @param name The name of the mapping argument, used for error messages
#' @param ... Additional arguments passed to `guesser`
#'
#' @description
#' If `mapping` is `NULL` or empty it is set to `FALSE` with a warning. `FALSE`
#' values return an empty mapping.
#'
#' @returns A named mapping vector
#' @noRd
get_mapping <- function(mapping, guesser, obj, name, ...) {
  if (rlang::is_empty(mapping)) {
    cli_warn(c(
      "The {.arg {name}} argument is empty, setting it to {.val {FALSE}}"
    ))

    mapping <- FALSE
  }

  # If FALSE, return an empty mapping
  if (isFALSE(mapping)) {
    return(list())
  }

  # If TRUE, use the guesser function to get the default mapping
  if (isTRUE(mapping)) {
    return(guesser(obj, ...))
  }

  if (!is.vector(mapping)) {
    cli_abort(paste(
      "{.arg {name}} must be a vector, {.val {TRUE}} or {.val {FALSE}}, not",
      "{.cls {class(mapping)}}"
    ))
  }

  # Make sure provided mapping has names
  self_name(mapping)
}

#' Check dimensions and skip
#'
#' Check the dimensions of a matrix-like object and return `NULL` if they do not
#' match the expected dimensions, with a warning. For use in conversion
#' functions to skip items that do not match the required dimensions.
#'
#' @param x The object to check
#' @param field The field the object comes from, used in the warning message
#' @param name The name of the object, used in the warning message
#' @param expected_dims Expected dimensions
#' @param expected_rows Expected number of rows
#' @param expected_cols Expected number of columns
#'
#' @returns The object `x` if it matches the expected dimensions, otherwise
#'   `NULL`
#' @noRd
check_dims_and_skip <- function(
  x,
  field,
  name,
  expected_dims = NULL,
  expected_rows = NULL,
  expected_cols = NULL
) {
  msg <- NULL

  if (!is.null(expected_dims) && !identical(dim(x), expected_dims)) {
    expected_dims <- as.integer(expected_dims)
    msg <- c(
      "i" = paste0(
        "Expected [{style_vec(expected_dims)}], ",
        "got [{style_vec(as.integer(dim(x)))}]"
      )
    )
  } else if (!is.null(expected_rows) && nrow(x) != expected_rows) {
    msg <- c(
      "i" = paste0(
        "Expected {.val {expected_rows}} rows, got {.val {nrow(x)}}"
      )
    )
  } else if (!is.null(expected_cols) && ncol(x) != expected_cols) {
    msg <- c(
      "i" = paste0(
        "Expected {.val {expected_cols}} colums, got {.val {ncol(x)}}"
      )
    )
  }

  if (!is.null(msg)) {
    cli_warn(
      c(
        "Skipping {.field {field}} {.val {name}} with unexpected dimensions",
        msg
      ),
      call = NULL
    )

    NULL
  } else {
    x
  }
}

#' Warn matrix dim names not writeable
#'
#' Warn that matrix dim names can not be written to a given object
#'
#' @param mat The object to check, if not a matrix-like object nothing is
#' checked
#' @param label A label for `mat` to use in warning messages
#' @param to_object The object to which `mat` would be written
#' @param rows Whether to check row names
#' @param cols Whether to check column names
#'
#' @returns `NULL`, invisibly
#' @noRd
# nolint start: object_name_linter
warn_matrix_dimnames_not_writeable <- function(
  mat,
  label,
  to_object,
  rows = TRUE,
  cols = TRUE
) {
  # nolint end: object_name_linter
  if (!is.matrix(mat) && !inherits(mat, "Matrix")) {
    return(invisible())
  }

  if (rows && !is.null(rownames(mat))) {
    cli_warn(
      c(
        paste(
          "Matrix row names cannot be written to {.obj_type_friendly {to_object}},",
          "they will be lost"
        ),
        "i" = paste(
          "To write row names for {.field {label}}, store it as",
          "{.cls data.frame} instead of {.obj_type_friendly {mat}}"
        ),
        "i" = "{.strong NOTE:} {.field obs_names} and {.field var_names} are stored separately"
      ),
      call = NULL
    )
  }

  if (cols && !is.null(colnames(mat))) {
    cli_warn(
      c(
        paste(
          "Matrix column names cannot be written to {.obj_type_friendly {to_object}},",
          "they will be lost"
        ),
        "i" = paste(
          "To write column names for {.field {label}}, store it as",
          "{.cls data.frame} instead of {.obj_type_friendly {mat}}"
        ),
        "i" = "{.strong NOTE:} {.field obs_names} and {.field var_names} are stored separately"
      ),
      call = NULL
    )
  }

  invisible()
}

#' Construct a sparse matrix from CSR/CSC components
#'
#' Build a `dgCMatrix` or `dgRMatrix` from raw data, index, and pointer vectors.
#'
#' @param data Non-zero values. Coerced to `double`.
#' @param indices Column indices (CSC) or row indices (CSR), 0-based. Coerced
#'   to `integer`.
#' @param indptr Index pointers, 0-based. Coerced to `integer`.
#' @param shape Matrix dimensions. Coerced to `integer`.
#' @param type Either `"csc_matrix"` or `"csr_matrix"`.
#'
#' @return A `dgCMatrix` (CSC) or `dgRMatrix` (CSR).
#'
#' @noRd
construct_sparse_matrix <- function(
  data,
  indices,
  indptr,
  shape,
  type = c("csc_matrix", "csr_matrix")
) {
  type <- match.arg(type)

  data <- as.double(data)
  indices <- as.integer(indices)
  indptr <- as.integer(indptr)
  shape <- as.integer(shape)

  # The Matrix package validity checks require that indices are sorted within
  # each major axis group (row indices within columns for CSC, column indices
  # within rows for CSR). For sparse matrices in Python order isn't guaranteed,
  # so we sort if needed.
  if (length(indices) > 1L) {
    row_lengths <- diff(indptr)
    group_ids <- rep.int(seq_along(row_lengths), row_lengths)
    ord <- order(group_ids, indices)
    if (is.unsorted(ord)) {
      indices <- indices[ord]
      data <- data[ord]
    }
  }

  if (type == "csc_matrix") {
    # Directly construct dgCMatrix (CSC format) to avoid overhead of constructing
    # a general sparseMatrix and then coercing to dgCMatrix
    # Slots: i = row indices (0-based), p = col pointers, x = values, Dim
    new("dgCMatrix", i = indices, p = indptr, x = data, Dim = shape)
  } else if (type == "csr_matrix") {
    # Directly construct dgRMatrix (CSR format)
    # Slots: j = column indices (0-based), p = row pointers, x = values, Dim
    new("dgRMatrix", j = indices, p = indptr, x = data, Dim = shape)
  }
}

col_matrix <- Matrix::rsparsematrix(nrow = 10, ncol = 20, density = 0.1)
row_matrix <- as(col_matrix, "RsparseMatrix")

# we expect to receive a transposed dgRMatrix from to_py_matrix
test_that("to_py_matrix works with dgCMatrix", {
  result <- to_py_matrix(col_matrix)
  expect_s4_class(result, "dgRMatrix")
  expect_equal(result, Matrix::t(row_matrix))
})

test_that("to_py_matrix works with dgRMatrix", {
  result <- to_py_matrix(row_matrix)
  expect_s4_class(result, "dgRMatrix")
  expect_equal(result, Matrix::t(row_matrix))
})

# we expect to receive a transposed dgCMatrix from to_R_matrix
test_that("to_R_matrix works with dgRMatrix", {
  result <- to_R_matrix(row_matrix)
  expect_s4_class(result, "dgCMatrix")
  expect_equal(result, Matrix::t(col_matrix))
})

test_that("to_R_matrix works with dgCMatrix", {
  result <- to_R_matrix(col_matrix)
  expect_s4_class(result, "dgCMatrix")
  expect_equal(result, Matrix::t(col_matrix))
})

test_that("has_row_names works on matrix", {
  expect_false(has_row_names(matrix(1:26, ncol = 1)))
  expect_true(
    has_row_names(matrix(1:26, ncol = 1, dimnames = list(letters, NULL)))
  )
})

test_that("has_row_names works on data.frame", {
  expect_false(has_row_names(data.frame(x = 1:26)))
  expect_true(has_row_names(data.frame(x = 1:26, row.names = letters)))
})

#' Write Zarr element
#'
#' Write an element to a Zarr store
#'
#' @param value The value to write
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"` or `"gzip"`. Defaults to `"none"`.
#' @param stop_on_error Whether to stop on error or generate a warning instead
#' @param ... Additional arguments passed to writing functions
#'
#' @noRd
#'
#' @details
#' `write_zarr_element()` should always be used instead of any of the specific
#' writing functions as it contains additional boilerplate to make sure
#' elements are written correctly.
write_zarr_element <- function(
  value,
  store,
  name,
  compression = c(
    "none",
    "gzip",
    "blosc",
    "zstd",
    "lzma",
    "bz2",
    "zlib",
    "lz4"
  ),
  stop_on_error = FALSE,
  ...
) {
  compression <- match.arg(compression)

  # Sparse matrices
  write_fun <-
    if (is.null(value)) {
      write_zarr_null
    } else if (inherits(value, "sparseMatrix")) {
      # Sparse matrices
      write_zarr_sparse_array
    } else if (is.factor(value)) {
      # Categoricals
      write_zarr_categorical
    } else if (is.list(value)) {
      # Lists and data frames
      if (is.data.frame(value)) {
        write_zarr_data_frame
      } else {
        write_zarr_mapping
      }
    } else if (is.character(value)) {
      # Character values
      if (length(value) == 1 && !is.matrix(value)) {
        write_zarr_string_scalar
      } else {
        write_zarr_string_array
      }
    } else if (is.numeric(value) || inherits(value, "denseMatrix")) {
      # Numeric values
      if (length(value) == 1 && !is.matrix(value)) {
        write_zarr_numeric_scalar
      } else if (is.integer(value) && any(is.na(value))) {
        write_zarr_nullable_integer
      } else {
        write_zarr_dense_array
      }
    } else if (is.logical(value)) {
      # Logical values
      if (any(is.na(value))) {
        write_zarr_nullable_boolean
      } else if (length(value) == 1) {
        # Single Booleans should be written as numeric scalars
        write_zarr_numeric_scalar
      } else {
        write_zarr_dense_array
      }
    } else {
      # Fail if unknown
      cli_abort(c(
        "Writing {.cls {class(value)}} objects to Zarr is not supported",
        "i" = "Attempting to write to {.path {name}} in {.file {store}}"
      ))
    }

  # Delete the path if it already exists
  if (zarr_path_exists(store, name)) {
    unlink(file.path(store, name), recursive = TRUE)
  }

  tryCatch(
    {
      write_fun(
        value = value,
        store = store,
        name = name,
        compression = compression,
        ...
      )
    },
    error = function(e) {
      message <- paste0(
        "Could not write element '",
        name,
        "' of type '",
        class(value),
        "':\n",
        conditionMessage(e)
      )
      if (stop_on_error) {
        cli_abort(message)
      } else {
        cli_warn(message)
        NULL
      }
    }
  )
}

#' Write Zarr encoding
#'
#' Write Zarr encoding attributes to an element in a Zarr store
#'
#' @noRd
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param encoding The encoding type to set
#' @param version The encoding version to set
write_zarr_encoding <- function(store, name, encoding, version) {
  Rarr::write_zarr_attributes(
    file.path(store, name),
    new.zattrs = list(`encoding-type` = encoding, `encoding-version` = version)
  )
}

#' Write Zarr null
#'
#' Write a null dataset to an Zarr file
#'
#' @param value Value to write, not used
#' @param store An open Zarr handle
#' @param name Name of the element within the Zarr store
#' @param compression Not used as there is no value
#' @param version Encoding version of the element to write
#'
#' @noRd
write_zarr_null <- function(
  value,
  store,
  name,
  compression,
  version = "0.1.0"
) {
  if (isFALSE(getOption("anndataR.write_null", "TRUE"))) {
    return(invisible(NULL))
  }

  Rarr::create_empty_zarr_array(
    file.path(store, name),
    dim = 0,
    chunk_dim = 0,
    data_type = "logical",
    zarr_version = 2L
  )

  write_zarr_encoding(store, name, "null", version)
}

#' Write Zarr dense array
#'
#' Write a dense array to a Zarr store
#'
#' @noRd
#'
#' @param value Value to write
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
write_zarr_dense_array <- function(
  value,
  store,
  name,
  compression,
  version = "0.2.0"
) {
  version <- match.arg(version)

  # matrices of type 'dgeMatrix' can simply be converted to a matrix
  if (inherits(value, "denseMatrix")) {
    value <- as.matrix(value)
  }

  zarr_write_compressed(
    store,
    name,
    value,
    compression
  )

  # Write attributes
  write_zarr_encoding(store, name, "array", version)
}

#' Write Zarr sparse array
#'
#' Write a sparse array to a Zarr store
#'
#' @noRd
#'
#' @param value Value to write
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
write_zarr_sparse_array <- function(
  value,
  store,
  name,
  compression,
  version = "0.1.0"
) {
  version <- match.arg(version)

  # check types
  stopifnot(inherits(value, "sparseMatrix"))

  if (inherits(value, "RsparseMatrix")) {
    type <- "csr_matrix"
    indices_attr <- "j"
  } else if (inherits(value, "CsparseMatrix")) {
    type <- "csc_matrix"
    indices_attr <- "i"
  } else {
    cli_abort(c(
      "Unsupported matrix format in {.path {name}}",
      "i" = "Supported matrices inherit from {.cls RsparseMatrix} or {.cls CsparseMatrix}"
    ))
  }

  # Write sparse matrix
  create_zarr_group(store, name)
  zarr_write_compressed(
    store,
    paste0(name, "/indices"),
    attr(value, indices_attr),
    compression
  )
  zarr_write_compressed(
    store,
    paste0(name, "/indptr"),
    value@p,
    compression
  )
  zarr_write_compressed(
    store,
    paste0(name, "/data"),
    value@x,
    compression
  )

  # Add encoding
  write_zarr_encoding(store, name, type, version)

  # Write shape attribute
  Rarr::write_zarr_attributes(file.path(store, name), list(shape = dim(value)))
}

#' Write Zarr nullable boolean
#'
#' Write a nullable boolean to a Zarr store
#'
#' @noRd
#'
#' @param value Value to write
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
write_zarr_nullable_boolean <- function(
  value,
  store,
  name,
  compression,
  version = "0.1.0"
) {
  # write mask and values
  create_zarr_group(store, name)
  value_no_na <- value
  value_no_na[is.na(value_no_na)] <- FALSE

  zarr_write_compressed(
    store,
    paste0(name, "/values"),
    value_no_na,
    compression
  )
  zarr_write_compressed(
    store,
    paste0(name, "/mask"),
    is.na(value),
    compression
  )

  # Write attributes
  write_zarr_encoding(store, name, "nullable-boolean", version)
}

#' Write Zarr nullable integer
#'
#' Write a nullable integer to a Zarr store
#'
#' @noRd
#'
#' @param value Value to write
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
write_zarr_nullable_integer <- function(
  value,
  store,
  name,
  compression,
  version = "0.1.0"
) {
  # write mask and values
  create_zarr_group(store, name)
  value_no_na <- value
  value_no_na[is.na(value_no_na)] <- -1L

  zarr_write_compressed(
    store,
    paste0(name, "/values"),
    value_no_na,
    compression
  )
  zarr_write_compressed(
    store,
    paste0(name, "/mask"),
    is.na(value),
    compression
  )

  # Write attributes
  write_zarr_encoding(store, name, "nullable-integer", version)
}

#' Write Zarr string array
#'
#' Write a string array to a Zarr store
#'
#' @noRd
#'
#' @param value Value to write
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
write_zarr_string_array <- function(
  value,
  store,
  name,
  compression,
  version = "0.2.0"
) {
  dims <- dim(value) %||% length(value)

  # replace NA to "NA" (as in rhdf5:::.h5postProcessDataset)
  # to read as "NA" -> NA later after Rarr:read_zarr_array
  value[is.na(value)] <- "NA"

  if (any(dims == 0)) {
    Rarr::create_empty_zarr_array(
      file.path(store, name),
      dim = dims,
      chunk_dim = dims,
      data_type = "<U",
      nchar = 1,
      compressor = .get_compressor(compression),
      zarr_version = 2L
    )
  } else {
    data <- array(data = value, dim = dims)
    Rarr::write_zarr_array(
      data,
      zarr_array_path = file.path(store, name),
      chunk_dim = dims,
      order = if (length(dims) > 1) "C" else "F",
      # TODO: string arrays require vlen-utf8 filter support
      # see https://github.com/Huber-group-EMBL/Rarr/issues/98
      data_type = "<U",
      nchar = max(nchar(value)),
      compressor = .get_compressor(compression),
      zarr_version = 2L
    )
  }

  write_zarr_encoding(store, name, "string-array", version)
}

#' Write Zarr categorical
#'
#' Write a categorical to a Zarr store
#'
#' @noRd
#'
#' @param value Value to write
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
write_zarr_categorical <- function(
  value,
  store,
  name,
  compression,
  version = "0.2.0"
) {
  create_zarr_group(store, name)

  categories <- levels(value)

  # Use zero-indexed values
  codes <- as.integer(value) - 1L

  # Set missing values to -1
  codes[is.na(codes)] <- -1L

  # write values to file
  write_zarr_string_array(
    categories,
    store,
    paste0(name, "/categories"),
    compression
  )
  write_zarr_dense_array(codes, store, paste0(name, "/codes"), compression)

  # Write encoding
  write_zarr_encoding(
    store = store,
    name = name,
    encoding = "categorical",
    version = version
  )

  # Write ordered attribute
  Rarr::write_zarr_attributes(
    file.path(store, name),
    new.zattrs = list("ordered" = is.ordered(value))
  )
}

#' Write Zarr string scalar
#'
#' Write a string scalar to a Zarr store
#'
#' @noRd
#'
#' @param value Value to write
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
write_zarr_string_scalar <- function(
  value,
  store,
  name,
  compression,
  version = "0.2.0"
) {
  # Write scalar
  value <- array(data = value, dim = 1)
  Rarr::write_zarr_array(
    value,
    zarr_array_path = file.path(store, name),
    chunk_dim = 1,
    compressor = .get_compressor(compression),
    zarr_version = 2L
  )

  # Write attributes
  write_zarr_encoding(store, name, "string", version)
}

#' Write Zarr numeric scalar
#'
#' Write a numeric scalar to a Zarr store
#'
#' @noRd
#'
#' @param value Value to write
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
write_zarr_numeric_scalar <- function(
  value,
  store,
  name,
  compression,
  version = "0.2.0"
) {
  # Write scalar
  zarr_write_compressed(store, name, value, compression)

  # Write attributes
  write_zarr_encoding(store, name, "numeric-scalar", version)
}

#' Write Zarr mapping
#'
#' Write a mapping to a Zarr store
#'
#' @noRd
#'
#' @param value Value to write
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
write_zarr_mapping <- function(
  value,
  store,
  name,
  compression,
  version = "0.1.0"
) {
  create_zarr_group(store, name)

  # Write mapping elements
  for (key in names(value)) {
    write_zarr_element(
      value[[key]],
      store,
      paste0(name, "/", key),
      compression
    )
  }

  write_zarr_encoding(store, name, "dict", version)
}

#' Write Zarr data frame
#'
#' Write a data frame to a Zarr store
#'
#' @noRd
#'
#' @param value Value to write
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param index The index to write. Can either be a vector of length equal to
#' the number of rows in `values` or a single character string giving the name
#' of a column in `values`. If `NULL` then `rownames(value)` is used.
#' @param version Encoding version of the element to write
write_zarr_data_frame <- function(
  value,
  store,
  name,
  compression,
  index = NULL,
  version = "0.2.0"
) {
  create_zarr_group(store, name)
  write_zarr_encoding(store, name, "dataframe", version)

  if (is.null(index)) {
    index_name <- "_index"
    index_value <- rownames(value)
  } else if (length(index) == nrow(value)) {
    index_name <- "_index"
    index_value <- index
  } else if (length(index) == 1 && index %in% colnames(value)) {
    index_name <- index
    index_value <- value[[index_name]]
    value[[index_name]] <- NULL
  } else {
    cli_abort(paste(
      "{.arg index} must be a vector with length {.code nrow(value)} or",
      "a single character vector giving the name of a column in {.arg value}"
    ))
  }
  if (is.null(index_value)) {
    index_value <- seq_len(nrow(value)) - 1L
  }

  # Write data frame columns
  for (col in colnames(value)) {
    write_zarr_element(
      value[[col]],
      store,
      paste0(name, "/", col),
      compression
    )
  }

  # Write index
  write_zarr_element(
    index_value,
    store,
    paste0(name, "/", index_name),
    compression
  )

  # Write additional data frame attributes
  Rarr::write_zarr_attributes(
    zarr_path = file.path(store, name),
    new.zattrs = list("_index" = index_name)
  )

  # Write additional data frame attributes
  col_order <- colnames(value)
  col_order <- col_order[col_order != index_name]
  # If there are no columns other than the index we set column order to an
  # empty numeric vector
  if (length(col_order) == 0) {
    col_order <- numeric()
  } else {
    col_order <- array(col_order)
  }

  Rarr::write_zarr_attributes(
    zarr_path = file.path(store, name),
    new.zattrs = list(`column-order` = col_order)
  )
}

#' Write empty Zarr
#'
#' Write a new empty Zarr store
#'
#' @noRd
#'
#' @param store Path to the Zarr store to write
#' @param obs Data frame with observations
#' @param var Data frame with variables
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"` or `"gzip"`. Defaults to `"none"`.
#' @param version The anndata on-disk format version to write
write_empty_zarr <- function(
  store,
  obs,
  var,
  compression,
  version = "0.1.0"
) {
  create_zarr(store = store)
  write_zarr_encoding(store, "/", "anndata", "0.1.0")

  write_zarr_element(obs[, integer(0)], store, "/obs", compression)
  write_zarr_element(var[, integer(0)], store, "/var", compression)

  create_zarr_group(store, "layers")
  write_zarr_encoding(store, "/layers", "dict", "0.1.0")

  create_zarr_group(store, "obsm")
  write_zarr_encoding(store, "/obsm", "dict", "0.1.0")

  create_zarr_group(store, "obsp")
  write_zarr_encoding(store, "/obsp", "dict", "0.1.0")

  create_zarr_group(store, "uns")
  write_zarr_encoding(store, "/uns", "dict", "0.1.0")

  create_zarr_group(store, "varm")
  write_zarr_encoding(store, "/varm", "dict", "0.1.0")

  create_zarr_group(store, "varp")
  write_zarr_encoding(store, "/varp", "dict", "0.1.0")
}

#' Zarr write compressed
#'
#' Write Zarr dataset with chosen compression (can be none)
#'
#' @return  Returns (invisibly) `TRUE` if the array is successfully written.
#'
#' @noRd
#'
#' @param store Path to a Zarr store
#' @param name Name of the element within the Zarr store containing the data
#' frame
#' @param value Value to write. Must be a vector to the same length as the data
#' frame.
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"` or `"gzip"`. Defaults to `"none"`.
zarr_write_compressed <- function(
  store,
  name,
  value,
  compression = c("none", "gzip", "blosc", "zstd", "lzma", "bz2", "zlib", "lz4")
) {
  dims <- dim(value) %||% length(value)
  data <- array(data = value, dim = dims)
  Rarr::write_zarr_array(
    data,
    zarr_array_path = file.path(store, name),
    chunk_dim = dims,
    order = if (length(dims) > 1) "C" else "F",
    compressor = .get_compressor(compression),
    zarr_version = 2L
  )
}

#' Get Zarr compressor
#'
#' Convert a compression name to the corresponding Rarr compressor object.
#'
#' @param compression The compression algorithm name. One of `"none"`,
#'   `"gzip"`, `"blosc"`, `"zstd"`, `"lzma"`, `"bz2"`, `"zlib"`, `"lz4"`.
#'
#' @return A Rarr compressor object, or `NULL` for no compression.
#'
#' @noRd
.get_compressor <- function(compression) {
  switch(
    compression,
    "none" = NULL,
    "zstd" = Rarr::use_zstd(),
    "blosc" = Rarr::use_blosc(),
    "gzip" = Rarr::use_gzip(),
    "lzma" = Rarr::use_lzma(),
    "bz2" = Rarr::use_bz2(),
    "zlib" = Rarr::use_zlib(),
    "lz4" = Rarr::use_lz4()
  )
}

#' Style a vector
#'
#' Style a vector for use in **{cli}** calls
#'
#' @param x The vector to style
#' @param last The separator before the last element in the vector
#' @param trunc The maximum number of elements to show
#' @param trunc_style The truncation style to use, either "both-ends"
#'   (1, 2, ..., n-1, 1) or "head" (1, 2, 3, 4, ...)
#' @param wrap Whether to wrap the output to appear as a vector, if `TRUE` then
#' "c(1, 2, 3)" else "1, 2, 3"
#'
#' @returns A styled string that can be included directly using "{syle_vec(...)}"
#' @noRd
style_vec <- function(
  x,
  last = ", ",
  trunc = 20L,
  trunc_style = c("both-ends", "head"),
  wrap = FALSE
) {
  trunc_style <- match.arg(trunc_style)

  if (is.null(x)) {
    return(cli::col_blue("NULL"))
  }

  style <- list(
    "vec-last" = last,
    "vec-sep2" = last,
    "vec-trunc" = trunc,
    "vec-trunc-style" = trunc_style
  )

  x <- cli::cli_vec(x, style)

  if (isTRUE(wrap)) {
    x_str <- "c({.val {x}})"
  } else {
    x_str <- "{.val {x}}"
  }

  cli::cli_fmt(cli::cli_text(x_str))
}

# should take a look at
# https://anndata.readthedocs.io/en/latest/fileformat-prose.html
# again

#' Write H5AD element
#'
#' Write an element to an H5AD file
#'
#' @param value The value to write
#' @param file An open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' #' @param stop_on_error Whether to stop on error or generate a warning instead
#' @param ... Additional arguments passed to writing functions
#'
#' @noRd
#'
#' @details
#' `write_h5ad_element()` should always be used instead of any of the specific
#' writing functions as it contains additional boilerplate to make sure
#' elements are written correctly.
# nolint start: cyclocomp_linter
write_h5ad_element <- function(
  value,
  file,
  name,
  compression = c("none", "gzip", "lzf"),
  chunk_size = "auto",
  stop_on_error = FALSE,
  ...
) {
  compression <- match.arg(compression)

  # Sparse matrices
  write_fun <-
    if (is.null(value)) {
      write_h5ad_null
    } else if (inherits(value, "sparseMatrix")) {
      # Sparse matrices
      write_h5ad_sparse_array
    } else if (is.factor(value)) {
      # Categoricals
      write_h5ad_categorical
    } else if (is.list(value)) {
      # Lists and data frames
      if (is.data.frame(value)) {
        write_h5ad_data_frame
      } else {
        write_h5ad_mapping
      }
    } else if (is.character(value)) {
      # Character values
      if (length(value) == 1 && !is.matrix(value)) {
        write_h5ad_string_scalar
      } else {
        write_h5ad_string_array
      }
    } else if (is.numeric(value) || inherits(value, "denseMatrix")) {
      # Numeric values
      if (length(value) == 1 && !is.matrix(value)) {
        write_h5ad_numeric_scalar
      } else if (
        is.integer(value) && any(is.na(value)) && length(dim(value)) <= 1
      ) {
        write_h5ad_nullable_integer
      } else {
        write_h5ad_dense_array
      }
    } else if (is.logical(value)) {
      # Logical values
      if (any(is.na(value))) {
        write_h5ad_nullable_boolean
      } else if (length(value) == 1) {
        # Single Booleans should be written as numeric scalars
        write_h5ad_numeric_scalar
      } else {
        write_h5ad_dense_array
      }
    } else {
      # Fail if unknown
      cli_abort(c(
        "Writing {.cls {class(value)}} objects to H5AD is not supported",
        "i" = "Attempting to write to {.path {name}} in {.file {file}}"
      ))
    }

  # Delete the path if it already exists
  # TODO: do this here?
  if (hdf5_path_exists(file, name)) {
    rhdf5::h5delete(file, name)
  }

  tryCatch(
    {
      write_fun(
        value = value,
        file = file,
        name = name,
        compression = compression,
        chunk_size = chunk_size,
        ...
      )
    },
    error = function(e) {
      message <- paste0(
        "Could not write element '",
        name,
        "' of type '",
        class(value),
        "':\n",
        conditionMessage(e)
      )
      if (stop_on_error) {
        cli_abort(message)
      } else {
        cli_warn(message)
        NULL
      }
    }
  )
}
# nolint end: cyclocomp_linter

#' Write H5AD encoding
#'
#' Write H5AD encoding attributes to an element in an H5AD file
#'
#' @noRd
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param encoding The encoding type to set
#' @param version The encoding version to set
write_h5ad_encoding <- function(file, name, encoding, version) {
  hdf5_write_attribute(
    file,
    name,
    "encoding-type",
    encoding,
    is_scalar = TRUE
  )

  hdf5_write_attribute(
    file,
    name,
    "encoding-version",
    version,
    is_scalar = TRUE
  )
}

#' Write H5AD null
#'
#' Write a null dataset to an H5AD file
#'
#' @param value Value to write, not used
#' @param file An open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param compression Not used as there is no value
#' @param version Encoding version of the element to write
#'
#' @noRd
write_h5ad_null <- function(
  value,
  file,
  name,
  compression,
  chunk_size = "auto",
  version = "0.1.0"
) {
  if (isFALSE(getOption("anndataR.write_null", "TRUE"))) {
    return(invisible(NULL))
  }

  h5s <- rhdf5::H5Screate("H5S_NULL")
  on.exit(rhdf5::H5Sclose(h5s), add = TRUE)

  h5d <- rhdf5::H5Dcreate(
    file,
    name = name,
    dtype_id = "H5T_IEEE_F32LE",
    h5space = h5s
  )
  on.exit(rhdf5::H5Dclose(h5d), add = TRUE)

  write_h5ad_encoding(file, name, "null", version)
}

#' Write H5AD dense array
#'
#' Write a dense array to an H5AD file
#'
#' @param value Value to write
#' @param file An open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
#'
#' @noRd
write_h5ad_dense_array <- function(
  value,
  file,
  name,
  compression,
  chunk_size = "auto",
  version = "0.2.0"
) {
  version <- match.arg(version)

  # matrices of type 'dgeMatrix' can simply be converted to a matrix
  if (inherits(value, "denseMatrix")) {
    value <- as.matrix(value)
  }

  if (is.matrix(value) && any(is.na(value))) {
    # is.na(value) <- NaN gets ignored
    na_indices <- is.na(value)
    value[na_indices] <- NaN
  }

  if (!is.vector(value)) {
    if (is.matrix(value)) {
      value <- t(value)
    } else if (is.array(value)) {
      value <- aperm(value)
    }
  }

  H5type <- if (is.integer(value)) {
    "H5T_STD_I64LE"
  } else {
    NULL
  }

  # Write dense array
  if (is.logical(value)) {
    hdf5_write_boolean_dataset(
      file = file,
      name = name,
      value = value,
      compression = compression,
      chunk_size = chunk_size
    )
  } else {
    hdf5_write_dataset(
      file = file,
      name = name,
      value = value,
      H5type = H5type,
      compression = compression,
      chunk_size = chunk_size
    )
  }

  write_h5ad_encoding(file, name, "array", version)
}

#' Write H5AD sparse array
#'
#' Write a sparse array to an H5AD file
#'
#' @noRd
#'
#' @param value Value to write
#' @param file An open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
write_h5ad_sparse_array <- function(
  value,
  file,
  name,
  compression,
  chunk_size = "auto",
  version = "0.1.0"
) {
  version <- match.arg(version)

  # check types
  if (!(inherits(value, "sparseMatrix"))) {
    cli_abort(
      "{.arg value} must be a {.cls sparseMatrix} but has class {.cls {class(value)}}"
    )
  }

  if (inherits(value, "RsparseMatrix")) {
    type <- "csr_matrix"
    indices_attr <- "j"
  } else if (inherits(value, "CsparseMatrix")) {
    type <- "csc_matrix"
    indices_attr <- "i"
  } else {
    cli_abort(c(
      "Unsupported matrix format in {.path {name}}",
      "i" = "Supported matrices inherit from {.cls RsparseMatrix} or {.cls CsparseMatrix}"
    ))
  }

  # Write sparse matrix
  rhdf5::h5createGroup(file, name)
  hdf5_write_dataset(
    file = file,
    name = paste0(name, "/indices"),
    value = attr(value, indices_attr),
    compression = compression,
    chunk_size = chunk_size
  )
  hdf5_write_dataset(
    file = file,
    name = paste0(name, "/indptr"),
    value = value@p,
    compression = compression,
    chunk_size = chunk_size
  )
  hdf5_write_dataset(
    file = file,
    name = paste0(name, "/data"),
    value = value@x,
    compression = compression,
    chunk_size = chunk_size
  )
  write_h5ad_encoding(file, name, type, version)

  # Write shape attribute
  hdf5_write_attribute(
    file,
    name,
    "shape",
    dim(value),
    is_scalar = FALSE
  )
}

#' Write H5AD nullable boolean
#'
#' Write a nullable boolean to an H5AD file
#'
#' @noRd
#'
#' @param value Value to write
#' @param file An open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
# nolint start: object_length_linter
write_h5ad_nullable_boolean <- function(
  value,
  file,
  name,
  compression,
  chunk_size = "auto",
  version = "0.1.0"
) {
  # nolint end: object_length_linter
  rhdf5::h5createGroup(file, name)

  value_no_na <- value
  value_no_na[is.na(value_no_na)] <- FALSE

  write_h5ad_dense_array(
    value_no_na,
    file,
    paste0(name, "/values"),
    compression,
    chunk_size
  )

  write_h5ad_dense_array(
    is.na(value),
    file,
    paste0(name, "/mask"),
    compression,
    chunk_size
  )

  # set encoding
  write_h5ad_encoding(file, name, "nullable-boolean", version)
}

#' Write H5AD nullable integer
#'
#' Write a nullable integer to an H5AD file
#'
#' @noRd
#'
#' @param value Value to write
#' @param file An open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
# nolint start: object_length_linter
write_h5ad_nullable_integer <- function(
  value,
  file,
  name,
  compression,
  chunk_size = "auto",
  version = "0.1.0"
) {
  # nolint end: object_length_linter
  rhdf5::h5createGroup(file, name)

  value_no_na <- value
  value_no_na[is.na(value_no_na)] <- 0L

  write_h5ad_dense_array(
    value_no_na,
    file,
    paste0(name, "/values"),
    compression,
    chunk_size
  )

  write_h5ad_dense_array(
    is.na(value),
    file,
    paste0(name, "/mask"),
    compression,
    chunk_size
  )

  write_h5ad_encoding(file, name, "nullable-integer", version)
}

#' Write H5AD string array
#'
#' Write a string array to an H5AD file
#'
#' @noRd
#'
#' @param value Value to write
#' @param file An open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
write_h5ad_string_array <- function(
  value,
  file,
  name,
  compression,
  chunk_size = "auto",
  version = "0.2.0"
) {
  if (!is.vector(value)) {
    if (is.matrix(value)) {
      value <- t(value)
    } else if (is.array(value)) {
      value <- aperm(value)
    }
  }

  hdf5_write_dataset(
    file = file,
    name = name,
    value = value,
    compression = compression,
    chunk_size = chunk_size
  )

  write_h5ad_encoding(file, name, "string-array", version)
}

#' Write H5AD categorical
#'
#' Write a categorical to an H5AD file
#'
#' @noRd
#'
#' @param value Value to write
#' @param file An open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
write_h5ad_categorical <- function(
  value,
  file,
  name,
  compression,
  chunk_size = "auto",
  version = "0.2.0"
) {
  rhdf5::h5createGroup(file, name)

  categories <- levels(value)

  # Use zero-indexed values
  codes <- as.integer(value) - 1L

  # Set missing values to -1
  codes[is.na(codes)] <- -1L

  # write values to file
  write_h5ad_string_array(
    categories,
    file,
    paste0(name, "/categories"),
    compression,
    chunk_size
  )
  write_h5ad_dense_array(
    codes,
    file,
    paste0(name, "/codes"),
    compression,
    chunk_size
  )

  # Write encoding
  write_h5ad_encoding(
    file = file,
    name = name,
    encoding = "categorical",
    version = version
  )

  # Write ordered attribute
  hdf5_write_attribute(
    file,
    name,
    "ordered",
    is.ordered(value),
    is_scalar = TRUE
  )
}

#' Write H5AD string scalar
#'
#' Write a string scalar to an H5AD file
#'
#' @noRd
#'
#' @param value Value to write
#' @param file An open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
write_h5ad_string_scalar <- function(
  value,
  file,
  name,
  compression,
  chunk_size = "auto",
  version = "0.2.0"
) {
  hdf5_write_scalar(
    file = file,
    name = name,
    value = value
  )

  # Write encoding
  write_h5ad_encoding(file, name, "string", version)
}

#' Write H5AD numeric scalar
#'
#' Write a numeric scalar to an H5AD file
#'
#' @noRd
#'
#' @param value Value to write
#' @param file An open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
write_h5ad_numeric_scalar <- function(
  value,
  file,
  name,
  compression,
  chunk_size = "auto",
  version = "0.2.0"
) {
  if (is.logical(value)) {
    hdf5_write_boolean_dataset(
      file = file,
      name = name,
      value = value,
      is_scalar = TRUE,
      compression = compression,
      chunk_size = chunk_size
    )
  } else {
    hdf5_write_scalar(
      file = file,
      name = name,
      value = value
    )
  }

  # Write encoding
  write_h5ad_encoding(file, name, "numeric-scalar", version)
}

#' Write H5AD mapping
#'
#' Write a mapping to an H5AD file
#'
#' @noRd
#'
#' @param value Value to write
#' @param file An open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
write_h5ad_mapping <- function(
  value,
  file,
  name,
  compression,
  chunk_size = "auto",
  version = "0.1.0"
) {
  rhdf5::h5createGroup(file, name)

  # Write mapping elements
  for (key in names(value)) {
    write_h5ad_element(
      value[[key]],
      file,
      paste0(name, "/", key),
      compression,
      chunk_size = chunk_size
    )
  }

  write_h5ad_encoding(file, name, "dict", version)
}

#' Write H5AD data frame
#'
#' Write a data frame to an H5AD file
#'
#' @noRd
#'
#' @param value Value to write
#' @param file An open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param index The index to write. Can either be a vector of length equal to
#' the number of rows in `values` or a single character string giving the name
#' of a column in `values`. If `NULL` then `rownames(value)` is used.
#' @param version Encoding version of the element to write
write_h5ad_data_frame <- function(
  value,
  file,
  name,
  compression,
  chunk_size = "auto",
  index = NULL,
  version = "0.2.0"
) {
  rhdf5::h5createGroup(file, name)
  write_h5ad_encoding(file, name, "dataframe", version)

  if (is.null(index)) {
    index_name <- "_index"
    index_value <- rownames(value)
  } else if (length(index) == nrow(value)) {
    index_name <- "_index"
    index_value <- index
  } else if (length(index) == 1 && index %in% colnames(value)) {
    index_name <- index
    index_value <- value[[index_name]]
    value[[index_name]] <- NULL
  } else {
    cli_abort(paste(
      "{.arg index} must be a vector with length {.code nrow(value)} or",
      "a single character vector giving the name of a column in {.arg value}"
    ))
  }
  if (is.null(index_value)) {
    index_value <- seq_len(nrow(value)) - 1L
  }

  # Write data frame columns
  for (col in colnames(value)) {
    write_h5ad_element(
      value[[col]],
      file,
      paste0(name, "/", col),
      compression,
      chunk_size = chunk_size
    )
  }

  # Write index name
  hdf5_write_attribute(
    file,
    name,
    "_index",
    index_name,
    is_scalar = TRUE
  )

  # Write index
  write_h5ad_data_frame_index(
    index_value,
    file,
    name,
    compression,
    chunk_size = chunk_size
  )

  col_order <- colnames(value)
  col_order <- col_order[col_order != index_name]
  # If there are no columns other than the index we set column order to an
  # empty numeric vector
  if (length(col_order) == 0) {
    col_order <- numeric()
  }

  # Write column order
  hdf5_write_attribute(
    file,
    name,
    "column-order",
    col_order,
    is_scalar = FALSE
  )
}

#' Write H5AD data frame index
#'
#' Write a data frame index to an H5AD file
#'
#' @noRd
#'
#' @param index_value Value to write
#' @param file An open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version Encoding version of the element to write
write_h5ad_data_frame_index <- function(
  index_value,
  file,
  name,
  compression,
  chunk_size = "auto",
  version = "0.2.0"
) {
  attrs <- rhdf5::h5readAttributes(file, name, native = FALSE)
  index_name <- attrs[["_index"]]

  write_h5ad_element(
    index_value,
    file,
    paste0(name, "/", index_name),
    compression,
    chunk_size = chunk_size
  )
}

#' Write empty H5AD
#'
#' Write a new empty H5AD file
#'
#' @noRd
#'
#' @param file Path to the H5AD file to write
#' @param obs Data frame with observations
#' @param var Data frame with variables
#' @param compression The compression to use when writing the element. Can be
#' one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param version The H5AD version to write
write_empty_h5ad <- function(
  file,
  obs,
  var,
  compression,
  chunk_size = "auto",
  version = "0.1.0"
) {
  write_h5ad_encoding(file, "/", "anndata", "0.1.0")

  write_h5ad_element(
    obs[, integer(0)],
    file,
    "/obs",
    compression,
    chunk_size = chunk_size
  )
  write_h5ad_element(
    var[, integer(0)],
    file,
    "/var",
    compression,
    chunk_size = chunk_size
  )

  rhdf5::h5createGroup(file, "layers")
  write_h5ad_encoding(file, "/layers", "dict", "0.1.0")

  rhdf5::h5createGroup(file, "obsm")
  write_h5ad_encoding(file, "/obsm", "dict", "0.1.0")

  rhdf5::h5createGroup(file, "obsp")
  write_h5ad_encoding(file, "/obsp", "dict", "0.1.0")

  rhdf5::h5createGroup(file, "uns")
  write_h5ad_encoding(file, "/uns", "dict", "0.1.0")

  rhdf5::h5createGroup(file, "varm")
  write_h5ad_encoding(file, "/varm", "dict", "0.1.0")

  rhdf5::h5createGroup(file, "varp")
  write_h5ad_encoding(file, "/varp", "dict", "0.1.0")

  invisible(NULL)
}

#' Read H5AD
#'
#' Read data from a H5AD file
#'
#' @param path Path to the H5AD file to read
#' @param as The type of object to return. One of:
#'
#'   * `"InMemoryAnnData"`: Read the H5AD file into memory as an
#'     [`InMemoryAnnData`] object
#'   * `"HDF5AnnData"`: Read the H5AD file as an [`HDF5AnnData`] object
#'   * `"SingleCellExperiment"`: Read the H5AD file as a
#'     [`SingleCellExperiment::SingleCellExperiment`] object
#'   * `"Seurat"`: Read the H5AD file as a
#'     [`SeuratObject::Seurat`] object
#' @param mode The mode to open the HDF5 file.
#'
#'   * `a` creates a new file or opens an existing one for read/write.
#'   * `r` opens an existing file for reading.
#'   * `r+` opens an existing file for read/write.
#'   * `w` creates a file, truncating any existing ones.
#'   * `w-`/`x` are synonyms, creating a file and failing if it already exists.
#' @param ... Extra arguments provided to the `as_*` conversion function for the
#'   object specified by `as`
#'
#' @return The object specified by `as`
#' @export
#'
#' @family AnnData creators
#'
#' @examples
#' h5ad_file <- system.file("extdata", "example.h5ad", package = "anndataR")
#'
#' # Read the H5AD as a SingleCellExperiment object
#' if (requireNamespace("SingleCellExperiment", quietly = TRUE)) {
#'   sce <- read_h5ad(h5ad_file, as = "SingleCellExperiment")
#' }
#'
#' # Read the H5AD as a Seurat object
#' if (requireNamespace("SeuratObject", quietly = TRUE)) {
#'   seurat <- read_h5ad(h5ad_file, as = "Seurat")
#' }
read_h5ad <- function(
  path,
  as = c("InMemoryAnnData", "HDF5AnnData", "SingleCellExperiment", "Seurat"),
  mode = c("r", "r+", "a", "w", "w-", "x"),
  ...
) {
  as <- match.arg(as)
  mode <- match.arg(mode)

  hdf5_adata <- HDF5AnnData$new(path, mode = mode)

  if (as == "HDF5AnnData") {
    return(hdf5_adata)
  }

  adata <- switch(
    as,
    "SingleCellExperiment" = hdf5_adata$as_SingleCellExperiment(...),
    "Seurat" = hdf5_adata$as_Seurat(...),
    "InMemoryAnnData" = hdf5_adata$as_InMemoryAnnData(...)
  )

  hdf5_adata$close()

  adata
}

file <- system.file("extdata", "example.h5ad", package = "anndataR")

test_that("reading H5AD as SingleCellExperiment works", {
  skip_if_not_installed("SingleCellExperiment")

  sce <- read_h5ad(file, as = "SingleCellExperiment", mode = "r")
  expect_s4_class(sce, "SingleCellExperiment")
})

test_that("reading H5AD as Seurat works", {
  skip_if_not_installed("SeuratObject")
  # TODO: remove this suppression when the to_seurat, from_seurat functions are updated.
  seurat <- suppressWarnings(read_h5ad(file, as = "Seurat"))
  expect_s4_class(seurat, "Seurat")
})

test_that("reading H5AD as InMemoryAnnData works", {
  adata <- read_h5ad(file, as = "InMemoryAnnData", mode = "r")
  expect_equal(class(adata), c("InMemoryAnnData", "AbstractAnnData", "R6"))
})

# helper function to skip tests if h5diff is not available
skip_if_no_h5diff <- function() {
  testthat::skip_if_not(
    {
      s <- system2(
        command = "which",
        args = "h5diff",
        stdout = TRUE,
        stderr = TRUE
      )
      is.null(attr(s, "status"))
    },
    message = "h5diff not available for testing"
  )
}

## ----options, include = FALSE-------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  warning = FALSE
)

## ----prep-file----------------------------------------------------------------
library(anndataR)
library(Seurat)

h5ad_file <- system.file("extdata", "example.h5ad", package = "anndataR")

## ----read-data----------------------------------------------------------------
seurat_obj <- read_h5ad(h5ad_file, as = "Seurat")
seurat_obj

## ----convert-seurat-----------------------------------------------------------
adata <- read_h5ad(h5ad_file)
seurat_obj <- adata$as_Seurat()
seurat_obj

## ----prep-file-zarr-----------------------------------------------------------
# Please use "example_v3.zarr.zip" for AnnData stored as Zarr version 3
zarr_path <- system.file("extdata", "example_v2.zarr.zip", package = "anndataR")
td <- tempdir(check = TRUE)
unzip(zarr_path, exdir = td)
zarr_path <- file.path(td, "example_v2.zarr")

seurat_obj_zarr <- read_zarr(zarr_path, as = "Seurat")
seurat_obj_zarr

## ----convert-seurat-zarr------------------------------------------------------
adata <- read_zarr(zarr_path)
seurat_obj_zarr <- adata$as_Seurat()
seurat_obj_zarr

## ----mapping, fig.cap = "Mapping between `AnnData` and `Seurat` objects", fig.wide = TRUE, echo = FALSE----
knitr::include_graphics("../man/figures/AnnData-Seurat.png")

## ----customize-seurat-conversion----------------------------------------------
seurat_obj <- adata$as_Seurat(
  layers_mapping = c("counts", "dense_counts"),
  object_metadata_mapping = c(metadata1 = "Int", metadata2 = "Float"),
  assay_metadata_mapping = FALSE,
  reduction_mapping = list(
    pca = c(key = "PC_", embeddings = "X_pca", loadings = "PCs"),
    umap = c(key = "UMAP_", embeddings = "X_umap")
  ),
  graph_mapping = TRUE,
  misc_mapping = c(misc1 = "Bool", misc2 = "IntScalar")
)
seurat_obj

## ----write-seurat, eval=FALSE-------------------------------------------------
# write_h5ad(seurat_obj, tempfile(fileext = ".h5ad"))
# write_zarr(seurat_obj, tempfile(fileext = ".zarr"))

## ----convert-to-anndata, eval=FALSE-------------------------------------------
# adata <- as_AnnData(seurat_obj)
# adata$write_h5ad(tempfile(fileext = ".h5ad"))
# adata$write_zarr(tempfile(fileext = ".zarr"))

## ----customize-anndata-conversion---------------------------------------------
adata <- as_AnnData(
  seurat_obj,
  assay_name = "RNA",
  x_mapping = "counts",
  layers_mapping = c("dense_counts"),
  obs_mapping = c(RNA_count = "nCount_RNA", metadata1 = "metadata1"),
  var_mapping = FALSE,
  obsm_mapping = list(X_pca = "pca", X_umap = "umap"),
  obsp_mapping = TRUE,
  uns_mapping = c("misc1", "misc2")
)
adata

## ----sessioninfo--------------------------------------------------------------
sessionInfo()

#' Check required packages
#'
#' Check that required packages are available and give a nice error message with
#' install instructions if not
#'
#' @param what A message stating what the packages are required for. Used at the
#'   start of the error message e.g. "{what} requires...".
#' @param requires Character vector of required package names
#' @param where Where to install the packages from. Either "CRAN", "Bioc", or "Python"
#'
#' @return `'TRUE` invisibly if all packages are available, otherwise calls
#'   [cli::cli_abort()]
#'
#' @importFrom rlang caller_env
#' @noRd
check_requires <- function(
  what,
  requires,
  where = c("CRAN", "Bioc", "Python")
) {
  where <- match.arg(where)

  if (where == "Python") {
    check_python_packages(what, requires)
  } else {
    check_r_packages(what, requires, where)
  }

  invisible(TRUE)
}

#' Check required Python packages
#'
#' @param what A message stating what the packages are required for
#' @param requires Character vector of required Python package names
#'
#' @importFrom rlang caller_env
#' @noRd
check_python_packages <- function(what, requires) {
  check_requires(what, "reticulate")

  is_available <- map_lgl(requires, reticulate::py_module_available)

  if (any(!is_available)) {
    missing <- requires[!is_available]
    # nolint start object_usage_linter
    missing_str <- format_package_list(missing)
    # nolint end object_usage_linter

    cli_abort(
      c(
        "{what} requires the Python {.pkg {missing}} package{?s}",
        "i" = paste(
          "To continue, require {cli::qty(missing)}{?it/them} using",
          "{.code reticulate::py_require({missing_str})} or install",
          "{cli::qty(missing)}{?it/them} them in your Python environment",
          "using another method"
        )
      ),
      call = caller_env()
    )
  }
}

#' Check required R packages
#'
#' @param what A message stating what the packages are required for
#' @param requires Character vector of required R package names
#' @param where Where to install the packages from. Either "CRAN" or "Bioc"
#'
#' @importFrom rlang caller_env
#' @noRd
check_r_packages <- function(what, requires, where) {
  is_available <- map_lgl(requires, requireNamespace, quietly = TRUE)

  if (any(!is_available)) {
    missing <- requires[!is_available]
    # nolint start object_usage_linter
    missing_str <- format_package_list(missing)
    install_fun <- get_r_install_function(where)
    # nolint end object_usage_linter

    cli_abort(
      c(
        "{what} requires the {.pkg {missing}} package{?s}",
        "i" = paste(
          "To continue, install {cli::qty(missing)}{?it/them} using",
          "{.run {install_fun}({missing_str})}"
        )
      ),
      call = caller_env()
    )
  }
}

#' Format package list for installation command
#'
#' @param packages Character vector of package names
#' @return Formatted string for use in installation functions
#' @noRd
format_package_list <- function(packages) {
  missing_str <- paste0("\"", paste(packages, collapse = "\", \""), "\"")
  if (length(packages) > 1) {
    missing_str <- paste0("c(", missing_str, ")")
  }
  missing_str
}

#' Get R package installation function
#'
#' @param where Where to install from. Either "CRAN" or "Bioc"
#' @return Installation function name as string
#' @noRd
get_r_install_function <- function(where) {
  # nolint start object_usage_linter
  switch(
    where,
    CRAN = "install.packages",
    Bioc = "install.packages(\"BiocManager\"); BiocManager::install"
  )
  # nolint end object_usage_linter
}

#' S3 Methods for AbstractAnnData Objects
#'
#' These S3 methods provide standard R interfaces for AbstractAnnData objects,
#' making them behave like native R objects with familiar syntax.
#'
#' @details
#' **Subsetting behaviour**: The `[` method supports logical, integer, and character
#' subsetting for both observations (rows) and variables (columns). However, unlike
#' standard R behaviour:
#'
#' - Logical vectors are **not recycled** and must have the exact same length as
#'   the dimension being subset
#' - **Negative indices are not supported** (R's "exclude these" syntax)
#'
#' These design choices ensure clear and predictable subsetting behaviour for
#' biological data matrices, avoiding potential confusion from accidental recycling
#' or exclusion patterns.
#'
#' @name AbstractAnnData-s3methods
#' @param x An AbstractAnnData object
#' @param value For `dimnames<-`: A list of two character vectors (obs_names, var_names)
#' @param i Row indices (observations). Can be numeric, logical, or character.
#' @param j Column indices (variables). Can be numeric, logical, or character.
#' @param drop Ignored (for compatibility with generic)
#' @param ... Additional arguments passed to methods
#'
#' @details
#' The following S3 methods are available:
#'
#'   * `dim(x)`: Get dimensions (n_obs, n_vars), equivalent to `x$shape()`
#'   * `nrow(x)`: Get number of observations, equivalent to `x$n_obs()`
#'   * `ncol(x)`: Get number of variables, equivalent to `x$n_vars()`
#'   * `dimnames(x)`: Get dimension names, (obs_names, var_names)
#'   * `rownames(x)`: Get observation names, equivalent to `x$obs_names()`
#'   * `colnames(x)`: Get variable names, equivalent to `x$var_names()`
#'   * `dimnames(x) <- value`: Set dimension names
#'   * `rownames(x) <- value`: Set observation names, equivalent to `x$obs_names() <- ...`
#'   * `colnames(x) <- value`: Set variable names, equivalent to `x$var_names() <- ...`
#'   * `x[i, j]`: Subset observations and/or variables
#'
#' @return
#'
#'   * `dim`: Numeric vector of length 2 (n_obs, n_vars)
#'   * `nrow`, `ncol`: Integer count
#'   * `dimnames`: List with obs_names and var_names
#'   * `rownames`, `colnames`: Character vector
#'   * `dimnames<-`, `rownames<-`, `colnames<-`: The modified object (invisibly)
#'   * `[`: A AnnDataView object with the specified subset
#'
#' @examples
#' # Create example data
#' ad <- generate_dataset(n_obs = 100, n_vars = 50, format = "AnnData")
#'
#' # Standard R methods work
#' dim(ad)
#' nrow(ad)
#' ncol(ad)
#' dimnames(ad)
#' rownames(ad)
#' colnames(ad)
#'
#' # Set names using dimnames
#' dimnames(ad) <- list(
#'   paste0("cell_", 1:nrow(ad)),
#'   paste0("gene_", 1:ncol(ad))
#' )
#'
#' # Or set names individually (uses dimnames<- internally)
#' rownames(ad) <- paste0("cell_", 1:nrow(ad))
#' colnames(ad) <- paste0("gene_", 1:ncol(ad))
#'
#' # Subsetting creates AnnDataView
#' subset_ad <- ad[1:10, 1:5]
#' subset_ad <- ad[rep(c(TRUE, FALSE), length.out = nrow(ad)), ]  # logical subsetting (no recycling)
#' subset_ad <- ad[c("cell_1", "cell_2"), c("gene_1", "gene_2")]  # name subsetting
NULL

#' @rdname AbstractAnnData-s3methods
#' @method dim AbstractAnnData
#' @export
dim.AbstractAnnData <- function(x) {
  x$shape()
}

#' @rdname AbstractAnnData-s3methods
#' @method nrow AbstractAnnData
#' @export
nrow.AbstractAnnData <- function(x) {
  x$n_obs()
}

#' @rdname AbstractAnnData-s3methods
#' @method ncol AbstractAnnData
#' @export
ncol.AbstractAnnData <- function(x) {
  x$n_vars()
}

#' @rdname AbstractAnnData-s3methods
#' @method dimnames AbstractAnnData
#' @export
dimnames.AbstractAnnData <- function(x) {
  list(x$obs_names, x$var_names)
}

#' @rdname AbstractAnnData-s3methods
#' @method dimnames<- AbstractAnnData
#' @export
`dimnames<-.AbstractAnnData` <- function(x, value) {
  if (is.null(value)) {
    # When dimnames(x) <- NULL, generate default sequential names
    # This mimics Python AnnData behaviour but uses 1-based indexing (R convention)
    # instead of 0-based indexing (Python convention)
    x$obs_names <- as.character(seq_len(x$n_obs()))
    x$var_names <- as.character(seq_len(x$n_vars()))
  } else {
    if (is.null(value[[1]])) {
      x$obs_names <- as.character(seq_len(x$n_obs()))
    } else {
      x$obs_names <- value[[1]]
    }

    if (is.null(value[[2]])) {
      x$var_names <- as.character(seq_len(x$n_vars()))
    } else {
      x$var_names <- value[[2]]
    }
  }
  x
}

#' @rdname AbstractAnnData-s3methods
#' @method [ AbstractAnnData
#' @export
`[.AbstractAnnData` <- function(x, i, j, drop = TRUE, ...) {
  if (inherits(x, "AnnDataView")) {
    # If x is already a view, we need to update the view with new indices
    return(x$subset(i, j))
  }

  # Create AnnDataView with both subsets at once
  AnnDataView$new(x, i, j) # nolint: object_usage_linter
}

#' @title A View of an AnnData Object
#'
#' @description A lazy view of an AnnData object that allows applying subsetting operations
#' without immediately executing them. Subsetting is applied when converting to
#' a concrete AnnData implementation (InMemoryAnnData, HDF5AnnData) or other
#' formats (SingleCellExperiment, Seurat).
#'
#' @return A `AnnDataView` object
#'
#' @seealso [AnnData-usage] for details on creating and using `AnnData` objects
#'
#' @family AnnData classes
#'
#' @examples
#' # Create a base AnnData object
#' ad <- AnnData(
#'   X = matrix(1:15, 3L, 5L),
#'   obs = data.frame(row.names = LETTERS[1:3], cell_type = c("A", "B", "A")),
#'   var = data.frame(row.names = letters[1:5], gene_type = c("X", "Y", "X", "Y", "Z"))
#' )
#'
#' # Create a view with lazy subsetting using S3 [ method
#' view <- ad[ad$obs$cell_type == "A", ad$var$gene_type %in% c("X", "Y")]
#'
#' # Apply subsetting by converting to a concrete implementation
#' result <- view$as_InMemoryAnnData()
#'
#' @export
AnnDataView <- R6::R6Class(
  "AnnDataView",
  inherit = AbstractAnnData,
  private = list(
    .base_adata = NULL,
    .obs_subset = NULL,
    .var_subset = NULL,

    # Apply subsetting to matrices/data frames with explicit dimension control
    .apply_subset = function(
      x,
      obs_on_rows = FALSE,
      var_on_rows = FALSE,
      obs_on_cols = FALSE,
      var_on_cols = FALSE
    ) {
      if (is.null(x)) {
        return(x)
      }

      # Check if x is a subsettable matrix-like object (data.frame, matrix, or Matrix)
      if (is.data.frame(x) || is.matrix(x) || inherits(x, "Matrix")) {
        result <- x

        # Apply obs subsetting to rows if requested
        if (obs_on_rows && !is.null(private$.obs_subset)) {
          result <- result[private$.obs_subset, , drop = FALSE]
        }

        # Apply var subsetting to rows if requested
        if (var_on_rows && !is.null(private$.var_subset)) {
          result <- result[private$.var_subset, , drop = FALSE]
        }

        # Apply obs subsetting to columns if requested
        if (obs_on_cols && !is.null(private$.obs_subset)) {
          result <- result[, private$.obs_subset, drop = FALSE]
        }

        # Apply var subsetting to columns if requested
        if (var_on_cols && !is.null(private$.var_subset)) {
          result <- result[, private$.var_subset, drop = FALSE]
        }

        result
      } else {
        x
      }
    },

    # Apply subsetting to vectors
    .apply_vector_subset = function(x, use_obs = FALSE, use_var = FALSE) {
      if (is.null(x) || !is.vector(x)) {
        return(x)
      }

      if (use_obs && !is.null(private$.obs_subset)) {
        return(x[private$.obs_subset])
      }

      if (use_var && !is.null(private$.var_subset)) {
        return(x[private$.var_subset])
      }

      x
    },

    # Helper to show error for setter operations
    .abort_setter = function(field_name) {
      cli_abort(
        paste0(
          "Cannot set {.field {field_name}} on an {.cls AnnDataView} object. Convert to a concrete implementation ",
          "first using any of the {.code as_*()} methods ",
          "(e.g., {.code adata$as_InMemoryAnnData()}, {.code adata$as_HDF5AnnData()})."
        )
      )
    },

    # Override class name to show "View of BaseClass"
    .class_name = function() {
      base_class <- class(private$.base_adata)[1]
      paste("View of", base_class)
    }
  ),
  active = list(
    #' @field X See [AnnData-usage]
    X = function(value) {
      if (!missing(value)) {
        private$.abort_setter("X")
      }

      private$.apply_subset(
        private$.base_adata$X,
        obs_on_rows = TRUE,
        var_on_cols = TRUE
      )
    },

    #' @field layers See [AnnData-usage]
    layers = function(value) {
      if (!missing(value)) {
        private$.abort_setter("layers")
      }

      layers <- private$.base_adata$layers
      if (is.null(layers)) {
        return(NULL)
      }

      # Apply subsetting to each layer (obs on rows, var on columns)
      lapply(layers, function(x) {
        private$.apply_subset(x, obs_on_rows = TRUE, var_on_cols = TRUE)
      })
    },

    #' @field obs See [AnnData-usage]
    obs = function(value) {
      if (!missing(value)) {
        private$.abort_setter("obs")
      }

      private$.apply_subset(private$.base_adata$obs, obs_on_rows = TRUE)
    },

    #' @field var See [AnnData-usage]
    var = function(value) {
      if (!missing(value)) {
        private$.abort_setter("var")
      }

      private$.apply_subset(private$.base_adata$var, var_on_rows = TRUE)
    },

    #' @field obs_names See [AnnData-usage]
    obs_names = function(value) {
      if (!missing(value)) {
        private$.abort_setter("obs_names")
      }

      private$.apply_vector_subset(
        private$.base_adata$obs_names,
        use_obs = TRUE
      )
    },

    #' @field var_names See [AnnData-usage]
    var_names = function(value) {
      if (!missing(value)) {
        private$.abort_setter("var_names")
      }

      private$.apply_vector_subset(
        private$.base_adata$var_names,
        use_var = TRUE
      )
    },

    #' @field obsm See [AnnData-usage]
    obsm = function(value) {
      if (!missing(value)) {
        private$.abort_setter("obsm")
      }

      obsm <- private$.base_adata$obsm
      if (is.null(obsm)) {
        return(NULL)
      }

      # Apply obs subsetting to each matrix (filter rows only)
      lapply(obsm, function(x) {
        private$.apply_subset(x, obs_on_rows = TRUE)
      })
    },

    #' @field varm See [AnnData-usage]
    varm = function(value) {
      if (!missing(value)) {
        private$.abort_setter("varm")
      }

      varm <- private$.base_adata$varm
      if (is.null(varm)) {
        return(NULL)
      }

      # Apply var subsetting to each matrix (filter rows only)
      lapply(varm, function(x) {
        private$.apply_subset(x, var_on_rows = TRUE)
      })
    },

    #' @field obsp See [AnnData-usage]
    obsp = function(value) {
      if (!missing(value)) {
        private$.abort_setter("obsp")
      }

      obsp <- private$.base_adata$obsp
      if (is.null(obsp)) {
        return(NULL)
      }

      # Apply obs subsetting to each matrix (both rows and columns)
      lapply(obsp, function(x) {
        private$.apply_subset(x, obs_on_rows = TRUE, obs_on_cols = TRUE)
      })
    },

    #' @field varp See [AnnData-usage]
    varp = function(value) {
      if (!missing(value)) {
        private$.abort_setter("varp")
      }

      varp <- private$.base_adata$varp
      if (is.null(varp)) {
        return(NULL)
      }

      # Apply var subsetting to each matrix (both rows and columns)
      lapply(varp, function(x) {
        private$.apply_subset(x, var_on_rows = TRUE, var_on_cols = TRUE)
      })
    },

    #' @field uns See [AnnData-usage]
    uns = function(value) {
      if (!missing(value)) {
        private$.abort_setter("uns")
      }

      # uns is not affected by subsetting
      private$.base_adata$uns
    }
  ),
  public = list(
    #' @description
    #' Create a new AnnDataView object
    #'
    #' @param base_adata An existing AnnData object to create a view of
    #' @param i Optional initial obs subset (logical, integer, or character vector)
    #' @param j Optional initial var subset (logical, integer, or character vector)
    #'
    #' @return A new `AnnDataView` object
    initialize = function(base_adata, i, j) {
      if (!inherits(base_adata, "AbstractAnnData")) {
        cli_abort("{.arg base_adata} must be an {.cls AbstractAnnData} object")
      }

      private$.base_adata <- base_adata

      private$.obs_subset <- convert_to_indices(
        i,
        base_adata$n_obs(),
        base_adata$obs_names,
        "observations"
      )
      private$.var_subset <- convert_to_indices(
        j,
        base_adata$n_vars(),
        base_adata$var_names,
        "variables"
      )

      invisible(self)
    },
    #' Subset the AnnDataView
    #'
    #' @param i Row indices (observations). Can be numeric, logical, or character.
    #' @param j Column indices (variables). Can be numeric, logical, or character.
    #'
    #' @return A new `AnnDataView` object
    subset = function(i, j) {
      if (missing(i)) {
        i <- NULL
      }
      if (missing(j)) {
        j <- NULL
      }

      # processing observation indices
      processed_i <- convert_to_indices(
        i,
        self$n_obs(),
        self$obs_names,
        "observations"
      )
      new_i <- if (is.null(processed_i)) {
        private$.obs_subset
      } else if (is.null(private$.obs_subset)) {
        processed_i
      } else {
        private$.obs_subset[processed_i]
      }

      # processing variable indices
      processed_j <- convert_to_indices(
        j,
        self$n_vars(),
        self$var_names,
        "variables"
      )
      new_j <- if (is.null(processed_j)) {
        private$.var_subset
      } else if (is.null(private$.var_subset)) {
        processed_j
      } else {
        private$.var_subset[processed_j]
      }

      AnnDataView$new(private$.base_adata, new_i, new_j)
    }
  )
)

#' Convert various subset types to integer indices
#'
#' @param subset The subset condition (logical, integer, or character vector)
#' @param max_length The maximum allowed length/index
#' @param names_vector The names to match against for character subsetting
#' @param context_name Name for error messages ("observations" or "variables")
#'
#' @return Integer vector of indices, or NULL if subset is NULL
#' @keywords internal
#' @noRd
convert_to_indices <- function(
  subset,
  max_length,
  names_vector,
  context_name = "items"
) {
  if (missing(subset) || is.null(subset)) {
    return(NULL)
  }

  if (is.logical(subset)) {
    if (length(subset) != max_length) {
      cli_abort(
        "Logical subset of {context_name} must have length {max_length}"
      )
    }
    which(subset)
  } else if (is.integer(subset) || is.numeric(subset)) {
    subset <- as.integer(subset)
    if (any(subset < 1 | subset > max_length)) {
      cli_abort(
        "Integer indices for {context_name} must be between 1 and {max_length}"
      )
    }
    subset
  } else if (is.character(subset)) {
    if (is.null(names_vector)) {
      cli_abort(c(
        "Cannot use character names to subset {context_name}",
        "i" = "The {context_name} do not have names ({.field obs_names}/{.field var_names} are NULL)",
        "i" = "Use integer indices instead, or set names first"
      ))
    }
    indices <- match(subset, names_vector)
    if (any(is.na(indices))) {
      # nolint start: object_usage_linter
      missing_names <- subset[is.na(indices)]
      # nolint end: object_usage_linter
      cli_abort(
        "Names of {context_name} not found: {paste(missing_names, collapse = ', ')}"
      )
    }
    indices
  } else {
    cli_abort(
      "Subset of {context_name} must be logical, integer, or character vector"
    )
  }
}

# This file contains the known issues that are currently present in the package.
# It can be used to generate documentation, but also throw warnings instead of errors
# in tests.
read_known_issues <- function() {
  check_requires("Reading known issues", "yaml")

  data <- yaml::read_yaml(system.file(
    "known_issues.yaml",
    package = "anndataR"
  ))

  map_dfr(
    data$known_issues,
    function(row) {
      expected_names <- c(
        "backend",
        "slot",
        "dtype",
        "process",
        "error_message",
        "description",
        "proposed_solution",
        "to_investigate",
        "to_fix"
      )
      if (!all(expected_names %in% names(row))) {
        cli_abort(c(
          "Unexpected columns in {.file known_issues.yaml}",
          "i" = "Expected columns: {.val {expected_names}}",
          "i" = "Actual columns: {.val {names(row)}}"
        ))
      }

      expand.grid(row)
    }
  )
}

is_known <- function(backend, slot, dtype, process, known_issues = NULL) {
  if (is.null(known_issues)) {
    known_issues <- read_known_issues()
  }

  filt <- rep(TRUE, nrow(known_issues))

  if (!is.null(backend)) {
    filt <- filt & known_issues$backend %in% backend
  }
  if (!is.null(slot)) {
    filt <- filt & known_issues$slot %in% slot
  }
  if (!is.null(dtype)) {
    filt <- filt & known_issues$dtype %in% dtype
  }
  if (!is.null(process)) {
    filt <- filt & known_issues$process %in% process
  }

  filt
}

message_if_known <- function(
  backend,
  slot,
  dtype,
  process,
  known_issues = NULL
) {
  if (is.null(known_issues)) {
    known_issues <- read_known_issues()
  }

  filt <- is_known(backend, slot, dtype, process, known_issues)

  if (any(filt)) {
    # take first
    row <- known_issues[which(filt)[[1]], ]

    paste0(
      "Known issue for backend '",
      row$backend,
      "', slot '",
      row$slot,
      "', dtype '",
      row$dtype,
      "', process '",
      row$process,
      "': ",
      row$description
    )
  } else {
    NULL
  }
}

skip_if_no_anndata_py()

library(reticulate)

ad <- reticulate::import("anndata", convert = FALSE)
# anndata >= 0.12 requires opting in to write nullable strings (pd.arrays.StringArray)
# see https://github.com/scverse/anndata/issues/2221
tryCatch(ad$settings$allow_write_nullable_strings <- TRUE, error = function(e) {
  NULL
})
bi <- reticulate::import_builtins()

known_issues <- read_known_issues()

name <- "empty"

for (fmt in c("h5ad", "zarr")) {
  fmt_config <- get_fmt_config(fmt)

  # first generate a python adata
  adata_py <- ad$AnnData()

  # create a couple of paths
  file_py <- withr::local_file(
    tempfile(paste0("anndata_py_", name), fileext = fmt_config$ext)
  )
  file_r <- withr::local_file(
    tempfile(paste0("anndata_r_", name), fileext = fmt_config$ext)
  )

  # write to file
  adata_py[[fmt_config$py_write_method]](file_py)
  # Read it back in to get the version as read from disk
  adata_py <- ad[[fmt_config$py_read_method]](file_py)

  test_that(
    paste0("Reading an AnnData with layer '", name, "' (", fmt, ") works"),
    {
      msg <- message_if_known(
        backend = fmt_config$backend,
        slot = c("none"),
        dtype = name,
        process = "read",
        known_issues = known_issues
      )
      skip_if(!is.null(msg), message = msg)

      adata_r <- fmt_config$r_read_fun(file_py, as = fmt_config$backend)
      expect_equal(
        adata_r$shape(),
        unlist(reticulate::py_to_r(adata_py$shape))
      )

      # check that the print output is the same (normalize class names)
      expect_anndata_print_equal(adata_r, adata_py)
    }
  )

  gc()

  test_that(
    paste0("Writing an AnnData with layer '", name, "' (", fmt, ") works"),
    {
      msg <- message_if_known(
        backend = fmt_config$backend,
        slot = c("none"),
        dtype = name,
        process = c("read", "write"),
        known_issues = known_issues
      )
      skip_if(!is.null(msg), message = msg)

      adata_r <- fmt_config$r_read_fun(file_py, as = "InMemoryAnnData")
      fmt_config$r_write_fun(adata_r, file_r)

      # read from file
      adata_py2 <- ad[[fmt_config$py_read_method]](file_r)

      # check that the shape is the same
      expect_equal(
        unlist(reticulate::py_to_r(adata_py2$shape)),
        unlist(reticulate::py_to_r(adata_py$shape))
      )

      # check that the print output is the same
      str_py2 <- capture.output(print(adata_py2))
      str_py <- capture.output(print(adata_py))
      expect_equal(str_py2, str_py)
    }
  )
}

skip_if_no_anndata_py()
skip_if_no_dummy_anndata()

library(reticulate)

ad <- reticulate::import("anndata", convert = FALSE)
da <- reticulate::import("dummy_anndata", convert = FALSE)
bi <- reticulate::import_builtins()

known_issues <- read_known_issues()

test_names <- c(
  names(da$matrix_generators),
  names(da$vector_generators),
  names(da$scalar_generators)
)

for (fmt in c("h5ad", "zarr")) {
  fmt_config <- get_fmt_config(fmt)

  for (name in test_names) {
    # first generate a python adata
    adata_py <- da$generate_dataset(
      x_type = NULL,
      obs_types = list(),
      var_types = list(),
      layer_types = list(),
      obsm_types = list(),
      varm_types = list(),
      obsp_types = list(),
      varp_types = list(),
      uns_types = list(name),
      nested_uns_types = list()
    )

    # create a couple of paths
    file_py <- withr::local_file(
      tempfile(paste0("anndata_py_", name), fileext = fmt_config$ext)
    )
    file_r <- withr::local_file(
      tempfile(paste0("anndata_r_", name), fileext = fmt_config$ext)
    )

    # write to file
    adata_py[[fmt_config$py_write_method]](file_py)
    # Read it back in to get the version as read from disk
    adata_py <- ad[[fmt_config$py_read_method]](file_py)

    test_that(
      paste0("Reading an AnnData with uns '", name, "' (", fmt, ") works"),
      {
        msg <- message_if_known(
          backend = fmt_config$backend,
          slot = c("uns"),
          dtype = name,
          process = "read",
          known_issues = known_issues
        )
        skip_if(!is.null(msg), message = msg)

        adata_r <- fmt_config$r_read_fun(file_py, as = fmt_config$backend)

        expect_equal(
          names(adata_r$uns),
          bi$list(adata_py$uns$keys())
        )

        # check that the print output is the same (normalize class names)
        expect_anndata_print_equal(adata_r, adata_py)
      }
    )

    test_that(
      paste0(
        "Comparing an anndata with uns '",
        name,
        "' (",
        fmt,
        ") with reticulate works"
      ),
      {
        msg <- message_if_known(
          backend = fmt_config$backend,
          slot = c("uns"),
          dtype = name,
          process = c("read", "reticulate"),
          known_issues = known_issues
        )
        skip_if(!is.null(msg), message = msg)

        adata_r <- fmt_config$r_read_fun(file_py, as = fmt_config$backend)

        py_value <- convert_py_value(adata_py$uns[[name]], name)

        expect_equal(
          adata_r$uns[[name]],
          py_value
        )
      }
    )

    gc()

    test_that(
      paste0("Writing an AnnData with uns '", name, "' (", fmt, ") works"),
      {
        msg <- message_if_known(
          backend = fmt_config$backend,
          slot = c("uns"),
          dtype = name,
          process = c("read", "write"),
          known_issues = known_issues
        )
        skip_if(!is.null(msg), message = msg)

        adata_r <- fmt_config$r_read_fun(file_py, as = "InMemoryAnnData")
        fmt_config$r_write_fun(adata_r, file_r)

        # read from file
        adata_py2 <- ad[[fmt_config$py_read_method]](file_r)

        # expect name is one of the keys
        expect_contains(
          bi$list(adata_py2$uns$keys()),
          name
        )

        # expect that the objects are the same
        expect_equal_py(
          py_get_item(adata_py2$uns, name),
          py_get_item(adata_py$uns, name)
        )
      }
    )
  }
}

## ----options, include = FALSE-------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

# already load SeuratObject and SingleCellExperiment
# so warnings generated by these packages are not shown
library(SeuratObject)
library(SingleCellExperiment)

## ----install, eval = FALSE----------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE)) {
#   install.packages("BiocManager")
# }
# BiocManager::install("anndataR")

## ----h5ad-path----------------------------------------------------------------
library(anndataR)

h5ad_path <- system.file("extdata", "example.h5ad", package = "anndataR")

## ----read-in-memory-----------------------------------------------------------
adata <- read_h5ad(h5ad_path)

## ----read-as-SingleCellExperiment---------------------------------------------
sce <- read_h5ad(h5ad_path, as = "SingleCellExperiment")

## ----read-as-Seurat-----------------------------------------------------------
obj <- read_h5ad(h5ad_path, as = "Seurat")

## ----read-on-disk-------------------------------------------------------------
adata <- read_h5ad(h5ad_path, as = "HDF5AnnData")

## ----zarr-path----------------------------------------------------------------
zarr_path <- system.file("extdata", "example_v2.zarr.zip", package = "anndataR")
td <- tempdir(check = TRUE)
unzip(zarr_path, exdir = td)
zarr_path <- file.path(td, "example_v2.zarr")

## ----read-zarr----------------------------------------------------------------
# in-memory
adata <- read_zarr(zarr_path)

# as SingleCellExperiment
sce <- read_zarr(zarr_path, as = "SingleCellExperiment")

# as Seurat
obj <- read_zarr(zarr_path, as = "Seurat")

# as Zarr-backed
adata <- read_zarr(zarr_path, as = "ZarrAnnData")

## ----show-structure-----------------------------------------------------------
adata

## ----access-slots-------------------------------------------------------------
dim(adata$X)
adata$obs[1:5, 1:6]
adata$var[1:5, 1:6]

## ----as-SingleCellExperiment--------------------------------------------------
sce <- adata$as_SingleCellExperiment()
sce

## ----as-Seurat----------------------------------------------------------------
obj <- adata$as_Seurat()
obj

## ----as-AnnData-from-SingleCellExperiment-------------------------------------
adata <- as_AnnData(sce)
adata

## ----as-AnnData-from-Seurat---------------------------------------------------
adata <- as_AnnData(obj)
adata

## ----manually-create-object---------------------------------------------------
adata <- AnnData(
  X = matrix(rnorm(100), nrow = 10),
  obs = data.frame(
    cell_type = factor(rep(c("A", "B"), each = 5))
  ),
  var = data.frame(
    gene_name = paste0("gene_", 1:10)
  )
)

adata

## ----write-to-disk------------------------------------------------------------
tmpfile <- tempfile(fileext = ".h5ad")
adata$write_h5ad(tmpfile) # Alternatively, write_h5ad(adata, tmpfile)

## ----write-SingleCellExperiment-to-disk---------------------------------------
tmpfile <- tempfile(fileext = ".h5ad")
write_h5ad(sce, tmpfile)

## ----write-Seurat-to-disk-----------------------------------------------------
tmpfile <- tempfile(fileext = ".h5ad")
write_h5ad(obj, tmpfile)

## ----write-to-disk-zarr-------------------------------------------------------
tmpfile <- tempfile(fileext = ".zarr")
adata$write_zarr(tmpfile) # Alternatively, write_zarr(adata, tmpfile)

tmpfile <- tempfile(fileext = ".zarr")
write_zarr(sce, tmpfile)

tmpfile <- tempfile(fileext = ".zarr")
write_zarr(obj, tmpfile)

## ----subset-obs---------------------------------------------------------------
# Create some sample data
adata <- AnnData(
  X = matrix(rnorm(50), nrow = 10, ncol = 5),
  obs = data.frame(
    cell_type = factor(rep(c("A", "B", "C"), c(3, 4, 3))),
    score = runif(10)
  ),
  var = data.frame(
    gene_name = paste0("gene_", 1:5),
    highly_variable = c(TRUE, FALSE, TRUE, TRUE, FALSE)
  )
)

# Subset to cell type "A"
view1 <- adata[adata$obs$cell_type == "A", ]
view1

## ----subset-vars--------------------------------------------------------------
# Subset to highly variable genes
view2 <- adata[, adata$var$highly_variable]
view2

## ----subset-both--------------------------------------------------------------
# Subset to cell type "A" and highly variable genes
view3 <- adata[adata$obs$cell_type == "A", adata$var$highly_variable]
view3

## ----subset-types-------------------------------------------------------------
# Numeric indices
view4 <- adata[1:5, 1:3]
view4

# Character names (if available)
rownames(adata) <- paste0("cell_", 1:10)
colnames(adata) <- paste0("gene_", 1:5)
view5 <- adata[c("cell_1", "cell_2"), c("gene_1", "gene_3")]
view5

## ----view-properties----------------------------------------------------------
# Access dimensions
dim(view3)
nrow(view3)
ncol(view3)

# Access names
rownames(view3)
colnames(view3)

# Access data matrices and metadata
view3$X
view3$obs
view3$var

# Views can be converted to concrete implementations
concrete <- view3$as_InMemoryAnnData()
concrete

## ----citation-----------------------------------------------------------------
citation("anndataR")

## ----sessioninfo--------------------------------------------------------------
sessionInfo()

#' Generate a mock dataset
#'
#' Generate a mock synthetic dataset with different types of columns and layers.
#' This is primarily designed for use in tests, examples, vignettes and other
#' documentation but is also provided to users for creating reproducible
#' examples.
#'
#' @param n_obs Number of observations to generate
#' @param n_vars Number of variables to generate
#' @param x_type Type of matrix to generate for `X`
#' @param layer_types Types of matrices to generate for `layers`
#' @param obs_types Types of vectors to generate for `obs`
#' @param var_types Types of vectors to generate for `var`
#' @param obsm_types Types of matrices to generate for `obsm`
#' @param varm_types Types of matrices to generate for `varm`
#' @param obsp_types Types of matrices to generate for `obsp`
#' @param varp_types Types of matrices to generate for `varp`
#' @param uns_types Types of objects to generate for `uns`
#' @param example If `TRUE`, the types will be overridden with a small subset of
#'   types. This is useful for documentation.
#' @param format Object type to output, one of "list", "AnnData",
#'   "SingleCellExperiment", or "Seurat".
#'
#' @return For `generate_dataset()`, an object as defined by `output` containing
#'   the generated dataset
#' @export
#'
#' @details
#' To generate no data for a given slot, set the matching type argument to
#' `NULL` or an empty vector, e.g. `obs_types = c()` will generate an empty
#' `obs` data frame.
#'
#' When generating `SingleCellExperiment` or `Seurat` objects, only some of the
#' generated slots will be included in the output object. To generate a more
#' complete object, use `format = "AnnData"` followed by
#' `adata$as_SingleCellExperiment()` or `adata$as_Seurat()`.
#'
#' @examples
#' # Generate all types as a list
#' dummy <- generate_dataset()
#'
#' # Generate the example types
#' dummy_example <- generate_dataset(example = TRUE)
#'
#' # Generate an AnnData
#' dummy_anndata <- generate_dataset(format = "AnnData", example = TRUE)
#'
#' # Generate a SingleCellExperiment
#' if (rlang::is_installed("SingleCellExperiment")) {
#'   dummy_sce <- generate_dataset(format = "SingleCellExperiment", example = TRUE)
#' }
#'
#' # Generate a Seurat object
#' if (rlang::is_installed("SeuratObject")) {
#'   dummy_seurat <- generate_dataset(format = "Seurat", example = TRUE)
#' }
#'
generate_dataset <- function(
  n_obs = 10L,
  n_vars = 20L,
  x_type = "numeric_matrix",
  layer_types = get_generator_types(slot = "layers"),
  obs_types = get_generator_types(slot = "obs"),
  var_types = get_generator_types(slot = "var"),
  obsm_types = get_generator_types(slot = "obsm"),
  varm_types = get_generator_types(slot = "varm"),
  obsp_types = get_generator_types(slot = "obsp"),
  varp_types = get_generator_types(slot = "varp"),
  uns_types = get_generator_types(slot = "uns"),
  example = FALSE,
  format = c("list", "AnnData", "SingleCellExperiment", "Seurat")
) {
  format <- match.arg(format)

  if (example) {
    example_generator_types <- get_generator_types(example = TRUE)

    x_type <- example_generator_types$X
    layer_types <- example_generator_types$layers
    obs_types <- example_generator_types$obs
    var_types <- example_generator_types$var
    obsm_types <- example_generator_types$obsm
    varm_types <- example_generator_types$varm
    obsp_types <- example_generator_types$obsp
    varp_types <- example_generator_types$varp
    uns_types <- example_generator_types$uns
  }

  if (!rlang::is_empty(x_type) && length(x_type) != 1) {
    cli_abort("{.arg x_type} must be a single type")
  }

  for (slot in .anndata_slots) {
    types_arg <- if (slot == "X") {
      "x_type"
    } else if (slot == "layers") {
      "layer_types"
    } else {
      paste0(slot, "_types")
    }
    types <- get(types_arg)
    if (!all(types %in% .generator_types[[slot]])) {
      invalid_types <- types[!types %in% .generator_types[[slot]]] # nolint: object_use_linter
      cli_abort(c(
        "Some {.arg {types_arg}} types are not valid: {.val {invalid_types}}.",
        "i" = "Valid types are: {.val {.generator_types[[slot]]}}"
      ))
    }
  }

  dataset_list <- .generate_dataset_as_list(
    n_obs = n_obs,
    n_vars = n_vars,
    x_type = x_type,
    layer_types = layer_types,
    obs_types = obs_types,
    var_types = var_types,
    obsm_types = obsm_types,
    varm_types = varm_types,
    obsp_types = obsp_types,
    varp_types = varp_types,
    uns_types = uns_types
  )

  conversion_fun <- switch(
    format,
    "list" = identity,
    "SingleCellExperiment" = .generate_dataset_as_sce,
    "Seurat" = .generate_dataset_as_seurat,
    "AnnData" = .generate_dataset_as_anndata
  )

  conversion_fun(dataset_list)
}

#' Generate a dummy dataset as a list
#'
#' @inheritParams generate_dataset
#'
#' @return A list with the generated dataset
#'
#' @noRd
.generate_dataset_as_list <- function(
  n_obs = 10L,
  n_vars = 20L,
  x_type = get_generator_types(slot = "X")[1],
  layer_types = get_generator_types(slot = "layers"),
  obs_types = get_generator_types(slot = "obs"),
  var_types = get_generator_types(slot = "var"),
  obsm_types = get_generator_types(slot = "obsm"),
  varm_types = get_generator_types(slot = "varm"),
  obsp_types = get_generator_types(slot = "obsp"),
  varp_types = get_generator_types(slot = "varp"),
  uns_types = get_generator_types(slot = "uns")
) {
  # generate X
  X <- generate_matrix(n_obs, n_vars, x_type)

  # generate layers
  layers <- lapply(layer_types, generate_matrix, n_obs = n_obs, n_vars = n_vars)
  names(layers) <- layer_types

  # generate obs
  obs <- generate_dataframe(n_obs, obs_types)

  # generate var
  var <- generate_dataframe(n_vars, var_types)

  # generate obs_names
  obs_names <- paste0("cell", seq_len(n_obs))
  rownames(obs) <- obs_names

  # generate var_names
  var_names <- paste0("gene", seq_len(n_vars))
  rownames(var) <- var_names

  # generate obsm
  obsm <- lapply(obsm_types, function(obsm_type) {
    if (obsm_type %in% names(vector_generators)) {
      generate_dataframe(n_obs, obsm_type)
    } else {
      # generate n_obs vars to stay aligned with dummy-anndata, see scverse/anndataR#286
      generate_matrix(n_obs, n_vars = n_obs, obsm_type)
    }
  })
  names(obsm) <- obsm_types

  # generate varm
  varm <- lapply(varm_types, function(varm_type) {
    if (varm_type %in% names(vector_generators)) {
      generate_dataframe(n_vars, varm_type)
    } else {
      # generate n_vars vars to stay aligned with dummy-anndata, see scverse/anndataR#286
      generate_matrix(n_vars, n_vars = n_vars, varm_type)
    }
  })
  names(varm) <- varm_types

  # generate obsp
  obsp <- lapply(obsp_types, generate_matrix, n_obs = n_obs, n_vars = n_obs)
  names(obsp) <- obsp_types

  # generate varp
  varp <- lapply(varp_types, generate_matrix, n_obs = n_vars, n_vars = n_vars)
  names(varp) <- varp_types

  # generate uns by combining other classes
  uns <- lapply(uns_types, function(uns_type) {
    if (uns_type == "list") {
      # TODO: add multiple data types here
      list(
        1L,
        1,
        "a",
        factor("a"),
        TRUE,
        list(nested = list(list = c(1, 2, 3)))
      )
    } else if (uns_type == "scalar_character_with_nas") {
      NA_character_
    } else if (uns_type == "scalar_integer_with_nas") {
      NA_integer_
    } else if (uns_type == "scalar_factor_with_nas") {
      factor(NA_character_)
    } else if (uns_type == "scalar_factor_ordered_with_nas") {
      factor(NA_character_, ordered = TRUE)
    } else if (uns_type == "scalar_logical_with_nas") {
      NA_real_
    } else if (grepl("scalar_", uns_type)) {
      generate_vector(1L, gsub("scalar_", "", uns_type))
    } else if (grepl("vec_", uns_type)) {
      generate_vector(10L, gsub("vec_", "", uns_type))
    } else if (grepl("df_", uns_type)) {
      generate_dataframe(10L, gsub("df_", "", uns_type))
    } else if (grepl("mat_", uns_type)) {
      generate_matrix(10L, 10L, gsub("mat_", "", uns_type))
    } else {
      cli_abort("Unknown {.field uns} type: {.val {uns_type}}")
    }
  })
  names(uns) <- uns_types

  # return list
  list(
    X = X,
    obs = obs,
    obsm = obsm,
    obsp = obsp,
    var = var,
    varm = varm,
    varp = varp,
    layers = layers,
    uns = uns
  )
}

#' Convert a dummy dataset to a SingleCellExperiment object
#'
#' @param dataset_list Output of `.generate_dataset_as_list()`
#'
#' @return SingleCellExperiment containing the generated data
#'
#' @noRd
.generate_dataset_as_sce <- function(dataset_list) {
  check_requires(
    "Creating a SingleCellExperiment",
    "SingleCellExperiment",
    "Bioc"
  )

  assays_list <- c(
    list(X = dataset_list$X),
    dataset_list$layers
  )
  assays_list <- lapply(assays_list, Matrix::t)

  sce <- SingleCellExperiment::SingleCellExperiment(
    assays = assays_list,
    rowData = dataset_list$var,
    colData = dataset_list$obs
  )
  colnames(sce) <- dataset_list$obs_names
  rownames(sce) <- dataset_list$var_names

  # TODO: add obsm, varm, obsp, varp, uns?

  sce
}

#' Convert a dummy dataset to a Seurat object
#'
#' @param dataset_list Output of `.generate_dataset_as_list()`
#'
#' @return Seurat containing the generated data
#'
#' @noRd
.generate_dataset_as_seurat <- function(dataset_list) {
  check_requires("Creating a SeuratObject", "SeuratObject")

  if (!is.null(dataset_list$X)) {
    X <- t(dataset_list$X)
  } else if (!is.null(dataset_list$layers)) {
    X <- t(dataset_list$layers[[1]])
  } else {
    cli_abort(
      "Creating a {.cls Seurat} requires {.arg x_type} or {.arg layer_types} to be set"
    )
  }

  X <- t(dataset_list$X)
  colnames(X) <- dataset_list$obs_names
  rownames(X) <- dataset_list$var_names

  # Convert to sparse matrix to avoid Seurat warning about coercing dense matrix
  if (!inherits(X, "sparseMatrix")) {
    X <- as(X, "CsparseMatrix")
  }

  seurat <- SeuratObject::CreateSeuratObject(X)

  for (layer in names(dataset_list$layers)) {
    layer_data <- Matrix::t(dataset_list$layers[[layer]])
    colnames(layer_data) <- dataset_list$obs_names
    rownames(layer_data) <- dataset_list$var_names
    seurat <- SeuratObject::SetAssayData(seurat, layer, layer_data)
  }

  seurat <- SeuratObject::AddMetaData(seurat, dataset_list$obs)

  # TODO: add obsm, varm, obsp, varp, uns?

  seurat
}

#' Convert a dummy dataset to an AnnData object
#'
#' @param list Output of `.generate_dataset_as_list()`
#'
#' @return SingleCellExperiment containing the generated data
#'
#' @noRd
# nolint start: object_name_linter object_length_linter
.generate_dataset_as_anndata <- function(dataset_list) {
  # nolint end: object_name_linter object_length_linter
  AnnData(
    X = dataset_list$X,
    obs = dataset_list$obs,
    obsm = dataset_list$obsm,
    obsp = dataset_list$obsp,
    var = dataset_list$var,
    varm = dataset_list$varm,
    varp = dataset_list$varp,
    layers = dataset_list$layers,
    uns = dataset_list$uns
  )
}

test_that("generating dummy data works", {
  dataset <- generate_dataset()
  expect_type(dataset, "list")
  expect_setequal(
    names(dataset),
    .anndata_slots
  )
  expect_identical(dim(dataset$X), c(10L, 20L))
})

test_that("generating dummy SingleCellExperiment works", {
  skip_if_not_installed("SingleCellExperiment")

  dummy <- generate_dataset(format = "SingleCellExperiment")
  expect_s4_class(dummy, "SingleCellExperiment")

  dummy <- generate_dataset(format = "SingleCellExperiment", example = TRUE)
  expect_s4_class(dummy, "SingleCellExperiment")
})

test_that("generating dummy Seurat works", {
  skip_if_not_installed("SeuratObject")

  dummy <- generate_dataset(format = "Seurat")
  expect_s4_class(dummy, "Seurat")

  dummy <- generate_dataset(format = "Seurat", example = TRUE)
  expect_s4_class(dummy, "Seurat")
})


args1 <- formals(generate_dataset)
args2 <- formals(.generate_dataset_as_list)

# If any of these tests are failing, the arguments of generate_dataset()
# need to be updated to include the new generator types.
for (arg in intersect(names(args1), names(args2))) {
  test_that(
    paste0(
      "generate_dataset(): argument '",
      arg,
      "' has correct default value"
    ),
    {
      expect_equal(eval(args1[[arg]]), eval(args2[[arg]]))
    }
  )
}

test_that("Generated obsm/varm have expected dimensions", {
  n_obs <- 10L
  n_vars <- 20L
  dummy <- generate_dataset(
    n_obs = n_obs,
    n_vars = n_vars,
    x_type = NULL,
    obs_types = list(),
    var_types = list(),
    layer_types = list(),
    obsm_types = list("integer_matrix"),
    varm_types = list("integer_matrix"),
    obsp_types = list(),
    varp_types = list(),
    uns_types = list(),
  )

  expect_identical(dim(dummy$obsm$integer_matrix), c(n_obs, n_obs))
  expect_identical(dim(dummy$varm$integer_matrix), c(n_vars, n_vars))
})

test_that("generate_dataset() works with empty types", {
  expect_no_error(
    generate_dataset(
      x_type = NULL,
      obs_types = list(),
      var_types = list(),
      layer_types = list(),
      obsm_types = list(),
      varm_types = list(),
      obsp_types = list(),
      varp_types = list(),
      uns_types = list()
    )
  )
})

test_that("generated logical vectors are as expected", {
  dummy <- generate_dataset(
    n_obs = 10L,
    x_type = NULL,
    obs_types = list("logical", "logical_with_nas"),
    var_types = list(),
    layer_types = list(),
    obsm_types = list(),
    varm_types = list(),
    obsp_types = list(),
    varp_types = list(),
    uns_types = list()
  )

  expect_true(dummy$obs$logical[1])
  expect_false(dummy$obs$logical[2])
  expect_true(sum(dummy$obs$logical == TRUE) == 5)
  expect_true(sum(dummy$obs$logical == FALSE) == 5)

  expect_true(is.na(dummy$obs$logical_with_nas[1]))
  expect_false(dummy$obs$logical_with_nas[2])
  expect_true(dummy$obs$logical_with_nas[3])
  expect_true(sum(dummy$obs$logical_with_nas == TRUE, na.rm = TRUE) == 4)
  expect_true(sum(dummy$obs$logical_with_nas == FALSE, na.rm = TRUE) == 5)
  expect_true(sum(is.na(dummy$obs$logical_with_nas)) == 1)
})

matrix_equivalences <- list(
  c("float_matrix", "numeric_matrix"),
  c("float_matrix", "numeric_dense"),
  c("float_matrix_nas", "numeric_matrix_with_nas"),
  c("float_matrix_nas", "numeric_dense_with_nas"),
  c("integer_matrix", "integer_matrix"),
  c("float_csparse", "numeric_csparse"),
  c("float_csparse_nas", "numeric_csparse_with_nas"),
  c("float_rsparse", "numeric_rsparse"),
  c("float_rsparse_nas", "numeric_rsparse_with_nas")
)

# python, R
vector_equivalences <- list(
  c("categorical", "factor"),
  c("categorical_ordered", "factor_ordered"),
  c("categorical_missing_values", "factor_with_nas"),
  c("categorical_ordered_missing_values", "factor_ordered_with_nas"),
  c("string_array", "character"),
  c("dense_array", "numeric"),
  c("integer_array", "integer"),
  c("boolean_array", "logical"),
  c("nullable_integer_array", "integer_with_nas"),
  c("nullable_boolean_array", "logical_with_nas")
)

all_equivalences <- c(matrix_equivalences, vector_equivalences)

check_arg <- function(args, name, falseval) {
  if (name %in% names(args)) {
    args[[name]][[1]]
  } else {
    falseval
  }
}

r_generate_dataset <- function(n_obs, n_vars, write = FALSE, ...) {
  args <- list(...)

  data <- generate_dataset(
    n_obs,
    n_vars,
    x_type = check_arg(args, "x_type", "numeric_matrix"),
    layer_types = check_arg(args, "layer_types", character()),
    obs_types = check_arg(args, "obs_types", character()),
    var_types = check_arg(args, "var_types", character()),
    obsm_types = check_arg(args, "obsm_types", character()),
    varm_types = check_arg(args, "varm_types", character()),
    obsp_types = check_arg(args, "obsp_types", character()),
    varp_types = check_arg(args, "varp_types", character()),
    uns_types = check_arg(args, "uns_types", character()),
    format = "AnnData"
  )
  if (write) {
    r_write_dataset(data)
  }

  data
}

r_write_dataset <- function(dataset, file = NULL) {
  if (is.null(file)) {
    file <- tempfile(pattern = "hdf5_write_R_", fileext = ".h5ad")
  }
  write_h5ad(dataset, file)
  file
}

#' Convert an `AnnData` to a `SingleCellExperiment`
#'
#' Convert an `AnnData` object to a `SingleCellExperiment` object
#'
#' @param adata The `AnnData` object to convert
#' @param x_mapping A string specifying the name of the assay in the resulting
#'   `SingleCellExperiment` where the data in the `X` slot of `adata` will be
#'   mapped to
#' @param assays_mapping A named vector where names are names of `assays` in the
#'   resulting `SingleCellExperiment` object and values are keys of `layers` in
#'   `adata`. See below for details.
#' @param colData_mapping A named vector where names are columns of `colData` in
#'   the resulting `SingleCellExperiment` object and values are columns of `obs`
#'   in `adata`. See below for details.
#' @param rowData_mapping A named vector where names are columns of `rowData` in
#'   the resulting `SingleCellExperiment` object and values are columns of `var`
#'   in `adata`. See below for details.
#' @param reducedDims_mapping A named vector where names are names of
#'   `reducedDims` in the resulting `SingleCellExperiment` object and values are
#'   keys of `obsm` in `adata`. Alternatively, a named list where names are
#'   names of `reducedDims` in the resulting `SingleCellExperiment` object and
#'   values are vectors with the items `"sampleFactors"` and `"featureLoadings"`
#'   and/or `"metadata"`. See below for details.
#' @param colPairs_mapping A named vector where names are names of `colPairs` in
#'   the resulting `SingleCellExperiment` object and values are keys of `obsp`
#'   in `adata`. See below for details.
#' @param rowPairs_mapping A named vector where names are names of `rowPairs` in
#'   the resulting `SingleCellExperiment` object and values are keys of `varp`
#'   in `adata`. See below for details.
#' @param metadata_mapping A named vector where names are names of `metadata` in
#'   the resulting `SingleCellExperiment` object and values are keys of `uns` in
#'   `adata`. See below for details.
#'
#' @details
#'
#' ## Mapping arguments
#'
#' All mapping arguments expect a named character vector where names are the
#' names of the slot in the `SingleCellExperiment` object and values are the
#' keys of the corresponding slot of `adata`. If `TRUE`, the conversion function
#' will guess which items to copy as described in the conversion tables below.
#' In most cases, the default is to copy all items using the same names except
#' where the correspondence between objects is unclear. The
#' `reducedDims_mapping` argument can also accept a more complex list format,
#' see below for details. To avoid copying anything to a slot, set the mapping
#' argument to `FALSE`. Empty mapping arguments (`NULL`, `c()`, `list()`) will
#' be treated as `FALSE` with a warning. If an unnamed vector is provided, the
#' values will be used as names.
#'
#' ### Examples:
#'
#' - `TRUE` will guess which items to copy as described in the conversion
#'   table
#' - `c(sce_item = "adata_item")` will copy `adata_item` from the slot in
#'   `adata` to `sce_item` in the corresponding slot of the new
#'   `SingleCellExperiment` object
#' - `FALSE` will avoid copying anything to the slot
#' - `c("adata_item")` is equivalent to `c(adata_item = "adata_item")`
#'
#' ## Conversion table
#'
# nolint start: line_length_linter
#'
#' | **From `AnnData`** | **To `SingleCellExperiment`** | **Example mapping argument** | **Default** |
#' |--------------------|-------------------------------|------------------------------|-----------------------|
#' | `adata$X` | `assays(sce)` | `x_mapping = "counts"` | The data in `adata$X` is copied to the assay named `X` |
#' | `adata$layers` | `assays(sce)` | `assays_mapping = c(counts = "counts")` | All items are copied by name |
#' | `adata$obs` | `colData(sce)` | `colData_mapping = c(n_counts = "n_counts", cell_type = "CellType")` | All columns are copied by name |
#' | `adata$var` | `rowData(sce)` | `rowData_mapping = c(n_cells = "n_cells", pct_zero = "PctZero")` | All columns are copied by name |
#' | `adata$obsm` | `reducedDims(sce)` | `reducedDims_mapping = c(pca = "X_pca")` **OR** `reducedDims_mapping = list(pca = c(sampleFactors = "X_pca", featureLoadings = "PCs", metadata = "pca_metadata"))`  | All items are copied by name without loadings except for `"X_pca"` for which loadings are added from `"PCs"` |
#' | `adata$obsp` | `colPairs(sce)` | `colPairs_mapping = c(nn = "connectivities")` | All items are copied by name |
#' | `adata$varp` | `rowPairs(sce)` | `rowPairs_mapping = c(gene_overlaps = "similarities")` | All items are copied by name |
#' | `adata$uns` | `metadata(sce)` | `uns_mapping = c(project_metadata = "metadata")` | All items are copied by name |
#'
# nolint end: line_length_linter
#'
#' ## The `reducedDims_mapping` argument
#'
#' For the simpler named vector format, the names should be the names of
#' `reducedDims` in the resulting `SingleCellExperiment` object, and the values
#' should be the keys of `obsm` in `adata`.
#'
#' For more advanced mapping, use the list format where each item is a vector
#' with the following names used to create a
#' [`SingleCellExperiment::LinearEmbeddingMatrix`] (if `featureLoadings` or
#' `metadata` is provided):
#'
#' - `sampleFactors`: a key of the `obsm` slot in `adata`,
#'   `adata$obsm[[sampleFactors]]` is passed to the `sampleFactors` argument
#' - `featureLoadings`: a key of the `varm` slot in `adata` (optional),
#'   `adata$varm[[featureLoadings]]` is passed to the `featureLoadings` argument
#' - `metadata`: a key of the `uns` slot in `adata` (optional),
#'   `adata$uns[[metadata]]` is passed to the `metadata` argument
#'
#' ## The `x_mapping` and `assays_mapping` arguments
#'
#' In order to specify where the data in `adata$X` will be stored in the
#' `assays(sce)` slot of the resulting object, you can use either the
#' `x_mapping` argument or the `assays_mapping` argument.
#' If you use `x_mapping`, it should be a string specifying the name of the
#' layer in `assays(sce)` where the data in `adata$X` will be stored.
#' If you use `assays_mapping`, it should be a named vector where names are
#' names of `assays(sce)` and values are keys of `layers` in `adata`.
#' In order to indicate the `adata$X` slot, you use `NA` as the value in the
#' vector. The name you provide for `x_mapping` may not be a name in
#' `assays_mapping`.
#'
#' @return A `SingleCellExperiment` object containing the requested data from
#'   `adata`
#'
#' @family object converters
#'
#' @examplesIf rlang::is_installed("SingleCellExperiment")
#'   ad <- AnnData(
#'     X = matrix(1:5, 3L, 5L),
#'     layers = list(A = matrix(5:1, 3L, 5L), B = matrix(letters[1:5], 3L, 5L)),
#'     obs = data.frame(row.names = LETTERS[1:3], cell = 1:3),
#'     var = data.frame(row.names = letters[1:5], gene = 1:5)
#'   )
#'
#'   # Default usage
#'   sce <- ad$as_SingleCellExperiment(
#'     assays_mapping = TRUE,
#'     colData_mapping = TRUE,
#'     rowData_mapping = TRUE,
#'     reducedDims_mapping = TRUE,
#'     colPairs_mapping = TRUE,
#'     rowPairs_mapping = TRUE,
#'     metadata_mapping = TRUE
#'  )
# nolint start: object_name_linter
as_SingleCellExperiment <- function(
  adata,
  x_mapping = NULL,
  assays_mapping = TRUE,
  colData_mapping = TRUE,
  rowData_mapping = TRUE,
  reducedDims_mapping = TRUE,
  colPairs_mapping = TRUE,
  rowPairs_mapping = TRUE,
  metadata_mapping = TRUE
) {
  # nolint end: object_name_linter
  check_requires(
    "Converting AnnData to SingleCellExperiment",
    "SingleCellExperiment",
    "Bioc"
  )

  if (!(inherits(adata, "AbstractAnnData"))) {
    cli_abort(
      "{.arg adata} must be a {.cls AbstractAnnData} but has class {.cls {class(adata)}}"
    )
  }

  # guess mappings if not provided
  # nolint start object_name_linter
  assays_mapping <- get_mapping(
    assays_mapping,
    .as_SCE_guess_all,
    adata,
    "assays_mapping",
    slot = "layers"
  )
  colData_mapping <- get_mapping(
    colData_mapping,
    .as_SCE_guess_all,
    adata,
    "colData_mapping",
    slot = "obs"
  )
  rowData_mapping <- get_mapping(
    rowData_mapping,
    .as_SCE_guess_all,
    adata,
    "rowData_mapping",
    slot = "var"
  )
  reducedDims_mapping <- get_mapping(
    reducedDims_mapping,
    .as_SCE_guess_reducedDims,
    adata,
    "reducedDims_mapping"
  )
  colPairs_mapping <- get_mapping(
    colPairs_mapping,
    .as_SCE_guess_all,
    adata,
    "colPairs_mapping",
    slot = "obsp"
  )
  rowPairs_mapping <- get_mapping(
    rowPairs_mapping,
    .as_SCE_guess_all,
    adata,
    "rowPairs_mapping",
    slot = "varp"
  )
  metadata_mapping <- get_mapping(
    metadata_mapping,
    .as_SCE_guess_all,
    adata,
    "metadata_mapping",
    slot = "uns"
  )
  # nolint end object_name_linter

  # trackstatus: class=SingleCellExperiment, feature=get_X, status=done
  # trackstatus: class=SingleCellExperiment, feature=get_layers, status=done

  if (!is.null(x_mapping)) {
    assays_mapping <- setNames(
      c(NA, assays_mapping),
      c(x_mapping, names(assays_mapping))
    )
  } else if (!is.null(adata$X)) {
    assays_mapping[["X"]] <- NA
  }
  if (any(duplicated(names(assays_mapping)))) {
    cli_abort(
      "{.arg assays_mapping} or {.arg x_mapping} must not contain any duplicate names",
      "i" = "Found duplicate names: {.val {names(assays_mapping)[duplicated(names(assays_mapping))]}}"
    )
  }
  sce_assays <- vector("list", length(assays_mapping))
  names(sce_assays) <- names(assays_mapping)
  for (i in seq_along(assays_mapping)) {
    from <- assays_mapping[[i]]
    to <- names(assays_mapping)[[i]]
    sce_assays[[to]] <-
      if (is.na(from)) {
        to_R_matrix(adata$X)
      } else {
        to_R_matrix(adata$layers[[from]])
      }
  }

  # construct colData
  # trackstatus: class=SingleCellExperiment, feature=get_obs, status=done
  # trackstatus: class=SingleCellExperiment, feature=get_obs_names, status=done
  col_data <- .as_SCE_process_dataframe_mapping(adata, colData_mapping, "obs")

  # construct rowData
  # trackstatus: class=SingleCellExperiment, feature=get_var, status=done
  # trackstatus: class=SingleCellExperiment, feature=get_var_names, status=done
  row_data <- .as_SCE_process_dataframe_mapping(adata, rowData_mapping, "var")

  # construct colPairs
  # trackstatus: class=SingleCellExperiment, feature=get_obsp, status=done
  col_pairs <- .as_SCE_process_simple_mapping(adata, colPairs_mapping, "obsp")

  # construct rowPairs
  # trackstatus: class=SingleCellExperiment, feature=get_varp, status=done
  row_pairs <- .as_SCE_process_simple_mapping(adata, rowPairs_mapping, "varp")

  # construct metadata
  # trackstatus: class=SingleCellExperiment, feature=get_uns, status=done
  metadata <- .as_SCE_process_simple_mapping(adata, metadata_mapping, "uns")

  # construct reducedDims
  reduceddims <- .as_SCE_process_reducedDims_mapping(adata, reducedDims_mapping)

  # construct output object
  sce <- SingleCellExperiment::SingleCellExperiment(
    assays = sce_assays,
    colData = col_data,
    rowData = row_data,
    colPairs = col_pairs,
    rowPairs = row_pairs,
    metadata = metadata,
    checkDimnames = TRUE
  )

  # only here to ensure that the dimensions are right
  SingleCellExperiment::reducedDims(sce) <- reduceddims

  sce
}

# nolint start: object_length_linter object_name_linter
.as_SCE_guess_all <- function(adata, slot) {
  # nolint end: object_length_linter object_name_linter
  if (!(inherits(adata, "AbstractAnnData"))) {
    cli_abort(
      "{.arg adata} must be a {.cls AbstractAnnData} but has class {.cls {class(adata)}}"
    )
  }

  self_name(names(adata[[slot]]))
}

# nolint start: object_length_linter object_name_linter
.as_SCE_guess_reducedDims <- function(adata) {
  # nolint end: object_length_linter object_name_linter
  purrr::map(adata$obsm_keys(), function(.obsm) {
    if (!is.numeric(as.matrix(adata$obsm[[.obsm]]))) {
      return(NULL)
    }

    mapping <- c(sampleFactors = .obsm)
    if (.obsm == "X_pca" && "PCs" %in% names(adata$varm)) {
      mapping["featureLoadings"] <- "PCs"
    }

    mapping
  }) |>
    setNames(adata$obsm_keys()) |>
    purrr::compact()
}

# nolint start: object_length_linter object_name_linter
.as_SCE_process_simple_mapping <- function(adata, mapping, slot) {
  # nolint end: object_length_linter object_name_linter

  if (rlang::is_empty(mapping)) {
    return(list())
  }

  purrr::map(mapping, function(.item) {
    adata[[slot]][[.item]]
  })
}

# nolint start: object_length_linter object_name_linter
.as_SCE_process_dataframe_mapping <- function(adata, mapping, slot) {
  # nolint end: object_length_linter object_name_linter
  if (slot == "obs") {
    row_names <- adata$obs_names
  } else if (slot == "var") {
    row_names <- adata$var_names
  } else {
    cli_abort(c(
      "{.arg slot} must be either {.val obs} or {.val var}, but is {.val {slot}}"
    ))
  }

  if (rlang::is_empty(mapping)) {
    return(S4Vectors::DataFrame(row.names = row_names))
  }

  purrr::map(mapping, function(.item) {
    adata[[slot]][[.item]]
  }) |>
    S4Vectors::DataFrame(row.names = row_names)
}

# trackstatus: class=SingleCellExperiment, feature=get_obsm, status=done
# trackstatus: class=SingleCellExperiment, feature=get_varm, status=done
# nolint start: object_length_linter object_name_linter
.as_SCE_process_reducedDim <- function(
  # nolint end: object_length_linter object_name_linter
  adata,
  obsm_key,
  varm_key,
  uns_key
) {
  if (!(obsm_key %in% adata$obsm_keys())) {
    cli_abort(
      c(
        "{.val {obsm_key}} is not an item in {.code adata$obsm}",
        "i" = "{.code adata$obsm_keys()}: {.val {adata$obsm_keys()}}"
      )
    )
  }

  embedding <- adata$obsm[[obsm_key]]
  rownames(embedding) <- adata$obs_names

  # If there is no extra info to add, return the embedding matrix
  if (is.null(varm_key) && is.null(uns_key)) {
    return(embedding)
  }

  if (!is.null(varm_key)) {
    if (!(varm_key %in% adata$varm_keys())) {
      cli_abort(
        c(
          "{.val {varm_key}} is not an item in {.code adata$varm}",
          "i" = "{.code adata$varm_keys()}: {.val {adata$varm_keys()}}"
        )
      )
    }

    loadings <- adata$varm[[varm_key]]
    rownames(loadings) <- colnames(embedding)
  } else {
    loadings <- matrix(nrow = 0, ncol = ncol(embedding))
  }

  if (!is.null(uns_key)) {
    if (!(uns_key %in% adata$uns_keys())) {
      cli_abort(
        c(
          "{.val {uns_key}} is not an item in {.code adata$uns}",
          "i" = "{.code adata$uns_keys()}: {.val {adata$uns_keys()}}"
        )
      )
    }

    metadata <- adata$uns[[uns_key]]
  } else {
    metadata <- list()
  }

  lem <- SingleCellExperiment::LinearEmbeddingMatrix(
    sampleFactors = embedding,
    featureLoadings = loadings,
    metadata = metadata
  )
  rownames(lem) <- rownames(embedding)
  colnames(lem) <- colnames(loadings)

  lem
}

# nolint start: object_length_linter object_name_linter
.as_SCE_process_reducedDims_mapping <- function(adata, reducedDims_mapping) {
  # nolint end: object_length_linter object_name_linter

  # If the mapping is a vector expand it to the list format
  if (is.atomic(reducedDims_mapping)) {
    # nolint start: object_name_linter
    reducedDims_mapping <- purrr::map(reducedDims_mapping, function(.obsm) {
      # nolint end: object_name_linter
      c(sampleFactors = .obsm)
    })
  } else {
    purrr::walk(names(reducedDims_mapping), function(.name) {
      mapping <- reducedDims_mapping[[.name]]
      if (!(is.character(mapping) && ("sampleFactors" %in% names(mapping)))) {
        cli_abort(c(
          paste(
            "If it is a list, each item in {.arg reducedDims_mapping} must be a
            {.cls character} vector with the name {.val sampleFactors} and
            optional names {.val featureLoadings} and {.val metadata}"
          ),
          "i" = paste(
            "{.code names(reducedDims_mapping[[{.val { .name }}]])}:",
            "{style_vec(names(mapping))}"
          )
        ))
      }
    })
  }

  purrr::map(reducedDims_mapping, function(.map) {
    varm <- if ("featureLoadings" %in% names(.map)) {
      .map[["featureLoadings"]]
    } else {
      NULL
    }
    uns <- if ("metadata" %in% names(.map)) .map[["metadata"]] else NULL

    .as_SCE_process_reducedDim(
      adata,
      obsm_key = .map[["sampleFactors"]],
      varm_key = varm,
      uns_key = uns
    )
  })
}

skip_if_not_installed("SingleCellExperiment")
library(SingleCellExperiment)

known_issues <- read_known_issues()

ad <- generate_dataset(n_obs = 10L, n_vars = 20L, format = "AnnData")
ad$obsm[["X_pca"]] <- matrix(1:50, 10, 5)
ad$varm[["PCs"]] <- matrix(1:100, 20, 5)

sce <- ad$as_SingleCellExperiment()

test_that("as_SCE retains nr of observations and features", {
  expect_equal(nrow(sce), 20)
  expect_equal(ncol(sce), 10)

  # trackstatus: class=SingleCellExperiment, feature=test_get_var_names, status=done
  expect_equal(rownames(sce), rownames(ad$var))
  # trackstatus: class=SingleCellExperiment, feature=test_get_obs_names, status=done
  expect_equal(colnames(sce), rownames(ad$obs))
})

# trackstatus: class=SingleCellExperiment, feature=test_get_obs, status=done
for (obs_key in colnames(ad$obs)) {
  test_that(paste0("as_SCE retains obs key: ", obs_key), {
    msg <- message_if_known(
      backend = "to_SCE",
      slot = c("obs"),
      dtype = obs_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(obs_key %in% colnames(colData(sce)))
    expect_equal(
      colData(sce)[[obs_key]],
      ad$obs[[obs_key]],
      info = paste0("obs_key: ", obs_key)
    )
  })
}

# trackstatus: class=SingleCellExperiment, feature=test_get_var, status=done
for (var_key in colnames(ad$var)) {
  test_that(paste0("as_SCE retains var key: ", var_key), {
    msg <- message_if_known(
      backend = "to_SCE",
      slot = c("var"),
      dtype = var_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(var_key %in% colnames(rowData(sce)))
    expect_equal(
      rowData(sce)[[var_key]],
      ad$var[[var_key]],
      info = paste0("var_key: ", var_key)
    )
  })
}

# trackstatus: class=SingleCellExperiment, feature=test_get_layers, status=done
for (layer_key in names(ad$layers)) {
  test_that(paste0("as_SCE retains layer: ", layer_key), {
    msg <- message_if_known(
      backend = "to_SCE",
      slot = c("layers"),
      dtype = layer_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(layer_key %in% assayNames(sce))
    expect_true(
      all.equal(
        as.matrix(t(assay(sce, layer_key))),
        as.matrix(ad$layers[[layer_key]]),
        check.attributes = FALSE
      ),
      info = paste0("layer_key: ", layer_key)
    )
  })
}

test_that("as_SCE fails when providing duplicate assay names", {
  expect_error(
    ad$as_SingleCellExperiment(
      x_mapping = "counts",
      assays_mapping = c(counts = "numeric_matrix", integer = "integer_matrix")
    ),
    regexp = "duplicate names"
  )
})

test_that("as_SCE works when only providing x_mapping", {
  sce <- ad$as_SingleCellExperiment(x_mapping = "counts")
  assay_names <- assayNames(sce)
  expect_true("counts" %in% assay_names)
  expect_true(all(ad$layers_keys() %in% assay_names))
})

test_that("as_SCE works with assays_mapping and x_mapping", {
  sce <- ad$as_SingleCellExperiment(
    x_mapping = "counts",
    assays_mapping = c(data = "numeric_matrix", integer = "integer_matrix")
  )
  assay_names <- assayNames(sce)
  expect_true("counts" %in% assay_names)
  expect_true("data" %in% assay_names)
  expect_true("integer" %in% assay_names)
})

test_that("as_SCE works with no x_mapping and no layers_mapping", {
  sce <- ad$as_SingleCellExperiment()
  assay_names <- assayNames(sce)
  expect_true("X" %in% assay_names)
  expect_true(all(ad$layers_keys() %in% assay_names))
})

# trackstatus: class=SingleCellExperiment, feature=test_get_obsp, status=done
for (obsp_key in names(ad$obsp)) {
  test_that(paste0("as_SCE retains obsp key: ", obsp_key), {
    msg <- message_if_known(
      backend = "to_SCE",
      slot = c("obsp"),
      dtype = obsp_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(obsp_key %in% names(colPairs(sce)))

    sce_matrix <- as.matrix(colPair(sce, obsp_key, asSparse = TRUE))
    ad_matrix <- as.matrix(ad$obsp[[obsp_key]])

    # Remove dimnames for comparison since SCE doesn't preserve AnnData dimnames
    dimnames(sce_matrix) <- NULL
    dimnames(ad_matrix) <- NULL
    expect_equal(sce_matrix, ad_matrix, info = paste0("obsp_key: ", obsp_key))
  })
}

# trackstatus: class=SingleCellExperiment, feature=test_get_varp, status=done
for (varp_key in names(ad$varp)) {
  test_that(paste0("as_SCE retains varp key: ", varp_key), {
    msg <- message_if_known(
      backend = "to_SCE",
      slot = c("obsp"),
      dtype = varp_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(varp_key %in% names(rowPairs(sce)))

    sce_matrix <- as.matrix(rowPair(sce, varp_key, asSparse = TRUE))
    ad_matrix <- as.matrix(ad$varp[[varp_key]])

    # Remove dimnames for comparison since SCE doesn't preserve AnnData dimnames
    dimnames(sce_matrix) <- NULL
    dimnames(ad_matrix) <- NULL
    expect_equal(sce_matrix, ad_matrix, info = paste0("varp_key: ", varp_key))
  })
}

# trackstatus: class=SingleCellExperiment, feature=test_get_uns, status=done
for (uns_key in names(ad$uns)) {
  test_that(paste0("as_SCE retains uns key: ", uns_key), {
    msg <- message_if_known(
      backend = "to_SCE",
      slot = c("uns"),
      dtype = uns_key,
      process = "convert",
      known_issues = known_issues
    )
    skip_if(!is.null(msg), message = msg)

    expect_true(uns_key %in% names(metadata(sce)))
    expect_equal(
      metadata(sce)[[uns_key]],
      ad$uns[[uns_key]],
      info = paste0("uns_key: ", uns_key)
    )
  })
}

test_that("as_SCE retains pca dimred", {
  msg <- message_if_known(
    backend = "to_SCE",
    slot = c("obsm", "varm"),
    dtype = "pca",
    process = "convert",
    known_issues = known_issues
  )
  skip_if(!is.null(msg), message = msg)

  # trackstatus: class=SingleCellExperiment, feature=test_get_obsm, status=wip
  expect_true("pca" %in% names(reducedDims(sce)))
  expect_equal(
    sampleFactors(reducedDims(sce)$pca),
    ad$obsm[["X_pca"]],
    ignore.attributes = TRUE
  )

  # trackstatus: class=SingleCellExperiment, feature=test_get_varm, status=wip
  expect_equal(
    featureLoadings(reducedDims(sce)$pca),
    ad$varm[["PCs"]]
  )
})

test_that("as_SCE works with list mappings", {
  expect_no_error(
    ad$as_SingleCellExperiment(
      assays_mapping = as.list(.as_SCE_guess_all(ad, "layers")),
      colData_mapping = as.list(.as_SCE_guess_all(ad, "obs")),
      rowData_mapping = as.list(.as_SCE_guess_all(ad, "var")),
      reducedDims_mapping = as.list(.as_SCE_guess_reducedDims(ad)),
      colPairs_mapping = as.list(.as_SCE_guess_all(ad, "obsp")),
      rowPairs_mapping = as.list(.as_SCE_guess_all(ad, "varp")),
      metadata_mapping = as.list(.as_SCE_guess_all(ad, "uns"))
    )
  )

  expect_error(
    ad$as_SingleCellExperiment(
      reducedDims_mapping = list(numeric = "numeric_matrix")
    )
  )
})

test_that("as_SCE works with a vector reducedDims_mapping", {
  expect_no_error(
    ad$as_SingleCellExperiment(
      reducedDims_mapping = c(numeric = "numeric_matrix")
    )
  )
})

test_that("as_SCE works with unnamed mappings", {
  expect_no_error(
    ad$as_SingleCellExperiment(
      assays_mapping = unname(.as_SCE_guess_all(ad, "layers")),
      colData_mapping = unname(.as_SCE_guess_all(ad, "obs")),
      rowData_mapping = unname(.as_SCE_guess_all(ad, "var")),
      colPairs_mapping = unname(.as_SCE_guess_all(ad, "obsp")),
      rowPairs_mapping = unname(.as_SCE_guess_all(ad, "varp")),
      metadata_mapping = unname(.as_SCE_guess_all(ad, "uns"))
    )
  )
})

#' Convert to an `AnnData` object
#'
#' Convert other objects to an `AnnData` object. See the sections below for
#' details on how slots are mapped between objects. For more information on the
#' functionality of an `AnnData` object, see [AnnData-usage].
#'
#' @param x The object to convert
#' @param x_mapping A string specifying the data to map to the `X` slot. If
#'   `NULL`, no data will be copied to the `X` slot. See below for details.
#' @param layers_mapping A named character vector where the names are keys of
#'   `layers` in the new `AnnData` object and values are the names of items in
#'   the corresponding slot of `x`. See below for details.
#' @param obs_mapping A named character vector where the names are names of
#'   `obs` columns in the new `AnnData` object and values are the names of
#'   columns in the corresponding slot of `x`. See below for details.
#' @param var_mapping A named character vector where the names are names of
#'   `var` columns in the new `AnnData` object and values are the names of
#'   columns in the corresponding slot of `x`. See below for details.
#' @param obsm_mapping A named character vector where the names are keys of
#'   `obsm` in the new `AnnData` object and values are the names of items in the
#'   corresponding slot of `x`. See below for details.
#' @param varm_mapping A named character vector where the names are keys of
#'   `varm` in the new `AnnData` object and values are the names of items in the
#'   corresponding slot of `x`. See below for details.
#' @param obsp_mapping A named character vector where the names are keys of
#'   `obsp` in the new `AnnData` object and values are the names of items in the
#'   corresponding slot of `x`. See below for details.
#' @param varp_mapping A named character vector where the names are keys of
#'   `varp` in the new `AnnData` object and values are the names of items in the
#'   corresponding slot of `x`. See below for details.
#' @param uns_mapping A named character vector where the names are keys of `uns`
#'   in the new `AnnData` object and values are the names of items in the
#'   corresponding slot of `x`. See below for details.
#' @param assay_name For [`SeuratObject::Seurat`] objects, the name of the assay
#'   to be converted. If `NULL`, the default assay will be used
#'   ([SeuratObject::DefaultAssay()]). This is ignored for other objects.
#' @param output_class The `AnnData` class to convert to. Must be one of
#'   `"HDF5AnnData"` or `"InMemoryAnnData"`.
#' @param ... Additional arguments passed to the generator function for
#'   `output_class`
#'
#' @section Details of mapping arguments:
#'
#'   All mapping arguments except for `x_mapping` expect a named character
#'   vector where names are the keys of the slot in the `AnnData` object and
#'   values are the names of items in the corresponding slot of `x`. If `TRUE`,
#'   the conversion function will guess which items to copy as described in the
#'   conversion tables for each object type. In most cases, the default is to
#'   copy all items using the same names except where the correspondence between
#'   objects is unclear. To avoid copying anything to a slot, set the mapping
#'   argument to `FALSE`. Empty mapping arguments (`NULL`, `c()`, `list()`) will
#'   be treated as `FALSE` with a warning. If an unnamed vector is provided, the
#'   values will be used as names.
#'
#'   - `TRUE` will guess which items to copy as described in the conversion
#'     tables for each object type
#'   - `c(adata_item = "x_item")` will copy `x_item` from the slot in `x` to
#'     `adata_item` in the corresponding slot of new `AnnData` object
#'   - `FALSE` will avoid copying anything to the slot
#'   - `c("x_item")` is equivalent to `c(x_item = "x_item")`
#'
#' @section Converting from a `SingleCellExperiment` object:
#'
#'   This table describes how slots in a
#'   [`SingleCellExperiment::SingleCellExperiment`] object to the new `AnnData`
#'   object.
#'
# nolint start: line_length_linter
#'
#'   | **From `SingleCellExperiment`** | **To `AnnData`** | **Example mapping argument** | **Default** |
#'   |---------------------------------|------------------|------------------------------|-----------------------|
#'   | `assays(x)` | `adata$X` | `x_mapping = "counts"` | Nothing is copied to `X` |
#'   | `assays(x)` | `adata$layers` | `layers_mapping = c(counts = "counts")` | All items are copied by name |
#'   | `colData(x)` | `adata$obs` | `obs_mapping = c(n_counts = "n_counts", cell_type = "CellType")` | All columns are copied by name |
#'   | `rowData(x)` | `adata$var` | `var_mapping = c(n_cells = "n_cells", pct_zero = "PctZero")` | All columns are copied by name |
#'   | `reducedDims(x)` | `adata$obsm` | `obsm_mapping = c(X_pca = "pca")` | All items are copied by name |
#'   | `featureLoadings(reducedDims(x))` | `adata$varm` | `varm_mapping = c(PCs = "pca")` | Feature loadings from all [`SingleCellExperiment::LinearEmbeddingMatrix`] objects in `reducedDims(x)` |
#'   | `colPairs(x)` | `adata$obsp` | `obsp_mapping = c(connectivities = "RNA_nn")` | All items are copied by name |
#'   | `rowPairs(x)` | `adata$varp` | `varp_mapping = c(similarities = "gene_overlaps")` | All items are copied by name |
#'   | `metadata(x)` | `adata$uns` | `uns_mapping = c(metadata = "project_metadata")` | All items are copied by name |
#'
#'
# nolint end: line_length_linter
#'
#'   ## Unnamed assays
#'
#'   If `assayNames(x)` is `NULL` or any assay names are empty they will
#'   automatically be named with a warning:
#'
#'   **Examples:**
#'
#'   - Old names: `NULL` -> New names: `"assay1", "assay2", ...`
#'   - Old names: `"counts"` -> New names: `"counts", "assay2"`
#'
#' @section Converting from a `Seurat` object:
#'
#'   Only one assay can be converted from a [`SeuratObject::Seurat`] object to
#'   an `AnnData` object at a time. This can be controlled using the
#'   `assay_name` argument. By default, the current default assay will be used.
#'
#'   This table describes how slots in a [`SeuratObject::Seurat`] object to the
#'   new `AnnData` object.
#'
# nolint start: line_length_linter
#'
#'   | **From `Seurat`** | **To `AnnData`** | **Example mapping argument** | **Default** |
#'   |-------------------|------------------|------------------------------|-----------------------|
#'   | `Layers(x)` | `adata$X` | `x_mapping = "counts"` | Nothing is copied to `X` |
#'   | `Layers(x)` | `adata$layers` | `layers_mapping = c(counts = "counts")` | All items are copied by name |
#'   | `x[[]]` | `adata$obs` | `obs_mapping = c(n_counts = "n_counts", cell_type = "CellType")` | All columns are copied by name |
#'   | `x[[assay_name]][[]]` | `adata$var` | `var_mapping = c(n_cells = "n_cells", pct_zero = "PctZero")` | All columns are copied by name |
#'   | `Reductions(x)` | `adata$obsm` | `obsm_mapping = c(X_pca = "pca")` | All embeddings matching `assay_name` are copied by name |
#'   | `Loadings(x)` | `adata$varm` | `varm_mapping = c(PCs = "pca")` | All valid loadings are copied by name |
#'   | `Graphs(x)` | `adata$obsp` | `obsp_mapping = c(connectivities = "RNA_nn")` | All graphs matching `assay_name` are copied by name |
#'   | `Misc(x)` | `adata$varp` | `varp_mapping = c(similarities = "gene_overlaps")` | No data is copied to `varp` |
#'   | `Misc(x)` | `adata$uns` | `uns_mapping = c(metadata = "project_metadata")` | All items are copied by name |
#'
# nolint end: line_length_linter
#'
#'   ## Graph conversion
#'
#'   By default, all graphs in a [`SeuratObject::Seurat`] object that match the
#'   assay being converted are copied to the `obsp` slot of the new `AnnData`
#'   object. If a graph does not have an associated assay:
#'
#'   - If `assay_name` is the default assay, they will be _converted_ with a
#'     warning
#'   - if `assay_name` is not the default assay, they will be _skipped_ with a
#'     warning
#'
#'   To override this behaviour, provide a custom mapping using the
#'   `obsp_mapping` argument.
#'
#'   ## Unexpected dimensions
#'
#'   A [`SeuratObject::Seurat`] is more flexible in terms of the dimensions of
#'   items that can be stored in various slots. For example, a `Layer` does not
#'   have to match the dimensions of the whole object. If an item has
#'   unexpected dimensions, it will be skipped with a warning.
#'
#' @return An `AnnData` object of the class requested by `output_class`
#'   containing the data specified in the mapping arguments.
#' @export
#'
#' @family AnnData creators
#' @family object converters
#'
#' @examplesIf rlang::is_installed("Seurat")
#' # Convert a Seurat object to an AnnData object
#' library(Seurat)
#'
#' counts <- matrix(rbinom(20000, 1000, .001), nrow = 100)
#' obj <- CreateSeuratObject(counts = counts)
#' obj <- NormalizeData(obj)
#' obj <- FindVariableFeatures(obj)
#' obj <- ScaleData(obj)
#' obj <- RunPCA(obj, npcs = 10L)
#' obj <- FindNeighbors(obj)
#' obj <- RunUMAP(obj, dims = 1:10)
#'
#' as_AnnData(obj)
#'
#' @examplesIf rlang::is_installed("SingleCellExperiment")
#' # Convert a SingleCellExperiment object to an AnnData object
#' library(SingleCellExperiment)
#'
#' sce <- SingleCellExperiment(
#'   assays = list(counts = matrix(1:5, 5L, 3L)),
#'   colData = DataFrame(cell = 1:3, row.names = paste0("Cell", 1:3)),
#'   rowData = DataFrame(gene = 1:5, row.names = paste0("Gene", 1:5))
#' )
#'
#' as_AnnData(sce)
# nolint start: object_name_linter
as_AnnData <- function(
  # nolint end: object_name_linter
  x,
  x_mapping = NULL,
  layers_mapping = TRUE,
  obs_mapping = TRUE,
  var_mapping = TRUE,
  obsm_mapping = TRUE,
  varm_mapping = TRUE,
  obsp_mapping = TRUE,
  varp_mapping = TRUE,
  uns_mapping = TRUE,
  assay_name = NULL,
  output_class = c(
    "InMemory",
    "HDF5AnnData",
    "ZarrAnnData",
    "ReticulateAnnData"
  ),
  ...
) {
  UseMethod("as_AnnData", x)
}

#' @rdname as_AnnData
#' @export
as_AnnData.SingleCellExperiment <- function(
  x,
  x_mapping = NULL,
  layers_mapping = TRUE,
  obs_mapping = TRUE,
  var_mapping = TRUE,
  obsm_mapping = TRUE,
  varm_mapping = TRUE,
  obsp_mapping = TRUE,
  varp_mapping = TRUE,
  uns_mapping = TRUE,
  assay_name = TRUE,
  output_class = c(
    "InMemory",
    "HDF5AnnData",
    "ZarrAnnData",
    "ReticulateAnnData"
  ),
  ...
) {
  from_SingleCellExperiment(
    sce = x,
    x_mapping = x_mapping,
    layers_mapping = layers_mapping,
    obs_mapping = obs_mapping,
    var_mapping = var_mapping,
    obsm_mapping = obsm_mapping,
    varm_mapping = varm_mapping,
    obsp_mapping = obsp_mapping,
    varp_mapping = varp_mapping,
    uns_mapping = uns_mapping,
    output_class = output_class,
    ...
  )
}

#' @rdname as_AnnData
#' @export
as_AnnData.Seurat <- function(
  x,
  x_mapping = NULL,
  layers_mapping = TRUE,
  obs_mapping = TRUE,
  var_mapping = TRUE,
  obsm_mapping = TRUE,
  varm_mapping = TRUE,
  obsp_mapping = TRUE,
  varp_mapping = TRUE,
  uns_mapping = TRUE,
  assay_name = NULL,
  output_class = c(
    "InMemory",
    "HDF5AnnData",
    "ZarrAnnData",
    "ReticulateAnnData"
  ),
  ...
) {
  from_Seurat(
    seurat_obj = x,
    assay_name = assay_name,
    x_mapping = x_mapping,
    layers_mapping = layers_mapping,
    obs_mapping = obs_mapping,
    var_mapping = var_mapping,
    obsm_mapping = obsm_mapping,
    varm_mapping = varm_mapping,
    obsp_mapping = obsp_mapping,
    varp_mapping = varp_mapping,
    uns_mapping = uns_mapping,
    output_class = output_class,
    ...
  )
}

#' Read Zarr encoding
#'
#' Read the encoding and version of an element in a Zarr store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#'
#' @return A named list with names type and version
#'
#' @noRd
read_zarr_encoding <- function(store, name) {
  tryCatch(
    {
      attrs <- Rarr::read_zarr_attributes(file.path(store, name))
      list(
        type = attrs[["encoding-type"]],
        version = attrs[["encoding-version"]]
      )
    },
    error = function(e) {
      cli_abort(
        "Encoding attributes not found for element {.val {name}} in {.path {store}}"
      )
    }
  )
}

#' Read Zarr element
#'
#' Read an element from a Zarr store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param type The encoding type of the element to read
#' @param version The encoding version of the element to read
#' @param stop_on_error Whether to stop on error or generate a warning instead
#' @param ... Extra arguments passed to individual reading functions
#'
#' @details
#' Encoding is automatically determined from the element using
#' `read_zarr_encoding` and used to select the appropriate reading function.
#'
#' @return Value depending on the encoding
#'
#' @noRd
read_zarr_element <- function(
  store,
  name,
  type = NULL,
  version = NULL,
  stop_on_error = FALSE,
  ...
) {
  if (!zarr_path_exists(store, name)) {
    return(NULL)
  }

  if (is.null(type)) {
    encoding_list <- read_zarr_encoding(store, name)
    type <- encoding_list$type
    version <- encoding_list$version
  }

  read_fun <- switch(
    type,
    "null" = read_zarr_null,
    "array" = read_zarr_dense_array,
    "rec-array" = read_zarr_rec_array,
    "csr_matrix" = read_zarr_csr_matrix,
    "csc_matrix" = read_zarr_csc_matrix,
    "dataframe" = read_zarr_data_frame,
    "dict" = read_zarr_mapping,
    "string" = read_zarr_string_scalar,
    "numeric-scalar" = read_zarr_numeric_scalar,
    "categorical" = read_zarr_categorical,
    "string-array" = read_zarr_string_array,
    "nullable-integer" = read_zarr_nullable_integer,
    "nullable-boolean" = read_zarr_nullable_boolean,
    cli_abort(
      "No function for reading Zarr encoding {.cls {type}} for element {.val {name}}"
    )
  )

  tryCatch(
    {
      read_fun(store = store, name = name, version = version, ...)
    },
    error = function(e) {
      msg <- cli::cli_fmt(cli::cli_bullets(c(
        paste0(
          "Error reading element {.field {name}} of type {.cls {type}}"
        ),
        "i" = conditionMessage(e)
      )))
      if (stop_on_error) {
        cli_abort(msg)
      } else {
        cli_warn(msg)
        NULL
      }
    }
  )
}

#' Read Zarr null
#'
#' Read a null value from an Zarr store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param version Encoding version of the element to read
#'
#' @return `NULL`
#' @noRd
read_zarr_null <- function(store, name, version = "0.1.0") {
  version <- match.arg(version)

  NULL
}

#' Read Zarr dense array
#'
#' Read a dense array from a Zarr store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param version Encoding version of the element to read
#'
#' @return A matrix or a vector if 1D
#'
#' @noRd
read_zarr_dense_array <- function(store, name, version = "0.2.0") {
  version <- match.arg(version)

  data <- Rarr::read_zarr_array(file.path(store, name))

  data
}

read_zarr_csr_matrix <- function(store, name, version) {
  read_zarr_sparse_array(
    store = store,
    name = name,
    version = version,
    type = "csr_matrix"
  )
}

read_zarr_csc_matrix <- function(store, name, version) {
  read_zarr_sparse_array(
    store = store,
    name = name,
    version = version,
    type = "csc_matrix"
  )
}

#' Read Zarr sparse array
#'
#' Read a sparse array from a Zarr store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param version Encoding version of the element to read
#' @param type Type of the sparse matrix, either "csr_matrix" or "csc_matrix"
#'
#' @return A sparse matrix/DelayedArray???, or a vector if 1D
#' @importFrom Matrix sparseMatrix
#'
#' @noRd
read_zarr_sparse_array <- function(
  store,
  name,
  version = "0.1.0",
  type = c("csr_matrix", "csc_matrix")
) {
  version <- match.arg(version)
  type <- match.arg(type)

  attrs <- Rarr::read_zarr_attributes(file.path(store, name))

  construct_sparse_matrix(
    data = as.vector(Rarr::read_zarr_array(file.path(store, name, "data"))),
    indices = as.vector(Rarr::read_zarr_array(file.path(
      store,
      name,
      "indices"
    ))),
    indptr = as.vector(Rarr::read_zarr_array(file.path(store, name, "indptr"))),
    shape = as.vector(unlist(attrs$shape, use.names = FALSE)),
    type = type
  )
}

#' Read Zarr recarray
#'
#' Read a recarray from a Zarr store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param version Encoding version of the element to read
#'
#' @details
#' A "record array" (recarray) is a Python NumPy array type that contains
#' "fields" that can be indexed using attributes (similar to columns in a
#' spreadsheet). See https://numpy.org/doc/stable/reference/generated/numpy.recarray.html
#' for details.
#'
#' They are used by **scanpy** to score marker gene testing results.
#'
#' @return A named list of 1D arrays
#'
#' @noRd
read_zarr_rec_array <- function(store, name, version = "0.2.0") {
  version <- match.arg(version)
  Rarr::read_zarr_array(file.path(store, name)) |>
    lapply(as.vector)
}

#' Read Zarr nullable boolean
#'
#' Read a nullable boolean from a Zarr store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param version Encoding version of the element to read
#'
#' @return A boolean vector
#'
#' @noRd
read_zarr_nullable_boolean <- function(store, name, version = "0.1.0") {
  as.logical(read_zarr_nullable(store, name, version))
}

#' Read Zarr nullable integer
#'
#' Read a nullable integer from a Zarr store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param version Encoding version of the element to read
#'
#' @return An integer vector
#'
#' @noRd
read_zarr_nullable_integer <- function(store, name, version = "0.1.0") {
  as.integer(read_zarr_nullable(store, name, version))
}

#' Read Zarr nullable
#'
#' Read a nullable vector (boolean or integer) from a Zarr store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param version Encoding version of the element to read
#'
#' @return A nullable vector
#'
#' @noRd
read_zarr_nullable <- function(store, name, version = "0.1.0") {
  version <- match.arg(version)

  mask <- Rarr::read_zarr_array(file.path(store, paste0(name, "/mask")))
  values <- Rarr::read_zarr_array(file.path(store, paste0(name, "/values")))

  # Get values and set missing
  element <- values
  element[mask] <- NA

  element
}

#' Read Zarr string array
#'
#' Read a string array from a Zarr store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param version Encoding version of the element to read
#'
#' @return A character vector/matrix
#'
#' @noRd
read_zarr_string_array <- function(store, name, version = "0.2.0") {
  version <- match.arg(version)

  data <- Rarr::read_zarr_array(file.path(store, name))

  # convert "NA" to NA (as in rhdf5:::.h5postProcessDataset)
  data[data == "NA"] <- NA

  data
}

#' Read Zarr categorical
#'
#' Read a categorical from a Zarr store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param version Encoding version of the element to read
#'
#' @return A factor
#'
#' @noRd
read_zarr_categorical <- function(store, name, version = "0.2.0") {
  version <- match.arg(version)

  codes <- Rarr::read_zarr_array(file.path(store, paste0(name, "/codes")))
  categories <- Rarr::read_zarr_array(file.path(
    store,
    paste0(name, "/categories")
  ))

  # Get codes and convert to 1-based indexing
  codes <- codes + 1L

  # Set missing values
  codes[codes == 0L] <- NA_integer_

  levels <- categories

  attributes <- Rarr::read_zarr_attributes(file.path(store, name))
  ordered <- attributes[["ordered"]]

  factor(levels[codes], levels = levels, ordered = ordered)
}

#' Read Zarr string scalar
#'
#' Read a string scalar from a Zarr store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param version Encoding version of the element to read
#'
#' @return A character vector of length 1
#'
#' @noRd
read_zarr_string_scalar <- function(store, name, version = "0.2.0") {
  version <- match.arg(version)
  as.character(Rarr::read_zarr_array(file.path(store, name)))
}

#' Read Zarr numeric scalar
#'
#' Read a numeric scalar from a Zarr store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param version Encoding version of the element to read
#'
#' @return A numeric vector of length 1
#'
#' @noRd
read_zarr_numeric_scalar <- function(store, name, version = "0.2.0") {
  version <- match.arg(version)

  value <- Rarr::read_zarr_array(file.path(store, name))

  # convert array to vector
  value <- as.vector(value)

  value
}

#' Read Zarr mapping
#'
#' Read a mapping from a Zarr store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param version Encoding version of the element to read
#'
#' @return A named list
#'
#' @noRd
read_zarr_mapping <- function(store, name, version = "0.1.0") {
  version <- match.arg(version)
  items <- read_zarr_mapping_keys(store, name, version)
  read_zarr_collection(store, name, items)
}

#' Read Zarr data frame
#'
#' Read a data frame from a Zarr store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param version Encoding version of the element to read
#'
#' @return A data.frame
#'
#' @noRd
read_zarr_data_frame <- function(
  store,
  name,
  version = "0.2.0"
) {
  version <- match.arg(version)

  dim_keys <- read_zarr_data_frame_keys(store, name, version)
  data <- read_zarr_collection(store, name, dim_keys$cols)

  as.data.frame(
    row.names = dim_keys$rows,
    data,
    check.names = FALSE,
    fix.empty.names = FALSE
  )
}

#' Read multiple Zarr datatypes
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param item_names Vector of item names (in order)
#'
#' @return A named list
#'
#' @noRd
read_zarr_collection <- function(store, name, item_names) {
  items <- lapply(
    item_names,
    function(item_name) {
      new_name <- paste0(name, "/", item_name)
      encoding <- read_zarr_encoding(store, new_name)
      read_zarr_element(
        store = store,
        name = new_name,
        type = encoding$type,
        version = encoding$version
      )
    }
  )
  names(items) <- item_names
  items
}

#' Read Zarr element keys
#'
#' Read the keys of an element from a Zarr store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param type The encoding type of the element to read
#' @param version The encoding version of the element to read
#' @param stop_on_error Whether to stop on error or generate a warning instead
#' @param ... Extra arguments passed to individual reading functions
#'
#' @return A character vector of keys
#'
#' @noRd
read_zarr_element_keys <- function(
  store,
  name,
  type = NULL,
  version = NULL,
  stop_on_error = FALSE,
  ...
) {
  if (!zarr_path_exists(store, name)) {
    return(NULL)
  }

  if (is.null(type)) {
    encoding_list <- read_zarr_encoding(store, name)
    type <- encoding_list$type
    version <- encoding_list$version
  }

  read_fun <- switch(
    type,
    "dataframe" = read_zarr_data_frame_keys,
    "dict" = read_zarr_mapping_keys,
    cli_abort(
      "No function for reading keys for Zarr encoding {.cls {type}} for element {.val {name}}"
    )
  )

  tryCatch(
    {
      read_fun(store = store, name = name, version = version, ...)
    },
    error = function(e) {
      msg <- cli::cli_fmt(cli::cli_bullets(c(
        paste0(
          "Error reading element keys for {.field {name}} of type {.cls {type}}"
        ),
        "i" = conditionMessage(e)
      )))
      if (stop_on_error) {
        cli_abort(msg)
      } else {
        cli_warn(msg)
        NULL
      }
    }
  )
}

#' Read Zarr mapping keys
#'
#' Read keys for a mapping (dict) from a Zarr store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param version Encoding version of the element to read
#'
#' @return A character vector of item names
#'
#' @noRd
read_zarr_mapping_keys <- function(store, name, version = "0.1.0") {
  version <- match.arg(version)

  items <- list.dirs(
    path = file.path(store, name),
    recursive = FALSE,
    full.names = FALSE
  )
  items[!items %in% ZARR_METADATA_FILES]
}

#' Read Zarr data frame keys
#'
#' Read the row names (index) and/or column names of a data frame from a Zarr
#' store
#'
#' @param store A Zarr store instance
#' @param name Name of the element within the Zarr store
#' @param version Encoding version of the element to read
#' @param dim Dimension to read keys for: `"both"`, `"rows"`, or `"cols"`
#'
#' @return A character vector if `dim` is `"rows"` or `"cols"`, or a list with
#'   elements `"rows"` and `"cols"` if `dim` is `"both"`
#'
#' @noRd
read_zarr_data_frame_keys <- function(
  store,
  name,
  version = "0.2.0",
  dim = c("both", "rows", "cols")
) {
  version <- match.arg(version)
  dim <- match.arg(dim)

  attrs <- Rarr::read_zarr_attributes(file.path(store, name))
  index_name <- attrs[["_index"]]
  column_order <- attrs[["column-order"]]

  if (dim == "both") {
    list(
      rows = as.vector(read_zarr_element(store, file.path(name, index_name))),
      cols = as.character(column_order)
    )
  } else if (dim == "rows") {
    as.vector(read_zarr_element(store, file.path(name, index_name)))
  } else if (dim == "cols") {
    as.character(column_order)
  }
}

skip_if_not_installed("Rarr")

for (zarr_version in c("v2", "v3")) {
  zarr_zip <- system.file(
    "extdata",
    paste0("example_", zarr_version, ".zarr.zip"),
    package = "anndataR"
  )
  td <- tempdir(check = TRUE)
  unzip(zarr_zip, exdir = td)
  store <- file.path(td, paste0("example_", zarr_version, ".zarr"))

  test_that(paste("reading Zarr", zarr_version, "encoding works"), {
    encoding <- read_zarr_encoding(store, "obs")
    expect_equal(names(encoding), c("type", "version"))
  })

  test_that(paste("reading Zarr", zarr_version, "dense matrices works"), {
    mat <- read_zarr_dense_array(store, "layers/dense_counts")
    expect_true(is.matrix(mat))
    expect_type(mat, "integer")
    expect_equal(dim(mat), c(50, 100))

    mat <- read_zarr_dense_array(store, "layers/dense_X")
    expect_true(is.matrix(mat))
    expect_type(mat, "double")
    expect_equal(dim(mat), c(50, 100))
  })

  test_that(paste("reading Zarr", zarr_version, "sparse matrices works"), {
    mat <- read_zarr_sparse_array(store, "layers/csc_counts", type = "csc")
    expect_s4_class(mat, "dgCMatrix")
    expect_equal(dim(mat), c(50, 100))

    mat <- read_zarr_sparse_array(store, "layers/counts", type = "csr")
    expect_s4_class(mat, "dgRMatrix")
    expect_equal(dim(mat), c(50, 100))
  })

  #  TODO: Re-enable when recarays are handled consistently, see https://github.com/scverse/anndataR/issues/409
  test_that(paste("reading Zarr", zarr_version, "recarrays works"), {
    if (zarr_version == "v3") {
      skip("Read support for Zarr v3 rec arrays is not implemented yet")
    }
    array_list <- read_zarr_rec_array(
      store,
      "uns/rank_genes_groups/logfoldchanges"
    )
    expect_true(is.list(array_list))
    for (array in array_list) {
      expect_true(is.vector(array))
      expect_type(array, "double")
      expect_equal(length(array), 6)
    }
  })

  test_that(paste("reading Zarr", zarr_version, "1D numeric arrays works"), {
    array_1d <- read_zarr_dense_array(store, "obs/Int")
    expect_equal(array_1d, array(0L:49L))

    array_1d <- read_zarr_dense_array(store, "obs/Float")
    expect_equal(array_1d, array(rep(42.42, 50)))
  })

  test_that(
    paste("reading Zarr", zarr_version, "1D sparse numeric arrays works"),
    {
      array_1d <- read_zarr_sparse_array(store, "uns/Sparse1D", type = "csc")
      expect_s4_class(array_1d, "dgCMatrix")
      expect_equal(dim(array_1d), c(1, 6))
    }
  )

  test_that(paste("reading Zarr", zarr_version, "1D nullable arrays works"), {
    array_1d <- read_zarr_nullable_integer(store, "obs/IntNA")
    expect_vector(array_1d, ptype = integer(), size = 50)
    expect_true(any(is.na(array_1d)))

    array_1d <- read_zarr_dense_array(store, "obs/FloatNA")
    expected <- array(rep(42.42, 50))
    expected[1] <- NA
    expect_equal(array_1d, expected)

    array_1d <- read_zarr_nullable_boolean(store, "obs/BoolNA")
    expect_vector(array_1d, ptype = logical(), size = 50)
    expect_true(any(is.na(array_1d)))
  })

  test_that(paste("reading Zarr", zarr_version, "string scalars works"), {
    scalar <- read_zarr_string_scalar(store, "uns/StringScalar")
    expect_equal(scalar, "A string")
  })

  test_that(paste("reading Zarr", zarr_version, "numeric scalars works"), {
    scalar <- read_zarr_numeric_scalar(store, "uns/IntScalar")
    expect_equal(scalar, 1)
  })

  test_that(paste("reading Zarr", zarr_version, "string arrays works"), {
    array <- read_zarr_string_array(store, "uns/String")
    expect_equal(array, array(paste0("String ", 0L:9L)))

    array <- read_zarr_string_array(store, "uns/String2D")
    expect_true(is.matrix(array))
    expect_type(array, "character")
    expect_equal(dim(array), c(5, 10))
  })

  test_that(paste("reading Zarr", zarr_version, "mappings works"), {
    if (zarr_version == "v3") {
      # TODO: Remove when v3 recarray support is implemented
      mapping <- suppressWarnings(read_zarr_mapping(store, "uns"))
    } else {
      mapping <- read_zarr_mapping(store, "uns")
    }
    expect_type(mapping, "list")
    expect_type(names(mapping), "character")
  })

  test_that(paste("reading Zarr", zarr_version, "dataframes works"), {
    df <- read_zarr_data_frame(store, "obs")
    expect_s3_class(df, "data.frame")
    expect_equal(
      colnames(df),
      c(
        "Float",
        "FloatNA",
        "Int",
        "IntNA",
        "Bool",
        "BoolNA",
        "n_genes_by_counts",
        "log1p_n_genes_by_counts",
        "total_counts",
        "log1p_total_counts",
        "leiden"
      )
    )
  })

  test_that(
    paste("reading Zarr", zarr_version, "as SingleCellExperiment works"),
    {
      skip_if_not_installed("SingleCellExperiment")

      if (zarr_version == "v3") {
        # TODO: Remove when v3 recarray support is implemented
        sce <- suppressWarnings(read_zarr(store, as = "SingleCellExperiment"))
      } else {
        sce <- read_zarr(store, as = "SingleCellExperiment")
      }

      expect_s4_class(sce, "SingleCellExperiment")
    }
  )

  test_that(paste("reading Zarr", zarr_version, "as Seurat works"), {
    skip_if_not_installed("SeuratObject")

    if (zarr_version == "v3") {
      # TODO: Remove when v3 recarray support is implemented
      seurat <- suppressWarnings(read_zarr(store, as = "Seurat"))
    } else {
      seurat <- read_zarr(store, as = "Seurat")
    }

    expect_s4_class(seurat, "Seurat")
  })
}

skip_if_not_installed("rhdf5")
skip_if_not_installed("Rarr")

# h5ad file
filename <- system.file("extdata", "example.h5ad", package = "anndataR")
file <- rhdf5::H5Fopen(filename, flags = "H5F_ACC_RDONLY", native = FALSE)

# zarr file
zarr_dir <- system.file("extdata", "example_v2.zarr.zip", package = "anndataR")
td <- tempdir(check = TRUE)
unzip(zarr_dir, exdir = td)
store <- file.path(td, "example_v2.zarr")

# helper to compare h5ad and zarr reads for the same path
expect_equal_h5ad_zarr <- function(h5ad_fn, zarr_fn, path, ...) {
  testthat::expect_equal(h5ad_fn(file, path, ...), zarr_fn(store, path, ...))
}

# compare rec arrays of h5ad and zarr
compare_rec_array <- function(rec_array_h5ad, rec_array_zarr, test_fun) {
  test_fun(length(rec_array_h5ad), length(rec_array_zarr[[1]]))
  test_fun(do.call(rbind, rec_array_h5ad), {
    array_list_zarr_mat <- do.call(cbind, rec_array_zarr)
    rownames(array_list_zarr_mat) <-
      paste(0:(nrow(array_list_zarr_mat) - 1))
    array_list_zarr_mat
  })
}

test_that("reading dense matrices is the same for h5ad and zarr", {
  for (path in c("layers/dense_counts", "layers/dense_X")) {
    expect_equal_h5ad_zarr(read_h5ad_dense_array, read_zarr_dense_array, path)
  }
})

test_that("reading sparse matrices is same for h5ad and zarr", {
  sparse_mats <- list(
    list(path = "layers/csc_counts", type = "csc"),
    list(path = "layers/counts", type = "csr")
  )
  for (mat in sparse_mats) {
    expect_equal_h5ad_zarr(
      read_h5ad_sparse_array,
      read_zarr_sparse_array,
      mat$path,
      type = mat$type
    )
  }
})

test_that("reading recarrays is the the same for h5ad and zarr", {
  # h5ad returns a list of 6 arrays of length 100
  array_list_h5ad <- read_h5ad_rec_array(
    file,
    "uns/rank_genes_groups/logfoldchanges"
  )
  # zarr returns a list of 100 arrays of length 6
  array_list_zarr <- read_zarr_rec_array(
    store,
    "uns/rank_genes_groups/logfoldchanges"
  )
  compare_rec_array(array_list_h5ad, array_list_zarr, expect_equal)
})

test_that("reading 1D numeric arrays is the same for h5ad and zarr", {
  for (path in c("obs/Int", "obs/Float")) {
    expect_equal_h5ad_zarr(read_h5ad_dense_array, read_zarr_dense_array, path)
  }
})

test_that("reading 1D sparse numeric arrays is the same for h5ad and zarr", {
  expect_equal_h5ad_zarr(
    read_h5ad_sparse_array,
    read_zarr_sparse_array,
    "uns/Sparse1D",
    type = "csc"
  )
})

test_that("reading 1D nullable arrays is the same for h5ad and zarr", {
  expect_equal_h5ad_zarr(
    read_h5ad_nullable_integer,
    read_zarr_nullable_integer,
    "obs/IntNA"
  )
  expect_equal_h5ad_zarr(
    read_h5ad_dense_array,
    read_zarr_dense_array,
    "obs/FloatNA"
  )
  for (path in c("obs/Bool", "obs/BoolNA")) {
    expect_equal_h5ad_zarr(
      read_h5ad_nullable_boolean,
      read_zarr_nullable_boolean,
      path
    )
  }
})

test_that("reading string scalars is the same for h5ad and zarr", {
  expect_equal_h5ad_zarr(
    read_h5ad_string_scalar,
    read_zarr_string_scalar,
    "uns/StringScalar"
  )
})

test_that("reading numeric scalars is the same for h5ad and zarr", {
  expect_equal_h5ad_zarr(
    read_h5ad_numeric_scalar,
    read_zarr_numeric_scalar,
    "uns/IntScalar"
  )
})

test_that("reading string arrays is the same for h5ad and zarr", {
  for (path in c("uns/String", "uns/String2D")) {
    expect_equal_h5ad_zarr(read_h5ad_string_array, read_zarr_string_array, path)
  }
})

# TODO: Re-enable when recarays are handled consistently, see https://github.com/scverse/anndataR/issues/409
test_that("reading mappings is the same for h5ad and zarr", {
  skip(
    "skipping test for mappings since rec arrays are read differently
       across h5ad and zarr"
  )
  # since rec arrays are read differently across h5ad and zarr,
  # we compare all elements individually
  mapping_h5ad <- read_h5ad_mapping(file, "uns")
  mapping_zarr <- read_zarr_mapping(store, "uns")
  for (nm in names(mapping_h5ad)) {
    if (!nm %in% "rank_genes_groups") {
      expect_equal(mapping_h5ad[[nm]], mapping_zarr[[nm]])
    } else {
      map_ranks_h5ad <- mapping_h5ad$rank_genes_groups
      map_ranks_zarr <- mapping_zarr$rank_genes_groups
      lapply(
        names(map_ranks_h5ad)[!names(map_ranks_h5ad) %in% "params"],
        function(nmr) {
          print(nmr)
          compare_rec_array(
            map_ranks_h5ad[[nmr]],
            map_ranks_zarr[[nmr]],
            expect_equal
          )
        }
      )
    }
  }
})

tmp <- read_zarr_element(store, "uns/neighbors/params/random_state")
tmp2 <- read_h5ad_element(file, "uns/neighbors/params/random_state")

test_that("reading dataframes is the the same for h5ad and zarr", {
  expect_equal_h5ad_zarr(read_h5ad_data_frame, read_zarr_data_frame, "obs")
})

rhdf5::H5Fclose(file)

test_that("reading H5AD as SingleCellExperiment is the same for h5ad and zarr", {
  skip_if_not_installed("SingleCellExperiment")
  skip_if_not_installed("S4Vectors")
  sce_h5ad <- read_h5ad(filename, as = "SingleCellExperiment")
  sce_zarr <- read_zarr(store, as = "SingleCellExperiment")
  # TODO: Update when recarays are handled consistently, see https://github.com/scverse/anndataR/issues/409
  S4Vectors::metadata(sce_zarr) <- S4Vectors::metadata(sce_h5ad)
  expect_equal(sce_h5ad, sce_zarr)
})

test_that("reading H5AD as Seurat is the same for h5ad and zarr", {
  skip_if_not_installed("Seurat")
  sce_h5ad <- read_h5ad(filename, as = "Seurat")
  sce_zarr <- read_zarr(store, as = "Seurat")
  # TODO: Update when recarays are handled consistently, see https://github.com/scverse/anndataR/issues/409
  expect_warning(
    Seurat::Misc(sce_zarr, "rank_genes_groups") <-
      Seurat::Misc(sce_h5ad, "rank_genes_groups"),
    "Overwriting miscellanous"
  )
  # TODO: neighbors/params/random_state and
  # leiden/params/random_state read as 0 in Python anndata but as an empty
  # array in Zarr
  expect_warning(
    Seurat::Misc(sce_zarr, "neighbors") <-
      Seurat::Misc(sce_h5ad, "neighbors"),
    "Overwriting miscellanous"
  )
  expect_warning(
    Seurat::Misc(sce_zarr, "leiden") <-
      Seurat::Misc(sce_h5ad, "leiden"),
    "Overwriting miscellanous"
  )
  # Sort Misc by name to make comparison order-agnostic
  sce_h5ad@misc <- sce_h5ad@misc[sort(names(sce_h5ad@misc))]
  sce_zarr@misc <- sce_zarr@misc[sort(names(sce_zarr@misc))]
  expect_equal(sce_h5ad, sce_zarr)
})

#' Write a dataset to a HDF5 file
#'
#' Write a HDF5 dataset with chosen compression (can be none)
#'
#' @param file A HDF5 file handle
#' @param name Name of the element within the H5AD file
#' @param value Value to write
#' @param H5type Datatype to write, see [rhdf5::h5createDataset()]
#' @param compression The compression to use when writing the element. Can be
#'   one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`.
#' @param chunk_size Target chunk size in bytes. When `"auto"` (default), the
#'   chunk size is determined automatically using `hdf5_auto_chunk()`.
#'   When `NULL`, chunking is disabled (contiguous storage, the rhdf5 default).
#'   When a number, it is used as the target chunk size in bytes.
#' @param ... Other arguments passed to [rhdf5::h5write()]
#'
#' @noRd
hdf5_write_dataset <- function(
  file,
  name,
  value,
  H5type = NULL,
  compression = c("none", "gzip", "lzf"),
  chunk_size = "auto",
  ...
) {
  compression <- match.arg(compression)

  if (!is.null(dim(value))) {
    dims <- dim(value)
  } else {
    dims <- length(value)
  }

  # Avoid segfault when creating a character dataset with LZF compression,
  # see https://github.com/Huber-group-EMBL/rhdf5/issues/168
  if (compression == "lzf" && (storage.mode(value) == "character")) {
    compression <- "none"
  }

  # Compute chunk sizes
  # - "auto"   → mimic h5py's auto-chunking algorithm
  # - NULL     → no chunking (contiguous storage, rhdf5 default)
  # - <number> → use provided byte size as target
  if (identical(chunk_size, "auto")) {
    chunk <- hdf5_auto_chunk(dims, storage.mode(value), target_size = NULL)
  } else if (is.null(chunk_size)) {
    chunk <- NULL
  } else {
    chunk <- hdf5_auto_chunk(
      dims,
      storage.mode(value),
      target_size = chunk_size
    )
  }

  # When no chunking or no compression, set level = 0 to prevent rhdf5 from
  # warning about "Compression (level > 0) requires chunking"
  level <- if (is.null(chunk) || compression == "none") 0L else 6L

  rhdf5::h5createDataset(
    file,
    name,
    dims,
    storage.mode = storage.mode(value),
    H5type = H5type,
    chunk = chunk,
    level = level,
    filter = toupper(compression),
    native = FALSE
  )

  rhdf5::h5write(value, file, name, native = FALSE, ...)
}

#' Write a scalar to a HDF5 file
#'
#' Write a HDF5 scalar
#'
#' @param file A HDF5 file handle
#' @param name Name of the element within the H5AD file
#' @param value Value to write
#'
#' @noRd
hdf5_write_scalar <- function(
  file,
  name,
  value
) {
  # Missing values need to be stored as floats
  if (is.integer(value) && is.na(value)) {
    value <- as.numeric(value)
  }

  h5space <- rhdf5::H5Screate("H5S_SCALAR", native = TRUE)
  on.exit(rhdf5::H5Sclose(h5space), add = TRUE)

  # Adjusted based on rhdf5:::.setDataType
  tid <- switch(
    storage.mode(value)[1],
    integer = "H5T_STD_I64LE",
    double = "H5T_IEEE_F64LE",
    character = {
      tid <- rhdf5::H5Tcopy("H5T_C_S1")
      rhdf5::H5Tset_strpad(tid, strpad = "NULLTERM")
      rhdf5::H5Tset_size(tid, NULL)
      rhdf5::H5Tset_cset(tid, "UTF-8")
      tid
    },
    {
      cli_abort(c(
        "{.arg value} must be of type {.val integer}, {.val double} or {.val character}",
        "i" = "Got {.val {storage.mode(value)[1]}}"
      ))
    }
  )

  dcpl <- rhdf5::H5Pcreate("H5P_DATASET_CREATE")
  on.exit(rhdf5::H5Pclose(dcpl), add = TRUE)
  rhdf5::H5Pset_fill_time(dcpl, "H5D_FILL_TIME_ALLOC")
  rhdf5::H5Pset_obj_track_times(dcpl, FALSE)

  # Create the dataset with this new datatype
  h5dataset <- rhdf5::H5Dcreate(
    h5loc = file,
    name = name,
    dtype_id = tid,
    h5space = h5space,
    dcpl = dcpl
  )
  on.exit(rhdf5::H5Dclose(h5dataset), add = TRUE)

  rhdf5::H5Dwrite(h5dataset, value)
}

#' Write a boolean dataset to a HDF5 array
#'
#' Write a boolean dataset with chosen compression (can be none)
#'
#' @param file A HDF5 file handle
#' @param name Name of the element within the H5AD file
#' @param value Value to write
#' @param is_scalar Whether to use a scalar data space
#' @param compression The compression to use when writing the element. Can be
#'   one of `"none"`, `"gzip"` or `"lzf"`. Defaults to `"none"`. CURRENTLY NOT
#'   IMPLEMENTED!
#'
#' @noRd
hdf5_write_boolean_dataset <- function(
  file,
  name,
  value,
  is_scalar = FALSE,
  compression = c("none", "gzip", "lzf"),
  chunk_size = "auto"
) {
  # Based on https://stackoverflow.com/a/74653515/4384120

  # TODO: Add compression
  # nolint start
  # dcpl <- rhdf5::H5Pcreate("H5P_DATASET_CREATE")
  # on.exit(rhdf5::H5Pclose(dcpl), add = TRUE)
  # if (compression == "gzip") {
  #   rhdf5::H5Pset_deflate(dcpl, 6L) # 6 is a good default compression level
  # } else if (compression == "lzf") {
  #   rhdf5::H5Pset_lzf(dcpl, h5tid = tid)
  # }
  # nolint end

  value <- as.integer(value)

  # Create the dataspace for the data to write
  if (is_scalar) {
    h5space <- rhdf5::H5Screate("H5S_SCALAR", native = TRUE)
  } else {
    if (!is.null(dim(value))) {
      dims <- dim(value)
    } else {
      dims <- length(value)
    }

    h5space <- rhdf5::H5Screate_simple(dims = dims, NULL, native = TRUE)
  }
  on.exit(rhdf5::H5Sclose(h5space), add = TRUE)

  # Create the Boolean ENUM datatype (TRUE = 0 FALSE = 1)
  tid <- rhdf5::H5Tenum_create(dtype_id = "H5T_NATIVE_SCHAR")
  rhdf5::H5Tenum_insert(tid, name = "FALSE", value = 0L)
  rhdf5::H5Tenum_insert(tid, name = "TRUE", value = 1L)

  dcpl <- rhdf5::H5Pcreate("H5P_DATASET_CREATE")
  on.exit(rhdf5::H5Pclose(dcpl), add = TRUE)
  rhdf5::H5Pset_fill_time(dcpl, "H5D_FILL_TIME_ALLOC")
  rhdf5::H5Pset_obj_track_times(dcpl, FALSE)

  # Create the dataset with this new datatype
  h5dataset <- rhdf5::H5Dcreate(
    h5loc = file,
    name = name,
    dtype_id = tid,
    h5space = h5space,
    dcpl = dcpl
  )
  on.exit(rhdf5::H5Dclose(h5dataset), add = TRUE)

  # Write the data. We have to use as.raw() because our base type is 8-bit and
  # R integers are 32-bit
  rhdf5::H5Dwrite(h5dataset, as.raw(value), h5type = tid)
}

#' HDF5 path exists
#'
#' Check that a path in HDF5 exists
#'
#' @param file Path to a HDF5 file
#' @param target_path The path within the file to test for
#'
#' @return Whether `target_path` exists in `file`
#' @noRd
hdf5_path_exists <- function(file, target_path) {
  tryCatch(
    {
      rhdf5::H5Lexists(file, target_path)
    },
    error = function(e) {
      FALSE
    }
  )
}

#' Write a HDF5 attribute
#'
#' Write a HDF5 attribute to a HDF5 file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param attr_name Name of the attribute to write
#' @param attr_value Value of the attribute to write
#' @param is_scalar Whether to write the attribute as a scalar value
#'
#' @noRd
hdf5_write_attribute <- function(
  file,
  name,
  attr_name,
  attr_value,
  is_scalar = TRUE
) {
  if (!inherits(file, "H5IdComponent")) {
    cli_abort("{.arg file} must be an open H5AD handle")
  }

  if (name != "/") {
    h5obj <- rhdf5::H5Oopen(file, name)
    on.exit(rhdf5::H5Oclose(h5obj), add = TRUE)
  } else {
    h5obj <- file
  }

  rhdf5::h5writeAttribute(
    attr = attr_value,
    h5obj = h5obj,
    name = attr_name,
    asScalar = is_scalar,
    encoding = "UTF-8",
    variableLengthString = TRUE
  )
}

#' Clear rhdf5 attributes
#'
#' Remove attributes added by rhdf5 from an element in a HDF5 file
#'
#' @param h5file A HDF5 file handle or a path to a HDF5 file
#' @name name Name of the element within the HDF5 file
#'
#' @details
#' rhdf5 adds a `rhdf5-NA.OK` attribute to elements which doesn't affect the
#' validity of the HDF5 but shows up when comparing to a file created by Python.
#' This function removes those attributes from an element so files are
#' comparable.
#'
#' @noRd
hdf5_clear_rhdf5_attributes <- function(h5file, name) {
  if (!inherits(h5file, "H5IdComponent")) {
    h5file <- rhdf5::H5Fopen(h5file)
    on.exit(rhdf5::H5Fclose(h5file), add = TRUE)
  }

  h5obj <- rhdf5::H5Oopen(h5file, name)
  h5type <- rhdf5::H5Iget_type(h5obj)
  rhdf5_na_ok_exists <- rhdf5::H5Aexists(h5obj, "rhdf5-NA.OK")
  rhdf5::H5Oclose(h5obj)

  if (rhdf5_na_ok_exists) {
    rhdf5::h5deleteAttribute(h5file, name, "rhdf5-NA.OK")
  }

  if (h5type == "H5I_GROUP") {
    h5group <- rhdf5::H5Gopen(h5file, name)
    contents <- rhdf5::h5ls(h5group, recursive = FALSE)
    rhdf5::H5Gclose(h5group)

    for (item in contents$name) {
      hdf5_clear_rhdf5_attributes(h5file, paste0(name, "/", item))
    }
  }
}

#' Compute chunk dimensions for an HDF5 dataset
#'
#' Attempt to match h5py's auto-chunking algorithm. Uses a dynamic target
#' chunk size based on dataset size (log-scaled between 8 KB and 1 MB), and
#' cycles through dimensions in round-robin fashion, halving each until the
#' chunk fits within the target.
#'
#' See https://github.com/h5py/h5py/blob/62b4942/h5py/_hl/filters.py#L361
#'
#' @param dims Integer vector of dataset dimensions
#' @param storage_mode Storage mode of the data ("double", "integer", etc.)
#' @param target_size The target chunk size in bytes. When `NULL` (default),
#'   the target size is determined automatically based on the dataset size.
#'
#' @return Integer vector of chunk dimensions
#'
#' @noRd
hdf5_auto_chunk <- function(dims, storage_mode, target_size = NULL) {
  # h5py constants
  chunk_base <- 16L * 1024L # 16 KB - multiplier for target calculation
  chunk_min <- 8L * 1024L # 8 KB - soft lower limit
  chunk_max <- 1024L * 1024L # 1 MB - hard upper limit

  # Estimate bytes per element
  element_bytes <- switch(
    storage_mode,
    double = 8L,
    integer = 4L,
    character = 16L, # variable-length strings: rough estimate
    8L
  )

  ndims <- length(dims)
  chunk <- as.double(dims)

  # Compute dynamic target size using h5py's PyTables-derived expression
  if (is.null(target_size)) {
    dset_size <- prod(chunk) * element_bytes
    target_size <- chunk_base * (2^log10(dset_size / (1024 * 1024)))
    target_size <- max(chunk_min, min(chunk_max, target_size))
  }

  # Round-robin halving of dimensions until within target
  idx <- 0L
  repeat {
    chunk_bytes <- prod(chunk) * element_bytes

    # Stop when:
    # - chunk is smaller than target, OR within 50% of target, AND
    # - chunk is smaller than the hard upper limit
    is_within_target <- (chunk_bytes < target_size) ||
      (abs(chunk_bytes - target_size) / target_size < 0.5)
    if (is_within_target && chunk_bytes < chunk_max) {
      break
    }

    # Can't reduce further
    if (prod(chunk) == 1) {
      break
    }

    dim_idx <- (idx %% ndims) + 1L
    chunk[dim_idx] <- ceiling(chunk[dim_idx] / 2)
    idx <- idx + 1L
  }

  as.integer(chunk)
}

test_that("hdf5_auto_chunk returns integer vector", {
  result <- hdf5_auto_chunk(c(100L, 50L), "double")
  expect_type(result, "integer")
})

test_that("hdf5_auto_chunk preserves dimensionality", {
  result_1d <- hdf5_auto_chunk(1000L, "double")
  expect_length(result_1d, 1)

  result_2d <- hdf5_auto_chunk(c(100L, 50L), "double")
  expect_length(result_2d, 2)

  result_3d <- hdf5_auto_chunk(c(100L, 50L, 30L), "double")
  expect_length(result_3d, 3)
})

test_that("hdf5_auto_chunk doesn't exceed original dims", {
  dims <- c(2000L, 1000L)
  result <- hdf5_auto_chunk(dims, "double")
  expect_true(all(result <= dims))
})

test_that("hdf5_auto_chunk keeps small datasets as-is", {
  # 5 doubles = 40 bytes, well under any chunk target
  result <- hdf5_auto_chunk(5L, "double")
  expect_equal(result, 5L)

  # 10x10 doubles = 800 bytes
  result <- hdf5_auto_chunk(c(10L, 10L), "double")
  expect_equal(result, c(10L, 10L))
})

test_that("hdf5_auto_chunk reduces large datasets", {
  # 2000 x 1000 doubles = 16 MB, should be chunked below 1 MB
  dims <- c(2000L, 1000L)
  result <- hdf5_auto_chunk(dims, "double")
  chunk_bytes <- prod(result) * 8L
  expect_true(chunk_bytes < 1024L * 1024L)
  expect_true(any(result < dims))
})

test_that("hdf5_auto_chunk handles very large datasets", {
  # 50000 x 20000 doubles = 8 GB
  dims <- c(50000L, 20000L)
  result <- hdf5_auto_chunk(dims, "double")
  chunk_bytes <- prod(result) * 8L
  expect_true(chunk_bytes < 1024L * 1024L)
  expect_true(all(result >= 1L))
})

test_that("hdf5_auto_chunk handles 1D vectors", {
  # 2 million doubles = 16 MB
  result <- hdf5_auto_chunk(2000000L, "double")
  chunk_bytes <- result * 8L
  expect_true(chunk_bytes < 1024L * 1024L)
  expect_true(result >= 1L)
})

test_that("hdf5_auto_chunk respects storage mode", {
  dims <- c(2000L, 1000L)

  result_double <- hdf5_auto_chunk(dims, "double")
  result_integer <- hdf5_auto_chunk(dims, "integer")

  # Integer elements are 4 bytes vs 8 bytes for double,

  # so integer chunks can be larger in element count
  expect_true(prod(result_integer) >= prod(result_double))
})

test_that("hdf5_auto_chunk handles all storage modes", {
  dims <- c(500L, 500L)

  expect_no_error(hdf5_auto_chunk(dims, "double"))
  expect_no_error(hdf5_auto_chunk(dims, "integer"))
  expect_no_error(hdf5_auto_chunk(dims, "character"))
  # Unknown mode falls back to 8 bytes
  expect_no_error(hdf5_auto_chunk(dims, "raw"))
})

test_that("hdf5_auto_chunk produces positive chunk dimensions", {
  # Edge case: very large dataset with small element size
  result <- hdf5_auto_chunk(c(100000L, 100000L), "integer")
  expect_true(all(result >= 1L))
})

test_that("hdf5_auto_chunk handles dimension of 1", {
  # Tall skinny matrix: 1000000 x 1
  result <- hdf5_auto_chunk(c(1000000L, 1L), "double")
  expect_equal(result[2], 1L)
  expect_true(result[1] <= 1000000L)

  # Wide flat matrix: 1 x 1000000
  result <- hdf5_auto_chunk(c(1L, 1000000L), "double")
  expect_equal(result[1], 1L)
  expect_true(result[2] <= 1000000L)
})

test_that("hdf5_auto_chunk respects explicit target_size", {
  dims <- c(2000L, 1000L)

  # 64 KB target
  result_64k <- hdf5_auto_chunk(dims, "double", target_size = 64L * 1024L)
  chunk_bytes_64k <- prod(result_64k) * 8L
  expect_true(chunk_bytes_64k <= 64L * 1024L * 1.5)

  # 512 KB target should produce larger chunks than 64 KB target
  result_512k <- hdf5_auto_chunk(dims, "double", target_size = 512L * 1024L)
  expect_true(prod(result_512k) >= prod(result_64k))
})

test_that("hdf5_auto_chunk avoids the 4 GB chunk limit (regression test for #415)", {
  # The original report used n_obs x n_vars = 321427 x 17690 doubles.
  # Without auto-chunking rhdf5 set chunk = dims, which at 8 bytes/element
  # gives ~45 GB per chunk - exceeding HDF5's 4 GB hard limit.
  # See https://github.com/scverse/anndataR/issues/415
  dims <- c(321427L, 17690L)
  result <- hdf5_auto_chunk(dims, "double")
  chunk_bytes <- prod(as.numeric(result)) * 8
  limit_4gb <- 4 * 1024^3
  expect_true(chunk_bytes < limit_4gb)
  # In practice it should be well within the 1 MB auto-chunk ceiling
  expect_true(chunk_bytes <= 1024L * 1024L)
})

#' @keywords internal
"_PACKAGE"

## usethis namespace: start
#' @importFrom cli cli_abort cli_warn cli_inform
#' @importFrom lifecycle deprecated
#' @importFrom methods as new
#' @importFrom purrr map_lgl map_dfr
#' @importFrom R6 R6Class
#' @importFrom rlang `%||%`
#' @importFrom stats setNames
#' @importFrom utils tail
## usethis namespace: end
NULL

.onAttach <- function(libname, pkgname) {
  # Check if the R anndata package is loaded and warn about conflicts
  if ("anndata" %in% loadedNamespaces()) {
    cli::cli_warn(c(
      "The R {.pkg anndata} package is loaded and may interfere with {.pkg anndataR}'s Python integration.",
      "i" = "This may cause automatic conversion of Python AnnData objects to R6 classes.",
      "i" = "Consider restarting R and loading {.pkg anndataR} before {.pkg anndata} to avoid conflicts.",
      "i" = "Use {.code reticulate::import('anndata', convert = FALSE)} to prevent automatic conversion."
    ))
  }
}

convert_py_value <- function(py_value, name) {
  if (
    name %in%
      c(
        "categorical",
        "categorical_missing_values",
        "categorical_ordered",
        "categorical_ordered_missing_values"
      )
  ) {
    py_value <- convert_categorical(py_value)
  } else if (name == "nullable_integer_array") {
    py_value <- convert_nullable_integer_array(py_value)
  } else if (name == "nullable_boolean_array") {
    py_value <- convert_nullable_boolean_array(py_value)
  } else {
    py_value <- reticulate::py_to_r(py_value)
  }

  py_value
}

convert_categorical <- function(categorical) {
  converted <- try(reticulate::py_to_r(categorical), silent = TRUE)
  if (
    !inherits(converted, "try-error") &&
      !inherits(converted, "python.builtin.object")
  ) {
    return(converted)
  }

  categories <- reticulate::py_to_r(categorical$categories$to_list())
  codes <- reticulate::py_to_r(categorical$codes)
  ordered <- reticulate::py_to_r(categorical$ordered)
  is_na <- codes == -1L
  codes[is_na] <- 0L
  py_value <- factor(
    categories[codes + 1],
    levels = categories,
    ordered = ordered
  )
  py_value[is_na] <- NA

  py_value
}

convert_nullable_integer_array <- function(nullable_array) {
  nullable_array <- reticulate::py_to_r(nullable_array)
  if (!inherits(nullable_array, "python.builtin.object")) {
    return(nullable_array)
  }

  mask <- reticulate::py_to_r(reticulate::py_get_attr(nullable_array, "_mask"))
  data <- reticulate::py_to_r(reticulate::py_get_attr(nullable_array, "_data"))
  py_value <- as.integer(data)
  py_value[mask] <- NA

  py_value
}

convert_nullable_boolean_array <- function(nullable_array) {
  nullable_array <- reticulate::py_to_r(nullable_array)
  if (!inherits(nullable_array, "python.builtin.object")) {
    return(nullable_array)
  }

  mask <- reticulate::py_to_r(reticulate::py_get_attr(nullable_array, "_mask"))
  data <- reticulate::py_to_r(reticulate::py_get_attr(nullable_array, "_data"))
  py_value <- as.logical(data)
  py_value[mask] <- NA

  py_value
}

.abstract_function <- function(fun_name = NA_character_) {
  fun_str <- if (is.na(fun_name)) {
    "This function"
  } else {
    "{.fun {fun_name}}"
  }
  cli_abort(
    paste(fun_str, "is an abstract function."),
    call = rlang::caller_env()
  )
}

.anndata_slots <- c(
  "X",
  "obs",
  "var",
  "uns",
  "obsm",
  "varm",
  "layers",
  "obsp",
  "varp"
)

#' @title Abstract AnnData class
#'
#' @description
#' This class is an abstract representation of an `AnnData` object. It is
#' intended to be used as a base class for concrete implementations of
#' `AnnData` objects, such as [InMemoryAnnData] or [HDF5AnnData].
#'
#' See [AnnData-usage] for details on creating and using `AnnData` objects.
#'
#' @return An `AbstractAnnData` object
#'
#' @seealso [AnnData-usage] for details on creating and using `AnnData` objects
#'
#' @family AnnData classes
AbstractAnnData <- R6::R6Class(
  "AbstractAnnData",
  active = list(
    #' @field X See [AnnData-usage]
    X = function(value) {
      .abstract_function("ad$X")
    },
    #' @field layers See [AnnData-usage]
    layers = function(value) {
      .abstract_function("ad$layers")
    },
    #' @field obs See [AnnData-usage]
    obs = function(value) {
      .abstract_function("ad$obs")
    },
    #' @field var See [AnnData-usage]
    var = function(value) {
      .abstract_function("ad$var")
    },
    #' @field obs_names See [AnnData-usage]
    obs_names = function(value) {
      .abstract_function("ad$obs_names")
    },
    #' @field var_names See [AnnData-usage]
    var_names = function(value) {
      .abstract_function("ad$var_names")
    },
    #' @field obsm See [AnnData-usage]
    obsm = function(value) {
      .abstract_function("ad$obsm")
    },
    #' @field varm See [AnnData-usage]
    varm = function(value) {
      .abstract_function("ad$varm")
    },
    #' @field obsp See [AnnData-usage]
    obsp = function(value) {
      .abstract_function("ad$obsp")
    },
    #' @field varp See [AnnData-usage]
    varp = function(value) {
      .abstract_function("ad$varp")
    },
    #' @field uns See [AnnData-usage]
    uns = function(value) {
      .abstract_function("ad$uns")
    }
  ),
  public = list(
    #' @description See [AnnData-usage]
    #'
    #' @param ... Optional arguments to print method
    print = function(...) {
      # Get the class name (can be overridden by subclasses)
      class_name <- private$.class_name()

      cat(
        class_name,
        " object with n_obs \u00D7 n_vars = ",
        self$n_obs(),
        " \u00D7 ",
        self$n_vars(),
        "\n",
        sep = ""
      )

      for (attribute in .anndata_slots[-1]) {
        key_fun <- self[[paste0(attribute, "_keys")]]
        keys <-
          if (!is.null(key_fun)) {
            key_fun()
          } else {
            NULL
          }
        if (length(keys) > 0) {
          cat(
            "    ",
            attribute,
            ": ",
            paste(paste0("'", keys, "'"), collapse = ", "),
            "\n",
            sep = ""
          )
        }
      }
    },

    #' @description See [AnnData-usage]
    shape = function() {
      c(
        self$n_obs(),
        self$n_vars()
      )
    },
    #' @description See [AnnData-usage]
    n_obs = function() {
      nrow(self$obs)
    },
    #' @description See [AnnData-usage]
    n_vars = function() {
      nrow(self$var)
    },
    #' @description See [AnnData-usage]
    obs_keys = function() {
      names(self$obs)
    },
    #' @description See [AnnData-usage]
    var_keys = function() {
      names(self$var)
    },
    #' @description See [AnnData-usage]
    layers_keys = function() {
      names(self$layers)
    },
    #' @description See [AnnData-usage]
    obsm_keys = function() {
      names(self$obsm)
    },
    #' @description See [AnnData-usage]
    varm_keys = function() {
      names(self$varm)
    },
    #' @description See [AnnData-usage]
    obsp_keys = function() {
      names(self$obsp)
    },
    #' @description See [AnnData-usage]
    varp_keys = function() {
      names(self$varp)
    },
    #' @description See [AnnData-usage]
    uns_keys = function() {
      names(self$uns)
    },
    #' @description
    #' Convert to `SingleCellExperiment`
    #'
    #' See [as_SingleCellExperiment()] for more details on the conversion
    #'
    #' @param x_mapping See [as_SingleCellExperiment()]
    #' @param assays_mapping See [as_SingleCellExperiment()]
    #' @param colData_mapping See [as_SingleCellExperiment()]
    #' @param rowData_mapping See [as_SingleCellExperiment()]
    #' @param reducedDims_mapping See [as_SingleCellExperiment()]
    #' @param colPairs_mapping See [as_SingleCellExperiment()]
    #' @param rowPairs_mapping See [as_SingleCellExperiment()]
    #' @param metadata_mapping See [as_SingleCellExperiment()]
    #'
    #' @return A `SingleCellExperiment` object
    # nolint start: object_name_linter
    as_SingleCellExperiment = function(
      x_mapping = NULL,
      assays_mapping = TRUE,
      colData_mapping = TRUE,
      rowData_mapping = TRUE,
      reducedDims_mapping = TRUE,
      colPairs_mapping = TRUE,
      rowPairs_mapping = TRUE,
      metadata_mapping = TRUE
    ) {
      # nolint end: object_name_linter
      as_SingleCellExperiment(
        self,
        x_mapping = x_mapping,
        assays_mapping = assays_mapping,
        colData_mapping = colData_mapping,
        rowData_mapping = rowData_mapping,
        reducedDims_mapping = reducedDims_mapping,
        colPairs_mapping = colPairs_mapping, # nolint
        rowPairs_mapping = rowPairs_mapping, # nolint
        metadata_mapping = metadata_mapping
      )
    },
    #' @description
    #' Convert to `Seurat`
    #'
    #' See [as_Seurat()] for more details on the conversion
    #'
    #' @param assay_name See [as_Seurat()]
    #' @param x_mapping See [as_Seurat()]
    #' @param layers_mapping See [as_Seurat()]
    #' @param object_metadata_mapping See [as_Seurat()]
    #' @param assay_metadata_mapping See [as_Seurat()]
    #' @param reduction_mapping See [as_Seurat()]
    #' @param graph_mapping See [as_Seurat()]
    #' @param misc_mapping See [as_Seurat()]
    #'
    #' @return A `Seurat` object
    as_Seurat = function(
      assay_name = "RNA",
      x_mapping = NULL,
      layers_mapping = TRUE,
      object_metadata_mapping = TRUE,
      assay_metadata_mapping = TRUE,
      reduction_mapping = TRUE,
      graph_mapping = TRUE,
      misc_mapping = TRUE
    ) {
      as_Seurat(
        self,
        assay_name = assay_name,
        x_mapping = x_mapping,
        layers_mapping = layers_mapping,
        object_metadata_mapping = object_metadata_mapping,
        assay_metadata_mapping = assay_metadata_mapping,
        reduction_mapping = reduction_mapping,
        graph_mapping = graph_mapping,
        misc_mapping = misc_mapping
      )
    },
    #' @description
    #' Convert to an [`InMemoryAnnData`]
    #'
    #' See [as_InMemoryAnnData()] for more details on the conversion
    #'
    #' @return An [InMemoryAnnData] object
    as_InMemoryAnnData = function() {
      as_InMemoryAnnData(self)
    },
    #' @description
    #' Convert to a [`ReticulateAnnData`]
    #'
    #' See [as_ReticulateAnnData()] for more details on the conversion
    #'
    #' @return A [ReticulateAnnData] object
    as_ReticulateAnnData = function() {
      as_ReticulateAnnData(self)
    },
    #' @description
    #' Convert to an [`HDF5AnnData`]
    #'
    #' See [as_HDF5AnnData()] for more details on the conversion
    #'
    #' @param file See [as_HDF5AnnData()]
    #' @param compression See [as_HDF5AnnData()]
    #' @param chunk_size See [as_HDF5AnnData()]
    #' @param mode See [as_HDF5AnnData()]
    #'
    #' @return An [`HDF5AnnData`] object
    as_HDF5AnnData = function(
      file,
      compression = c("none", "gzip", "lzf"),
      chunk_size = "auto",
      mode = c("w-", "r", "r+", "a", "w", "x")
    ) {
      as_HDF5AnnData(
        adata = self,
        file = file,
        compression = compression,
        chunk_size = chunk_size,
        mode = mode
      )
    },
    #' @description
    #' Convert to a [`ZarrAnnData`]
    #'
    #' See [as_ZarrAnnData()] for more details on the conversion
    #'
    #' @param file See [as_ZarrAnnData()]
    #' @param compression See [as_ZarrAnnData()]
    #' @param mode See [as_ZarrAnnData()]
    #'
    #' @return A [`ZarrAnnData`] object
    as_ZarrAnnData = function(
      file,
      compression = c(
        "none",
        "gzip",
        "blosc",
        "zstd",
        "lzma",
        "bz2",
        "zlib",
        "lz4"
      ),
      mode = c("w-", "r", "r+", "a", "w", "x")
    ) {
      as_ZarrAnnData(
        adata = self,
        file = file,
        compression = compression,
        mode = mode
      )
    },
    #' @description
    #' Write the `AnnData` object to an H5AD file
    #'
    #' See [write_h5ad()] for details
    #'
    #' @param path See [write_h5ad()]
    #' @param compression See [write_h5ad()]
    #' @param chunk_size See [write_h5ad()]
    #' @param mode See [write_h5ad()]
    #'
    #' @return `path` invisibly
    write_h5ad = function(
      path,
      compression = c("none", "gzip", "lzf"),
      chunk_size = "auto",
      mode = c("w-", "r", "r+", "a", "w", "x")
    ) {
      write_h5ad(
        object = self,
        path,
        compression = compression,
        chunk_size = chunk_size,
        mode = mode
      )
    },
    #' @description
    #' Write the `AnnData` object to a Zarr file
    #'
    #' See [write_zarr()] for details
    #'
    #' @param path See [write_zarr()]
    #' @param compression See [write_zarr()]
    #' @param mode See [write_zarr()]
    #'
    #' @return `path` invisibly
    write_zarr = function(
      path,
      compression = c(
        "none",
        "gzip",
        "blosc",
        "zstd",
        "lzma",
        "bz2",
        "zlib",
        "lz4"
      ),
      mode = c("w-", "r", "r+", "a", "w", "x")
    ) {
      write_zarr(
        object = self,
        path,
        compression = compression,
        mode = mode
      )
    }
  ),
  private = list(
    # @description `.validate_aligned_array()` checks that dimensions are
    #   consistent with the AnnData object.
    #
    # @param mat A matrix (or data frame) to validate
    # @param label Must be `"X"` or `"<<slot>>[[...]]"` where `<<slot>>` is the
    #   name of an AnnData slot and `...` is an item in that slot
    # @param shape Expected dimensions of `mat`, if shorter than `dim(mat)`,
    #   only the first `length(shape)` dimensions are checked
    # @param expected_rownames Expected row names
    # @param expected_colnames Expected column names
    # @param strip_rownames Whether to strip row names after validation
    # @param strip_colnames Whether to strip column names after validation
    # @param warn_rownames Whether to warn if row names are present but can not
    #   be written
    # @param warn_colnames Whether to warn if column names are present but can
    #   not be written
    #
    # @return The validated matrix
    .validate_aligned_array = function(
      mat,
      label,
      shape,
      expected_rownames = NULL,
      expected_colnames = NULL,
      strip_rownames = TRUE,
      strip_colnames = TRUE,
      warn_rownames = FALSE,
      warn_colnames = FALSE
    ) {
      if (is.null(mat)) {
        return(mat)
      }
      mat_dims <- dim(mat)

      if (
        length(shape) > length(mat_dims) ||
          any(shape != mat_dims[seq_along(shape)])
      ) {
        cli_abort(
          c(
            "Unexpected shape for {.field {label}}",
            "i" = paste0(
              "Expected [",
              paste(shape, collapse = ", "),
              "], got [",
              paste(mat_dims, collapse = ", "),
              "]"
            )
          ),
          call = rlang::caller_env()
        )
      }

      if (!is.null(expected_rownames) && has_row_names(mat)) {
        if (!identical(rownames(mat), expected_rownames)) {
          cli_abort(
            c(
              "{.code rownames({label})} is not as expected",
              "i" = "Expected row names: {style_vec(expected_rownames)}",
              "i" = "Provided row names: {style_vec(rownames(mat))}"
            ),
            call = rlang::caller_env()
          )
        }
      }
      # Strip rownames for storage if requested
      if (strip_rownames) {
        rownames(mat) <- NULL
      }

      if (!is.null(expected_colnames) & !is.null(colnames(mat))) {
        if (!identical(colnames(mat), expected_colnames)) {
          cli_abort(
            c(
              "{.code colnames({label})} is not as expected",
              "i" = "Expected column names: {style_vec(expected_colnames)}",
              "i" = "Provided column names: {style_vec(colnames(mat))}"
            ),
            call = rlang::caller_env()
          )
        }
      }

      # Strip colnames for storage if requested
      if (strip_colnames) {
        colnames(mat) <- NULL
      }

      warn_matrix_dimnames_not_writeable(
        mat,
        label,
        to_object = self,
        rows = warn_rownames,
        cols = warn_colnames
      )

      mat
    },
    # @description `.validate_aligned_mapping()` checks for named lists and
    #   correct dimensions on elements.
    #
    # @param collection A named list of 0 or more matrix elements with
    #   whose entries will be validated
    # @param label The label of the collection, used for error messages
    # @param shape Expected dimensions of items in `collection`
    # @param expected_rownames Expected row names
    # @param expected_colnames Expected column names
    # @param strip_rownames Whether to strip row names after validation
    # @param strip_colnames Whether to strip column names after validation
    # @param warn_rownames Whether to warn if row names are present but can not
    #   be written
    # @param warn_colnames Whether to warn if column names are present but can
    #   not be written
    #
    # @return The validated mapping
    .validate_aligned_mapping = function(
      collection,
      label,
      shape,
      expected_rownames = NULL,
      expected_colnames = NULL,
      strip_rownames = TRUE,
      strip_colnames = TRUE,
      warn_rownames = FALSE,
      warn_colnames = FALSE
    ) {
      if (is.null(collection)) {
        return(collection)
      }

      collection <- private$.validate_named_list(collection, label)
      collection_names <- names(collection)

      for (mtx_name in collection_names) {
        collection_name <- paste0(label, "[['", mtx_name, "']]")
        collection[[mtx_name]] <- private$.validate_aligned_array(
          collection[[mtx_name]],
          collection_name,
          shape = shape,
          expected_rownames = expected_rownames,
          expected_colnames = expected_colnames,
          strip_rownames = strip_rownames,
          strip_colnames = strip_colnames,
          warn_rownames = warn_rownames,
          warn_colnames = warn_colnames
        )
      }

      collection
    },

    # @description `.validate_named_list()` checks for whether a value
    #   is NULL or a named list and throws an error if it is not.
    #
    # @param collection A collection to validate
    # @param label The label of the collection, used for error messages
    # @param warn_matrix_dimnames Whether to warn if matrix dim names are
    #   present but cannot be written for items in `collection`
    #
    # @return The validated named list
    .validate_named_list = function(
      collection,
      label,
      warn_matrix_dimnames = FALSE
    ) {
      if (is.null(collection)) {
        return(collection)
      }

      collection_names <- names(collection)
      if (
        !is.list(collection) ||
          ((length(collection) != 0) && is.null(collection_names))
      ) {
        cli_abort(
          "{.field {label}} must be a named {.cls list}, got {.cls {class(collection)}}",
          call = rlang::caller_env()
        )
      }

      if (warn_matrix_dimnames) {
        purrr::walk2(collection, names(collection), \(.item, .item_name) {
          warn_matrix_dimnames_not_writeable(
            .item,
            label = paste0(label, "[['", .item_name, "']]"),
            to_object = self
          )
        })
      }

      collection
    },

    # @description `.validate_obsvar_dataframe()` checks that the
    #   object is a data.frame and removes explicit dimnames.
    #
    # @param df A data frame to validate. Should be an obs or a var.
    # @param label Must be `"obs"` or `"var"`
    .validate_obsvar_dataframe = function(df, label = c("obs", "var")) {
      label <- match.arg(label)

      expected_nrow <- switch(label, obs = self$n_obs(), var = self$n_vars())

      if (is.null(df)) {
        # create empty data frame
        df <- data.frame(i = seq_len(expected_nrow))[, -1, drop = FALSE]
      }

      if (!is.data.frame(df)) {
        cli_abort(
          "{.field label} must be a {.cls data.frame}, got {.cls {class(df)}}",
          call = rlang::caller_env()
        )
      }

      if (nrow(df) != expected_nrow) {
        cli_abort(
          paste(
            "{.code nrow({label})} should equal {.val {expected_nrow}},",
            "got {.val {nrow(df)}}"
          ),
          call = rlang::caller_env()
        )
      }

      df
    },

    # @description `.validate_obsvar_names()` checks that `*_names()`
    #   are NULL or consistent with the dimensions of `obs` or `var`.
    #
    # @param names A vector to validate
    # @param label Must be `"obs"` or `"var"`
    .validate_obsvar_names = function(
      names,
      label = c("obs", "var"),
      check_length = TRUE
    ) {
      label <- match.arg(label)

      if (is.null(names)) {
        cli_abort(
          "{.field {label}_names} should be defined",
          call = rlang::caller_env()
        )
      }

      # only check whether sizes match if the obsvar names has already been defined
      prev_names <- attr(self, paste0(label, "_names"))
      if (!is.null(prev_names)) {
        expected_len <- length(prev_names)

        if (length(names) != expected_len) {
          size_check_label <- if (label == "obs") "n_obs" else "n_vars"
          cli_abort(
            paste(
              "{.code length({label}_names)} should match",
              "{.code ad${size_check_label}}"
            ),
            call = rlang::caller_env()
          )
        }
      }

      names
    },

    # @description Add dimnames to matrices/data.frames for user access
    # @param mat A matrix or data.frame to add dimnames to
    # @param slot_type The type of slot: "X", "layers", "obsm", "varm", "obsp", "varp"
    .add_matrix_dimnames = function(
      mat,
      slot_type = c("X", "layers", "obsm", "varm", "obsp", "varp")
    ) {
      if (is.null(mat)) {
        return(mat)
      }

      slot_type <- match.arg(slot_type)

      switch(
        slot_type,
        "X" = {
          dimnames(mat) <- list(self$obs_names, self$var_names)
        },
        "layers" = {
          dimnames(mat) <- list(self$obs_names, self$var_names)
        },
        "obsm" = {
          rownames(mat) <- self$obs_names
        },
        "varm" = {
          rownames(mat) <- self$var_names
        },
        "obsp" = {
          dimnames(mat) <- list(self$obs_names, self$obs_names)
        },
        "varp" = {
          dimnames(mat) <- list(self$var_names, self$var_names)
        }
      )

      mat
    },

    # @description Add dimnames to mapping lists (obsm, varm, obsp, varp, layers)
    # @param mapping_list A named list of matrices to add dimnames to
    # @param slot_type The type of slot: "layers", "obsm", "varm", "obsp", "varp"
    .add_mapping_dimnames = function(
      mapping_list,
      slot_type = c("layers", "obsm", "varm", "obsp", "varp")
    ) {
      if (is.null(mapping_list)) {
        return(mapping_list)
      }

      slot_type <- match.arg(slot_type)

      for (i in seq_along(mapping_list)) {
        if (!is.null(mapping_list[[i]])) {
          mapping_list[[i]] <- private$.add_matrix_dimnames(
            mapping_list[[i]],
            slot_type
          )
        }
      }

      mapping_list
    },

    # @description Add rownames to obs/var data.frames
    # @param df A data.frame to add rownames to
    # @param slot_type The type of slot: "obs" or "var"
    .add_obsvar_dimnames = function(df, slot_type = c("obs", "var")) {
      if (is.null(df)) {
        return(df)
      }

      slot_type <- match.arg(slot_type)

      switch(
        slot_type,
        "obs" = {
          rownames(df) <- self$obs_names
        },
        "var" = {
          rownames(df) <- self$var_names
        }
      )

      df
    },

    # @description Get the class name for printing
    # Default implementation returns the first class name
    # Can be overridden by subclasses (e.g., AnnDataView)
    .class_name = function() {
      class(self)[1]
    }
  )
)

test_that("AnnDataView basic subsetting methods work", {
  # Create a base AnnData object using the dataset generator
  ad <- generate_dataset(
    n_obs = 3L,
    n_vars = 5L,
    example = TRUE,
    format = "AnnData"
  )

  # Test that basic subsetting via [ returns AnnDataView
  # Using evaluated logical conditions instead of expressions
  obs_condition <- ad$obs$factor == "Value1" # Should select cell1 and cell3
  view_obs <- ad[obs_condition, ]
  expect_s3_class(view_obs, "AnnDataView")

  var_condition <- ad$var$factor == "Value1" # Should select gene1, gene3, gene5
  view_var <- ad[, var_condition]
  expect_s3_class(view_var, "AnnDataView")
})

test_that("AnnDataView obs subsetting works", {
  ad <- generate_dataset(
    n_obs = 3L,
    n_vars = 5L,
    example = TRUE,
    format = "AnnData"
  )

  # Test logical vector subsetting
  view1 <- ad[c(TRUE, FALSE, TRUE), ]

  expect_equal(nrow(view1$obs), 2L)
  expect_equal(view1$obs_names, c("cell1", "cell3"))
  expect_equal(dim(view1$X), c(2L, 5L))
  expect_identical(view1$X, ad$X[c(1, 3), , drop = FALSE])

  # Test evaluated logical condition subsetting
  obs_condition <- ad$obs$factor == "Value1" # Should select cell1 and cell3
  view2 <- ad[obs_condition, ]

  expect_equal(nrow(view2$obs), 2L)
  expect_equal(view2$obs_names, c("cell1", "cell3"))
  expect_equal(as.character(view2$obs$factor), c("Value1", "Value1"))

  # Test complex evaluated condition
  complex_condition <- ad$obs$factor == "Value1" & ad$obs$integer > 0
  view3 <- ad[complex_condition, ]

  expect_equal(nrow(view3$obs), 1L)
  expect_equal(view3$obs_names, "cell3")

  # Test numeric index subsetting
  view4 <- ad[c(1, 3), ]

  expect_equal(nrow(view4$obs), 2L)
  expect_equal(view4$obs_names, c("cell1", "cell3"))
  expect_equal(dim(view4$X), c(2L, 5L))

  # Test character name subsetting
  view5 <- ad[c("cell1", "cell3"), ]

  expect_equal(nrow(view5$obs), 2L)
  expect_equal(view5$obs_names, c("cell1", "cell3"))
  expect_equal(dim(view5$X), c(2L, 5L))
})

test_that("AnnDataView var subsetting works", {
  ad <- generate_dataset(
    n_obs = 3L,
    n_vars = 5L,
    example = TRUE,
    format = "AnnData"
  )

  # Test logical vector subsetting
  view1 <- ad[, c(TRUE, FALSE, TRUE, FALSE, FALSE)]

  expect_equal(nrow(view1$var), 2L)
  expect_equal(view1$var_names, c("gene1", "gene3"))
  expect_equal(dim(view1$X), c(3L, 2L))
  expect_identical(view1$X, ad$X[, c(1, 3), drop = FALSE])

  # Test evaluated logical condition subsetting
  gene_condition <- ad$var$factor == "Value1" # Should select gene1, gene3, gene5
  view2 <- ad[, gene_condition]

  expect_equal(nrow(view2$var), 3L)
  expect_equal(view2$var_names, c("gene1", "gene3", "gene5"))
  expect_equal(as.character(view2$var$factor), c("Value1", "Value1", "Value1"))

  # Test integer column subsetting
  view3 <- ad[, ad$var$integer >= 2] # Should select gene3, gene4, gene5

  expect_equal(nrow(view3$var), 3L)
  expect_equal(view3$var_names, c("gene3", "gene4", "gene5"))

  # Test numeric index subsetting
  view4 <- ad[, c(1, 3, 5)]

  expect_equal(nrow(view4$var), 3L)
  expect_equal(view4$var_names, c("gene1", "gene3", "gene5"))
  expect_equal(dim(view4$X), c(3L, 3L))

  # Test character name subsetting
  view5 <- ad[, c("gene1", "gene3", "gene5")]

  expect_equal(nrow(view5$var), 3L)
  expect_equal(view5$var_names, c("gene1", "gene3", "gene5"))
  expect_equal(dim(view5$X), c(3L, 3L))
})

test_that("AnnDataView combined subsetting works", {
  ad <- generate_dataset(
    n_obs = 3L,
    n_vars = 5L,
    example = TRUE,
    format = "AnnData"
  )

  # Create logical conditions
  obs_condition <- ad$obs$factor == "Value1" # Should select cell1 and cell3
  var_condition <- ad$var$factor == "Value1" # Should select gene1, gene3, gene5

  # Test combined obs and var subsetting
  view <- ad[obs_condition, var_condition]

  expect_equal(dim(view$X), c(2L, 3L)) # 2 obs × 3 vars
  expect_equal(view$obs_names, c("cell1", "cell3"))
  expect_equal(view$var_names, c("gene1", "gene3", "gene5"))

  # Check that obsm is subset correctly (obs on rows)
  expect_equal(nrow(view$obsm$numeric_matrix), 2L)
  expect_equal(ncol(view$obsm$numeric_matrix), 3L) # columns unchanged

  # Check that varm is subset correctly (var on rows)
  expect_equal(nrow(view$varm$numeric_matrix), 3L) # 3 selected vars
  expect_equal(ncol(view$varm$numeric_matrix), 5L) # columns unchanged

  # Check that obsp is subset correctly (obs on both dimensions)
  expect_equal(dim(view$obsp$numeric_matrix), c(2L, 2L))

  # Check that varp is subset correctly (var on both dimensions)
  expect_equal(dim(view$varp$numeric_matrix), c(3L, 3L))

  # Test combined numeric index subsetting
  view2 <- ad[c(1, 3), c(1, 3, 5)]

  expect_equal(dim(view2$X), c(2L, 3L))
  expect_equal(view2$obs_names, c("cell1", "cell3"))
  expect_equal(view2$var_names, c("gene1", "gene3", "gene5"))

  # Test combined character name subsetting
  view3 <- ad[c("cell1", "cell3"), c("gene1", "gene3", "gene5")]

  expect_equal(dim(view3$X), c(2L, 3L))
  expect_equal(view3$obs_names, c("cell1", "cell3"))
  expect_equal(view3$var_names, c("gene1", "gene3", "gene5"))

  # Test mixed subsetting (logical obs, numeric var)
  view4 <- ad[ad$obs$factor == "Value1", c(1, 3, 5)]

  expect_equal(dim(view4$X), c(2L, 3L))
  expect_equal(view4$obs_names, c("cell1", "cell3"))
  expect_equal(view4$var_names, c("gene1", "gene3", "gene5"))
})

test_that("AnnDataView layers subsetting works", {
  ad <- generate_dataset(
    n_obs = 3L,
    n_vars = 5L,
    example = TRUE,
    format = "AnnData"
  )

  # Create logical conditions
  obs_condition <- ad$obs$factor == "Value1" # Should select cell1 and cell3
  var_condition <- ad$var$factor == "Value1" # Should select gene1, gene3, gene5

  view <- ad[obs_condition, var_condition]

  # Check that all layers are subset correctly
  # Note: Layers should have the same dimensions as the view's X matrix
  expect_equal(dim(view$X), c(2L, 3L))
  expect_equal(dim(view$layers$numeric_matrix), c(2L, 3L))
  expect_equal(dim(view$layers$numeric_dense), c(2L, 3L))
  expect_equal(dim(view$layers$numeric_csparse), c(2L, 3L))

  # Verify that subsetting maintains the correct values
  expect_identical(
    view$layers$numeric_matrix,
    ad$layers$numeric_matrix[c(1, 3), c(1, 3, 5), drop = FALSE]
  )
})

test_that("AnnDataView obsm subsetting works", {
  ad <- generate_dataset(
    n_obs = 3L,
    n_vars = 5L,
    example = TRUE,
    format = "AnnData"
  )

  # Create logical conditions
  obs_condition <- ad$obs$factor == "Value1" # Should select cell1 and cell3
  var_condition <- ad$var$factor == "Value1" # Should select gene1, gene3, gene5

  view <- ad[obs_condition, var_condition]

  # obsm should be subset on rows (observations) but columns unchanged
  expect_equal(nrow(view$obsm$numeric_matrix), 2L) # 2 selected obs
  expect_equal(ncol(view$obsm$numeric_matrix), 3L) # columns unchanged
  expect_equal(nrow(view$obsm$numeric_dense), 2L)
  expect_equal(nrow(view$obsm$numeric_csparse), 2L)

  # Verify that subsetting maintains the correct values (obs rows only)
  expect_identical(
    view$obsm$numeric_matrix,
    ad$obsm$numeric_matrix[c(1, 3), , drop = FALSE]
  )
})

test_that("AnnDataView varm subsetting works", {
  ad <- generate_dataset(
    n_obs = 3L,
    n_vars = 5L,
    example = TRUE,
    format = "AnnData"
  )

  # Create logical conditions
  obs_condition <- ad$obs$factor == "Value1" # Should select cell1 and cell3
  var_condition <- ad$var$factor == "Value1" # Should select gene1, gene3, gene5

  view <- ad[obs_condition, var_condition]

  # varm should be subset on rows (variables) but columns unchanged
  expect_equal(nrow(view$varm$numeric_matrix), 3L) # 3 selected vars
  expect_equal(ncol(view$varm$numeric_matrix), 5L) # columns unchanged
  expect_equal(nrow(view$varm$numeric_dense), 3L)
  expect_equal(nrow(view$varm$numeric_csparse), 3L)

  # Verify that subsetting maintains the correct values (var rows only)
  expect_identical(
    view$varm$numeric_matrix,
    ad$varm$numeric_matrix[c(1, 3, 5), , drop = FALSE]
  )
})

test_that("AnnDataView obsp subsetting works", {
  ad <- generate_dataset(
    n_obs = 3L,
    n_vars = 5L,
    example = TRUE,
    format = "AnnData"
  )

  # Create logical conditions
  obs_condition <- ad$obs$factor == "Value1" # Should select cell1 and cell3
  var_condition <- ad$var$factor == "Value1" # Should select gene1, gene3, gene5

  view <- ad[obs_condition, var_condition]

  # obsp should be subset on both rows and columns (observations)
  expect_equal(dim(view$obsp$numeric_matrix), c(2L, 2L)) # 2x2 for selected obs
  expect_equal(dim(view$obsp$numeric_dense), c(2L, 2L))
  expect_equal(dim(view$obsp$numeric_csparse), c(2L, 2L))

  # Verify that subsetting maintains the correct values (both dimensions)
  expect_identical(
    view$obsp$numeric_matrix,
    ad$obsp$numeric_matrix[c(1, 3), c(1, 3), drop = FALSE]
  )
})

test_that("AnnDataView varp subsetting works", {
  ad <- generate_dataset(
    n_obs = 3L,
    n_vars = 5L,
    example = TRUE,
    format = "AnnData"
  )

  # Create logical conditions
  obs_condition <- ad$obs$factor == "Value1" # Should select cell1 and cell3
  var_condition <- ad$var$factor == "Value1" # Should select gene1, gene3, gene5

  view <- ad[obs_condition, var_condition]

  # varp should be subset on both rows and columns (variables)
  expect_equal(dim(view$varp$numeric_matrix), c(3L, 3L)) # 3x3 for selected vars
  expect_equal(dim(view$varp$numeric_dense), c(3L, 3L))
  expect_equal(dim(view$varp$numeric_csparse), c(3L, 3L))

  # Verify that subsetting maintains the correct values (both dimensions)
  expect_identical(
    view$varp$numeric_matrix,
    ad$varp$numeric_matrix[c(1, 3, 5), c(1, 3, 5), drop = FALSE]
  )
})

test_that("AnnDataView avoids nested wrappers when chaining subsets", {
  ad <- generate_dataset(
    n_obs = 3L,
    n_vars = 5L,
    example = TRUE,
    format = "AnnData"
  )

  # Create logical conditions
  obs_condition <- ad$obs$factor == "Value1" # Should select cell1 and cell3
  var_condition <- ad$var$factor == "Value1" # Should select gene1, gene3, gene5

  # Test that subsetting a view doesn't create nested AnnDataView(AnnDataView(...))
  # Instead, it should compute combined indices and create a new view from the original data
  view1 <- ad[obs_condition, ]
  view2 <- view1[, var_condition]

  expect_s3_class(view2, "AnnDataView")
  expect_equal(dim(view2$X), c(2L, 3L)) # 2 obs (cell1, cell3) × 3 vars (gene1, gene3, gene5)
  expect_equal(view2$obs_names, c("cell1", "cell3"))
  expect_equal(view2$var_names, c("gene1", "gene3", "gene5"))

  # Test chaining subsets on the same dimension multiple times
  # First subset obs to select cell1 and cell3, then further subset to just cell3
  view_obs1 <- ad[obs_condition, ] # cell1, cell3
  view_obs2 <- view_obs1[c("cell3"), ] # further subset to just cell3

  expect_s3_class(view_obs2, "AnnDataView")
  expect_equal(dim(view_obs2$X), c(1L, 5L)) # 1 obs × 5 vars
  expect_equal(view_obs2$obs_names, "cell3")

  # Test chaining var subsets multiple times
  # First subset vars to gene1, gene3, gene5, then further subset to gene1, gene5
  view_var1 <- ad[, var_condition] # gene1, gene3, gene5
  view_var2 <- view_var1[, c("gene1", "gene5")] # further subset

  expect_s3_class(view_var2, "AnnDataView")
  expect_equal(dim(view_var2$X), c(3L, 2L)) # 3 obs × 2 vars
  expect_equal(view_var2$var_names, c("gene1", "gene5"))

  # Test complex chaining: obs -> var -> obs -> var
  view_complex <- ad[obs_condition, ][, var_condition][c("cell3"), ][, c(
    "gene1",
    "gene5"
  )]

  expect_s3_class(view_complex, "AnnDataView")
  expect_equal(dim(view_complex$X), c(1L, 2L)) # 1 obs × 2 vars
  expect_equal(view_complex$obs_names, "cell3")
  expect_equal(view_complex$var_names, c("gene1", "gene5"))

  # Verify that chained subsetting produces the same result as combined subsetting
  # This indirectly ensures that the implementation avoids nested wrappers
  # by computing combined indices rather than wrapping views within views
  view_combined <- ad[obs_condition, var_condition]
  expect_identical(view2$X, view_combined$X)
  expect_identical(view2$obs, view_combined$obs)
  expect_identical(view2$var, view_combined$var)

  # Additional verification that the chained view behaves correctly
  expect_equal(view2$n_obs(), 2L)
  expect_equal(view2$n_vars(), 3L)
})

test_that("AnnDataView uns field are unaffected by subsetting", {
  ad <- generate_dataset(
    n_obs = 3L,
    n_vars = 5L,
    example = TRUE,
    format = "AnnData"
  )

  # Create logical condition
  obs_condition <- ad$obs$factor == "Value1" # Should select cell1 and cell3
  view <- ad[obs_condition, ]

  # uns should be unaffected by subsetting
  expect_identical(view$uns, ad$uns)
  expect_equal(view$uns$scalar_character, "value_0")
  expect_equal(length(view$uns$vec_integer), 10L)
})

test_that("AnnDataView conversion to InMemoryAnnData works", {
  ad <- generate_dataset(
    n_obs = 3L,
    n_vars = 5L,
    example = TRUE,
    format = "AnnData"
  )

  # Create logical conditions
  obs_condition <- ad$obs$factor == "Value1" # Should select cell1 and cell3
  var_condition <- ad$var$factor == "Value1" # Should select gene1, gene3, gene5

  # Create a view with subsetting
  view <- ad[obs_condition, var_condition]

  # Convert to InMemoryAnnData
  result <- view$as_InMemoryAnnData()

  expect_s3_class(result, "InMemoryAnnData")
  expect_equal(dim(result$X), c(2L, 3L))
  expect_equal(result$obs_names, c("cell1", "cell3"))
  expect_equal(result$var_names, c("gene1", "gene3", "gene5"))
  expect_equal(as.character(result$obs$factor), c("Value1", "Value1"))
  expect_equal(as.character(result$var$factor), c("Value1", "Value1", "Value1"))

  # Check that layers are preserved
  expect_equal(length(result$layers), length(ad$layers))
  expect_equal(dim(result$layers$numeric_matrix), c(2L, 3L))
})

test_that("AnnDataView error handling works", {
  ad <- generate_dataset(
    n_obs = 3L,
    n_vars = 5L,
    example = TRUE,
    format = "AnnData"
  )

  # Test initialization with non-AbstractAnnData
  expect_error(
    AnnDataView$new("not_an_anndata"),
    "must be an.*AbstractAnnData.*object"
  )

  # Test setting values on AnnDataView (create view first)
  # Create logical condition
  obs_condition <- ad$obs$factor == "Value1"

  view <- ad[obs_condition, ]
  expect_error(
    view$X <- matrix(1:15, 3L, 5L),
    "Cannot set X on an.*AnnDataView.*object"
  )
  expect_error(
    view$obs <- data.frame(),
    "Cannot set obs on an.*AnnDataView.*object"
  )
  expect_error(
    view$var <- data.frame(),
    "Cannot set var on an.*AnnDataView.*object"
  )
  expect_error(
    view$layers <- list(),
    "Cannot set layers on an.*AnnDataView.*object"
  )

  # Test that AnnDataView inherits from AbstractAnnData
  # Create logical condition
  obs_condition <- ad$obs$factor == "Value1"

  view2 <- ad[obs_condition, ]
  expect_s3_class(view2, "AbstractAnnData")
  expect_s3_class(view2, "AnnDataView")
})

test_that("AnnDataView subsetting fails with invalid conditions", {
  ad <- generate_dataset(
    n_obs = 3L,
    n_vars = 5L,
    example = TRUE,
    format = "AnnData"
  )

  # Test invalid logical vector length
  expect_error(
    ad[c(TRUE, FALSE), ], # Wrong length
    "Logical subset of observations must have length 3"
  )

  expect_error(
    ad[, c(TRUE, FALSE, TRUE)], # Wrong length
    "Logical subset of variables must have length 5"
  )

  # Test invalid condition types
  expect_error(
    ad["invalid", ], # String that's not a valid name
    "Names of observations not found: invalid"
  )

  # Test invalid numeric indices
  expect_error(
    ad[c(1, 5), ], # Index 5 is out of bounds (only 3 obs)
    "Integer indices for observations must be between 1 and 3"
  )

  expect_error(
    ad[, c(1, 10)], # Index 10 is out of bounds (only 5 vars)
    "Integer indices for variables must be between 1 and 5"
  )

  # Test negative indices (not supported)
  expect_error(
    ad[-1, ],
    "Integer indices for observations must be between 1 and 3"
  )

  expect_error(
    ad[, -1],
    "Integer indices for variables must be between 1 and 5"
  )

  # Test invalid character names
  expect_error(
    ad[c("cell1", "invalid_cell"), ],
    "Names of observations not found: invalid_cell"
  )

  expect_error(
    ad[, c("gene1", "invalid_gene")],
    "Names of variables not found: invalid_gene"
  )

  # Test with character subsetting when only auto-generated names exist
  ad_auto_names <- AnnData(X = matrix(1:15, 3L, 5L))
  # Auto-generated names are "1", "2", "3", so use names that don't exist
  expect_error(
    ad_auto_names[c("invalid1", "invalid2"), ],
    "Names of observations not found: invalid1, invalid2"
  )
})

skip_if_not_installed("Matrix")

test_that("S3 method dim.AbstractAnnData works", {
  ad <- generate_dataset(n_obs = 10, n_vars = 5, format = "AnnData")

  result <- dim(ad)
  expect_type(result, "integer")
  expect_length(result, 2)
  expect_equal(result, c(10, 5))
  expect_equal(result[1], ad$n_obs())
  expect_equal(result[2], ad$n_vars())
})

test_that("S3 method nrow.AbstractAnnData works", {
  ad <- generate_dataset(n_obs = 10, n_vars = 5, format = "AnnData")

  result <- nrow(ad)
  expect_type(result, "integer")
  expect_length(result, 1)
  expect_equal(result, 10)
  expect_equal(result, ad$n_obs())
})

test_that("S3 method ncol.AbstractAnnData works", {
  ad <- generate_dataset(n_obs = 10, n_vars = 5, format = "AnnData")

  result <- ncol(ad)
  expect_type(result, "integer")
  expect_length(result, 1)
  expect_equal(result, 5)
  expect_equal(result, ad$n_vars())
})

test_that("S3 method rownames.AbstractAnnData works", {
  ad <- generate_dataset(n_obs = 10, n_vars = 5, format = "AnnData")

  result <- rownames(ad)
  expect_type(result, "character")
  expect_length(result, 10)
  expect_equal(result, ad$obs_names)

  # Test with custom obs names
  custom_names <- paste0("cell_", 1:10)
  ad$obs_names <- custom_names
  expect_equal(rownames(ad), custom_names)
})

test_that("S3 method colnames.AbstractAnnData works", {
  ad <- generate_dataset(n_obs = 10, n_vars = 5, format = "AnnData")

  result <- colnames(ad)
  expect_type(result, "character")
  expect_length(result, 5)
  expect_equal(result, ad$var_names)

  # Test with custom var names
  custom_names <- paste0("gene_", 1:5)
  ad$var_names <- custom_names
  expect_equal(colnames(ad), custom_names)
})

test_that("S3 method rownames<-.AbstractAnnData works", {
  ad <- generate_dataset(n_obs = 10, n_vars = 5, format = "AnnData")

  new_names <- paste0("cell_", 1:10)
  rownames(ad) <- new_names

  expect_equal(rownames(ad), new_names)
  expect_equal(ad$obs_names, new_names)

  # Test that the function modifies the object correctly
  new_names2 <- paste0("obs_", 1:10)
  rownames(ad) <- new_names2
  expect_equal(rownames(ad), new_names2)

  # Test assignment result (R's standard behaviour for assignment operators)
  result <- rownames(ad) <- paste0("final_obs_", 1:10)
  expect_equal(result, paste0("final_obs_", 1:10))
  expect_equal(rownames(ad), paste0("final_obs_", 1:10))

  # Test with NULL (should work if the underlying implementation supports it)
  expect_no_error({
    rownames(ad) <- NULL
  })

  # Check that rownames are reset to default values
  default_names <- as.character(seq_len(10))
  expect_equal(rownames(ad), default_names)
  expect_equal(ad$obs_names, default_names)
})

test_that("S3 method colnames<-.AbstractAnnData works", {
  ad <- generate_dataset(n_obs = 10, n_vars = 5, format = "AnnData")

  new_names <- paste0("gene_", 1:5)
  colnames(ad) <- new_names

  expect_equal(colnames(ad), new_names)
  expect_equal(ad$var_names, new_names)

  # Test that the function modifies the object correctly
  new_names2 <- paste0("var_", 1:5)
  colnames(ad) <- new_names2
  expect_equal(colnames(ad), new_names2)

  # Test assignment result (R's standard behaviour for assignment operators)
  result <- colnames(ad) <- paste0("final_var_", 1:5)
  expect_equal(result, paste0("final_var_", 1:5))
  expect_equal(colnames(ad), paste0("final_var_", 1:5))

  # Test with NULL (should work if the underlying implementation supports it)
  expect_no_error({
    colnames(ad) <- NULL
  })

  # Check that colnames are reset to default values
  default_names <- as.character(seq_len(5))
  expect_equal(colnames(ad), default_names)
  expect_equal(ad$var_names, default_names)
})

test_that("S3 method [.AbstractAnnData works with numeric indices", {
  ad <- generate_dataset(n_obs = 10, n_vars = 5, format = "AnnData")

  result <- ad[1:3, ]
  expect_s3_class(result, "AnnDataView")
  expect_s3_class(result, "AbstractAnnData")
  expect_equal(nrow(result), 3)
  expect_equal(ncol(result), 5)
  expect_equal(rownames(result), rownames(ad)[1:3])
  expect_equal(colnames(result), colnames(ad))

  result <- ad[, 2:4]
  expect_s3_class(result, "AnnDataView")
  expect_equal(nrow(result), 10)
  expect_equal(ncol(result), 3)
  expect_equal(rownames(result), rownames(ad))
  expect_equal(colnames(result), colnames(ad)[2:4])

  result <- ad[1:3, 2:4]
  expect_s3_class(result, "AnnDataView")
  expect_equal(nrow(result), 3)
  expect_equal(ncol(result), 3)
  expect_equal(rownames(result), rownames(ad)[1:3])
  expect_equal(colnames(result), colnames(ad)[2:4])
})

test_that("S3 method [.AbstractAnnData works with logical indices", {
  ad <- generate_dataset(n_obs = 10, n_vars = 5, format = "AnnData")

  logical_rows <- c(
    TRUE,
    FALSE,
    TRUE,
    FALSE,
    TRUE,
    FALSE,
    TRUE,
    FALSE,
    TRUE,
    FALSE
  )
  result <- ad[logical_rows, ]
  expect_s3_class(result, "AnnDataView")
  expect_equal(nrow(result), 5)
  expect_equal(ncol(result), 5)
  expect_equal(rownames(result), rownames(ad)[logical_rows])

  logical_cols <- c(TRUE, FALSE, TRUE, FALSE, TRUE)
  result <- ad[, logical_cols]
  expect_s3_class(result, "AnnDataView")
  expect_equal(nrow(result), 10)
  expect_equal(ncol(result), 3)
  expect_equal(colnames(result), colnames(ad)[logical_cols])

  result <- ad[logical_rows, logical_cols]
  expect_s3_class(result, "AnnDataView")
  expect_equal(nrow(result), 5)
  expect_equal(ncol(result), 3)
})

test_that("S3 method [.AbstractAnnData works with character indices", {
  ad <- generate_dataset(n_obs = 10, n_vars = 5, format = "AnnData")

  # Set custom names for testing
  custom_obs_names <- paste0("cell_", 1:10)
  custom_var_names <- paste0("gene_", 1:5)
  ad$obs_names <- custom_obs_names
  ad$var_names <- custom_var_names

  selected_obs <- c("cell_1", "cell_3", "cell_5")
  result <- ad[selected_obs, ]
  expect_s3_class(result, "AnnDataView")
  expect_equal(nrow(result), 3)
  expect_equal(ncol(result), 5)
  expect_equal(rownames(result), selected_obs)

  selected_vars <- c("gene_2", "gene_4")
  result <- ad[, selected_vars]
  expect_s3_class(result, "AnnDataView")
  expect_equal(nrow(result), 10)
  expect_equal(ncol(result), 2)
  expect_equal(colnames(result), selected_vars)

  # Test combined character subsetting
  result <- ad[selected_obs, selected_vars]
  expect_s3_class(result, "AnnDataView")
  expect_equal(nrow(result), 3)
  expect_equal(ncol(result), 2)
  expect_equal(rownames(result), selected_obs)
  expect_equal(colnames(result), selected_vars)
})

test_that("S3 method [.AbstractAnnData error handling works", {
  ad <- generate_dataset(n_obs = 10, n_vars = 5, format = "AnnData")

  # Test invalid logical vector length for observations
  expect_error(
    ad[c(TRUE, FALSE), ],
    "Logical subset of observations must have length 10"
  )

  # Test invalid logical vector length for variables
  expect_error(
    ad[, c(TRUE, FALSE)],
    "Logical subset of variables must have length 5"
  )

  # Test out-of-bounds numeric indices for observations
  expect_error(
    ad[11, ],
    "Integer indices for observations must be between 1 and 10"
  )

  expect_error(
    ad[0, ],
    "Integer indices for observations must be between 1 and 10"
  )

  # Test out-of-bounds numeric indices for variables
  expect_error(
    ad[, 6],
    "Integer indices for variables must be between 1 and 5"
  )

  expect_error(
    ad[, 0],
    "Integer indices for variables must be between 1 and 5"
  )

  # Test invalid character names for observations
  expect_error(
    ad[c("nonexistent_obs"), ],
    "Names of observations not found: nonexistent_obs"
  )

  # Test invalid character names for variables
  expect_error(
    ad[, c("nonexistent_var")],
    "Names of variables not found: nonexistent_var"
  )
})

test_that("S3 methods work with HDF5AnnData", {
  skip_if_not_installed("rhdf5")

  h5ad_file <- withr::local_tempfile(fileext = ".h5ad")
  ad <- generate_dataset(n_obs = 10, n_vars = 5, format = "AnnData")

  # Write to HDF5 and read back
  write_h5ad(ad, h5ad_file)
  h5_ad <- read_h5ad(h5ad_file)

  # Test all S3 methods work with HDF5AnnData
  expect_equal(dim(h5_ad), c(10, 5))
  expect_equal(nrow(h5_ad), 10)
  expect_equal(ncol(h5_ad), 5)
  expect_length(rownames(h5_ad), 10)
  expect_length(colnames(h5_ad), 5)

  # Test subsetting works
  result <- h5_ad[1:3, 1:2]
  expect_s3_class(result, "AnnDataView")
  expect_equal(nrow(result), 3)
  expect_equal(ncol(result), 2)

  # Test print works
  expect_output(print(h5_ad), "InMemoryAnnData object")
})

test_that("S3 methods work with InMemoryAnnData", {
  ad <- generate_dataset(n_obs = 10, n_vars = 5, format = "AnnData")

  # Test all S3 methods work with InMemoryAnnData
  expect_equal(dim(ad), c(10, 5))
  expect_equal(nrow(ad), 10)
  expect_equal(ncol(ad), 5)
  expect_length(rownames(ad), 10)
  expect_length(colnames(ad), 5)

  # Test subsetting works
  result <- ad[1:3, 1:2]
  expect_s3_class(result, "AnnDataView")
  expect_equal(nrow(result), 3)
  expect_equal(ncol(result), 2)

  # Test print works
  expect_output(print(ad), "InMemoryAnnData object")
})

test_that("S3 methods integration: setting names and subsetting", {
  ad <- generate_dataset(n_obs = 10, n_vars = 5, format = "AnnData")

  # Set custom names using S3 setter methods
  custom_obs_names <- paste0("cell_", 1:10)
  custom_var_names <- paste0("gene_", 1:5)

  rownames(ad) <- custom_obs_names
  colnames(ad) <- custom_var_names

  # Verify names were set correctly
  expect_equal(rownames(ad), custom_obs_names)
  expect_equal(colnames(ad), custom_var_names)
  expect_equal(ad$obs_names, custom_obs_names)
  expect_equal(ad$var_names, custom_var_names)

  # Test subsetting using the custom names
  selected_cells <- c("cell_1", "cell_3", "cell_5")
  selected_genes <- c("gene_1", "gene_2")

  result <- ad[selected_cells, selected_genes]

  expect_s3_class(result, "AnnDataView")
  expect_equal(nrow(result), 3)
  expect_equal(ncol(result), 2)
  expect_equal(rownames(result), selected_cells)
  expect_equal(colnames(result), selected_genes)

  # Test that the subsetting actually worked by checking dimensions
  expect_identical(result$X, ad$X[c(1, 3, 5), c(1, 2), drop = FALSE])

  # Test mixed subsetting: numeric for rows, names for columns
  mixed_result <- ad[1:3, selected_genes]
  expect_equal(nrow(mixed_result), 3)
  expect_equal(ncol(mixed_result), 2)
  expect_equal(rownames(mixed_result), custom_obs_names[1:3])
  expect_equal(colnames(mixed_result), selected_genes)
})

test_that("S3 methods are consistent across different backends", {
  skip_if_not_installed("rhdf5")

  # Create InMemoryAnnData
  mem_ad <- generate_dataset(n_obs = 10, n_vars = 5, format = "AnnData")

  # Create HDF5AnnData
  h5ad_file <- withr::local_tempfile(fileext = ".h5ad")
  write_h5ad(mem_ad, h5ad_file)
  h5_ad <- read_h5ad(h5ad_file)

  # Test that S3 methods give consistent results
  expect_equal(dim(mem_ad), dim(h5_ad))
  expect_equal(nrow(mem_ad), nrow(h5_ad))
  expect_equal(ncol(mem_ad), ncol(h5_ad))
  expect_equal(rownames(mem_ad), rownames(h5_ad))
  expect_equal(colnames(mem_ad), colnames(h5_ad))

  # Test that subsetting gives consistent results
  mem_subset <- mem_ad[1:5, 1:3]
  h5_subset <- h5_ad[1:5, 1:3]

  expect_equal(dim(mem_subset), dim(h5_subset))
  expect_equal(rownames(mem_subset), rownames(h5_subset))
  expect_equal(colnames(mem_subset), colnames(h5_subset))
})

test_that("ReticulateAnnData creation works", {
  skip_if_no_anndata_py()

  # Test creating empty ReticulateAnnData
  adata <- ReticulateAnnData$new(shape = c(10, 5))
  expect_s3_class(adata, "ReticulateAnnData")
  expect_equal(adata$n_obs(), 10)
  expect_equal(adata$n_vars(), 5)

  # Test creating with data
  X <- matrix(1:20, nrow = 4, ncol = 5)
  obs <- data.frame(row.names = paste0("cell", 1:4), group = letters[1:4])
  var <- data.frame(row.names = paste0("gene", 1:5), type = rep("gene", 5))

  adata2 <- ReticulateAnnData$new(
    X = X,
    obs = obs,
    var = var
  )

  expect_s3_class(adata2, "ReticulateAnnData")
  expect_equal(adata2$n_obs(), 4)
  expect_equal(adata2$n_vars(), 5)
  expect_equal(dim(adata2$X), c(4, 5))
})

test_that("ReticulateAnnData wrapping Python object works", {
  skip_if_no_anndata_py()

  library(reticulate)
  ad <- import("anndata", convert = FALSE)

  # Create a Python AnnData object
  py_x <- r_to_py(matrix(1:20, nrow = 4, ncol = 5))
  py_adata <- ad$AnnData(X = py_x)

  # Wrap it with ReticulateAnnData
  r_adata <- ReticulateAnnData$new(py_anndata = py_adata)

  expect_s3_class(r_adata, "ReticulateAnnData")
  expect_equal(r_adata$n_obs(), 4)
  expect_equal(r_adata$n_vars(), 5)
  expect_equal(dim(r_adata$X), c(4, 5))
})

test_that("ReticulateAnnData slot access works", {
  skip_if_no_anndata_py()

  X <- matrix(1:20, nrow = 4, ncol = 5)
  obs <- data.frame(row.names = paste0("cell", 1:4), group = letters[1:4])
  var <- data.frame(row.names = paste0("gene", 1:5), type = rep("gene", 5))
  layers <- list(
    raw = matrix(21:40, nrow = 4, ncol = 5),
    scaled = matrix(41:60, nrow = 4, ncol = 5)
  )
  uns <- list(
    metadata = "test",
    params = list(param1 = 1, param2 = "value")
  )

  adata <- ReticulateAnnData$new(
    X = X,
    obs = obs,
    var = var,
    layers = layers,
    uns = uns
  )

  # Test X
  # trackstatus: class=ReticulateAnnData, feature=test_get_X, status=done
  expect_equal(dim(adata$X), c(4, 5))

  # Test obs
  # trackstatus: class=ReticulateAnnData, feature=test_get_obs, status=done
  expect_s3_class(adata$obs, "data.frame")
  expect_equal(nrow(adata$obs), 4)

  # Test var
  # trackstatus: class=ReticulateAnnData, feature=test_get_var, status=done
  expect_s3_class(adata$var, "data.frame")
  expect_equal(nrow(adata$var), 5)

  # Test layers
  # trackstatus: class=ReticulateAnnData, feature=test_get_layers, status=done
  expect_type(adata$layers, "list")
  expect_equal(names(adata$layers), c("raw", "scaled"))

  # Test uns
  # trackstatus: class=ReticulateAnnData, feature=test_get_uns, status=done
  expect_type(adata$uns, "list")
  expect_equal(adata$uns$metadata, "test")

  # Test obs_names and var_names
  # trackstatus: class=ReticulateAnnData, feature=test_get_obs_names, status=done
  expect_equal(adata$obs_names, paste0("cell", 1:4))
  # trackstatus: class=ReticulateAnnData, feature=test_get_var_names, status=done
  expect_equal(adata$var_names, paste0("gene", 1:5))
})

test_that("ReticulateAnnData slot setting works", {
  skip_if_no_anndata_py()

  adata <- ReticulateAnnData$new(shape = c(3, 4))

  # Set X
  # trackstatus: class=ReticulateAnnData, feature=test_set_X, status=done
  new_x <- matrix(1:12, nrow = 3, ncol = 4)
  adata$X <- new_x
  expect_equal(dim(adata$X), c(3, 4))

  # Set obs
  # trackstatus: class=ReticulateAnnData, feature=test_set_obs, status=done
  new_obs <- data.frame(
    row.names = paste0("cell", 1:3),
    type = c("A", "B", "C")
  )
  adata$obs <- new_obs
  expect_equal(nrow(adata$obs), 3)
  expect_equal(adata$obs$type, c("A", "B", "C"))

  # Set var
  # trackstatus: class=ReticulateAnnData, feature=test_set_var, status=done
  new_var <- data.frame(
    row.names = paste0("gene", 1:4),
    biotype = rep("protein_coding", 4)
  )
  adata$var <- new_var
  expect_equal(nrow(adata$var), 4)
  expect_equal(adata$var$biotype, rep("protein_coding", 4))

  # Set uns
  # trackstatus: class=ReticulateAnnData, feature=test_set_uns, status=done
  new_uns <- list(experiment = "test", date = "2023-01-01")
  adata$uns <- new_uns
  expect_equal(adata$uns$experiment, "test")
})

test_that("ReticulateAnnData obsm, varm, obsp, varp access works", {
  skip_if_no_anndata_py()

  X <- matrix(1:20, nrow = 4, ncol = 5)
  obs <- data.frame(row.names = paste0("cell", 1:4), group = letters[1:4])
  var <- data.frame(row.names = paste0("gene", 1:5), type = rep("gene", 5))

  obsm <- list(
    X_pca = matrix(rnorm(8), nrow = 4, ncol = 2)
  )
  varm <- list(
    PCs = matrix(rnorm(10), nrow = 5, ncol = 2)
  )
  obsp <- list(
    connectivities = matrix(rnorm(16), nrow = 4, ncol = 4)
  )
  varp <- list(
    correlations = matrix(rnorm(25), nrow = 5, ncol = 5)
  )

  adata <- ReticulateAnnData$new(
    X = X,
    obs = obs,
    var = var,
    obsm = obsm,
    varm = varm,
    obsp = obsp,
    varp = varp
  )

  # Test obsm
  # trackstatus: class=ReticulateAnnData, feature=test_get_obsm, status=done
  expect_type(adata$obsm, "list")
  expect_equal(names(adata$obsm), "X_pca")
  expect_equal(dim(adata$obsm$X_pca), c(4, 2))

  # Test varm
  # trackstatus: class=ReticulateAnnData, feature=test_get_varm, status=done
  expect_type(adata$varm, "list")
  expect_equal(names(adata$varm), "PCs")
  expect_equal(dim(adata$varm$PCs), c(5, 2))

  # Test obsp
  # trackstatus: class=ReticulateAnnData, feature=test_get_obsp, status=done
  expect_type(adata$obsp, "list")
  expect_equal(names(adata$obsp), "connectivities")
  expect_equal(dim(adata$obsp$connectivities), c(4, 4))

  # Test varp
  # trackstatus: class=ReticulateAnnData, feature=test_get_varp, status=done
  expect_type(adata$varp, "list")
  expect_equal(names(adata$varp), "correlations")
  expect_equal(dim(adata$varp$correlations), c(5, 5))
})

test_that("ReticulateAnnData obsm, varm, obsp, varp setting works", {
  skip_if_no_anndata_py()

  X <- matrix(1:20, nrow = 4, ncol = 5)
  adata <- ReticulateAnnData$new(X = X)

  # Set obsm
  # trackstatus: class=ReticulateAnnData, feature=test_set_obsm, status=done
  new_obsm <- list(X_pca = matrix(rnorm(8), nrow = 4, ncol = 2))
  adata$obsm <- new_obsm
  expect_equal(names(adata$obsm), "X_pca")
  expect_equal(dim(adata$obsm$X_pca), c(4, 2))

  # Set varm
  # trackstatus: class=ReticulateAnnData, feature=test_set_varm, status=done
  new_varm <- list(PCs = matrix(rnorm(10), nrow = 5, ncol = 2))
  adata$varm <- new_varm
  expect_equal(names(adata$varm), "PCs")
  expect_equal(dim(adata$varm$PCs), c(5, 2))

  # Set obsp
  # trackstatus: class=ReticulateAnnData, feature=test_set_obsp, status=done
  new_obsp <- list(connectivities = matrix(rnorm(16), nrow = 4, ncol = 4))
  adata$obsp <- new_obsp
  expect_equal(names(adata$obsp), "connectivities")
  expect_equal(dim(adata$obsp$connectivities), c(4, 4))

  # Set varp
  # trackstatus: class=ReticulateAnnData, feature=test_set_varp, status=done
  new_varp <- list(correlations = matrix(rnorm(25), nrow = 5, ncol = 5))
  adata$varp <- new_varp
  expect_equal(names(adata$varp), "correlations")
  expect_equal(dim(adata$varp$correlations), c(5, 5))
})

test_that("ReticulateAnnData names setting works", {
  skip_if_no_anndata_py()

  X <- matrix(1:20, nrow = 4, ncol = 5)
  adata <- ReticulateAnnData$new(X = X)

  # Set obs_names
  # trackstatus: class=ReticulateAnnData, feature=test_set_obs_names, status=done
  new_obs_names <- paste0("sample", 1:4)
  adata$obs_names <- new_obs_names
  expect_equal(adata$obs_names, new_obs_names)

  # Set var_names
  # trackstatus: class=ReticulateAnnData, feature=test_set_var_names, status=done
  new_var_names <- paste0("feature", 1:5)
  adata$var_names <- new_var_names
  expect_equal(adata$var_names, new_var_names)
})

test_that("ReticulateAnnData layers setting works", {
  skip_if_no_anndata_py()

  X <- matrix(1:20, nrow = 4, ncol = 5)
  adata <- ReticulateAnnData$new(X = X)

  # Set layers
  # trackstatus: class=ReticulateAnnData, feature=test_set_layers, status=done
  new_layers <- list(
    raw = matrix(21:40, nrow = 4, ncol = 5),
    normalized = matrix(41:60, nrow = 4, ncol = 5)
  )
  adata$layers <- new_layers
  expect_equal(names(adata$layers), c("raw", "normalized"))
  expect_equal(dim(adata$layers$raw), c(4, 5))
  expect_equal(dim(adata$layers$normalized), c(4, 5))
})

test_that("Conversion between ReticulateAnnData and other types works", {
  skip_if_no_anndata_py()

  X <- matrix(1:20, nrow = 4, ncol = 5)
  obs <- data.frame(row.names = paste0("cell", 1:4), group = letters[1:4])
  var <- data.frame(row.names = paste0("gene", 1:5), type = rep("gene", 5))

  # Create ReticulateAnnData
  ret_adata <- ReticulateAnnData$new(X = X, obs = obs, var = var)

  # Convert to InMemoryAnnData
  mem_adata <- ret_adata$as_InMemoryAnnData()
  expect_s3_class(mem_adata, "InMemoryAnnData")
  expect_equal(mem_adata$n_obs(), 4)
  expect_equal(mem_adata$n_vars(), 5)

  # Convert InMemoryAnnData to ReticulateAnnData
  ret_adata2 <- mem_adata$as_ReticulateAnnData()
  expect_s3_class(ret_adata2, "ReticulateAnnData")
  expect_equal(ret_adata2$n_obs(), 4)
  expect_equal(ret_adata2$n_vars(), 5)
})

test_that("automatic py_to_r and r_to_py conversion works", {
  skip_if_no_anndata_py()

  library(reticulate)
  ad <- import("anndata", convert = FALSE)

  # Create Python AnnData
  py_x <- r_to_py(matrix(1:12, nrow = 3, ncol = 4))
  py_adata <- ad$AnnData(X = py_x)

  # Test automatic py_to_r conversion
  r_adata <- py_to_r(py_adata)
  expect_s3_class(r_adata, "ReticulateAnnData")
  expect_equal(r_adata$n_obs(), 3)
  expect_equal(r_adata$n_vars(), 4)

  # Test automatic r_to_py conversion
  py_adata2 <- r_to_py(r_adata)
  expect_true(inherits(py_adata2, "python.builtin.object"))
  expect_equal(as.integer(py_to_r(py_adata2$n_obs)), 3L)
  expect_equal(as.integer(py_to_r(py_adata2$n_vars)), 4L)

  # Test with other AnnData types
  mem_adata <- AnnData(X = matrix(1:20, nrow = 4, ncol = 5))
  py_adata3 <- r_to_py(mem_adata) # Should convert InMemoryAnnData to Python
  expect_true(inherits(py_adata3, "python.builtin.object"))
  expect_equal(as.integer(py_to_r(py_adata3$n_obs)), 4L)
  expect_equal(as.integer(py_to_r(py_adata3$n_vars)), 5L)
})

test_that("automatic py_to_r and r_to_py conversion works", {
  skip_if_no_anndata_py()

  library(reticulate)
  ad <- import("anndata", convert = FALSE)

  # Create Python AnnData
  py_x <- r_to_py(matrix(1:12, nrow = 3, ncol = 4))
  py_adata <- ad$AnnData(X = py_x)

  # Test automatic Python to R conversion via S3 method
  r_adata <- py_to_r(py_adata)
  expect_s3_class(r_adata, "ReticulateAnnData")
  expect_equal(r_adata$n_obs(), 3)
  expect_equal(r_adata$n_vars(), 4)

  # Test automatic R to Python conversion via S3 method
  py_adata2 <- r_to_py(r_adata)
  expect_true(inherits(py_adata2, "python.builtin.object"))
  expect_equal(as.integer(py_to_r(py_adata2$n_obs)), 3L)
  expect_equal(as.integer(py_to_r(py_adata2$n_vars)), 4L)

  # Test with other AnnData types (should also work automatically)
  mem_adata <- AnnData(X = matrix(1:20, nrow = 4, ncol = 5))
  py_adata3 <- r_to_py(mem_adata)
  expect_true(inherits(py_adata3, "python.builtin.object"))
  expect_equal(as.integer(py_to_r(py_adata3$n_obs)), 4L)
  expect_equal(as.integer(py_to_r(py_adata3$n_vars)), 5L)
})

test_that("reticulate utility functions work", {
  library(reticulate)

  # Test conversion utilities with simple objects
  r_mat <- matrix(1:6, 2, 3)
  py_mat <- r_to_py(r_mat)
  r_mat2 <- py_to_r(py_mat)
  expect_equal(dim(r_mat2), c(2, 3))

  # Test with data frame
  r_df <- data.frame(x = 1:3, y = letters[1:3])
  py_df <- r_to_py(r_df)
  r_df2 <- py_to_r(py_df)
  expect_s3_class(r_df2, "data.frame")
  expect_equal(nrow(r_df2), 3)
})

dummy <- generate_dataset(10L, 20L)

# GETTERS ----------------------------------------------------------------
test_that("Creating InMemoryAnnData works", {
  ad <- AnnData(
    X = dummy$X,
    obs = dummy$obs,
    var = dummy$var
  )

  # trackstatus: class=InMemoryAnnData, feature=test_get_X, status=done
  # X should now have dimnames added on-the-fly
  expected_x <- dummy$X
  dimnames(expected_x) <- list(rownames(dummy$obs), rownames(dummy$var))
  expect_equal(ad$X, expected_x)
  # trackstatus: class=InMemoryAnnData, feature=test_get_obs, status=done
  expect_equal(ad$obs, dummy$obs)
  # trackstatus: class=InMemoryAnnData, feature=test_get_var, status=done
  expect_equal(ad$var, dummy$var)
  # trackstatus: class=InMemoryAnnData, feature=test_get_obs_names, status=done
  expect_equal(ad$obs_names, rownames(dummy$obs))
  # trackstatus: class=InMemoryAnnData, feature=test_get_var_names, status=done
  expect_equal(ad$var_names, rownames(dummy$var))
  expect_identical(ad$shape(), c(10L, 20L))
})

test_that("Creating InMemoryAnnData works with empty obs", {
  ad <- AnnData(
    obs = data.frame(),
    var = dummy$var
  )
  expect_identical(ad$shape(), c(0L, 20L))
})

test_that("Creating InMemoryAnnData works with empty var", {
  ad <- AnnData(
    obs = dummy$obs,
    var = data.frame()
  )
  expect_identical(ad$shape(), c(10L, 0L))
})

test_that("Creating AnnData works with only X, no obs or var", {
  X <- dummy$X
  dimnames(X) <- list(
    rownames(dummy$obs),
    rownames(dummy$var)
  )
  ad <- AnnData(X = X)
  expect_identical(ad$shape(), c(10L, 20L))
  expect_identical(ad$obs_names, rownames(dummy$obs))
  expect_identical(ad$var_names, rownames(dummy$var))
})

# trackstatus: class=InMemoryAnnData, feature=test_get_layers, status=done
test_that("'layers' works", {
  ## layers test helper function
  layers_test <- function(obs, var, layers) {
    expect_no_condition({
      ad <- AnnData(obs = obs, var = var, layers = layers)
    })
    # Expected layers should have dimnames added
    expected_layers <- layers
    if (!is.null(expected_layers)) {
      for (i in seq_along(expected_layers)) {
        if (!is.null(expected_layers[[i]])) {
          dimnames(expected_layers[[i]]) <- list(rownames(obs), rownames(var))
        }
      }
    }
    expect_identical(ad$layers, expected_layers)
  }

  obs <- var <- data.frame()
  layers_test(obs, var, NULL)
  layers_test(obs, var, setNames(list(), character()))
  layers_test(obs, var, list(A = matrix(0, 0, 0)))
  ## must be a named list
  expect_error(AnnData(obs, var, list()))

  obs <- data.frame(row.names = letters[1:3])
  var <- data.frame(row.names = LETTERS[1:5])
  layers_test(obs, var, NULL)
  layers_test(obs, var, list(A = matrix(0, 3, 5)))
  layers_test(obs, var, list(A = matrix(0, 3, 5), B = matrix(1, 3, 5)))

  ## must be a named list
  layers <- list(matrix(0, 3, 5))
  expect_error(AnnData(obs = obs, var = var, layers = layers))
  ## matching dimensions
  layers <- list(A = matrix(0, 0, 0))
  expect_error(AnnData(obs = obs, var = var, layers = layers))
  layers <- list(A = matrix(0, 3, 5), B = matrix(1, 5, 3))
  expect_error(AnnData(obs = obs, var = var, layers = layers))
})

test_that("*_keys() works", {
  obs <- var <- data.frame()
  ad <- AnnData(obs = obs, var = var)
  expect_identical(ad$layers_keys(), NULL)
  expect_identical(ad$obs_keys(), character())
  expect_identical(ad$var_keys(), character())

  layers <- setNames(list(), character())
  ad <- AnnData(obs = obs, var = var, layers = layers)
  expect_identical(ad$layers_keys(), character())

  layers <- list(A = matrix(0, 3, 5), B = matrix(1, 3, 5))
  obs <- data.frame(row.names = letters[1:3], x = 1:3)
  var <- data.frame(row.names = letters[1:5], y = 1:5)
  ad <- AnnData(obs = obs, var = var, layers = layers)
  expect_identical(ad$layers_keys(), c("A", "B"))
  expect_identical(ad$obs_keys(), "x")
  expect_identical(ad$var_keys(), "y")
})

# SETTERS -----------------------------------------------------------------

# trackstatus: class=InMemoryAnnData, feature=test_set_X, status=done
test_that("write to X", {
  ad <- AnnData(
    X = dummy$X,
    obs = dummy$obs,
    var = dummy$var
  )

  X2 <- Matrix::rsparsematrix(nrow = 10, ncol = 20, density = .1)
  ad$X <- X2

  # X should have dimnames added on-the-fly
  expected_x2 <- X2
  dimnames(expected_x2) <- list(ad$obs_names, ad$var_names)
  expect_equal(ad$X, expected_x2)

  # change row in X
  ad$X[2, ] <- 10
  expected_row <- rep(10, 20L)
  names(expected_row) <- ad$var_names
  expect_equal(ad$X[2, ], expected_row)

  # change column in X
  ad$X[, 3] <- 5
  expected_col <- rep(5, 10L)
  names(expected_col) <- ad$obs_names
  expect_equal(ad$X[, 3], expected_col)
})

# trackstatus: class=InMemoryAnnData, feature=test_set_obs, status=done
test_that("write to obs", {
  ad <- AnnData(
    X = dummy$X,
    obs = dummy$obs,
    var = dummy$var
  )

  obs2 <- data.frame(
    foo = sample(letters, 10, replace = TRUE),
    bar = sample.int(4, 10, replace = TRUE),
    zing = sample(c(TRUE, FALSE), 10, replace = TRUE)
  )
  ad$obs <- obs2

  expect_equal(ncol(ad$obs), 3)
  expect_equal(nrow(ad$obs), 10)
  # obs should now have rownames added on-the-fly
  expected_obs2 <- obs2
  rownames(expected_obs2) <- ad$obs_names
  expect_equal(ad$obs, expected_obs2)

  # change row in obs
  obs2row <- data.frame(foo = "a", bar = 3, zing = FALSE)
  ad$obs[2, ] <- obs2row
  expect_equal(ad$obs[2, ], obs2row, ignore_attr = TRUE)

  # change column in obs
  ad$obs[, 3] <- FALSE
  expect_equal(ad$obs[, 3], rep(FALSE, 10L))
})

# trackstatus: class=InMemoryAnnData, feature=test_set_var, status=done
test_that("write to var", {
  ad <- AnnData(
    X = dummy$X,
    obs = dummy$obs,
    var = dummy$var
  )

  var2 <- data.frame(
    foo = sample(letters, 20L, replace = TRUE),
    bar = sample.int(4, 20L, replace = TRUE),
    zing = sample(c(TRUE, FALSE), 20L, replace = TRUE)
  )
  ad$var <- var2

  expect_equal(ncol(ad$var), 3)
  expect_equal(nrow(ad$var), 20)
  # var should now have rownames added on-the-fly
  expected_var2 <- var2
  rownames(expected_var2) <- ad$var_names
  expect_equal(ad$var, expected_var2)

  # change row in var
  var2row <- data.frame(foo = "a", bar = 3, zing = FALSE)
  ad$var[2, ] <- var2row
  expect_equal(ad$var[2, ], var2row, ignore_attr = TRUE)

  # change column in var
  ad$var[, 3] <- FALSE
  expect_equal(ad$var[, 3], rep(FALSE, 20L))
})

# trackstatus: class=InMemoryAnnData, feature=test_set_obs_names, status=done
test_that("write to obs_names", {
  ad <- AnnData(
    X = dummy$X,
    obs = dummy$obs,
    var = dummy$var
  )

  obs_names2 <- letters[1:10]
  ad$obs_names <- obs_names2

  expect_equal(ad$obs_names, obs_names2)

  # change value in obs_names
  ad$obs_names[2:3] <- c("foo", "bar")
  expect_equal(ad$obs_names[1:4], c("a", "foo", "bar", "d"))
})

# trackstatus: class=InMemoryAnnData, feature=test_set_var_names, status=done
test_that("write to var_names", {
  ad <- AnnData(
    X = dummy$X,
    obs = dummy$obs,
    var = dummy$var
  )

  var_names2 <- LETTERS[1:20]
  ad$var_names <- var_names2

  expect_equal(ad$var_names, var_names2)

  # change value in var_names
  ad$var_names[2:3] <- c("foo", "bar")
  expect_equal(ad$var_names[1:4], c("A", "foo", "bar", "D"))
})

# trackstatus: class=InMemoryAnnData, feature=test_set_layers, status=done
test_that("write to layers", {
  ad <- AnnData(
    X = dummy$X,
    obs = dummy$obs,
    var = dummy$var,
    layers = dummy$layers
  )

  ## element assignment
  ad$layers[["X2"]] <- dummy$X + 2
  expected_x2 <- dummy$X + 2
  dimnames(expected_x2) <- list(ad$obs_names, ad$var_names)
  expect_equal(ad$layers[["X2"]], expected_x2)

  ad$layers[["X4"]] <- dummy$X + 4
  expected_x4 <- dummy$X + 4
  dimnames(expected_x4) <- list(ad$obs_names, ad$var_names)
  expect_equal(ad$layers[["X4"]], expected_x4)

  ## list assignment
  ad$layers <- rev(dummy$layers)
  expected_layers <- rev(dummy$layers)
  for (i in seq_along(expected_layers)) {
    if (!is.null(expected_layers[[i]])) {
      dimnames(expected_layers[[i]]) <- list(ad$obs_names, ad$var_names)
    }
  }
  expect_equal(ad$layers, expected_layers)

  ## remove
  ad$layers <- NULL
  expect_true(is.null(ad$layers))
  ## add to NULL
  ad$layers <- dummy$layers
  expected_layers <- dummy$layers
  for (i in seq_along(expected_layers)) {
    if (!is.null(expected_layers[[i]])) {
      dimnames(expected_layers[[i]]) <- list(ad$obs_names, ad$var_names)
    }
  }
  expect_identical(ad$layers, expected_layers)
})

skip_if_no_anndata_py()
skip_if_no_dummy_anndata()

library(reticulate)

ad <- reticulate::import("anndata", convert = FALSE)
da <- reticulate::import("dummy_anndata", convert = FALSE)
bi <- reticulate::import_builtins()

known_issues <- read_known_issues()

test_names <- names(da$matrix_generators)

for (fmt in c("h5ad", "zarr")) {
  fmt_config <- get_fmt_config(fmt)

  for (name in test_names) {
    # first generate a python adata
    adata_py <- da$generate_dataset(
      x_type = NULL,
      obs_types = list(),
      var_types = list(),
      layer_types = list(name),
      obsm_types = list(),
      varm_types = list(),
      obsp_types = list(),
      varp_types = list(),
      uns_types = list(),
      nested_uns_types = list()
    )

    # create a couple of paths
    file_py <- withr::local_file(
      tempfile(paste0("anndata_py_", name), fileext = fmt_config$ext)
    )
    file_r <- withr::local_file(
      tempfile(paste0("anndata_r_", name), fileext = fmt_config$ext)
    )
    file_r2 <- withr::local_file(
      tempfile(paste0("anndata_r2_", name), fileext = fmt_config$ext)
    )

    # write to file
    adata_py[[fmt_config$py_write_method]](file_py)
    # Read it back in to get the version as read from disk
    adata_py <- ad[[fmt_config$py_read_method]](file_py)

    test_that(
      paste0("Reading an AnnData with layer '", name, "' (", fmt, ") works"),
      {
        msg <- message_if_known(
          backend = fmt_config$backend,
          slot = c("layers"),
          dtype = name,
          process = "read",
          known_issues = known_issues
        )
        skip_if(!is.null(msg), message = msg)

        adata_r <- fmt_config$r_read_fun(file_py, as = fmt_config$backend)
        expect_equal(
          adata_r$shape(),
          unlist(reticulate::py_to_r(adata_py$shape))
        )
        expect_equal(
          adata_r$layers_keys(),
          bi$list(adata_py$layers$keys())
        )

        # check that the print output is the same (normalize class names)
        expect_anndata_print_equal(adata_r, adata_py)
      }
    )

    gc()

    test_that(
      paste0(
        "Comparing an anndata with layer '",
        name,
        "' (",
        fmt,
        ") with reticulate works"
      ),
      {
        msg <- message_if_known(
          backend = fmt_config$backend,
          slot = c("layers"),
          dtype = name,
          process = c("read", "reticulate"),
          known_issues = known_issues
        )
        skip_if(!is.null(msg), message = msg)

        adata_r <- fmt_config$r_read_fun(file_py, as = fmt_config$backend)

        # R AnnData now adds dimnames on-the-fly, but Python doesn't preserve them
        # So we need to strip dimnames for comparison
        actual_mat <- adata_r$layers[[name]]
        expected_mat <- py_to_r(py_get_item(adata_py$layers, name))
        dimnames(actual_mat) <- NULL
        dimnames(expected_mat) <- NULL

        expect_equal(
          actual_mat,
          expected_mat,
          tolerance = 1e-6
        )
      }
    )

    gc()

    test_that(
      paste0("Writing an AnnData with layer '", name, "' (", fmt, ") works"),
      {
        msg <- message_if_known(
          backend = fmt_config$backend,
          slot = c("layers"),
          dtype = name,
          process = c("read", "write"),
          known_issues = known_issues
        )
        skip_if(!is.null(msg), message = msg)

        adata_r <- fmt_config$r_read_fun(file_py, as = "InMemoryAnnData")
        fmt_config$r_write_fun(adata_r, file_r)

        # read from file
        adata_py2 <- ad[[fmt_config$py_read_method]](file_r)

        # expect name is one of the keys
        expect_contains(
          bi$list(adata_py2$layers$keys()),
          name
        )

        # expect that the objects are the same
        expect_equal_py(
          py_get_item(adata_py2$layers, name),
          py_get_item(adata_py$layers, name)
        )
      }
    )

    gc()

    if (fmt == "h5ad") {
      skip_if_no_h5diff()
      # Get all R datatypes that are equivalent to the python datatype (name)
      res <- Filter(function(x) x[[1]] == name, matrix_equivalences)
      r_datatypes <- vapply(res, function(x) x[[2]], character(1))

      for (r_name in r_datatypes) {
        test_msg <- paste0(
          "Comparing a python generated .h5ad with layer '",
          name,
          "' with an R generated .h5ad '",
          r_name,
          "' works"
        )
        test_that(test_msg, {
          msg <- message_if_known(
            backend = "HDF5AnnData",
            slot = c("X"),
            dtype = c(name, r_name),
            process = c("h5diff"),
            known_issues = known_issues
          )

          skip_if(!is.null(msg), message = msg)

          # generate an R h5ad
          adata_r <- r_generate_dataset(10L, 20L, layer_types = list(r_name))
          write_h5ad(adata_r, file_r2, mode = "w")

          # Remove the rhdf5-NA.OK for comparison
          hdf5_clear_rhdf5_attributes(file_r2, paste0("/layers/", r_name))

          # run h5diff
          res <- processx::run(
            "h5diff",
            c(
              "-v2",
              file_py,
              file_r2,
              paste0("/layers/", name),
              paste0("/layers/", r_name)
            ),
            error_on_status = FALSE
          )

          expect_equal(res$status, 0, info = res$stdout)
        })
      }
    }
  }
}

# nolint start
generate_numeric_matrix <- function(n_obs, n_vars, NAs = FALSE) {
  # byrow = TRUE to mimic the way a matrix gets filled in Python
  m <- matrix(
    seq(0.5, n_obs * n_vars),
    nrow = n_obs,
    ncol = n_vars,
    byrow = TRUE
  )
  if (NAs) {
    m[1, 1] <- NA_real_
  }
  m
}

generate_integer_matrix <- function(n_obs, n_vars, NAs = FALSE) {
  # byrow = TRUE to mimic the way a matrix gets filled in Python
  m <- matrix(
    seq(0L, n_obs * n_vars - 1),
    nrow = n_obs,
    ncol = n_vars,
    byrow = TRUE
  )
  if (NAs) {
    m[1, 1] <- NA_integer_
  }
  m
}

matrix_generators <- list(
  numeric_matrix = function(n_obs, n_vars) {
    generate_numeric_matrix(n_obs, n_vars)
  },
  numeric_dense = function(n_obs, n_vars) {
    m <- generate_numeric_matrix(n_obs, n_vars)
    as(m, "denseMatrix")
  },
  numeric_csparse = function(n_obs, n_vars) {
    m <- generate_numeric_matrix(n_obs, n_vars)
    as(m, "CsparseMatrix")
  },
  numeric_rsparse = function(n_obs, n_vars) {
    m <- generate_numeric_matrix(n_obs, n_vars)
    as(m, "RsparseMatrix")
  },
  numeric_matrix_with_nas = function(n_obs, n_vars) {
    generate_numeric_matrix(n_obs, n_vars, NAs = TRUE)
  },
  numeric_dense_with_nas = function(n_obs, n_vars) {
    m <- generate_numeric_matrix(n_obs, n_vars, NAs = TRUE)
    as(m, "denseMatrix")
  },
  numeric_csparse_with_nas = function(n_obs, n_vars) {
    m <- generate_numeric_matrix(n_obs, n_vars, NAs = TRUE)
    as(m, "CsparseMatrix")
  },
  numeric_rsparse_with_nas = function(n_obs, n_vars) {
    m <- generate_numeric_matrix(n_obs, n_vars, NAs = TRUE)
    as(m, "RsparseMatrix")
  },
  integer_matrix = function(n_obs, n_vars) {
    generate_integer_matrix(n_obs, n_vars)
  },
  integer_csparse = function(n_obs, n_vars) {
    m <- generate_integer_matrix(n_obs, n_vars)
    as(m, "CsparseMatrix")
  },
  integer_rsparse = function(n_obs, n_vars) {
    m <- generate_integer_matrix(n_obs, n_vars)
    as(m, "RsparseMatrix")
  },
  integer_matrix_with_nas = function(n_obs, n_vars) {
    m <- generate_integer_matrix(n_obs, n_vars, NAs = TRUE)
    m
  },
  integer_csparse_with_nas = function(n_obs, n_vars) {
    m <- generate_integer_matrix(n_obs, n_vars, NAs = TRUE)
    as(m, "CsparseMatrix")
  },
  integer_rsparse_with_nas = function(n_obs, n_vars) {
    m <- generate_integer_matrix(n_obs, n_vars, NAs = TRUE)
    as(m, "RsparseMatrix")
  }
)
# nolint end

#' Generate a matrix
#'
#' Generate a matrix of a given type
#'
#' @param n_obs Number of observations to generate
#' @param n_vars Number of variables to generate
#'
#' @return A matrix of the given type
#'
#' @noRd
#'
#' @examples
#' generate_matrix(10L, 20L)
generate_matrix <- function(n_obs, n_vars, type = names(matrix_generators)) {
  type <- match.arg(type)
  matrix_generators[[type]](n_obs, n_vars)
}

# Zarr metadata files used to identify valid Zarr nodes (arrays or groups)
ZARR_METADATA_FILES <- c(".zarray", ".zattrs", ".zgroup", "zarr.json")

#' create_zarr_group
#'
#' Create a Zarr group
#'
#' @param store The location of the Zarr store
#' @param name Name of the group
#' @param version Zarr version
#'
#' @return `NULL`
#'
#' @noRd
create_zarr_group <- function(store, name, version = "v2") {
  # Split "a/b/c" into c("a", "b", "c")
  split_name <- strsplit(name, split = "/", fixed = TRUE)[[1]]
  if (length(split_name) > 1) {
    # Build cumulative paths: c("a", "a/b", "a/b/c")
    split_name <- vapply(
      seq_along(split_name),
      function(x) paste(split_name[seq_len(x)], collapse = "/"),
      FUN.VALUE = character(1)
    )
    # Keep only the target and its immediate parent:
    # split_name[1] = "a/b/c" (target), split_name[2] = "a/b" (parent)
    split_name <- rev(tail(split_name, 2))
    # Recursively ensure the parent group exists before creating the target
    if (!dir.exists(file.path(store, split_name[2]))) {
      create_zarr_group(store = store, name = split_name[2])
    }
  }
  dir.create(file.path(store, split_name[1]), showWarnings = FALSE)
  switch(
    version,
    v2 = {
      write(
        "{\"zarr_format\":2}",
        file = file.path(store, split_name[1], ".zgroup")
      )
    },
    v3 = {
      cli_abort("Currently only zarr v2 is supported!")
    },
    cli_abort("Only zarr v2 is supported. Use version = 'v2'")
  )
}

#' create_zarr
#'
#' Create Zarr store
#'
#' @param store The location of the Zarr store
#' @param version Zarr version
#'
#' @return `NULL`
#'
#' @noRd
create_zarr <- function(store, version = "v2") {
  prefix <- basename(store)
  dir <- gsub(paste0(prefix, "$"), "", store)
  create_zarr_group(store = dir, name = prefix, version = version)
}

#' is_zarr_empty
#'
#' Check if a Zarr store is empty
#'
#' @param store The location of the Zarr store
#'
#' @return Returns `TRUE` if the Zarr store is empty
#'
#' @noRd
is_zarr_empty <- function(store) {
  files <- list.files(store, recursive = FALSE, full.names = FALSE)
  all(files %in% ZARR_METADATA_FILES)
}

#' Zarr path exists
#'
#' Check that a path in Zarr exists
#'
#' @return Whether the `target_path` exists in `store`
#' @noRd
#'
#' @param store Path to a Zarr store
#' @param target_path The path within the store to test for
zarr_path_exists <- function(store, target_path) {
  zarr <- file.path(store, target_path)
  if (!dir.exists(zarr)) {
    FALSE
  } else {
    list_files <- list.files(
      path = zarr,
      full.names = FALSE,
      recursive = FALSE,
      all.files = TRUE
    )
    if (any(ZARR_METADATA_FILES %in% list_files)) {
      TRUE
    } else {
      FALSE
    }
  }
}

skip_if_not_installed("Rarr")

store <- tempfile(fileext = ".zarr")
if (dir.exists(store)) {
  unlink(store, recursive = TRUE)
}

create_zarr(store = store)

test_that("Writing Zarr dense arrays works", {
  array <- matrix(rnorm(20), nrow = 5, ncol = 4)

  expect_silent(write_zarr_element(
    array,
    store,
    "dense_array",
    compression = "none"
  ))
  expect_true(zarr_path_exists(store, "dense_array"))
  attrs <- Rarr::read_zarr_attributes(file.path(store, "dense_array"))
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "array")
})

test_that("Writing Zarr dense 3D arrays works", {
  value <- array(rnorm(60), dim = c(5, 4, 3))

  expect_silent(
    write_zarr_element(
      value,
      store,
      "dense_3d_array"
    )
  )
  expect_true(zarr_path_exists(store, "dense_3d_array"))
  attrs <- Rarr::read_zarr_attributes(file.path(store, "dense_3d_array"))
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "array")
})

test_that("Writing Zarr sparse arrays works", {
  array <- matrix(rnorm(20), nrow = 5, ncol = 4)

  csc_array <- as(array, "CsparseMatrix")
  expect_silent(write_zarr_element(
    csc_array,
    store,
    "csc_array",
    compression = "none"
  ))
  expect_true(zarr_path_exists(store, "csc_array"))
  expect_true(zarr_path_exists(store, "csc_array/data"))
  expect_true(zarr_path_exists(store, "csc_array/indices"))
  expect_true(zarr_path_exists(store, "csc_array/indptr"))
  attrs <- Rarr::read_zarr_attributes(file.path(store, "csc_array"))
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "csc_matrix")

  csr_array <- as(array, "RsparseMatrix")
  expect_silent(write_zarr_element(
    csr_array,
    store,
    "csr_array",
    compression = "none"
  ))
  expect_true(zarr_path_exists(store, "csr_array"))
  expect_true(zarr_path_exists(store, "csr_array/data"))
  expect_true(zarr_path_exists(store, "csr_array/indices"))
  expect_true(zarr_path_exists(store, "csr_array/indptr"))
  attrs <- Rarr::read_zarr_attributes(file.path(store, "csr_array"))
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "csr_matrix")
})

test_that("Writing dgeMatrix", {
  value <- matrix(rnorm(20), nrow = 5, ncol = 4) |>
    as("dMatrix") |>
    as("generalMatrix") |>
    as("unpackedMatrix")

  expect_silent(
    write_zarr_element(value, store, "dgematrix")
  )
  expect_true(zarr_path_exists(store, "dgematrix"))
  attrs <- Rarr::read_zarr_attributes(file.path(store, "dgematrix"))
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "array")
})

test_that("Writing Zarr nullable booleans works", {
  nullable <- c(TRUE, TRUE, FALSE, FALSE, FALSE)
  nullable[5] <- NA

  expect_silent(write_zarr_element(nullable, store, "nullable_bool"))
  expect_true(zarr_path_exists(store, "nullable_bool"))
  attrs <- Rarr::read_zarr_attributes(file.path(store, "nullable_bool"))
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "nullable-boolean")
})

test_that("Writing Zarr nullable integers works", {
  nullable <- as.integer(1:5)
  nullable[5] <- NA

  expect_silent(write_zarr_element(nullable, store, "nullable_int"))
  expect_true(zarr_path_exists(store, "nullable_int"))
  attrs <- Rarr::read_zarr_attributes(file.path(store, "nullable_int"))
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "nullable-integer")
})

test_that("Writing Zarr string arrays works", {
  string <- LETTERS[1:5]

  write_zarr_element(string, store, "string_array")
  expect_true(zarr_path_exists(store, "string_array"))
  attrs <- Rarr::read_zarr_attributes(file.path(store, "string_array"))
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "string-array")

  string2d <- matrix(LETTERS[1:20], nrow = 5, ncol = 4)

  expect_silent(write_zarr_element(string2d, store, "string_array2D"))
  expect_true(zarr_path_exists(store, "string_array2D"))
  attrs <- Rarr::read_zarr_attributes(file.path(store, "string_array2D"))
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "string-array")
})

test_that("Writing Zarr categoricals works", {
  categorical <- factor(LETTERS[1:5])

  expect_no_error(write_zarr_element(categorical, store, "categorical"))
  expect_true(zarr_path_exists(store, "categorical"))
  expect_true(zarr_path_exists(store, "categorical/categories"))
  expect_true(zarr_path_exists(store, "categorical/codes"))
  attrs <- Rarr::read_zarr_attributes(file.path(store, "categorical"))
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "categorical")
})

test_that("Writing Zarr string scalars works", {
  string <- "A"

  expect_silent(write_zarr_element(string, store, "string_scalar"))
  expect_true(zarr_path_exists(store, "string_scalar"))
  attrs <- Rarr::read_zarr_attributes(file.path(store, "string_scalar"))
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "string")
})

test_that("Writing Zarr numeric scalars works", {
  number <- 1.0

  expect_silent(write_zarr_element(number, store, "numeric_scalar"))
  expect_true(zarr_path_exists(store, "numeric_scalar"))
  attrs <- Rarr::read_zarr_attributes(file.path(store, "numeric_scalar"))
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "numeric-scalar")
})

test_that("Writing Zarr mappings works", {
  mapping <- list(
    array = matrix(rnorm(20), nrow = 5, ncol = 4),
    sparse = as(matrix(rnorm(20), nrow = 5, ncol = 4), "CsparseMatrix"),
    string = LETTERS[1:5],
    numeric = rnorm(5),
    scalar = 2
  )

  expect_silent(write_zarr_element(
    mapping,
    store,
    "mapping",
    compression = "none"
  ))
  expect_true(zarr_path_exists(store, "mapping"))
  expect_true(zarr_path_exists(store, "mapping/array"))
  expect_true(zarr_path_exists(store, "mapping/sparse"))
  expect_true(zarr_path_exists(store, "mapping/sparse/data"))
  expect_true(zarr_path_exists(store, "mapping/sparse/indices"))
  expect_true(zarr_path_exists(store, "mapping/sparse/indptr"))
  expect_true(zarr_path_exists(store, "mapping/string"))
  expect_true(zarr_path_exists(store, "mapping/numeric"))
  expect_true(zarr_path_exists(store, "mapping/scalar"))
  attrs <- Rarr::read_zarr_attributes(file.path(store, "mapping"))
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "dict")
})

test_that("Writing Zarr data frames works", {
  df <- data.frame(
    Letters = letters[1:5],
    Numbers = 1:5
  )

  expect_silent(write_zarr_element(df, store, "dataframe"))
  expect_true(zarr_path_exists(store, "dataframe"))
  expect_true(zarr_path_exists(store, "dataframe/Letters"))
  expect_true(zarr_path_exists(store, "dataframe/Numbers"))
  expect_true(zarr_path_exists(store, "dataframe/_index"))
  attrs <- Rarr::read_zarr_attributes(file.path(store, "dataframe"))
  expect_true(all(c("encoding-type", "encoding-version") %in% names(attrs)))
  expect_equal(attrs[["encoding-type"]], "dataframe")
  expect_true(all(c("_index", "column-order") %in% names(attrs)))
  expect_equal(attrs[["_index"]], "_index")
  expect_identical(
    as.character(attrs[["column-order"]]),
    c("Letters", "Numbers")
  )
})

test_that("writing Zarr from SingleCellExperiment works", {
  skip_if_not_installed("SingleCellExperiment")
  store <- tempfile(fileext = ".zarr")
  sce <- generate_dataset(format = "SingleCellExperiment")
  write_zarr(sce, store)
  expect_true(dir.exists(store))
})

test_that("writing Zarr from Seurat works", {
  skip_if_not_installed("SeuratObject")
  store <- tempfile(fileext = ".zarr")
  sce <- generate_dataset(format = "Seurat")
  write_zarr(sce, store)
  expect_true(dir.exists(store))
})

dir_size <- function(path) {
  files <- list.files(path, recursive = TRUE, full.names = TRUE)
  sum(file.info(files)$size, na.rm = TRUE)
}

test_that("writing compressed files works for Zarr", {
  dummy <- generate_dataset(100, 200)
  non_random_X <- matrix(5, 100, 200) # nolint

  adata <- AnnData(
    X = non_random_X,
    obs = dummy$obs,
    var = dummy$var
  )

  store_none <- tempfile(fileext = ".zarr")
  store_compressed <- tempfile(fileext = ".zarr")

  write_zarr(adata, store_none, compression = "none")

  comp_list <- c("gzip", "blosc", "zstd", "lzma", "bz2", "zlib", "lz4")
  for (comp in comp_list) {
    write_zarr(adata, store_compressed, compression = comp)
    unlink(store_compressed, recursive = TRUE)
    expect_true(dir_size(store_none) > dir_size(store_compressed))
  }
})

## ----options, include = FALSE-------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  warning = FALSE
)

## ----prep-h5ad-file-----------------------------------------------------------
library(anndataR)
library(SingleCellExperiment)

h5ad_file <- system.file("extdata", "example.h5ad", package = "anndataR")

## ----read-data----------------------------------------------------------------
sce_obj <- read_h5ad(h5ad_file, as = "SingleCellExperiment")
sce_obj

## ----read-h5ad----------------------------------------------------------------
adata <- read_h5ad(h5ad_file)
sce <- adata$as_SingleCellExperiment()
sce

## ----prep-file-zarr-----------------------------------------------------------
# Please use "example_v3.zarr.zip" for AnnData stored as Zarr version 3
zarr_path <- system.file("extdata", "example_v2.zarr.zip", package = "anndataR")
td <- tempdir(check = TRUE)
unzip(zarr_path, exdir = td)
zarr_path <- file.path(td, "example_v2.zarr")

sce_zarr <- read_zarr(zarr_path, as = "SingleCellExperiment")
sce_zarr

## ----read-zarr----------------------------------------------------------------
adata <- read_zarr(zarr_path)
sce_zarr <- adata$as_SingleCellExperiment()
sce_zarr

## ----mapping, fig.cap = "Mapping between `AnnData` and `SingleCellExperiment` objects", fig.wide = TRUE, echo = FALSE----
knitr::include_graphics("../man/figures/AnnData-SCE.png")

## ----ex-mapping---------------------------------------------------------------
adata$as_SingleCellExperiment(
  x_mapping = "counts",
  assays_mapping = c("csc_counts"),
  colData_mapping = c("Int", "IntNA"),
  rowData_mapping = c(rowdata1 = "String", rowdata2 = "total_counts"),
  reducedDims_mapping = list(
    "pca" = c(sampleFactors = "X_pca", featureLoadings = "PCs"),
    "umap" = c(sampleFactors = "X_umap")
  ),
  colPairs_mapping = TRUE,
  rowPairs_mapping = FALSE,
  metadata_mapping = c(value1 = "Bool", value2 = "IntScalar")
)

## ----write-sce, eval=FALSE----------------------------------------------------
# write_h5ad(sce_obj, tempfile(fileext = ".h5ad"))
# write_zarr(sce_obj, tempfile(fileext = ".zarr"))

## ----convert-and-write, eval=FALSE--------------------------------------------
# adata <- as_AnnData(sce_obj)
# adata$write_h5ad(tempfile(fileext = ".h5ad"))
# adata$write_zarr(tempfile(fileext = ".zarr"))

## ----customize-anndata-conversion---------------------------------------------
as_AnnData(
  sce_obj,
  x_mapping = "counts",
  layers_mapping = c("csc_counts"),
  obs_mapping = c(metadata1 = "Int", metadata2 = "IntNA"),
  var_mapping = FALSE,
  obsm_mapping = list(X_pca = "X_pca", X_umap = "X_umap"),
  obsp_mapping = TRUE,
  uns_mapping = c("Bool", "IntScalar")
)

## ----sessioninfo--------------------------------------------------------------
sessionInfo()

# helper function to skip tests if we don't have the Python 'anndata' module
skip_if_no_anndata_py <- function() {
  testthat::skip_if_not_installed("reticulate")
  requireNamespace("reticulate")
  reticulate::py_require("anndata")
  testthat::skip_if_not(
    reticulate::py_module_available("anndata"),
    message = "Python anndata module not available for testing"
  )
}

#' @title InMemoryAnnData
#'
#' @description
#' Implementation of an in-memory `AnnData` object where data is stored within
#' the R session. This is the simplest back end and will be most familiar to
#' users. It is want you will want to use in most cases where you want to
#' interact with an `AnnData` object.
#'
#' See [AnnData-usage] for details on creating and using `AnnData` objects.
#'
#' @return An `InMemoryAnnData` object
#'
#' @seealso [AnnData-usage] for details on creating and using `AnnData` objects
#'
#' @family AnnData classes
#'
#' @examples
#' ## complete example
#' ad <- AnnData(
#'   X = matrix(1:15, 3L, 5L),
#'   layers = list(
#'     A = matrix(5:1, 3L, 5L),
#'     B = matrix(letters[1:5], 3L, 5L)
#'   ),
#'   obs = data.frame(row.names = LETTERS[1:3], cell = 1:3),
#'   var = data.frame(row.names = letters[1:5], gene = 1:5)
#' )
#' ad
#'
#' ## minimum example
#' AnnData(
#'   obs = data.frame(row.names = letters[1:10]),
#'   var = data.frame(row.names = LETTERS[1:5])
#' )
#'
#' @importFrom Matrix as.matrix
InMemoryAnnData <- R6::R6Class(
  "InMemoryAnnData", # nolint
  inherit = AbstractAnnData,
  private = list(
    .X = NULL,
    .layers = NULL,
    .obs = NULL,
    .var = NULL,
    .obs_names = NULL,
    .var_names = NULL,
    .obsm = NULL,
    .varm = NULL,
    .obsp = NULL,
    .varp = NULL,
    .uns = NULL
  ),
  active = list(
    #' @field X See [AnnData-usage]
    X = function(value) {
      if (missing(value)) {
        # trackstatus: class=InMemoryAnnData, feature=get_X, status=done
        private$.X |>
          private$.add_matrix_dimnames("X")
      } else {
        # trackstatus: class=InMemoryAnnData, feature=set_X, status=done
        private$.X <- private$.validate_aligned_array(
          value,
          "X",
          shape = c(self$n_obs(), self$n_vars()),
          expected_rownames = self$obs_names,
          expected_colnames = self$var_names
        )
        self
      }
    },
    #' @field layers See [AnnData-usage]
    layers = function(value) {
      if (missing(value)) {
        # trackstatus: class=InMemoryAnnData, feature=get_layers, status=done
        private$.layers |>
          private$.add_mapping_dimnames("layers")
      } else {
        # trackstatus: class=InMemoryAnnData, feature=set_layers, status=done
        private$.layers <- private$.validate_aligned_mapping(
          value,
          "layers",
          c(self$n_obs(), self$n_vars()),
          expected_rownames = self$obs_names,
          expected_colnames = self$var_names
        )
        self
      }
    },
    #' @field obs See [AnnData-usage]
    obs = function(value) {
      if (missing(value)) {
        # trackstatus: class=InMemoryAnnData, feature=get_obs, status=done
        private$.obs |>
          private$.add_obsvar_dimnames("obs")
      } else {
        # trackstatus: class=InMemoryAnnData, feature=set_obs, status=done
        # Extract obs_names if present before validation
        if (!is.null(value) && has_row_names(value)) {
          private$.obs_names <- rownames(value)
          rownames(value) <- NULL
        }
        private$.obs <- private$.validate_obsvar_dataframe(value, "obs")
        self
      }
    },
    #' @field var See [AnnData-usage]
    var = function(value) {
      if (missing(value)) {
        # trackstatus: class=InMemoryAnnData, feature=get_var, status=done
        private$.var |>
          private$.add_obsvar_dimnames("var")
      } else {
        # trackstatus: class=InMemoryAnnData, feature=set_var, status=done
        # Extract var_names if present before validation
        if (!is.null(value) && has_row_names(value)) {
          private$.var_names <- rownames(value)
          rownames(value) <- NULL
        }
        private$.var <- private$.validate_obsvar_dataframe(value, "var")
        self
      }
    },
    #' @field obs_names See [AnnData-usage]
    obs_names = function(value) {
      if (missing(value)) {
        # trackstatus: class=InMemoryAnnData, feature=get_obs_names, status=done
        private$.obs_names
      } else {
        # trackstatus: class=InMemoryAnnData, feature=set_obs_names, status=done
        private$.obs_names <- private$.validate_obsvar_names(value, "obs")
        self
      }
    },
    #' @field var_names See [AnnData-usage]
    var_names = function(value) {
      if (missing(value)) {
        # trackstatus: class=InMemoryAnnData, feature=get_var_names, status=done
        private$.var_names
      } else {
        # trackstatus: class=InMemoryAnnData, feature=set_var_names, status=done
        private$.var_names <- private$.validate_obsvar_names(value, "var")
        self
      }
    },
    #' @field obsm See [AnnData-usage]
    obsm = function(value) {
      if (missing(value)) {
        # trackstatus: class=InMemoryAnnData, feature=get_obsm, status=done
        private$.obsm |>
          private$.add_mapping_dimnames("obsm")
      } else {
        # trackstatus: class=InMemoryAnnData, feature=set_obsm, status=done
        private$.obsm <- private$.validate_aligned_mapping(
          value,
          "obsm",
          c(self$n_obs()),
          expected_rownames = self$obs_names,
          strip_rownames = TRUE,
          strip_colnames = FALSE
        )
        self
      }
    },
    #' @field varm See [AnnData-usage]
    varm = function(value) {
      if (missing(value)) {
        # trackstatus: class=InMemoryAnnData, feature=get_varm, status=done
        private$.varm |>
          private$.add_mapping_dimnames("varm")
      } else {
        # trackstatus: class=InMemoryAnnData, feature=set_varm, status=done
        private$.varm <- private$.validate_aligned_mapping(
          value,
          "varm",
          c(self$n_vars()),
          expected_rownames = self$var_names,
          strip_rownames = TRUE,
          strip_colnames = FALSE
        )
        self
      }
    },
    #' @field obsp See [AnnData-usage]
    obsp = function(value) {
      if (missing(value)) {
        # trackstatus: class=InMemoryAnnData, feature=get_obsp, status=done
        private$.obsp |>
          private$.add_mapping_dimnames("obsp")
      } else {
        # trackstatus: class=InMemoryAnnData, feature=set_obsp, status=done
        private$.obsp <- private$.validate_aligned_mapping(
          value,
          "obsp",
          c(self$n_obs(), self$n_obs()),
          expected_rownames = self$obs_names,
          expected_colnames = self$obs_names
        )
        self
      }
    },
    #' @field varp See [AnnData-usage]
    varp = function(value) {
      if (missing(value)) {
        # trackstatus: class=InMemoryAnnData, feature=get_varp, status=done
        private$.varp |>
          private$.add_mapping_dimnames("varp")
      } else {
        # trackstatus: class=InMemoryAnnData, feature=set_varp, status=done
        private$.varp <- private$.validate_aligned_mapping(
          value,
          "varp",
          c(self$n_vars(), self$n_vars()),
          expected_rownames = self$var_names,
          expected_colnames = self$var_names
        )
        self
      }
    },
    #' @field uns See [AnnData-usage]
    uns = function(value) {
      if (missing(value)) {
        # trackstatus: class=InMemoryAnnData, feature=get_uns, status=done
        private$.uns
      } else {
        # trackstatus: class=InMemoryAnnData, feature=set_uns, status=done
        private$.uns <- private$.validate_named_list(value, "uns")
        self
      }
    }
  ),
  public = list(
    #' @description Creates a new instance of an in-memory `AnnData` object.
    #'   Inherits from [AbstractAnnData].
    #'
    #' @param X See the `X` slot in [AnnData-usage]
    #' @param layers See the `layers` slot in [AnnData-usage]
    #' @param obs See the `obs` slot in [AnnData-usage]
    #' @param var See the `var` slot in [AnnData-usage]
    #' @param obsm See the `obsm` slot in [AnnData-usage]
    #' @param varm See the `varm` slot in [AnnData-usage]
    #' @param obsp See the `obsp` slot in [AnnData-usage]
    #' @param varp See the `varp` slot in [AnnData-usage]
    #' @param uns See the `uns` slot in [AnnData-usage]
    #' @param shape Shape tuple (e.g. `c(n_obs, n_vars)`). Can be provided if
    #'   both `X` or `obs` and `var` are not provided.
    initialize = function(
      X = NULL,
      obs = NULL,
      var = NULL,
      layers = NULL,
      obsm = NULL,
      varm = NULL,
      obsp = NULL,
      varp = NULL,
      uns = NULL,
      shape = NULL
    ) {
      # Determine initial obs and var
      shape <- get_shape(obs, var, X, shape)
      obs <- get_initial_obs(obs, X, shape)
      var <- get_initial_var(var, X, shape)

      # set obs and var first
      if (!is.data.frame(obs)) {
        cli_abort("{.arg obs} must be a {.cls data.frame}")
      }
      if (!is.data.frame(var)) {
        cli_abort("{.arg var} must be a {.cls data.frame}")
      }

      # Extract and store obs_names/var_names separately
      private$.obs_names <- rownames(obs)
      private$.var_names <- rownames(var)

      # Remove rownames from the data.frames before storing
      rownames(obs) <- NULL
      rownames(var) <- NULL
      private$.obs <- obs
      private$.var <- var

      # write other slots later
      self$X <- X
      self$layers <- layers
      self$obsm <- obsm
      self$varm <- varm
      self$obsp <- obsp
      self$varp <- varp
      self$uns <- uns
    }
  )
)

#' Convert an `AnnData` to an `InMemoryAnnData`
#'
#' Convert another `AnnData` object to an [`InMemoryAnnData`] object
#'
#' @param adata An `AnnData` object to be converted to [`InMemoryAnnData`]
#'
#' @return An [`InMemoryAnnData`] object with the same data as the input
#'   `AnnData` object
#' @keywords internal
#'
#' @family object converters
#'
#' @examples
#' ad <- AnnData(
#'   X = matrix(1:5, 3L, 5L),
#'   layers = list(
#'     A = matrix(5:1, 3L, 5L),
#'     B = matrix(letters[1:5], 3L, 5L)
#'   ),
#'   obs = data.frame(row.names = LETTERS[1:3], cell = 1:3),
#'   var = data.frame(row.names = letters[1:5], gene = 1:5)
#' )
#' ad$as_InMemoryAnnData()
# nolint start: object_name_linter
as_InMemoryAnnData <- function(adata) {
  # nolint end: object_name_linter
  if (!(inherits(adata, "AbstractAnnData"))) {
    cli_abort(
      "{.arg adata} must be a {.cls AbstractAnnData} but has class {.cls {class(adata)}}"
    )
  }

  InMemoryAnnData$new(
    X = adata$X,
    obs = adata$obs,
    var = adata$var,
    layers = adata$layers,
    obsm = adata$obsm,
    varm = adata$varm,
    obsp = adata$obsp,
    varp = adata$varp,
    uns = adata$uns,
    shape = adata$shape()
  )
}

#' Read H5AD encoding
#'
#' Read the encoding and version of an element in a H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#'
#' @return A named list with names type and version
#'
#' @noRd
read_h5ad_encoding <- function(file, name) {
  tryCatch(
    {
      attrs <- rhdf5::h5readAttributes(file, name)
      list(
        type = attrs[["encoding-type"]],
        version = attrs[["encoding-version"]]
      )
    },
    error = function(e) {
      path <- if (is.character(file)) file else rhdf5::H5Fget_name(file) # nolint object_usage_linter
      cli_abort(
        "Encoding attributes not found for element {.val {name}} in {.path {path}}"
      )
    }
  )
}

#' Read H5AD element
#'
#' Read an element from a H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param type The encoding type of the element to read
#' @param version The encoding version of the element to read
#' @param stop_on_error Whether to stop on error or generate a warning instead
#' @param ... Extra arguments passed to individual reading functions
#'
#' @details
#' Encoding is automatically determined from the element using
#' `read_h5ad_encoding` and used to select the appropriate reading function.
#'
#' @return Value depending on the encoding
#'
#' @noRd
read_h5ad_element <- function(
  file,
  name,
  type = NULL,
  version = NULL,
  stop_on_error = FALSE,
  ...
) {
  if (!hdf5_path_exists(file, name)) {
    return(NULL)
  }

  if (is.null(type)) {
    encoding_list <- read_h5ad_encoding(file, name)
    type <- encoding_list$type
    version <- encoding_list$version
  }

  read_fun <- switch(
    type,
    "null" = read_h5ad_null,
    "array" = read_h5ad_dense_array,
    "rec-array" = read_h5ad_rec_array,
    "csr_matrix" = read_h5ad_csr_matrix,
    "csc_matrix" = read_h5ad_csc_matrix,
    "dataframe" = read_h5ad_data_frame,
    "dict" = read_h5ad_mapping,
    "string" = read_h5ad_string_scalar,
    "numeric-scalar" = read_h5ad_numeric_scalar,
    "categorical" = read_h5ad_categorical,
    "string-array" = read_h5ad_string_array,
    "nullable-integer" = read_h5ad_nullable_integer,
    "nullable-boolean" = read_h5ad_nullable_boolean,
    cli_abort(
      "No function for reading H5AD encoding {.cls {type}} for element {.val {name}}"
    )
  )

  tryCatch(
    {
      read_fun(file = file, name = name, version = version, ...)
    },
    error = function(e) {
      msg <- cli::cli_fmt(cli::cli_bullets(c(
        paste0("Error reading element {.field {name}} of type {.cls {type}}"),
        "i" = conditionMessage(e)
      )))
      if (stop_on_error) {
        cli_abort(msg)
      } else {
        cli_warn(msg)
        NULL
      }
    }
  )
}

#' Read H5AD element keys
#'
#' Read the keys of an element from a H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param type The encoding type of the element to read
#' @param version The encoding version of the element to read
#' @param stop_on_error Whether to stop on error or generate a warning instead
#' @param ... Extra arguments passed to individual reading functions
#'
#' @details
#' Encoding is automatically determined from the element using
#' `read_h5ad_encoding` and used to select the appropriate reading function.
#'
#' @return Value depending on the encoding
#'
#' @noRd
read_h5ad_element_keys <- function(
  file,
  name,
  type = NULL,
  version = NULL,
  stop_on_error = FALSE,
  ...
) {
  if (!hdf5_path_exists(file, name)) {
    return(NULL)
  }

  if (is.null(type)) {
    encoding_list <- read_h5ad_encoding(file, name)
    type <- encoding_list$type
    version <- encoding_list$version
  }

  read_fun <- switch(
    type,
    "dataframe" = read_h5ad_data_frame_keys,
    "dict" = read_h5ad_mapping_keys,
    cli_abort(
      "No function for reading keys for H5AD encoding {.cls {type}} for element {.val {name}}"
    )
  )

  tryCatch(
    {
      read_fun(file = file, name = name, version = version, ...)
    },
    error = function(e) {
      msg <- cli::cli_fmt(cli::cli_bullets(c(
        paste0(
          "Error reading element keys for {.field {name}} of type {.cls {type}}"
        ),
        "i" = conditionMessage(e)
      )))
      if (stop_on_error) {
        cli_abort(msg)
      } else {
        cli_warn(msg)
        NULL
      }
    }
  )
}

#' Read H5AD null
#'
#' Read a null value from an H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param version Encoding version of the element to read
#'
#' @return `NULL`
#' @noRd
read_h5ad_null <- function(file, name, version = "0.1.0") {
  version <- match.arg(version)

  NULL
}

#' Read H5AD dense array
#'
#' Read a dense array from an H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param version Encoding version of the element to read
#'
#' @return a matrix or a vector if 1D
#'
#' @noRd
read_h5ad_dense_array <- function(file, name, version = "0.2.0") {
  version <- match.arg(version)

  data <- rhdf5::h5read(file, name, native = FALSE)

  # If the array is 1D, explicitly add a dimension
  if (is.null(dim(data))) {
    data <- as.vector(data)
    dim(data) <- length(data)
  }

  # Transpose the matrix if need be
  if (is.matrix(data)) {
    data <- t(data)
  } else if (is.array(data) && length(dim(data)) > 1) {
    data <- aperm(data)
  }

  # Reverse {rhdf5} coercion to factors
  if (is.factor(data) && all(levels(data) %in% c("TRUE", "FALSE"))) {
    dims <- dim(data)
    data <- as.logical(data)
    dim(data) <- dims
  }

  data
}

read_h5ad_csr_matrix <- function(file, name, version) {
  read_h5ad_sparse_array(
    file = file,
    name = name,
    version = version,
    type = "csr_matrix"
  )
}

read_h5ad_csc_matrix <- function(file, name, version) {
  read_h5ad_sparse_array(
    file = file,
    name = name,
    version = version,
    type = "csc_matrix"
  )
}

#' Read H5AD sparse array
#'
#' Read a sparse array from an H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param version Encoding version of the element to read
#' @param type Type of the sparse matrix, either "csr_matrix" or "csc_matrix"
#'
#' @return a sparse matrix/DelayedArray???, or a vector if 1D
#' @importFrom Matrix sparseMatrix
#'
#' @noRd
read_h5ad_sparse_array <- function(
  file,
  name,
  version = "0.1.0",
  type = c("csr_matrix", "csc_matrix")
) {
  version <- match.arg(version)
  type <- match.arg(type)

  h5group <- rhdf5::H5Gopen(file, name)
  on.exit(rhdf5::H5Gclose(h5group), add = TRUE)
  attrs <- rhdf5::h5readAttributes(file, name, native = FALSE)

  construct_sparse_matrix(
    data = as.vector(h5group$data),
    indices = as.vector(h5group$indices),
    indptr = as.vector(h5group$indptr),
    shape = as.vector(attrs[["shape"]]),
    type = type
  )
}

#' Read H5AD recarray
#'
#' Read a recarray from an H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param version Encoding version of the element to read
#'
#' @details
#' A "record array" (recarray) is a Python NumPy array type that contains
#' "fields" that can be indexed using attributes (similar to columns in a
#' spreadsheet). See https://numpy.org/doc/stable/reference/generated/numpy.recarray.html
#' for details.
#'
#' They are used by **scanpy** to score marker gene testing results.
#'
#' @return a named list of 1D arrays
#'
#' @noRd
read_h5ad_rec_array <- function(file, name, version = "0.2.0") {
  version <- match.arg(version)

  rhdf5::h5read(file, name, native = FALSE, compoundAsDataFrame = FALSE) |>
    lapply(as.vector)
}

#' Read H5AD nullable boolean
#'
#' Read a nullable boolean from an H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param version Encoding version of the element to read
#'
#' @return a boolean vector
#'
#' @noRd
read_h5ad_nullable_boolean <- function(file, name, version = "0.1.0") {
  as.logical(read_h5ad_nullable(file, name, version))
}

#' Read H5AD nullable integer
#'
#' Read a nullable integer from an H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param version Encoding version of the element to read
#'
#' @return an integer vector
#'
#' @noRd
read_h5ad_nullable_integer <- function(file, name, version = "0.1.0") {
  as.integer(read_h5ad_nullable(file, name, version))
}

#' Read H5AD nullable
#'
#' Read a nullable vector (boolean or integer) from an H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param version Encoding version of the element to read
#'
#' @return a nullable vector
#'
#' @noRd
read_h5ad_nullable <- function(file, name, version = "0.1.0") {
  version <- match.arg(version)

  h5group <- rhdf5::H5Gopen(file, name)
  on.exit(rhdf5::H5Gclose(h5group), add = TRUE)

  data <- as.vector(h5group$values)

  mask <- as.logical(h5group$mask)

  data[mask] <- NA

  data
}

#' Read H5AD string array
#'
#' Read a string array from an H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param version Encoding version of the element to read
#'
#' @return a character vector/matrix
#'
#' @noRd
read_h5ad_string_array <- function(file, name, version = "0.2.0") {
  version <- match.arg(version)

  data <- rhdf5::h5read(file, name, native = FALSE)

  if (is.null(dim(data)) || length(dim(data)) == 1) {
    data <- as.vector(data)
    dim(data) <- length(data)
  }

  # transpose the matrix if need be
  if (is.matrix(data)) {
    data <- t(data)
  } else if (is.array(data) && length(dim(data)) > 1) {
    data <- aperm(data)
  }

  data
}

#' Read H5AD categorical
#'
#' Read a categorical from an H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param version Encoding version of the element to read
#'
#' @return a factor
#'
#' @noRd
read_h5ad_categorical <- function(file, name, version = "0.2.0") {
  version <- match.arg(version)

  h5group <- rhdf5::H5Gopen(file, name)
  on.exit(rhdf5::H5Gclose(h5group), add = TRUE)

  # Get codes and convert to 1-based indexing
  codes <- h5group$codes + 1L

  # Set missing values
  codes[codes == 0L] <- NA_integer_

  levels <- h5group$categories

  attrs <- rhdf5::h5readAttributes(file, name, native = FALSE)
  ordered <- attrs[["ordered"]]

  factor(levels[codes], levels = levels, ordered = ordered)
}

#' Read H5AD string scalar
#'
#' Read a string scalar from an H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param version Encoding version of the element to read
#'
#' @return a character vector of length 1
#'
#' @noRd
read_h5ad_string_scalar <- function(file, name, version = "0.2.0") {
  version <- match.arg(version)

  rhdf5::h5read(file, name, native = FALSE)
}

#' Read H5AD numeric scalar
#'
#' Read a numeric scalar from an H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param version Encoding version of the element to read
#'
#' @return a numeric vector of length 1
#'
#' @noRd
read_h5ad_numeric_scalar <- function(file, name, version = "0.2.0") {
  version <- match.arg(version)

  value <- rhdf5::h5read(file, name, native = FALSE)

  if (is.factor(value) && all(levels(value) %in% c("TRUE", "FALSE"))) {
    value <- as.logical(value)
  }

  value
}

#' Read H5AD mapping
#'
#' Read a mapping from an H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param version Encoding version of the element to read
#'
#' @return a named list
#'
#' @noRd
read_h5ad_mapping <- function(file, name, version = "0.1.0") {
  version <- match.arg(version)

  items <- read_h5ad_mapping_keys(file, name, version)

  read_h5ad_collection(file, name, items)
}

#' Read H5AD mapping keys
#'
#' Read keys for a mapping from an H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param version Encoding version of the element to read
#'
#' @return a character vector
#'
#' @noRd
read_h5ad_mapping_keys <- function(file, name, version = "0.1.0") {
  version <- match.arg(version)

  h5group <- rhdf5::H5Gopen(file, name)
  on.exit(rhdf5::H5Gclose(h5group), add = TRUE)

  rhdf5::h5ls(h5group, recursive = FALSE)$name
}

#' Read H5AD data frame
#'
#' Read a data frame from an H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param version Encoding version of the element to read
#'
#' @return a data.frame
#'
#' @noRd
read_h5ad_data_frame <- function(file, name, version = "0.2.0") {
  version <- match.arg(version)

  dim_keys <- read_h5ad_data_frame_keys(file, name, version)
  data <- read_h5ad_collection(file, name, dim_keys$cols)

  as.data.frame(
    row.names = dim_keys$rows,
    data,
    check.names = FALSE,
    fix.empty.names = FALSE
  )
}

#' Read H5AD data frame keys
#'
#' Read keys for a data frame from an H5AD file
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param version Encoding version of the element to read
#' @param dim Dimension to read keys for, either "both, "rows" or "cols"
#'
#' @return a character vector if dim is "rows" or "cols", or a list with
#' elements "rows" and "cols" if dim is "both"
#'
#' @noRd
read_h5ad_data_frame_keys <- function(
  file,
  name,
  version = "0.2.0",
  dim = c("both", "rows", "cols")
) {
  version <- match.arg(version)
  dim <- match.arg(dim)

  attrs <- rhdf5::h5readAttributes(file, name, native = FALSE)
  index_name <- attrs[["_index"]]
  column_order <- attrs[["column-order"]]

  if (dim == "both") {
    list(
      rows = as.character(read_h5ad_element(file, file.path(name, index_name))),
      cols = as.character(column_order)
    )
  } else if (dim == "rows") {
    as.character(read_h5ad_element(file, file.path(name, index_name)))
  } else if (dim == "cols") {
    as.character(column_order)
  }
}

#' Read multiple H5AD datatypes
#'
#' @param file Path to a H5AD file or an open H5AD handle
#' @param name Name of the element within the H5AD file
#' @param item_names Vector of item names (in order)
#'
#' @return a named list
#'
#' @noRd
read_h5ad_collection <- function(file, name, item_names) {
  items <- lapply(
    item_names,
    function(item_name) {
      new_name <- paste0(name, "/", item_name)
      encoding <- read_h5ad_encoding(file, new_name)
      read_h5ad_element(
        file = file,
        name = new_name,
        type = encoding$type,
        version = encoding$version
      )
    }
  )
  names(items) <- item_names

  items
}

skip_if_not_installed("rhdf5")

requireNamespace("vctrs")

filename <- system.file("extdata", "example.h5ad", package = "anndataR")
file <- rhdf5::H5Fopen(filename, flags = "H5F_ACC_RDONLY", native = FALSE)

test_that("reading encoding works", {
  encoding <- read_h5ad_encoding(file, "obs")
  expect_equal(names(encoding), c("type", "version"))
})

test_that("reading dense matrices works", {
  mat <- read_h5ad_dense_array(file, "layers/dense_counts")
  expect_true(is.matrix(mat))
  expect_type(mat, "integer")
  expect_equal(dim(mat), c(50, 100))

  mat <- read_h5ad_dense_array(file, "layers/dense_X")
  expect_true(is.matrix(mat))
  expect_type(mat, "double")
  expect_equal(dim(mat), c(50, 100))
})

test_that("reading sparse matrices works", {
  mat <- read_h5ad_sparse_array(file, "layers/csc_counts", type = "csc")
  expect_s4_class(mat, "dgCMatrix")
  expect_equal(dim(mat), c(50, 100))

  mat <- read_h5ad_sparse_array(file, "layers/counts", type = "csr")
  expect_s4_class(mat, "dgRMatrix")
  expect_equal(dim(mat), c(50, 100))
})

test_that("reading recarrays works", {
  array_list <- read_h5ad_rec_array(
    file,
    "uns/rank_genes_groups/logfoldchanges"
  )
  expect_true(is.list(array_list))
  expect_equal(names(array_list), c("0", "1", "2", "3", "4", "5"))
  for (array in array_list) {
    expect_true(is.vector(array))
    expect_type(array, "double")
    expect_equal(length(array), 100)
  }
})

test_that("reading 1D numeric arrays works", {
  array_1d <- read_h5ad_dense_array(file, "obs/Int")
  expect_equal(array_1d, array(0L:49L))

  array_1d <- read_h5ad_dense_array(file, "obs/Float")
  expect_equal(array_1d, array(rep(42.42, 50)))
})

test_that("reading 1D sparse numeric arrays works", {
  array_1d <- read_h5ad_sparse_array(file, "uns/Sparse1D", type = "csc")
  expect_s4_class(array_1d, "dgCMatrix")
  expect_equal(dim(array_1d), c(1, 6))
})

test_that("reading 1D nullable arrays works", {
  array_1d <- read_h5ad_nullable_integer(file, "obs/IntNA")
  expect_vector(array_1d, ptype = integer(), size = 50)
  expect_true(any(is.na(array_1d)))

  array_1d <- read_h5ad_dense_array(file, "obs/FloatNA")
  expected <- array(rep(42.42, 50))
  expected[1] <- NA
  expect_equal(array_1d, expected)

  array_1d <- read_h5ad_nullable_boolean(file, "obs/Bool")
  expect_vector(array_1d, ptype = logical(), size = 50)
  expect_false(any(is.na(array_1d)))

  array_1d <- read_h5ad_nullable_boolean(file, "obs/BoolNA")
  expect_vector(array_1d, ptype = logical(), size = 50)
  expect_true(any(is.na(array_1d)))
})

test_that("reading string scalars works", {
  scalar <- read_h5ad_string_scalar(file, "uns/StringScalar")
  expect_equal(scalar, "A string")
})

test_that("reading numeric scalars works", {
  scalar <- read_h5ad_numeric_scalar(file, "uns/IntScalar")
  expect_equal(scalar, 1)
})

test_that("reading string arrays works", {
  array <- read_h5ad_string_array(file, "uns/String")
  expect_equal(array, array(paste0("String ", 0L:9L)))

  array <- read_h5ad_string_array(file, "uns/String2D")
  expect_true(is.matrix(array))
  expect_type(array, "character")
  expect_equal(dim(array), c(5, 10))
})

test_that("reading mappings works", {
  mapping <- read_h5ad_mapping(file, "uns")
  expect_type(mapping, "list")
  expect_type(names(mapping), "character")
})

test_that("reading mapping keys works", {
  keys <- read_h5ad_mapping_keys(file, "uns")
  expect_type(keys, "character")
  expect_true(length(keys) > 0)
})

test_that("reading dataframes works", {
  df <- read_h5ad_data_frame(file, "obs")
  expect_s3_class(df, "data.frame")
  expect_equal(
    colnames(df),
    c(
      "Float",
      "FloatNA",
      "Int",
      "IntNA",
      "Bool",
      "BoolNA",
      "n_genes_by_counts",
      "log1p_n_genes_by_counts",
      "total_counts",
      "log1p_total_counts",
      "leiden"
    )
  )
})

test_that("reading dataframe keys works", {
  keys <- read_h5ad_data_frame_keys(file, "obs")

  expect_type(keys$cols, "character")
  expect_identical(
    keys$cols,
    c(
      "Float",
      "FloatNA",
      "Int",
      "IntNA",
      "Bool",
      "BoolNA",
      "n_genes_by_counts",
      "log1p_n_genes_by_counts",
      "total_counts",
      "log1p_total_counts",
      "leiden"
    )
  )

  expect_type(keys$rows, "character")
  expect_length(keys$rows, 50)
})

rhdf5::H5Fclose(file)

test_that("reading H5AD as SingleCellExperiment works", {
  suppressWarnings(skip_if_not_installed("SingleCellExperiment"))

  sce <- read_h5ad(filename, as = "SingleCellExperiment")
  expect_s4_class(sce, "SingleCellExperiment")
})

test_that("reading H5AD as Seurat works", {
  skip_if_not_installed("Seurat")

  seurat <- read_h5ad(filename, as = "Seurat")
  expect_s4_class(seurat, "Seurat")
})

expect_equal_py <- function(a, b) {
  requireNamespace("testthat")
  requireNamespace("reticulate")

  bi <- reticulate::import_builtins()

  # ↓ does this always work?
  testthat::expect_equal(bi$str(bi$type(a)), bi$str(bi$type(b)))

  if (inherits(a, "pandas.core.frame.DataFrame")) {
    pd <- reticulate::import("pandas")
    testthat::expect_null(
      pd$testing$assert_frame_equal(
        a,
        b,
        check_dtype = FALSE,
        check_exact = FALSE
      )
    )
  } else if (
    inherits(a, "np.ndarray") || inherits(a, "scipy.sparse.base.spmatrix")
  ) {
    scipy <- reticulate::import("scipy")
    np <- reticulate::import("numpy")

    testthat::expect_equal(a$dtype, b$dtype)

    testthat::expect_equal(
      py_to_r_ifneedbe(a$shape),
      py_to_r_ifneedbe(b$shape)
    )

    a_dense <-
      if (scipy$sparse$issparse(a)) {
        a$toarray()
      } else {
        a
      }
    b_dense <-
      if (scipy$sparse$issparse(b)) {
        b$toarray()
      } else {
        b
      }

    testthat::expect_null(
      np$testing$assert_allclose(a_dense, b_dense)
    )
  }
}

py_to_r_ifneedbe <- function(x) {
  if (inherits(x, "python.builtin.object")) {
    requireNamespace("reticulate")
    reticulate::py_to_r(x)
  } else {
    x
  }
}

---
title: "Python Integration with anndataR"
package: anndataR
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Python integration with anndataR}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
# Set up reticulate and check for required Python packages.
reticulate::py_require("mudata")
reticulate::py_require("scanpy")

# Check if required Python packages are available.
python_available <- reticulate::py_module_available("scanpy") &&
  reticulate::py_module_available("mudata")

# On CI, fail the vignette build if Python packages are not available
if (!python_available && nzchar(Sys.getenv("CI"))) {
  conf <- reticulate::py_config()
  conf_str <- paste(capture.output(print(conf)), collapse = "\n")
  stop(
    "Python packages scanpy/mudata are not available. ",
    "The usage_python vignette cannot be rendered on CI without them.",
    "\n\nPython configuration:\n", conf_str
  )
}

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  # Set eval based on Python package availability
  eval = python_available
)
```

# Introduction

`r Biocpkg("anndataR")` works with Python `AnnData` objects through `r CRANpkg("reticulate")`.
You can load Python objects, apply Python functions to them, and convert them to `Seurat` or `SingleCellExperiment` objects.

```{r python_unavailable, eval=!python_available}
message(
  "Python packages scanpy and mudata are required to run this vignette. Code chunks will not be evaluated."
)
```

## Prerequisites

This vignette requires Python with the _scanpy_ and _mudata_ packages installed.
If these are not available, the code chunks will not be evaluated but the examples remain visible.

# Basic Integration with _scanpy_

Install required Python packages if needed:

```{r python_setup, eval=FALSE}
reticulate::py_require("scanpy")
```

```{r load_libraries}
library(anndataR)
library(reticulate)
sc <- import("scanpy")
```

Load a dataset directly from _scanpy_:

```{r load_python_data}
adata <- sc$datasets$pbmc3k_processed()
adata
```

Apply _scanpy_ functions directly:

```{r apply_python_functions}
sc$pp$filter_cells(adata, min_genes = 200L)
sc$pp$normalize_total(adata, target_sum = 1e4)
sc$pp$log1p(adata)
```

# Conversion to R objects

Convert to `SingleCellExperiment` (see `vignette("usage_singlecellexperiment")`):

```{r convert_to_sce}
sce_obj <- adata$as_SingleCellExperiment()
sce_obj
```

Convert to `Seurat` (see `vignette("usage_seurat")`):

```{r convert_to_seurat}
seurat_obj <- adata$as_Seurat()
seurat_obj
```

# Multi-modal data with _mudata_

Install required Python packages if needed:

```{r mudata_setup, eval=FALSE}
reticulate::py_install("mudata")
```

```{r load_mudata}
md <- import("mudata")
```

Load a `MuData` object from file:

```{r load_mudata_example, eval = python_available && requireNamespace("BiocFileCache", quietly = TRUE)}
cache <- BiocFileCache::BiocFileCache(ask = FALSE)
h5mu_file <- BiocFileCache::bfcrpath(
  cache,
  "https://github.com/gtca/h5xx-datasets/raw/b1177ac8877c89d8bb355b072164384b4e9cc81d/datasets/minipbcite.h5mu"
)

mdata <- md$read_h5mu(h5mu_file)
```

Access individual modalities and convert them:

```{r access_modalities}
rna_mod <- mdata$mod[["rna"]]

rna_seurat <- rna_mod$as_Seurat()
print(rna_seurat)

rna_sce <- rna_mod$as_SingleCellExperiment()
print(rna_sce)
```

# Session info

## R

```{r r-sessioninfo}
sessionInfo()
```

## Python

```{r python-sessioninfo}
reticulate::py_config()

reticulate::py_list_packages()
```

---
title: Read/write Seurat objects using anndataR
package: anndataR
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Read/write Seurat objects using anndataR}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r options, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  warning = FALSE
)
```

# Introduction

This vignette demonstrates how to read and write `Seurat` objects using the `r Biocpkg("anndataR")` package, leveraging the interoperability between `Seurat` and the `AnnData` format.

`r CRANpkg("Seurat")` is a widely used toolkit for single-cell analysis in R.
`r Biocpkg("anndataR")` enables conversion between `Seurat` objects and `AnnData` objects, allowing you to leverage the strengths of both the [scverse](https://scverse.org/) and [Seurat](https://satijalab.org/seurat/) ecosystems.

## Prerequisites

This vignette requires the `r CRANpkg("Seurat")` package in addition to `r Biocpkg("anndataR")`.
You can install them using the following code:

```r
install.packages("Seurat")
```

# Reading H5AD files and Zarr stores to a `Seurat` Object

Using an example `.h5ad` file included in the package, we will demonstrate how to read an `.h5ad` file and convert it to a `Seurat` object.

```{r prep-file}
library(anndataR)
library(Seurat)

h5ad_file <- system.file("extdata", "example.h5ad", package = "anndataR")
```

Read the `.h5ad` file as a `Seurat` object:

```{r read-data}
seurat_obj <- read_h5ad(h5ad_file, as = "Seurat")
seurat_obj
```

This is equivalent to reading in the `.h5ad` file as an `AnnData` and explicitly converting:

```{r convert-seurat}
adata <- read_h5ad(h5ad_file)
seurat_obj <- adata$as_Seurat()
seurat_obj
```

Similarly, we can read from a Zarr store which we also demonstrate with an example `.zarr` store: 

```{r prep-file-zarr}
# Please use "example_v3.zarr.zip" for AnnData stored as Zarr version 3
zarr_path <- system.file("extdata", "example_v2.zarr.zip", package = "anndataR")
td <- tempdir(check = TRUE)
unzip(zarr_path, exdir = td)
zarr_path <- file.path(td, "example_v2.zarr")

seurat_obj_zarr <- read_zarr(zarr_path, as = "Seurat")
seurat_obj_zarr
```

or 

```{r convert-seurat-zarr}
adata <- read_zarr(zarr_path)
seurat_obj_zarr <- adata$as_Seurat()
seurat_obj_zarr
```

# Mapping between `AnnData` and `Seurat`

Figure \@ref(fig:mapping) shows the structures of the `AnnData` and `Seurat` objects and how `r Biocpkg("anndataR")` maps between them.
It is important to note that matrices in the two objects are transposed relative to each other.

```{r mapping, fig.cap = "Mapping between `AnnData` and `Seurat` objects", fig.wide = TRUE, echo = FALSE}
knitr::include_graphics("../man/figures/AnnData-Seurat.png")
```

By default, all items in most slots are converted using the same names.
An exception is the `varp` slot which doesn't have a corresponding slot in `Seurat`.
Items in the `varm` slot are only converted when they are specified in a mapping argument.
The `Neighbors` and `Images` slots are not mapped when converting from `Seurat`.
See `?as_Seurat` for more details on the default mapping.

# Customizing the conversion

You can customize the conversion process by providing specific mappings for each slot in the `Seurat` object.

Each of the mapping arguments can be provided with one of the following:

- `TRUE`: all items in the slot will be copied using the default mapping
- `FALSE`: the slot will not be copied
- A (named) character vector: the names are the names of the slot in the `Seurat` object, the values are the names of the slot in the `AnnData` object.

See `?as_Seurat` for more details on how to customize the conversion process. For instance:

```{r customize-seurat-conversion}
seurat_obj <- adata$as_Seurat(
  layers_mapping = c("counts", "dense_counts"),
  object_metadata_mapping = c(metadata1 = "Int", metadata2 = "Float"),
  assay_metadata_mapping = FALSE,
  reduction_mapping = list(
    pca = c(key = "PC_", embeddings = "X_pca", loadings = "PCs"),
    umap = c(key = "UMAP_", embeddings = "X_umap")
  ),
  graph_mapping = TRUE,
  misc_mapping = c(misc1 = "Bool", misc2 = "IntScalar")
)
seurat_obj
```

The mapping arguments can also be passed directly to `read_h5ad()`.

# Writing a `Seurat` object to a H5AD file or Zarr store

The reverse conversion is also possible, allowing you to convert the `Seurat` object back to an `AnnData` object, or to just write out the `Seurat` object as an `.h5ad` file or `.zarr` store. 

```{r write-seurat, eval=FALSE}
write_h5ad(seurat_obj, tempfile(fileext = ".h5ad"))
write_zarr(seurat_obj, tempfile(fileext = ".zarr"))
```

This is equivalent to converting the `Seurat` object to an `AnnData` object and then writing it out:

```{r convert-to-anndata, eval=FALSE}
adata <- as_AnnData(seurat_obj)
adata$write_h5ad(tempfile(fileext = ".h5ad"))
adata$write_zarr(tempfile(fileext = ".zarr"))
```

You can again customize the conversion process by providing specific mappings for each slot in the `AnnData` object.
For more details, see `?as_AnnData`.

Here's an example:

```{r customize-anndata-conversion}
adata <- as_AnnData(
  seurat_obj,
  assay_name = "RNA",
  x_mapping = "counts",
  layers_mapping = c("dense_counts"),
  obs_mapping = c(RNA_count = "nCount_RNA", metadata1 = "metadata1"),
  var_mapping = FALSE,
  obsm_mapping = list(X_pca = "pca", X_umap = "umap"),
  obsp_mapping = TRUE,
  uns_mapping = c("misc1", "misc2")
)
adata
```

The mapping arguments can also be passed directly to `write_h5ad()` or `write_zarr()`.

# Session info

```{r sessioninfo}
sessionInfo()
```

---
title: "Using anndataR"
author:
  - name: Robrecht Cannoodt
  - name: Luke Zappia
  - name: Martin Morgan
  - name: Louise Deconinck
package: anndataR
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Using anndataR to read and convert}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r options, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

# already load SeuratObject and SingleCellExperiment
# so warnings generated by these packages are not shown
library(SeuratObject)
library(SingleCellExperiment)
```

# Introduction

`r Biocpkg("anndataR")` allows users to work with `.h5ad` files and `.zarr` stores, interact with `AnnData` objects and convert to/from `SingleCellExperiment` or `Seurat` objects.
This enables users to move data easily between the different programming languages and analysis ecosystems needed to perform single-cell data analysis.

This package builds on our experience developing and using other interoperability packages and aims to provide a first-class R `AnnData` experience.

## Relationship to other packages

Existing packages provide similar functionality to `r Biocpkg("anndataR")` but there are some important differences:

- `r Biocpkg("zellkonverter")` provides conversion of `SingleCellExperiment` objects to/from `AnnData` and reading/writing of `.h5ad` files.
  This is facilitated via `r CRANpkg("reticulate")` using `r Biocpkg("basilisk")` to manage Python environments (native reading of `.h5ad` is also possible).
  In contrast, `r Biocpkg("anndataR")` provides a native R H5AD and Zarr interface, removing the need for Python dependencies.
  Conversion to/from `Seurat` objects is also supported.
- `r CRANpkg("anndata")` (on CRAN) is a wrapper around the Python _anndata_ package.
  It provides a nicer interface from within R but still requires a Python environment.
  `r Biocpkg("anndataR")` provides a pure R implementation of the `AnnData` data structure with different back ends and conversion to more common R objects.
- Other interoperability packages typically also require Python dependencies, have limited features or flexibility and/or are not available from a central package repository

There is significant overlap in functionality between these packages.
We anticipate that over time they will become more specialised and work better together or be deprecated in favour of `r Biocpkg("anndataR")`.

# Installation

Install `r Biocpkg("anndataR")` using `r CRANpkg("BiocManager")`:

```{r install, eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE)) {
  install.packages("BiocManager")
}
BiocManager::install("anndataR")
```

# Usage

These sections briefly show how to use `r Biocpkg("anndataR")`.

## Read from disk

First, we fetch an example `.h5ad` file included in the package:

```{r h5ad-path}
library(anndataR)

h5ad_path <- system.file("extdata", "example.h5ad", package = "anndataR")
```

By default, a H5AD is read to an in-memory `AnnData` object:

```{r read-in-memory}
adata <- read_h5ad(h5ad_path)
```

It can also be read as a `SingleCellExperiment` object (see `vignette("usage_singlecellexperiment")`):

```{r read-as-SingleCellExperiment}
sce <- read_h5ad(h5ad_path, as = "SingleCellExperiment")
```

Or as a `Seurat` object (see `vignette("usage_seurat")`):

```{r read-as-Seurat}
obj <- read_h5ad(h5ad_path, as = "Seurat")
```

There is also a HDF5-backed `AnnData` object:

```{r read-on-disk}
adata <- read_h5ad(h5ad_path, as = "HDF5AnnData")
```

Similarly, these functionalities are provided for `.zarr` stores too. 

```{r zarr-path}
zarr_path <- system.file("extdata", "example_v2.zarr.zip", package = "anndataR")
td <- tempdir(check = TRUE)
unzip(zarr_path, exdir = td)
zarr_path <- file.path(td, "example_v2.zarr")
```

```{r read-zarr}
# in-memory
adata <- read_zarr(zarr_path)

# as SingleCellExperiment
sce <- read_zarr(zarr_path, as = "SingleCellExperiment")

# as Seurat
obj <- read_zarr(zarr_path, as = "Seurat")

# as Zarr-backed
adata <- read_zarr(zarr_path, as = "ZarrAnnData")
```

See `r vignette("usage_python")` for interacting with a Python `AnnData` via `r CRANpkg("reticulate")`. 

## Using `AnnData` objects

View structure:

```{r show-structure}
adata
```

Access `AnnData` slots:

```{r access-slots}
dim(adata$X)
adata$obs[1:5, 1:6]
adata$var[1:5, 1:6]
```

[Subsetting](#subsetting) `AnnData` objects is covered below.
See ```?`AnnData-usage` ```for more details on how to work with `AnnData` objects.

## Interoperability

Convert the `AnnData` object to a `SingleCellExperiment` object (see `vignette("usage_singlecellexperiment")`):

```{r as-SingleCellExperiment}
sce <- adata$as_SingleCellExperiment()
sce
```

Convert the `AnnData` object to a `Seurat` object (see `vignette("usage_seurat")`):

```{r as-Seurat}
obj <- adata$as_Seurat()
obj
```

Convert a `SingleCellExperiment` object to an `AnnData` object (see `vignette("usage_singlecellexperiment")`):

```{r as-AnnData-from-SingleCellExperiment}
adata <- as_AnnData(sce)
adata
```

Convert a `Seurat` object to an `AnnData` object (see `vignette("usage_seurat")`):

```{r as-AnnData-from-Seurat}
adata <- as_AnnData(obj)
adata
```

## Manually create an `AnnData` object

```{r manually-create-object}
adata <- AnnData(
  X = matrix(rnorm(100), nrow = 10),
  obs = data.frame(
    cell_type = factor(rep(c("A", "B"), each = 5))
  ),
  var = data.frame(
    gene_name = paste0("gene_", 1:10)
  )
)

adata
```

## Write to disk

Write an `AnnData` object to disk:

```{r write-to-disk}
tmpfile <- tempfile(fileext = ".h5ad")
adata$write_h5ad(tmpfile) # Alternatively, write_h5ad(adata, tmpfile)
```

Write a `SingleCellExperiment` object to disk:

```{r write-SingleCellExperiment-to-disk}
tmpfile <- tempfile(fileext = ".h5ad")
write_h5ad(sce, tmpfile)
```

Write a `Seurat` object to disk:

```{r write-Seurat-to-disk}
tmpfile <- tempfile(fileext = ".h5ad")
write_h5ad(obj, tmpfile)
```

Similarly, we can write `AnnData` and other objects to `.zarr` stores too.

```{r write-to-disk-zarr}
tmpfile <- tempfile(fileext = ".zarr")
adata$write_zarr(tmpfile) # Alternatively, write_zarr(adata, tmpfile)

tmpfile <- tempfile(fileext = ".zarr")
write_zarr(sce, tmpfile)

tmpfile <- tempfile(fileext = ".zarr")
write_zarr(obj, tmpfile)
```

## Subsetting `AnnData` objects {#subsetting}

`r Biocpkg("anndataR")` provides standard R subsetting methods that work with familiar bracket notation. These methods return `AnnDataView` objects that provide lazy evaluation for efficient memory usage.

### Basic subsetting

Subset observations (rows) using logical conditions:

```{r subset-obs}
# Create some sample data
adata <- AnnData(
  X = matrix(rnorm(50), nrow = 10, ncol = 5),
  obs = data.frame(
    cell_type = factor(rep(c("A", "B", "C"), c(3, 4, 3))),
    score = runif(10)
  ),
  var = data.frame(
    gene_name = paste0("gene_", 1:5),
    highly_variable = c(TRUE, FALSE, TRUE, TRUE, FALSE)
  )
)

# Subset to cell type "A"
view1 <- adata[adata$obs$cell_type == "A", ]
view1
```

Subset variables (columns) using logical conditions:

```{r subset-vars}
# Subset to highly variable genes
view2 <- adata[, adata$var$highly_variable]
view2
```

### Combined subsetting

Subset both observations and variables simultaneously:

```{r subset-both}
# Subset to cell type "A" and highly variable genes
view3 <- adata[adata$obs$cell_type == "A", adata$var$highly_variable]
view3
```

### Using different index types

```{r subset-types}
# Numeric indices
view4 <- adata[1:5, 1:3]
view4

# Character names (if available)
rownames(adata) <- paste0("cell_", 1:10)
colnames(adata) <- paste0("gene_", 1:5)
view5 <- adata[c("cell_1", "cell_2"), c("gene_1", "gene_3")]
view5
```

### Working with views

Views maintain access to all original data slots:

```{r view-properties}
# Access dimensions
dim(view3)
nrow(view3)
ncol(view3)

# Access names
rownames(view3)
colnames(view3)

# Access data matrices and metadata
view3$X
view3$obs
view3$var

# Views can be converted to concrete implementations
concrete <- view3$as_InMemoryAnnData()
concrete
```

# Citing _anndataR_

If you use `r Biocpkg("anndataR")` in your work, please cite [_"anndataR improves interoperability between R and Python in single-cell transcriptomics"_](https://doi.org/10.1101/2025.08.18.669052):

```{r citation}
citation("anndataR")
```

# Session info

```{r sessioninfo}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AnnData-usage.R
\name{AnnData-usage}
\alias{AnnData-usage}
\title{AnnData structure and usage}
\value{
An \code{AnnData} object inheriting from \code{\link{AbstractAnnData}}
}
\description{
The \code{AnnData} object stores a data matrix \code{X} together with annotations of
observations \code{obs} (\code{obsm}, \code{obsp}) and variables \code{var} (\code{varm}, \code{varp}).
Additional layers of data can be stored in \code{layers} and unstructured
annotations in \code{uns}.
\subsection{Back ends}{

There are different back ends for \code{AnnData} objects that inherit from the
abstract \link{AbstractAnnData} class and store and access data in different ways:
\itemize{
\item \link{InMemoryAnnData} stores data in memory
\item \link{HDF5AnnData} provides an interface to a H5AD file
\item \link{ZarrAnnData} provides an interface to a Zarr store
\item \link{ReticulateAnnData} wraps a Python \code{AnnData} object via \pkg{reticulate}
}

See the class documentation for details.
}

\subsection{Usage}{

The items listed as \strong{"Slots"} are elements of the \code{AnnData} object that
contain data and can be accessed or set. \strong{"Fields"} return information
about the \code{AnnData} object but cannot be set directly. Both, as well as
methods, can be accessed using the \code{$} operator

For example:
\itemize{
\item \code{adata$X} returns the \code{X} matrix
\item \code{adata$X <- x} sets the \code{X} matrix
\item \code{adata$method()} calls a method
}
}
}
\section{Fields}{

\describe{
\item{\code{shape}}{Dimensions (observations x variables) of the \code{AnnData} object}

\item{\code{n_obs}}{Number of observations}

\item{\code{n_vars}}{Number of variables}

\item{\code{obs_keys}}{Keys (column names) of \code{obs}}

\item{\code{var_keys}}{Keys (column names) of \code{var}}

\item{\code{layers_keys}}{Keys (element names) of \code{layers}}

\item{\code{obsm_keys}}{Keys (element names) of \code{obsm}}

\item{\code{varm_keys}}{Keys (element names) of \code{varm}}

\item{\code{obsp_keys}}{Keys (element names) of \code{obsp}}

\item{\code{varp_keys}}{Keys (element names) of \code{varp}}

\item{\code{uns_keys}}{Keys (element names) of \code{uns}}
}}

\section{Slots}{

\describe{
\item{\code{X}}{The main data matrix. Either \code{NULL} or an observation x variable
matrix (without dimnames) with dimensions consistent with \code{n_obs} and
\code{n_vars}.}

\item{\code{layers}}{Additional data layers. Must be \code{NULL} or a named list of
matrices having dimensions consistent with \code{n_obs} and \code{n_vars}.}

\item{\code{obs}}{Observation annotations. A \code{data.frame} with columns containing
information about observations. The number of rows of \code{obs} defines the
observation dimension of the \code{AnnData} object (\code{n_obs}). If \code{NULL}, an
\code{n_obs} × 0 \code{data.frame} will automatically be generated.}

\item{\code{var}}{Variable annotations. A \code{data.frame} with columns containing
information about variables. The number of rows of \code{var} defines the
variable dimension of the \code{AnnData} object (\code{n_vars}). If \code{NULL}, an
\code{n_vars} × 0 \code{data.frame} will automatically be generated.}

\item{\code{obs_names}}{Observation names. Either \code{NULL} or a vector of unique
identifiers used to identify each row of \code{obs} and to act as an index into
the observation dimension of the \code{AnnData} object. For compatibility with
\emph{R} representations, \code{obs_names} should be a unique character vector.}

\item{\code{var_names}}{Variable names. Either \code{NULL} or a vector of unique
identifiers used to identify each row of \code{var} and to act as an index into
the variable dimension of the \code{AnnData} object. For compatibility with \emph{R}
representations, \code{var_names} should be a unique character vector.}

\item{\code{obsm}}{Multi-dimensional observation annotation. Must be \code{NULL} or a
named list of array-like elements with number of rows equal to \code{n_obs}.}

\item{\code{varm}}{Multi-dimensional variable annotations. Must be \code{NULL} or a named
list of array-like elements with number of rows equal to \code{n_vars}.}

\item{\code{obsp}}{Observation pairs. Must be \code{NULL} or a named list of array-like
elements with number of rows and columns equal to \code{n_obs}.}

\item{\code{varp}}{Variable pairs. Must be \code{NULL} or a named list of array-like
elements with number of rows and columns equal to \code{n_vars}.}

\item{\code{uns}}{Unstructured annotations. Must be \code{NULL} or a named list.}
}}

\section{Methods}{

\subsection{Conversion methods:}{

\describe{
\item{
\code{as_SingleCellExperiment()}
}{
Convert to \code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment::SingleCellExperiment}}, see
\code{\link[=as_SingleCellExperiment]{as_SingleCellExperiment()}}
}
\item{\code{as_Seurat()}}{Convert to \code{\link[SeuratObject:Seurat-class]{SeuratObject::Seurat}}, see \code{\link[=as_Seurat]{as_Seurat()}}}
\item{\code{as_InMemoryAnnData()}}{Convert to \code{\link{InMemoryAnnData}}, as \code{\link[=as_InMemoryAnnData]{as_InMemoryAnnData()}}}
\item{\code{as_HDF5AnnData()}}{Convert to \code{\link{HDF5AnnData}}, see \code{\link[=as_HDF5AnnData]{as_HDF5AnnData()}}}
\item{\code{as_ZarrAnnData()}}{Convert to \code{\link{ZarrAnnData}}, see \code{\link[=as_ZarrAnnData]{as_ZarrAnnData()}}}
\item{\code{as_ReticulateAnnData()}}{Convert to \code{\link{ReticulateAnnData}}, see \code{\link[=as_ReticulateAnnData]{as_ReticulateAnnData()}}}
}
}

\subsection{Output methods:}{

\describe{
\item{
\code{write_h5ad()}
}{
Write the \code{AnnData} object to an HDF5 file, see \code{\link[=write_h5ad]{write_h5ad()}}
}
}

\describe{
\item{
\code{write_zarr()}
}{
Write the \code{AnnData} object to a Zarr store, see \code{\link[=write_zarr]{write_zarr()}}
}
}
}

\subsection{General methods:}{

\describe{
\item{\code{print()}}{Print a summary of the \code{AnnData} object}
}
}
}

\section{Functions that can be used to create AnnData objects}{


\describe{
\item{\code{\link[=AnnData]{AnnData()}}}{Create an \link{InMemoryAnnData} object}
\item{\code{\link[=read_h5ad]{read_h5ad()}}}{Read an \code{AnnData} from a H5AD file}
\item{\code{\link[=read_zarr]{read_zarr()}}}{Read an \code{AnnData} from a Zarr store}
\item{\code{\link[=as_AnnData]{as_AnnData()}}}{Convert other objects to an \code{AnnData} object}
}
}

\seealso{
The documentation for the Python \code{anndata} package
\url{https://anndata.readthedocs.io/en/stable/}

\link{AbstractAnnData} for the abstract class that all \code{AnnData} objects
inherit from

\link{InMemoryAnnData} for the in-memory implementation of \code{AnnData}

\link{HDF5AnnData} for the HDF5-backed implementation of \code{AnnData}

\link{ZarrAnnData} for the Zarr-backed implementation of \code{AnnData}

\link{ReticulateAnnData} for the reticulate-based implementation that wraps Python AnnData objects
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/write_zarr.R
\name{write_zarr}
\alias{write_zarr}
\title{Write Zarr}
\usage{
write_zarr(
  object,
  path,
  compression = c("none", "gzip", "blosc", "zstd", "lzma", "bz2", "zlib", "lz4"),
  mode = c("w-", "r", "r+", "a", "w", "x"),
  ...
)
}
\arguments{
\item{object}{The object to write, either a
\code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment::SingleCellExperiment}} or a
\code{\link[SeuratObject:Seurat-class]{SeuratObject::Seurat}} object}

\item{path}{Path of the file to write to}

\item{compression}{The compression algorithm to use when writing the Zarr
file. Can be one of \code{"none"}, \code{"gzip"}, \code{"blosc"}, \code{"zstd"},
\code{"lzma"}, \code{"bz2"}, \code{"zlib"}, \code{"lz4"}. Defaults to \code{"none"}.
See \code{help("compressors", package = "Rarr")}.}

\item{mode}{The mode to open the Zarr file.
\itemize{
\item \code{a} creates a new file or opens an existing one for read/write
\item \verb{r+} opens an existing file for read/write
\item \code{w} creates a file, truncating any existing ones
\item \verb{w-}/\code{x} are synonyms creating a file and failing if it already exists
}}

\item{...}{Additional arguments passed to \code{\link[=as_AnnData]{as_AnnData()}}}
}
\value{
\code{path} invisibly
}
\description{
Write a Zarr file
}
\details{
\subsection{\code{NULL} values}{

For compatibility with changes in Python \strong{anndata} 0.12.0, \code{NULL} values
in \code{uns} are written to Zarr files as a \code{NULL} dataset (instead of not being
written at all). To disable this behaviour, set
\code{option(anndataR.write_null = FALSE)}. This may be required to allow the file
to be read by older versions of Python \strong{anndata}.
}
}
\examples{
adata <- AnnData(
  X = matrix(1:5, 3L, 5L),
  layers = list(
    A = matrix(5:1, 3L, 5L),
    B = matrix(letters[1:5], 3L, 5L)
  ),
  obs = data.frame(row.names = LETTERS[1:3], cell = 1:3),
  var = data.frame(row.names = letters[1:5], gene = 1:5)
)
zarr_store <- tempfile(fileext = ".zarr")
adata$write_zarr(zarr_store)

# Write a SingleCellExperiment as a Zarr store
if (requireNamespace("SingleCellExperiment", quietly = TRUE)) {
  ncells <- 100
  counts <- matrix(rpois(20000, 5), ncol = ncells)
  logcounts <- log2(counts + 1)

  pca <- matrix(runif(ncells * 5), ncells)
  tsne <- matrix(rnorm(ncells * 2), ncells)

  sce <- SingleCellExperiment::SingleCellExperiment(
    assays = list(counts = counts, logcounts = logcounts),
    reducedDims = list(PCA = pca, tSNE = tsne)
  )

  adata <- as_AnnData(sce)
  zarr_store <- tempfile(fileext = ".zarr")
  adata$write_zarr(zarr_store)
}

# Write a Seurat as a Zarr
if (requireNamespace("Seurat", quietly = TRUE)) {
  library(Seurat)

  counts <- matrix(1:15, 5L, 3L)
  dimnames(counts) <- list(
    LETTERS[1:5],
    letters[1:3]
  )
  cell.metadata <- data.frame(
    row.names = letters[1:3],
    cell = 1:3
  )
  obj <- CreateSeuratObject(counts, meta.data = cell.metadata)
  gene.metadata <- data.frame(
    row.names = LETTERS[1:5],
    gene = 1:5
  )
  obj[["RNA"]] <- AddMetaData(GetAssay(obj), gene.metadata)

  adata <- as_AnnData(obj)
  zarr_store <- tempfile(fileext = ".zarr")
  adata$write_zarr(zarr_store)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reticulate_helpers.R
\name{reticulate-helpers}
\alias{reticulate-helpers}
\alias{py_to_r.collections.abc.Mapping}
\alias{py_to_r.anndata._core.anndata.AnnData}
\alias{r_to_py.AbstractAnnData}
\title{Reticulate Helper Functions for AnnData Conversion}
\usage{
\method{py_to_r}{collections.abc.Mapping}(x)

\method{py_to_r}{anndata._core.anndata.AnnData}(x)

\method{r_to_py}{AbstractAnnData}(x, convert = TRUE)
}
\arguments{
\item{x}{An AbstractAnnData object (any anndataR implementation)}

\item{convert}{Whether to convert the result (passed to reticulate)}
}
\value{
A \code{\link{ReticulateAnnData}} object wrapping the Python object

A Python AnnData object
}
\description{
This file contains helper functions that enable seamless conversion between
R and Python AnnData objects using the reticulate package. These functions
provide automatic S3 method dispatch for converting AnnData objects across
the R-Python boundary.
}
\details{
The main conversion functions include:
\itemize{
\item \code{py_to_r.anndata._core.anndata.AnnData}: Converts Python AnnData
objects to R \link{ReticulateAnnData} objects
\item \code{r_to_py.AbstractAnnData}: Converts R \link{AbstractAnnData} objects
to Python AnnData objects
\item \code{py_to_r.collections.abc.Mapping}: Converts Python mapping
objects to R lists
}

These functions are automatically registered as S3 methods and are called
when using \code{reticulate::py_to_r()} and \code{reticulate::r_to_py()} on compatible
objects.
}
\examples{
\donttest{
# Requires Python anndata to be installed
if (requireNamespace("reticulate", quietly = TRUE) &&
      reticulate::py_module_available("anndata")) {

  library(reticulate)

  # Create Python AnnData object
  ad_py <- import("anndata", convert = FALSE)
  py_adata <- ad_py$AnnData(X = r_to_py(matrix(1:12, 3, 4)))

  # Automatic conversion to R (uses py_to_r.anndata._core.anndata.AnnData)
  r_adata <- py_to_r(py_adata)

  # Automatic conversion back to Python (uses r_to_py.AbstractAnnData)
  py_adata2 <- r_to_py(r_adata)
}
}
}
\seealso{
Other object converters: 
\code{\link{as_AnnData}()},
\code{\link{as_HDF5AnnData}()},
\code{\link{as_InMemoryAnnData}()},
\code{\link{as_ReticulateAnnData}()},
\code{\link{as_Seurat}()},
\code{\link{as_SingleCellExperiment}()},
\code{\link{as_ZarrAnnData}()}
}
\concept{object converters}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AnnData.R
\name{AnnData}
\alias{AnnData}
\title{Create an in-memory AnnData object.}
\usage{
AnnData(
  X = NULL,
  obs = NULL,
  var = NULL,
  layers = NULL,
  obsm = NULL,
  varm = NULL,
  obsp = NULL,
  varp = NULL,
  uns = NULL,
  shape = NULL
)
}
\arguments{
\item{X}{See the \code{X} slot in \link{AnnData-usage}}

\item{obs}{See the \code{obs} slot in \link{AnnData-usage}}

\item{var}{See the \code{var} slot in \link{AnnData-usage}}

\item{layers}{See the \code{layers} slot in \link{AnnData-usage}}

\item{obsm}{See the \code{obsm} slot in \link{AnnData-usage}}

\item{varm}{See the \code{varm} slot in \link{AnnData-usage}}

\item{obsp}{See the \code{obsp} slot in \link{AnnData-usage}}

\item{varp}{See the \code{varp} slot in \link{AnnData-usage}}

\item{uns}{See the \code{uns} slot in \link{AnnData-usage}}

\item{shape}{Shape tuple (e.g. \code{c(n_obs, n_vars)}). Can be provided if both
\code{X} or \code{obs} and \code{var} are not provided.}
}
\value{
An \link{InMemoryAnnData} object
}
\description{
For more information on the functionality of an AnnData object, see \link{AnnData-usage}
}
\examples{
adata <- AnnData(
  X = matrix(1:12, nrow = 3, ncol = 4),
  obs = data.frame(
    row.names = paste0("obs", 1:3),
    n_counts = c(1, 2, 3),
    n_cells = c(1, 2, 3)
  ),
  var = data.frame(
    row.names = paste0("var", 1:4),
    n_cells = c(1, 2, 3, 4)
  )
)

adata
}
\seealso{
\link{AnnData-usage} for details of \code{AnnData} structure and usage

Other AnnData creators: 
\code{\link{as_AnnData}()},
\code{\link{read_h5ad}()},
\code{\link{read_zarr}()}
}
\concept{AnnData creators}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_h5ad.R
\name{read_h5ad}
\alias{read_h5ad}
\title{Read H5AD}
\usage{
read_h5ad(
  path,
  as = c("InMemoryAnnData", "HDF5AnnData", "SingleCellExperiment", "Seurat"),
  mode = c("r", "r+", "a", "w", "w-", "x"),
  ...
)
}
\arguments{
\item{path}{Path to the H5AD file to read}

\item{as}{The type of object to return. One of:
\itemize{
\item \code{"InMemoryAnnData"}: Read the H5AD file into memory as an
\code{\link{InMemoryAnnData}} object
\item \code{"HDF5AnnData"}: Read the H5AD file as an \code{\link{HDF5AnnData}} object
\item \code{"SingleCellExperiment"}: Read the H5AD file as a
\code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment::SingleCellExperiment}} object
\item \code{"Seurat"}: Read the H5AD file as a
\code{\link[SeuratObject:Seurat-class]{SeuratObject::Seurat}} object
}}

\item{mode}{The mode to open the HDF5 file.
\itemize{
\item \code{a} creates a new file or opens an existing one for read/write.
\item \code{r} opens an existing file for reading.
\item \verb{r+} opens an existing file for read/write.
\item \code{w} creates a file, truncating any existing ones.
\item \verb{w-}/\code{x} are synonyms, creating a file and failing if it already exists.
}}

\item{...}{Extra arguments provided to the \verb{as_*} conversion function for the
object specified by \code{as}}
}
\value{
The object specified by \code{as}
}
\description{
Read data from a H5AD file
}
\examples{
h5ad_file <- system.file("extdata", "example.h5ad", package = "anndataR")

# Read the H5AD as a SingleCellExperiment object
if (requireNamespace("SingleCellExperiment", quietly = TRUE)) {
  sce <- read_h5ad(h5ad_file, as = "SingleCellExperiment")
}

# Read the H5AD as a Seurat object
if (requireNamespace("SeuratObject", quietly = TRUE)) {
  seurat <- read_h5ad(h5ad_file, as = "Seurat")
}
}
\seealso{
Other AnnData creators: 
\code{\link{AnnData}()},
\code{\link{as_AnnData}()},
\code{\link{read_zarr}()}
}
\concept{AnnData creators}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/InMemoryAnnData.R
\name{as_InMemoryAnnData}
\alias{as_InMemoryAnnData}
\title{Convert an \code{AnnData} to an \code{InMemoryAnnData}}
\usage{
as_InMemoryAnnData(adata)
}
\arguments{
\item{adata}{An \code{AnnData} object to be converted to \code{\link{InMemoryAnnData}}}
}
\value{
An \code{\link{InMemoryAnnData}} object with the same data as the input
\code{AnnData} object
}
\description{
Convert another \code{AnnData} object to an \code{\link{InMemoryAnnData}} object
}
\examples{
ad <- AnnData(
  X = matrix(1:5, 3L, 5L),
  layers = list(
    A = matrix(5:1, 3L, 5L),
    B = matrix(letters[1:5], 3L, 5L)
  ),
  obs = data.frame(row.names = LETTERS[1:3], cell = 1:3),
  var = data.frame(row.names = letters[1:5], gene = 1:5)
)
ad$as_InMemoryAnnData()
}
\seealso{
Other object converters: 
\code{\link{as_AnnData}()},
\code{\link{as_HDF5AnnData}()},
\code{\link{as_ReticulateAnnData}()},
\code{\link{as_Seurat}()},
\code{\link{as_SingleCellExperiment}()},
\code{\link{as_ZarrAnnData}()},
\code{\link{reticulate-helpers}}
}
\concept{object converters}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/as_Seurat.R
\name{as_Seurat}
\alias{as_Seurat}
\title{Convert an \code{AnnData} to a \code{Seurat}}
\usage{
as_Seurat(
  adata,
  assay_name = "RNA",
  x_mapping = NULL,
  layers_mapping = TRUE,
  object_metadata_mapping = TRUE,
  assay_metadata_mapping = TRUE,
  reduction_mapping = TRUE,
  graph_mapping = TRUE,
  misc_mapping = TRUE
)
}
\arguments{
\item{adata}{The \code{AnnData} object to convert.}

\item{assay_name}{Name of the assay to be created in the new \code{Seurat} object}

\item{x_mapping}{A string specifying the name of the layer in the resulting
\code{Seurat} object where the data in the \code{X} slot of \code{adata} will be mapped to}

\item{layers_mapping}{A named vector where names are names of \code{Layers} in the
resulting \code{Seurat} object and values are keys of \code{layers} in \code{adata}. See
below for details.}

\item{object_metadata_mapping}{A named vector where names are cell metadata
columns in the resulting \code{Seurat} object and values are columns of \code{obs} in
\code{adata}. See below for details.}

\item{assay_metadata_mapping}{A named vector where names are variable
metadata columns in the assay of the resulting \code{Seurat} object and values
are columns of \code{var} in \code{adata}. See below for details.}

\item{reduction_mapping}{A named vector where names are names of \code{Embeddings}
in the resulting \code{Seurat} object and values are keys of \code{obsm} in \code{adata}.
Alternatively, a named list where names are names of \code{Embeddings} in the
resulting \code{Seurat} object and values are vectors with the items \code{"key"},
\code{"embeddings"} and (optionally) \code{"loadings"}. See below for details.}

\item{graph_mapping}{A named vector where names are names of \code{Graphs} in the
resulting \code{Seurat} object and values are keys of \code{obsp} in \code{adata}. See
below for details.}

\item{misc_mapping}{A named vector where names are names of \code{Misc} in the
resulting \code{Seurat} object and values are keys of \code{uns} in \code{adata}. See
below for details.}
}
\value{
A \code{Seurat} object containing the requested data from \code{adata}
}
\description{
Convert an \code{AnnData} object to a \code{Seurat} object
}
\details{
\subsection{Mapping arguments}{

All mapping arguments expect a named character vector where names are the
names of the slot in the \code{Seurat} object and values are the keys of the
corresponding slot of \code{adata}. If \code{TRUE}, the conversion function will guess
which items to copy as described in the conversion table below. In most
cases, the default is to copy all items using the same names except where the
correspondence between objects is unclear. The \code{reduction_mapping} argument
can also accept a more complex list format, see below for details. To avoid
copying anything to a slot, set the mapping argument to \code{FALSE}. Empty
mapping arguments (\code{NULL}, \code{c()}, \code{list()}) will be treated as \code{FALSE} with
a warning. If an unnamed vector is provided, the values will be used as
names.
\subsection{Examples:}{
\itemize{
\item \code{TRUE} will guess which items to copy as described in the conversion
table
\item \code{c(seurat_item = "adata_item")} will copy \code{adata_item} from the slot in
\code{adata} to \code{seurat_item} in the corresponding slot of the new \code{Seurat}
object
\item \code{FALSE} will avoid copying anything to the slot
\item \code{c("adata_item")} is equivalent to \code{c(adata_item = "adata_item")}
}
}

}

\subsection{Conversion table}{\tabular{llll}{
   \strong{From \code{AnnData}} \tab \strong{To \code{Seurat}} \tab \strong{Example mapping argument} \tab \strong{Default} \cr
   \code{adata$X} \tab \code{Layers(seurat)} \tab \code{x_mapping = "counts"} \emph{OR} \code{layers_mapping = c(counts = NA)} \tab The data in \code{adata$X} is copied to a layer named \code{X} \cr
   \code{adata$layers} \tab \code{Layers(seurat)} \tab \code{layers_mapping = c(counts = "counts")} \tab All items are copied by name \cr
   \code{adata$obs} \tab \code{seurat[[]]} \tab \code{object_metadata_mapping = c(n_counts = "n_counts", cell_type = "CellType")} \tab All columns are copied by name \cr
   \code{adata$var} \tab \code{seurat[[assay_name]][[]]} \tab \code{assay_metadata_mapping = c(n_cells = "n_cells", pct_zero = "PctZero")} \tab All columns are copied by name \cr
   \code{adata$obsm} \tab \code{Reductions(seurat)} \tab \code{reduction_mapping = c(pca = "X_pca")} \strong{OR} \code{reduction_mapping = list(pca = c(key = "PC_", embeddings = "X_pca", loadings = "PCs"))} \tab All items that can be coerced to a numeric matrix are copied by name without loadings except for \code{"X_pca"} for which loadings are added from \code{"PCs"} \cr
   \code{adata$obsp} \tab \code{Graphs(seurat)} \tab \code{graph_mapping = c(nn = "connectivities")} \tab All items are copied by name \cr
   \code{adata$varp} \tab \emph{NA} \tab \emph{NA} \tab There is no corresponding slot for \code{varp} \cr
   \code{adata$uns} \tab \code{Misc(seurat)} \tab \code{misc_mapping = c(project_metadata = "metadata")} \tab All items are copied by name \cr
}

}

\subsection{The \code{reduction_mapping} argument}{

For the simpler named vector format, the names should be the names of
\code{Embeddings} in the resulting \code{Seurat} object, and the values
should be the keys of \code{obsm} in \code{adata}. A key will created from the \code{obsm}
key.

For more advanced mapping, use the list format where each item is a vector
with the following names defining arguments to
\code{\link[SeuratObject:CreateDimReducObject]{SeuratObject::CreateDimReducObject()}}:
\itemize{
\item \code{key}: the key of the resulting \code{\link[SeuratObject:DimReduc-class]{SeuratObject::DimReduc}} object, passed
to the \code{key} argument after processing with \code{\link[SeuratObject:Key]{SeuratObject::Key()}}
\item \code{embeddings}: a key of the \code{obsm} slot in \code{adata},
\code{adata$obsm[[embeddings]]} is passed to the \code{embeddings} argument
\item \code{loadings}: a key of the \code{varm} slot in \code{adata} (optional),
\code{adata$varm[[loadings]]} is passed to the \code{loadings} argument
}
}

\subsection{The \code{x_mapping} and \code{layers_mapping} arguments}{

In order to specify where the data in \code{adata$X} will be stored in the
\code{Layers(seurat)} slot of the resulting object, you can use either the \code{x_mapping}
argument or the \code{layers_mapping} argument.
If you use \code{x_mapping}, it should be a string specifying the name of the layer
in \code{Layers(seurat)} where the data in \code{adata$X} will be stored.
If you use \code{layers_mapping}, it should be a named vector where names are names
of \code{Layers(seurat)} and values are keys of \code{layers} in \code{adata}.
In order to indicate the \code{adata$X} slot, you use \code{NA} as the value in the vector.
The name you provide for \code{x_mapping} may not be a name in \code{layers_mapping}.
}
}
\examples{
\dontshow{if (rlang::is_installed("Seurat")) withAutoprint(\{ # examplesIf}
  ad <- AnnData(
    X = matrix(1:5, 3L, 5L),
    obs = data.frame(row.names = LETTERS[1:3], cell = 1:3),
    var = data.frame(row.names = letters[1:5], gene = 1:5)
  )

  # Default usage
  seurat <- ad$as_Seurat(
    assay_name = "RNA",
    x_mapping = "counts",
    layers_mapping = TRUE,
    object_metadata_mapping = TRUE,
    assay_metadata_mapping = TRUE,
    reduction_mapping = TRUE,
    graph_mapping = TRUE,
    misc_mapping = TRUE
  )
\dontshow{\}) # examplesIf}
}
\seealso{
Other object converters: 
\code{\link{as_AnnData}()},
\code{\link{as_HDF5AnnData}()},
\code{\link{as_InMemoryAnnData}()},
\code{\link{as_ReticulateAnnData}()},
\code{\link{as_SingleCellExperiment}()},
\code{\link{as_ZarrAnnData}()},
\code{\link{reticulate-helpers}}
}
\concept{object converters}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ZarrAnnData.R
\name{as_ZarrAnnData}
\alias{as_ZarrAnnData}
\title{Convert an \code{AnnData} to an \code{ZarrAnnData}}
\usage{
as_ZarrAnnData(
  adata,
  file,
  compression = c("none", "gzip", "blosc", "zstd", "lzma", "bz2", "zlib", "lz4"),
  mode = c("w-", "r", "r+", "a", "w", "x")
)
}
\arguments{
\item{adata}{An \code{AnnData} object to be converted to \code{\link{ZarrAnnData}}}

\item{file}{The file name (character) of the \code{.zarr} file}

\item{compression}{The compression algorithm to use when writing the
Zarr file. Can be one of \code{"none"}, \code{"gzip"}, \code{"blosc"}, \code{"zstd"},
\code{"lzma"}, \code{"bz2"}, \code{"zlib"} or \code{"lz4"}. Defaults to \code{"none"}.}

\item{mode}{The mode to open the Zarr file:
\itemize{
\item \code{a} creates a new file or opens an existing one for read/write
\item \code{r} opens an existing file for reading
\item \verb{r+} opens an existing file for read/write
\item \code{w} creates a file, truncating any existing ones
\item \verb{w-}/\code{x} are synonyms, creating a file and failing if it already exists
}}
}
\value{
A \code{\link{ZarrAnnData}} object with the same data as the input \code{AnnData}
object.
}
\description{
Convert another \code{AnnData} object to an \code{\link{ZarrAnnData}} object
}
\seealso{
Other object converters: 
\code{\link{as_AnnData}()},
\code{\link{as_HDF5AnnData}()},
\code{\link{as_InMemoryAnnData}()},
\code{\link{as_ReticulateAnnData}()},
\code{\link{as_Seurat}()},
\code{\link{as_SingleCellExperiment}()},
\code{\link{reticulate-helpers}}
}
\concept{object converters}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ReticulateAnnData.R
\name{ReticulateAnnData}
\alias{ReticulateAnnData}
\title{ReticulateAnnData}
\value{
A \code{ReticulateAnnData} object
}
\description{
Implementation of an \code{AnnData} object that wraps a Python \strong{anndata}
\code{AnnData} object using \pkg{reticulate}. This allows direct interaction with
Python \code{AnnData} objects while maintaining the R interface. It is useful when
you already have a Python \code{AnnData} or to access functionality that has not
yet been implemented in \pkg{anndataR}.

See \link{AnnData-usage} for details on creating and using \code{AnnData} objects.
}
\seealso{
\link{AnnData-usage} for details on creating and using \code{AnnData} objects

Other AnnData classes: 
\code{\link{AbstractAnnData}},
\code{\link{AnnDataView}},
\code{\link{HDF5AnnData}},
\code{\link{InMemoryAnnData}},
\code{\link{ZarrAnnData}}
}
\concept{AnnData classes}
\section{Super class}{
\code{\link[anndataR:AbstractAnnData]{anndataR::AbstractAnnData}} -> \code{ReticulateAnnData}
}
\section{Active bindings}{
\if{html}{\out{<div class="r6-active-bindings">}}
\describe{
\item{\code{X}}{See \link{AnnData-usage}}

\item{\code{layers}}{See \link{AnnData-usage}}

\item{\code{obs}}{See \link{AnnData-usage}}

\item{\code{var}}{See \link{AnnData-usage}}

\item{\code{obs_names}}{See \link{AnnData-usage}}

\item{\code{var_names}}{See \link{AnnData-usage}}

\item{\code{obsm}}{See \link{AnnData-usage}}

\item{\code{varm}}{See \link{AnnData-usage}}

\item{\code{obsp}}{See \link{AnnData-usage}}

\item{\code{varp}}{See \link{AnnData-usage}}

\item{\code{uns}}{See \link{AnnData-usage}}
}
\if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-ReticulateAnnData-new}{\code{ReticulateAnnData$new()}}
\item \href{#method-ReticulateAnnData-n_obs}{\code{ReticulateAnnData$n_obs()}}
\item \href{#method-ReticulateAnnData-n_vars}{\code{ReticulateAnnData$n_vars()}}
\item \href{#method-ReticulateAnnData-py_anndata}{\code{ReticulateAnnData$py_anndata()}}
}
}
\if{html}{\out{
<details><summary>Inherited methods</summary>
<ul>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_HDF5AnnData"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_HDF5AnnData'><code>anndataR::AbstractAnnData$as_HDF5AnnData()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_InMemoryAnnData"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_InMemoryAnnData'><code>anndataR::AbstractAnnData$as_InMemoryAnnData()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_ReticulateAnnData"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_ReticulateAnnData'><code>anndataR::AbstractAnnData$as_ReticulateAnnData()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_Seurat"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_Seurat'><code>anndataR::AbstractAnnData$as_Seurat()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_SingleCellExperiment"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_SingleCellExperiment'><code>anndataR::AbstractAnnData$as_SingleCellExperiment()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_ZarrAnnData"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_ZarrAnnData'><code>anndataR::AbstractAnnData$as_ZarrAnnData()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="layers_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-layers_keys'><code>anndataR::AbstractAnnData$layers_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="obs_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-obs_keys'><code>anndataR::AbstractAnnData$obs_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="obsm_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-obsm_keys'><code>anndataR::AbstractAnnData$obsm_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="obsp_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-obsp_keys'><code>anndataR::AbstractAnnData$obsp_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="print"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-print'><code>anndataR::AbstractAnnData$print()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="shape"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-shape'><code>anndataR::AbstractAnnData$shape()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="uns_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-uns_keys'><code>anndataR::AbstractAnnData$uns_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="var_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-var_keys'><code>anndataR::AbstractAnnData$var_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="varm_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-varm_keys'><code>anndataR::AbstractAnnData$varm_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="varp_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-varp_keys'><code>anndataR::AbstractAnnData$varp_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="write_h5ad"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-write_h5ad'><code>anndataR::AbstractAnnData$write_h5ad()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="write_zarr"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-write_zarr'><code>anndataR::AbstractAnnData$write_zarr()</code></a></span></li>
</ul>
</details>
}}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ReticulateAnnData-new"></a>}}
\if{latex}{\out{\hypertarget{method-ReticulateAnnData-new}{}}}
\subsection{Method \code{new()}}{
\code{ReticulateAnnData} constructor
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ReticulateAnnData$new(
  py_anndata = NULL,
  X = NULL,
  obs = NULL,
  var = NULL,
  layers = NULL,
  obsm = NULL,
  varm = NULL,
  obsp = NULL,
  varp = NULL,
  uns = NULL,
  shape = NULL
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{py_anndata}}{A Python AnnData object created using reticulate, or
NULL to create a new empty Python AnnData object}

\item{\code{X}}{See the \code{X} slot in \link{AnnData-usage} (only used if py_anndata is NULL)}

\item{\code{obs}}{See the \code{obs} slot in \link{AnnData-usage} (only used if py_anndata is NULL)}

\item{\code{var}}{See the \code{var} slot in \link{AnnData-usage} (only used if py_anndata is NULL)}

\item{\code{layers}}{See the \code{layers} slot in \link{AnnData-usage} (only used if py_anndata is NULL)}

\item{\code{obsm}}{See the \code{obsm} slot in \link{AnnData-usage} (only used if py_anndata is NULL)}

\item{\code{varm}}{See the \code{varm} slot in \link{AnnData-usage} (only used if py_anndata is NULL)}

\item{\code{obsp}}{See the \code{obsp} slot in \link{AnnData-usage} (only used if py_anndata is NULL)}

\item{\code{varp}}{See the \code{varp} slot in \link{AnnData-usage} (only used if py_anndata is NULL)}

\item{\code{uns}}{See the \code{uns} slot in \link{AnnData-usage} (only used if py_anndata is NULL)}

\item{\code{shape}}{Shape tuple (e.g. \code{c(n_obs, n_vars)}). Can be provided if
both \code{X} or \code{obs} and \code{var} are not provided. (only used if py_anndata is NULL)}
}
\if{html}{\out{</div>}}
}
\subsection{Details}{
The constructor creates a new ReticulateAnnData interface object that
wraps a Python AnnData object. If \code{py_anndata} is provided, it must be
a valid Python AnnData object. If NULL, a new Python AnnData object
will be created using the other provided arguments.
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ReticulateAnnData-n_obs"></a>}}
\if{latex}{\out{\hypertarget{method-ReticulateAnnData-n_obs}{}}}
\subsection{Method \code{n_obs()}}{
See the \code{n_obs} field in \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ReticulateAnnData$n_obs()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ReticulateAnnData-n_vars"></a>}}
\if{latex}{\out{\hypertarget{method-ReticulateAnnData-n_vars}{}}}
\subsection{Method \code{n_vars()}}{
See the \code{n_vars} field in \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ReticulateAnnData$n_vars()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ReticulateAnnData-py_anndata"></a>}}
\if{latex}{\out{\hypertarget{method-ReticulateAnnData-py_anndata}{}}}
\subsection{Method \code{py_anndata()}}{
Get the underlying Python AnnData object
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ReticulateAnnData$py_anndata()}\if{html}{\out{</div>}}
}

\subsection{Returns}{
The Python AnnData object wrapped by this ReticulateAnnData
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/anndataR-package.R
\docType{package}
\name{anndataR-package}
\alias{anndataR}
\alias{anndataR-package}
\title{anndataR: AnnData interoperability in R}
\description{
\if{html}{\figure{logo.png}{options: style='float: right' alt='logo' width='120'}}

Bring the power and flexibility of AnnData to the R ecosystem, allowing you to effortlessly manipulate and analyse your single-cell data. This package lets you work with backed h5ad and zarr files, directly access various slots (e.g. X, obs, var), or convert the data into SingleCellExperiment and Seurat objects.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://anndataR.scverse.org/}
  \item \url{https://github.com/scverse/anndataR}
  \item Report bugs at \url{https://github.com/scverse/anndataR/issues}
}

}
\author{
\strong{Maintainer}: Robrecht Cannoodt \email{rcannood@gmail.com} (\href{https://orcid.org/0000-0003-3641-729X}{ORCID}) (rcannood)

Authors:
\itemize{
  \item Luke Zappia \email{luke@lazappi.id.au} (\href{https://orcid.org/0000-0001-7744-8565}{ORCID}) (lazappi)
  \item Martin Morgan \email{mtmorgan.bioc@gmail.com} (\href{https://orcid.org/0000-0002-5874-8148}{ORCID}) (mtmorgan)
  \item Louise Deconinck \email{louise.deconinck@gmail.com} (\href{https://orcid.org/0000-0001-8100-6823}{ORCID}) (LouiseDck)
}

Other contributors:
\itemize{
  \item Danila Bredikhin \email{danila.bredikhin@embl.de} (\href{https://orcid.org/0000-0001-8089-6983}{ORCID}) (gtca) [contributor]
  \item Isaac Virshup (\href{https://orcid.org/0000-0002-1710-8945}{ORCID}) (ivirshup) [contributor]
  \item Brian Schilder \email{brian_schilder@alumni.brown.edu} (\href{https://orcid.org/0000-0001-5949-2191}{ORCID}) (bschilder) [contributor]
  \item Chananchida Sang-aram (\href{https://orcid.org/0000-0002-0922-0822}{ORCID}) (csangara) [contributor]
  \item Artür Manukyan (\href{https://orcid.org/0000-0002-0441-9517}{ORCID}) (Artur-man) [contributor]
  \item Hugo Gruson (\href{https://orcid.org/0000-0002-4094-1476}{ORCID}) (Bisaloo) [contributor]
  \item Data Intuitive \email{info@data-intuitive.com} [funder]
  \item Chan Zuckerberg Initiative [funder]
  \item scverse consortium [sponsor]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/as_SingleCellExperiment.R
\name{as_SingleCellExperiment}
\alias{as_SingleCellExperiment}
\title{Convert an \code{AnnData} to a \code{SingleCellExperiment}}
\usage{
as_SingleCellExperiment(
  adata,
  x_mapping = NULL,
  assays_mapping = TRUE,
  colData_mapping = TRUE,
  rowData_mapping = TRUE,
  reducedDims_mapping = TRUE,
  colPairs_mapping = TRUE,
  rowPairs_mapping = TRUE,
  metadata_mapping = TRUE
)
}
\arguments{
\item{adata}{The \code{AnnData} object to convert}

\item{x_mapping}{A string specifying the name of the assay in the resulting
\code{SingleCellExperiment} where the data in the \code{X} slot of \code{adata} will be
mapped to}

\item{assays_mapping}{A named vector where names are names of \code{assays} in the
resulting \code{SingleCellExperiment} object and values are keys of \code{layers} in
\code{adata}. See below for details.}

\item{colData_mapping}{A named vector where names are columns of \code{colData} in
the resulting \code{SingleCellExperiment} object and values are columns of \code{obs}
in \code{adata}. See below for details.}

\item{rowData_mapping}{A named vector where names are columns of \code{rowData} in
the resulting \code{SingleCellExperiment} object and values are columns of \code{var}
in \code{adata}. See below for details.}

\item{reducedDims_mapping}{A named vector where names are names of
\code{reducedDims} in the resulting \code{SingleCellExperiment} object and values are
keys of \code{obsm} in \code{adata}. Alternatively, a named list where names are
names of \code{reducedDims} in the resulting \code{SingleCellExperiment} object and
values are vectors with the items \code{"sampleFactors"} and \code{"featureLoadings"}
and/or \code{"metadata"}. See below for details.}

\item{colPairs_mapping}{A named vector where names are names of \code{colPairs} in
the resulting \code{SingleCellExperiment} object and values are keys of \code{obsp}
in \code{adata}. See below for details.}

\item{rowPairs_mapping}{A named vector where names are names of \code{rowPairs} in
the resulting \code{SingleCellExperiment} object and values are keys of \code{varp}
in \code{adata}. See below for details.}

\item{metadata_mapping}{A named vector where names are names of \code{metadata} in
the resulting \code{SingleCellExperiment} object and values are keys of \code{uns} in
\code{adata}. See below for details.}
}
\value{
A \code{SingleCellExperiment} object containing the requested data from
\code{adata}
}
\description{
Convert an \code{AnnData} object to a \code{SingleCellExperiment} object
}
\details{
\subsection{Mapping arguments}{

All mapping arguments expect a named character vector where names are the
names of the slot in the \code{SingleCellExperiment} object and values are the
keys of the corresponding slot of \code{adata}. If \code{TRUE}, the conversion function
will guess which items to copy as described in the conversion tables below.
In most cases, the default is to copy all items using the same names except
where the correspondence between objects is unclear. The
\code{reducedDims_mapping} argument can also accept a more complex list format,
see below for details. To avoid copying anything to a slot, set the mapping
argument to \code{FALSE}. Empty mapping arguments (\code{NULL}, \code{c()}, \code{list()}) will
be treated as \code{FALSE} with a warning. If an unnamed vector is provided, the
values will be used as names.
\subsection{Examples:}{
\itemize{
\item \code{TRUE} will guess which items to copy as described in the conversion
table
\item \code{c(sce_item = "adata_item")} will copy \code{adata_item} from the slot in
\code{adata} to \code{sce_item} in the corresponding slot of the new
\code{SingleCellExperiment} object
\item \code{FALSE} will avoid copying anything to the slot
\item \code{c("adata_item")} is equivalent to \code{c(adata_item = "adata_item")}
}
}

}

\subsection{Conversion table}{\tabular{llll}{
   \strong{From \code{AnnData}} \tab \strong{To \code{SingleCellExperiment}} \tab \strong{Example mapping argument} \tab \strong{Default} \cr
   \code{adata$X} \tab \code{assays(sce)} \tab \code{x_mapping = "counts"} \tab The data in \code{adata$X} is copied to the assay named \code{X} \cr
   \code{adata$layers} \tab \code{assays(sce)} \tab \code{assays_mapping = c(counts = "counts")} \tab All items are copied by name \cr
   \code{adata$obs} \tab \code{colData(sce)} \tab \code{colData_mapping = c(n_counts = "n_counts", cell_type = "CellType")} \tab All columns are copied by name \cr
   \code{adata$var} \tab \code{rowData(sce)} \tab \code{rowData_mapping = c(n_cells = "n_cells", pct_zero = "PctZero")} \tab All columns are copied by name \cr
   \code{adata$obsm} \tab \code{reducedDims(sce)} \tab \code{reducedDims_mapping = c(pca = "X_pca")} \strong{OR} \code{reducedDims_mapping = list(pca = c(sampleFactors = "X_pca", featureLoadings = "PCs", metadata = "pca_metadata"))} \tab All items are copied by name without loadings except for \code{"X_pca"} for which loadings are added from \code{"PCs"} \cr
   \code{adata$obsp} \tab \code{colPairs(sce)} \tab \code{colPairs_mapping = c(nn = "connectivities")} \tab All items are copied by name \cr
   \code{adata$varp} \tab \code{rowPairs(sce)} \tab \code{rowPairs_mapping = c(gene_overlaps = "similarities")} \tab All items are copied by name \cr
   \code{adata$uns} \tab \code{metadata(sce)} \tab \code{uns_mapping = c(project_metadata = "metadata")} \tab All items are copied by name \cr
}

}

\subsection{The \code{reducedDims_mapping} argument}{

For the simpler named vector format, the names should be the names of
\code{reducedDims} in the resulting \code{SingleCellExperiment} object, and the values
should be the keys of \code{obsm} in \code{adata}.

For more advanced mapping, use the list format where each item is a vector
with the following names used to create a
\code{\link[SingleCellExperiment:LinearEmbeddingMatrix]{SingleCellExperiment::LinearEmbeddingMatrix}} (if \code{featureLoadings} or
\code{metadata} is provided):
\itemize{
\item \code{sampleFactors}: a key of the \code{obsm} slot in \code{adata},
\code{adata$obsm[[sampleFactors]]} is passed to the \code{sampleFactors} argument
\item \code{featureLoadings}: a key of the \code{varm} slot in \code{adata} (optional),
\code{adata$varm[[featureLoadings]]} is passed to the \code{featureLoadings} argument
\item \code{metadata}: a key of the \code{uns} slot in \code{adata} (optional),
\code{adata$uns[[metadata]]} is passed to the \code{metadata} argument
}
}

\subsection{The \code{x_mapping} and \code{assays_mapping} arguments}{

In order to specify where the data in \code{adata$X} will be stored in the
\code{assays(sce)} slot of the resulting object, you can use either the
\code{x_mapping} argument or the \code{assays_mapping} argument.
If you use \code{x_mapping}, it should be a string specifying the name of the
layer in \code{assays(sce)} where the data in \code{adata$X} will be stored.
If you use \code{assays_mapping}, it should be a named vector where names are
names of \code{assays(sce)} and values are keys of \code{layers} in \code{adata}.
In order to indicate the \code{adata$X} slot, you use \code{NA} as the value in the
vector. The name you provide for \code{x_mapping} may not be a name in
\code{assays_mapping}.
}
}
\examples{
\dontshow{if (rlang::is_installed("SingleCellExperiment")) withAutoprint(\{ # examplesIf}
  ad <- AnnData(
    X = matrix(1:5, 3L, 5L),
    layers = list(A = matrix(5:1, 3L, 5L), B = matrix(letters[1:5], 3L, 5L)),
    obs = data.frame(row.names = LETTERS[1:3], cell = 1:3),
    var = data.frame(row.names = letters[1:5], gene = 1:5)
  )

  # Default usage
  sce <- ad$as_SingleCellExperiment(
    assays_mapping = TRUE,
    colData_mapping = TRUE,
    rowData_mapping = TRUE,
    reducedDims_mapping = TRUE,
    colPairs_mapping = TRUE,
    rowPairs_mapping = TRUE,
    metadata_mapping = TRUE
 )
\dontshow{\}) # examplesIf}
}
\seealso{
Other object converters: 
\code{\link{as_AnnData}()},
\code{\link{as_HDF5AnnData}()},
\code{\link{as_InMemoryAnnData}()},
\code{\link{as_ReticulateAnnData}()},
\code{\link{as_Seurat}()},
\code{\link{as_ZarrAnnData}()},
\code{\link{reticulate-helpers}}
}
\concept{object converters}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/as_AnnData.R
\name{as_AnnData}
\alias{as_AnnData}
\alias{as_AnnData.SingleCellExperiment}
\alias{as_AnnData.Seurat}
\title{Convert to an \code{AnnData} object}
\usage{
as_AnnData(
  x,
  x_mapping = NULL,
  layers_mapping = TRUE,
  obs_mapping = TRUE,
  var_mapping = TRUE,
  obsm_mapping = TRUE,
  varm_mapping = TRUE,
  obsp_mapping = TRUE,
  varp_mapping = TRUE,
  uns_mapping = TRUE,
  assay_name = NULL,
  output_class = c("InMemory", "HDF5AnnData", "ZarrAnnData", "ReticulateAnnData"),
  ...
)

\method{as_AnnData}{SingleCellExperiment}(
  x,
  x_mapping = NULL,
  layers_mapping = TRUE,
  obs_mapping = TRUE,
  var_mapping = TRUE,
  obsm_mapping = TRUE,
  varm_mapping = TRUE,
  obsp_mapping = TRUE,
  varp_mapping = TRUE,
  uns_mapping = TRUE,
  assay_name = TRUE,
  output_class = c("InMemory", "HDF5AnnData", "ZarrAnnData", "ReticulateAnnData"),
  ...
)

\method{as_AnnData}{Seurat}(
  x,
  x_mapping = NULL,
  layers_mapping = TRUE,
  obs_mapping = TRUE,
  var_mapping = TRUE,
  obsm_mapping = TRUE,
  varm_mapping = TRUE,
  obsp_mapping = TRUE,
  varp_mapping = TRUE,
  uns_mapping = TRUE,
  assay_name = NULL,
  output_class = c("InMemory", "HDF5AnnData", "ZarrAnnData", "ReticulateAnnData"),
  ...
)
}
\arguments{
\item{x}{The object to convert}

\item{x_mapping}{A string specifying the data to map to the \code{X} slot. If
\code{NULL}, no data will be copied to the \code{X} slot. See below for details.}

\item{layers_mapping}{A named character vector where the names are keys of
\code{layers} in the new \code{AnnData} object and values are the names of items in
the corresponding slot of \code{x}. See below for details.}

\item{obs_mapping}{A named character vector where the names are names of
\code{obs} columns in the new \code{AnnData} object and values are the names of
columns in the corresponding slot of \code{x}. See below for details.}

\item{var_mapping}{A named character vector where the names are names of
\code{var} columns in the new \code{AnnData} object and values are the names of
columns in the corresponding slot of \code{x}. See below for details.}

\item{obsm_mapping}{A named character vector where the names are keys of
\code{obsm} in the new \code{AnnData} object and values are the names of items in the
corresponding slot of \code{x}. See below for details.}

\item{varm_mapping}{A named character vector where the names are keys of
\code{varm} in the new \code{AnnData} object and values are the names of items in the
corresponding slot of \code{x}. See below for details.}

\item{obsp_mapping}{A named character vector where the names are keys of
\code{obsp} in the new \code{AnnData} object and values are the names of items in the
corresponding slot of \code{x}. See below for details.}

\item{varp_mapping}{A named character vector where the names are keys of
\code{varp} in the new \code{AnnData} object and values are the names of items in the
corresponding slot of \code{x}. See below for details.}

\item{uns_mapping}{A named character vector where the names are keys of \code{uns}
in the new \code{AnnData} object and values are the names of items in the
corresponding slot of \code{x}. See below for details.}

\item{assay_name}{For \code{\link[SeuratObject:Seurat-class]{SeuratObject::Seurat}} objects, the name of the assay
to be converted. If \code{NULL}, the default assay will be used
(\code{\link[SeuratObject:DefaultAssay]{SeuratObject::DefaultAssay()}}). This is ignored for other objects.}

\item{output_class}{The \code{AnnData} class to convert to. Must be one of
\code{"HDF5AnnData"} or \code{"InMemoryAnnData"}.}

\item{...}{Additional arguments passed to the generator function for
\code{output_class}}
}
\value{
An \code{AnnData} object of the class requested by \code{output_class}
containing the data specified in the mapping arguments.
}
\description{
Convert other objects to an \code{AnnData} object. See the sections below for
details on how slots are mapped between objects. For more information on the
functionality of an \code{AnnData} object, see \link{AnnData-usage}.
}
\section{Details of mapping arguments}{


All mapping arguments except for \code{x_mapping} expect a named character
vector where names are the keys of the slot in the \code{AnnData} object and
values are the names of items in the corresponding slot of \code{x}. If \code{TRUE},
the conversion function will guess which items to copy as described in the
conversion tables for each object type. In most cases, the default is to
copy all items using the same names except where the correspondence between
objects is unclear. To avoid copying anything to a slot, set the mapping
argument to \code{FALSE}. Empty mapping arguments (\code{NULL}, \code{c()}, \code{list()}) will
be treated as \code{FALSE} with a warning. If an unnamed vector is provided, the
values will be used as names.
\itemize{
\item \code{TRUE} will guess which items to copy as described in the conversion
tables for each object type
\item \code{c(adata_item = "x_item")} will copy \code{x_item} from the slot in \code{x} to
\code{adata_item} in the corresponding slot of new \code{AnnData} object
\item \code{FALSE} will avoid copying anything to the slot
\item \code{c("x_item")} is equivalent to \code{c(x_item = "x_item")}
}
}

\section{Converting from a \code{SingleCellExperiment} object}{


This table describes how slots in a
\code{\link[SingleCellExperiment:SingleCellExperiment]{SingleCellExperiment::SingleCellExperiment}} object to the new \code{AnnData}
object.\tabular{llll}{
   \strong{From \code{SingleCellExperiment}} \tab \strong{To \code{AnnData}} \tab \strong{Example mapping argument} \tab \strong{Default} \cr
   \code{assays(x)} \tab \code{adata$X} \tab \code{x_mapping = "counts"} \tab Nothing is copied to \code{X} \cr
   \code{assays(x)} \tab \code{adata$layers} \tab \code{layers_mapping = c(counts = "counts")} \tab All items are copied by name \cr
   \code{colData(x)} \tab \code{adata$obs} \tab \code{obs_mapping = c(n_counts = "n_counts", cell_type = "CellType")} \tab All columns are copied by name \cr
   \code{rowData(x)} \tab \code{adata$var} \tab \code{var_mapping = c(n_cells = "n_cells", pct_zero = "PctZero")} \tab All columns are copied by name \cr
   \code{reducedDims(x)} \tab \code{adata$obsm} \tab \code{obsm_mapping = c(X_pca = "pca")} \tab All items are copied by name \cr
   \code{featureLoadings(reducedDims(x))} \tab \code{adata$varm} \tab \code{varm_mapping = c(PCs = "pca")} \tab Feature loadings from all \code{\link[SingleCellExperiment:LinearEmbeddingMatrix]{SingleCellExperiment::LinearEmbeddingMatrix}} objects in \code{reducedDims(x)} \cr
   \code{colPairs(x)} \tab \code{adata$obsp} \tab \code{obsp_mapping = c(connectivities = "RNA_nn")} \tab All items are copied by name \cr
   \code{rowPairs(x)} \tab \code{adata$varp} \tab \code{varp_mapping = c(similarities = "gene_overlaps")} \tab All items are copied by name \cr
   \code{metadata(x)} \tab \code{adata$uns} \tab \code{uns_mapping = c(metadata = "project_metadata")} \tab All items are copied by name \cr
}

\subsection{Unnamed assays}{

If \code{assayNames(x)} is \code{NULL} or any assay names are empty they will
automatically be named with a warning:

\strong{Examples:}
\itemize{
\item Old names: \code{NULL} -> New names: \verb{"assay1", "assay2", ...}
\item Old names: \code{"counts"} -> New names: \verb{"counts", "assay2"}
}
}
}

\section{Converting from a \code{Seurat} object}{


Only one assay can be converted from a \code{\link[SeuratObject:Seurat-class]{SeuratObject::Seurat}} object to
an \code{AnnData} object at a time. This can be controlled using the
\code{assay_name} argument. By default, the current default assay will be used.

This table describes how slots in a \code{\link[SeuratObject:Seurat-class]{SeuratObject::Seurat}} object to the
new \code{AnnData} object.\tabular{llll}{
   \strong{From \code{Seurat}} \tab \strong{To \code{AnnData}} \tab \strong{Example mapping argument} \tab \strong{Default} \cr
   \code{Layers(x)} \tab \code{adata$X} \tab \code{x_mapping = "counts"} \tab Nothing is copied to \code{X} \cr
   \code{Layers(x)} \tab \code{adata$layers} \tab \code{layers_mapping = c(counts = "counts")} \tab All items are copied by name \cr
   \code{x[[]]} \tab \code{adata$obs} \tab \code{obs_mapping = c(n_counts = "n_counts", cell_type = "CellType")} \tab All columns are copied by name \cr
   \code{x[[assay_name]][[]]} \tab \code{adata$var} \tab \code{var_mapping = c(n_cells = "n_cells", pct_zero = "PctZero")} \tab All columns are copied by name \cr
   \code{Reductions(x)} \tab \code{adata$obsm} \tab \code{obsm_mapping = c(X_pca = "pca")} \tab All embeddings matching \code{assay_name} are copied by name \cr
   \code{Loadings(x)} \tab \code{adata$varm} \tab \code{varm_mapping = c(PCs = "pca")} \tab All valid loadings are copied by name \cr
   \code{Graphs(x)} \tab \code{adata$obsp} \tab \code{obsp_mapping = c(connectivities = "RNA_nn")} \tab All graphs matching \code{assay_name} are copied by name \cr
   \code{Misc(x)} \tab \code{adata$varp} \tab \code{varp_mapping = c(similarities = "gene_overlaps")} \tab No data is copied to \code{varp} \cr
   \code{Misc(x)} \tab \code{adata$uns} \tab \code{uns_mapping = c(metadata = "project_metadata")} \tab All items are copied by name \cr
}

\subsection{Graph conversion}{

By default, all graphs in a \code{\link[SeuratObject:Seurat-class]{SeuratObject::Seurat}} object that match the
assay being converted are copied to the \code{obsp} slot of the new \code{AnnData}
object. If a graph does not have an associated assay:
\itemize{
\item If \code{assay_name} is the default assay, they will be \emph{converted} with a
warning
\item if \code{assay_name} is not the default assay, they will be \emph{skipped} with a
warning
}

To override this behaviour, provide a custom mapping using the
\code{obsp_mapping} argument.
}

\subsection{Unexpected dimensions}{

A \code{\link[SeuratObject:Seurat-class]{SeuratObject::Seurat}} is more flexible in terms of the dimensions of
items that can be stored in various slots. For example, a \code{Layer} does not
have to match the dimensions of the whole object. If an item has
unexpected dimensions, it will be skipped with a warning.
}
}

\examples{
\dontshow{if (rlang::is_installed("Seurat")) withAutoprint(\{ # examplesIf}
# Convert a Seurat object to an AnnData object
library(Seurat)

counts <- matrix(rbinom(20000, 1000, .001), nrow = 100)
obj <- CreateSeuratObject(counts = counts)
obj <- NormalizeData(obj)
obj <- FindVariableFeatures(obj)
obj <- ScaleData(obj)
obj <- RunPCA(obj, npcs = 10L)
obj <- FindNeighbors(obj)
obj <- RunUMAP(obj, dims = 1:10)

as_AnnData(obj)
\dontshow{\}) # examplesIf}
\dontshow{if (rlang::is_installed("SingleCellExperiment")) withAutoprint(\{ # examplesIf}
# Convert a SingleCellExperiment object to an AnnData object
library(SingleCellExperiment)

sce <- SingleCellExperiment(
  assays = list(counts = matrix(1:5, 5L, 3L)),
  colData = DataFrame(cell = 1:3, row.names = paste0("Cell", 1:3)),
  rowData = DataFrame(gene = 1:5, row.names = paste0("Gene", 1:5))
)

as_AnnData(sce)
\dontshow{\}) # examplesIf}
}
\seealso{
Other AnnData creators: 
\code{\link{AnnData}()},
\code{\link{read_h5ad}()},
\code{\link{read_zarr}()}

Other object converters: 
\code{\link{as_HDF5AnnData}()},
\code{\link{as_InMemoryAnnData}()},
\code{\link{as_ReticulateAnnData}()},
\code{\link{as_Seurat}()},
\code{\link{as_SingleCellExperiment}()},
\code{\link{as_ZarrAnnData}()},
\code{\link{reticulate-helpers}}
}
\concept{AnnData creators}
\concept{object converters}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generate_dataset.R, R/generator_types.R
\name{generate_dataset}
\alias{generate_dataset}
\alias{get_generator_types}
\title{Generate a mock dataset}
\usage{
generate_dataset(
  n_obs = 10L,
  n_vars = 20L,
  x_type = "numeric_matrix",
  layer_types = get_generator_types(slot = "layers"),
  obs_types = get_generator_types(slot = "obs"),
  var_types = get_generator_types(slot = "var"),
  obsm_types = get_generator_types(slot = "obsm"),
  varm_types = get_generator_types(slot = "varm"),
  obsp_types = get_generator_types(slot = "obsp"),
  varp_types = get_generator_types(slot = "varp"),
  uns_types = get_generator_types(slot = "uns"),
  example = FALSE,
  format = c("list", "AnnData", "SingleCellExperiment", "Seurat")
)

get_generator_types(example = FALSE, slot = NULL)
}
\arguments{
\item{n_obs}{Number of observations to generate}

\item{n_vars}{Number of variables to generate}

\item{x_type}{Type of matrix to generate for \code{X}}

\item{layer_types}{Types of matrices to generate for \code{layers}}

\item{obs_types}{Types of vectors to generate for \code{obs}}

\item{var_types}{Types of vectors to generate for \code{var}}

\item{obsm_types}{Types of matrices to generate for \code{obsm}}

\item{varm_types}{Types of matrices to generate for \code{varm}}

\item{obsp_types}{Types of matrices to generate for \code{obsp}}

\item{varp_types}{Types of matrices to generate for \code{varp}}

\item{uns_types}{Types of objects to generate for \code{uns}}

\item{example}{If \code{TRUE}, the types will be overridden with a small subset of
types. This is useful for documentation.}

\item{format}{Object type to output, one of "list", "AnnData",
"SingleCellExperiment", or "Seurat".}

\item{slot}{Which slot to return types for, if \code{NULL} a named list of all
slots is returned}
}
\value{
For \code{generate_dataset()}, an object as defined by \code{output} containing
the generated dataset

For \code{get_generator_types()}, a named list of character vectors or a
single character vector if \code{slot} is not \code{NULL}
}
\description{
Generate a mock synthetic dataset with different types of columns and layers.
This is primarily designed for use in tests, examples, vignettes and other
documentation but is also provided to users for creating reproducible
examples.

Use \code{get_generator_types()} to get the available types for each slot.
}
\details{
To generate no data for a given slot, set the matching type argument to
\code{NULL} or an empty vector, e.g. \code{obs_types = c()} will generate an empty
\code{obs} data frame.

When generating \code{SingleCellExperiment} or \code{Seurat} objects, only some of the
generated slots will be included in the output object. To generate a more
complete object, use \code{format = "AnnData"} followed by
\code{adata$as_SingleCellExperiment()} or \code{adata$as_Seurat()}.

Use \code{get_generator_types()} to get a list of the available types for each
slot, or for a specific slot by setting \code{slot}. If \code{example = TRUE}, only the
example types are returned.
}
\examples{
# Generate all types as a list
dummy <- generate_dataset()

# Generate the example types
dummy_example <- generate_dataset(example = TRUE)

# Generate an AnnData
dummy_anndata <- generate_dataset(format = "AnnData", example = TRUE)

# Generate a SingleCellExperiment
if (rlang::is_installed("SingleCellExperiment")) {
  dummy_sce <- generate_dataset(format = "SingleCellExperiment", example = TRUE)
}

# Generate a Seurat object
if (rlang::is_installed("SeuratObject")) {
  dummy_seurat <- generate_dataset(format = "Seurat", example = TRUE)
}

# Get all available generator types
get_generator_types()

# Get generator types for a specific slot
get_generator_types(slot = "obs")

# Get generator types used when example = TRUE
get_generator_types(example = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AbstractAnnData-s3methods.R
\name{AbstractAnnData-s3methods}
\alias{AbstractAnnData-s3methods}
\alias{dim.AbstractAnnData}
\alias{nrow.AbstractAnnData}
\alias{ncol.AbstractAnnData}
\alias{dimnames.AbstractAnnData}
\alias{dimnames<-.AbstractAnnData}
\alias{[.AbstractAnnData}
\title{S3 Methods for AbstractAnnData Objects}
\usage{
\method{dim}{AbstractAnnData}(x)

\method{nrow}{AbstractAnnData}(x)

\method{ncol}{AbstractAnnData}(x)

\method{dimnames}{AbstractAnnData}(x)

\method{dimnames}{AbstractAnnData}(x) <- value

\method{[}{AbstractAnnData}(x, i, j, drop = TRUE, ...)
}
\arguments{
\item{x}{An AbstractAnnData object}

\item{value}{For \verb{dimnames<-}: A list of two character vectors (obs_names, var_names)}

\item{i}{Row indices (observations). Can be numeric, logical, or character.}

\item{j}{Column indices (variables). Can be numeric, logical, or character.}

\item{drop}{Ignored (for compatibility with generic)}

\item{...}{Additional arguments passed to methods}
}
\value{
\itemize{
\item \code{dim}: Numeric vector of length 2 (n_obs, n_vars)
\item \code{nrow}, \code{ncol}: Integer count
\item \code{dimnames}: List with obs_names and var_names
\item \code{rownames}, \code{colnames}: Character vector
\item \verb{dimnames<-}, \verb{rownames<-}, \verb{colnames<-}: The modified object (invisibly)
\item \code{[}: A AnnDataView object with the specified subset
}
}
\description{
These S3 methods provide standard R interfaces for AbstractAnnData objects,
making them behave like native R objects with familiar syntax.
}
\details{
\strong{Subsetting behaviour}: The \code{[} method supports logical, integer, and character
subsetting for both observations (rows) and variables (columns). However, unlike
standard R behaviour:
\itemize{
\item Logical vectors are \strong{not recycled} and must have the exact same length as
the dimension being subset
\item \strong{Negative indices are not supported} (R's "exclude these" syntax)
}

These design choices ensure clear and predictable subsetting behaviour for
biological data matrices, avoiding potential confusion from accidental recycling
or exclusion patterns.

The following S3 methods are available:
\itemize{
\item \code{dim(x)}: Get dimensions (n_obs, n_vars), equivalent to \code{x$shape()}
\item \code{nrow(x)}: Get number of observations, equivalent to \code{x$n_obs()}
\item \code{ncol(x)}: Get number of variables, equivalent to \code{x$n_vars()}
\item \code{dimnames(x)}: Get dimension names, (obs_names, var_names)
\item \code{rownames(x)}: Get observation names, equivalent to \code{x$obs_names()}
\item \code{colnames(x)}: Get variable names, equivalent to \code{x$var_names()}
\item \code{dimnames(x) <- value}: Set dimension names
\item \code{rownames(x) <- value}: Set observation names, equivalent to \code{x$obs_names() <- ...}
\item \code{colnames(x) <- value}: Set variable names, equivalent to \code{x$var_names() <- ...}
\item \code{x[i, j]}: Subset observations and/or variables
}
}
\examples{
# Create example data
ad <- generate_dataset(n_obs = 100, n_vars = 50, format = "AnnData")

# Standard R methods work
dim(ad)
nrow(ad)
ncol(ad)
dimnames(ad)
rownames(ad)
colnames(ad)

# Set names using dimnames
dimnames(ad) <- list(
  paste0("cell_", 1:nrow(ad)),
  paste0("gene_", 1:ncol(ad))
)

# Or set names individually (uses dimnames<- internally)
rownames(ad) <- paste0("cell_", 1:nrow(ad))
colnames(ad) <- paste0("gene_", 1:ncol(ad))

# Subsetting creates AnnDataView
subset_ad <- ad[1:10, 1:5]
subset_ad <- ad[rep(c(TRUE, FALSE), length.out = nrow(ad)), ]  # logical subsetting (no recycling)
subset_ad <- ad[c("cell_1", "cell_2"), c("gene_1", "gene_2")]  # name subsetting
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HDF5AnnData.R
\name{as_HDF5AnnData}
\alias{as_HDF5AnnData}
\title{Convert an \code{AnnData} to an \code{HDF5AnnData}}
\usage{
as_HDF5AnnData(
  adata,
  file,
  compression = c("none", "gzip", "lzf"),
  chunk_size = "auto",
  mode = c("w-", "r", "r+", "a", "w", "x")
)
}
\arguments{
\item{adata}{An \code{AnnData} object to be converted to \code{\link{HDF5AnnData}}}

\item{file}{The file name (character) of the \code{.h5ad} file}

\item{compression}{The compression algorithm to use when writing the
HDF5 file. Can be one of \code{"none"}, \code{"gzip"} or \code{"lzf"}. Defaults to
\code{"none"}.}

\item{chunk_size}{The target chunk size in bytes to use when writing
HDF5 datasets. When \code{"auto"} (default), the chunk size is determined
automatically using an algorithm that mimics h5py's auto-chunking
behaviour. Set to \code{NULL} to disable chunking (contiguous storage,
the rhdf5 default), or a number to use a specific target size in bytes.}

\item{mode}{The mode to open the HDF5 file:
\itemize{
\item \code{a} creates a new file or opens an existing one for read/write
\item \code{r} opens an existing file for reading
\item \verb{r+} opens an existing file for read/write
\item \code{w} creates a file, truncating any existing ones
\item \verb{w-}/\code{x} are synonyms, creating a file and failing if it already exists
}}
}
\value{
An \code{\link{HDF5AnnData}} object with the same data as the input \code{AnnData}
object.
}
\description{
Convert another \code{AnnData} object to an \code{\link{HDF5AnnData}} object
}
\seealso{
Other object converters: 
\code{\link{as_AnnData}()},
\code{\link{as_InMemoryAnnData}()},
\code{\link{as_ReticulateAnnData}()},
\code{\link{as_Seurat}()},
\code{\link{as_SingleCellExperiment}()},
\code{\link{as_ZarrAnnData}()},
\code{\link{reticulate-helpers}}
}
\concept{object converters}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ZarrAnnData.R
\name{ZarrAnnData}
\alias{ZarrAnnData}
\title{ZarrAnnData}
\value{
A \code{ZarrAnnData} object
}
\description{
Implementation of a Zarr-backed \code{AnnData} object. This class provides an
interface to a Zarr file and minimal data is stored in memory until it is
requested by the user. It is primarily designed as an intermediate object
when reading/writing Zarr files but can be useful for accessing parts of
large files.

See \link{AnnData-usage} for details on creating and using \code{AnnData} objects.
}
\seealso{
\link{AnnData-usage} for details on creating and using \code{AnnData} objects

Other AnnData classes: 
\code{\link{AbstractAnnData}},
\code{\link{AnnDataView}},
\code{\link{HDF5AnnData}},
\code{\link{InMemoryAnnData}},
\code{\link{ReticulateAnnData}}
}
\concept{AnnData classes}
\section{Super class}{
\code{\link[anndataR:AbstractAnnData]{anndataR::AbstractAnnData}} -> \code{ZarrAnnData}
}
\section{Active bindings}{
\if{html}{\out{<div class="r6-active-bindings">}}
\describe{
\item{\code{X}}{See \link{AnnData-usage}}

\item{\code{layers}}{See \link{AnnData-usage}}

\item{\code{obsm}}{See \link{AnnData-usage}}

\item{\code{varm}}{See \link{AnnData-usage}}

\item{\code{obsp}}{See \link{AnnData-usage}}

\item{\code{varp}}{See \link{AnnData-usage}}

\item{\code{obs}}{See \link{AnnData-usage}}

\item{\code{var}}{See \link{AnnData-usage}}

\item{\code{obs_names}}{See \link{AnnData-usage}}

\item{\code{var_names}}{See \link{AnnData-usage}}

\item{\code{uns}}{See \link{AnnData-usage}}
}
\if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-ZarrAnnData-new}{\code{ZarrAnnData$new()}}
\item \href{#method-ZarrAnnData-n_obs}{\code{ZarrAnnData$n_obs()}}
\item \href{#method-ZarrAnnData-n_vars}{\code{ZarrAnnData$n_vars()}}
\item \href{#method-ZarrAnnData-obs_keys}{\code{ZarrAnnData$obs_keys()}}
\item \href{#method-ZarrAnnData-var_keys}{\code{ZarrAnnData$var_keys()}}
\item \href{#method-ZarrAnnData-layers_keys}{\code{ZarrAnnData$layers_keys()}}
\item \href{#method-ZarrAnnData-obsm_keys}{\code{ZarrAnnData$obsm_keys()}}
\item \href{#method-ZarrAnnData-varm_keys}{\code{ZarrAnnData$varm_keys()}}
\item \href{#method-ZarrAnnData-obsp_keys}{\code{ZarrAnnData$obsp_keys()}}
\item \href{#method-ZarrAnnData-varp_keys}{\code{ZarrAnnData$varp_keys()}}
\item \href{#method-ZarrAnnData-uns_keys}{\code{ZarrAnnData$uns_keys()}}
}
}
\if{html}{\out{
<details><summary>Inherited methods</summary>
<ul>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_HDF5AnnData"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_HDF5AnnData'><code>anndataR::AbstractAnnData$as_HDF5AnnData()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_InMemoryAnnData"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_InMemoryAnnData'><code>anndataR::AbstractAnnData$as_InMemoryAnnData()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_ReticulateAnnData"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_ReticulateAnnData'><code>anndataR::AbstractAnnData$as_ReticulateAnnData()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_Seurat"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_Seurat'><code>anndataR::AbstractAnnData$as_Seurat()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_SingleCellExperiment"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_SingleCellExperiment'><code>anndataR::AbstractAnnData$as_SingleCellExperiment()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_ZarrAnnData"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_ZarrAnnData'><code>anndataR::AbstractAnnData$as_ZarrAnnData()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="print"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-print'><code>anndataR::AbstractAnnData$print()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="shape"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-shape'><code>anndataR::AbstractAnnData$shape()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="write_h5ad"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-write_h5ad'><code>anndataR::AbstractAnnData$write_h5ad()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="write_zarr"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-write_zarr'><code>anndataR::AbstractAnnData$write_zarr()</code></a></span></li>
</ul>
</details>
}}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ZarrAnnData-new"></a>}}
\if{latex}{\out{\hypertarget{method-ZarrAnnData-new}{}}}
\subsection{Method \code{new()}}{
\code{ZarrAnnData} constructor
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ZarrAnnData$new(
  file,
  X = NULL,
  obs = NULL,
  var = NULL,
  layers = NULL,
  obsm = NULL,
  varm = NULL,
  obsp = NULL,
  varp = NULL,
  uns = NULL,
  shape = NULL,
  mode = c("a", "r", "r+", "w", "w-", "x"),
  compression = c("none", "gzip", "blosc", "zstd", "lzma", "bz2", "zlib", "lz4")
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{file}}{The file name (character) of the \code{.zarr} file. If this file
already exits, other arguments must be \code{NULL}.}

\item{\code{X}}{See the \code{X} slot in \link{AnnData-usage}}

\item{\code{obs}}{See the \code{obs} slot in \link{AnnData-usage}}

\item{\code{var}}{See the \code{var} slot in \link{AnnData-usage}}

\item{\code{layers}}{See the \code{layers} slot in \link{AnnData-usage}}

\item{\code{obsm}}{See the \code{obsm} slot in \link{AnnData-usage}}

\item{\code{varm}}{See the \code{varm} slot in \link{AnnData-usage}}

\item{\code{obsp}}{See the \code{obsp} slot in \link{AnnData-usage}}

\item{\code{varp}}{See the \code{varp} slot in \link{AnnData-usage}}

\item{\code{uns}}{See the \code{uns} slot in \link{AnnData-usage}}

\item{\code{shape}}{Shape tuple (e.g. \code{c(n_obs, n_vars)}). Can be provided if
both \code{X} or \code{obs} and \code{var} are not provided.}

\item{\code{mode}}{The mode to open the Zarr file. See \code{\link[=as_ZarrAnnData]{as_ZarrAnnData()}} for
details}

\item{\code{compression}}{The compression algorithm to use. See
\code{\link[=as_ZarrAnnData]{as_ZarrAnnData()}} for details}
}
\if{html}{\out{</div>}}
}
\subsection{Details}{
The constructor creates a new Zarr \code{AnnData} interface object. This can
either be used to either connect to an existing \code{.zarr} file or to
create a new one. If any additional slot arguments are set an existing
file will be overwritten.
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ZarrAnnData-n_obs"></a>}}
\if{latex}{\out{\hypertarget{method-ZarrAnnData-n_obs}{}}}
\subsection{Method \code{n_obs()}}{
See the \code{n_obs} field in \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ZarrAnnData$n_obs()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ZarrAnnData-n_vars"></a>}}
\if{latex}{\out{\hypertarget{method-ZarrAnnData-n_vars}{}}}
\subsection{Method \code{n_vars()}}{
See the \code{n_vars} field in \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ZarrAnnData$n_vars()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ZarrAnnData-obs_keys"></a>}}
\if{latex}{\out{\hypertarget{method-ZarrAnnData-obs_keys}{}}}
\subsection{Method \code{obs_keys()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ZarrAnnData$obs_keys()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ZarrAnnData-var_keys"></a>}}
\if{latex}{\out{\hypertarget{method-ZarrAnnData-var_keys}{}}}
\subsection{Method \code{var_keys()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ZarrAnnData$var_keys()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ZarrAnnData-layers_keys"></a>}}
\if{latex}{\out{\hypertarget{method-ZarrAnnData-layers_keys}{}}}
\subsection{Method \code{layers_keys()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ZarrAnnData$layers_keys()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ZarrAnnData-obsm_keys"></a>}}
\if{latex}{\out{\hypertarget{method-ZarrAnnData-obsm_keys}{}}}
\subsection{Method \code{obsm_keys()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ZarrAnnData$obsm_keys()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ZarrAnnData-varm_keys"></a>}}
\if{latex}{\out{\hypertarget{method-ZarrAnnData-varm_keys}{}}}
\subsection{Method \code{varm_keys()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ZarrAnnData$varm_keys()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ZarrAnnData-obsp_keys"></a>}}
\if{latex}{\out{\hypertarget{method-ZarrAnnData-obsp_keys}{}}}
\subsection{Method \code{obsp_keys()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ZarrAnnData$obsp_keys()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ZarrAnnData-varp_keys"></a>}}
\if{latex}{\out{\hypertarget{method-ZarrAnnData-varp_keys}{}}}
\subsection{Method \code{varp_keys()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ZarrAnnData$varp_keys()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-ZarrAnnData-uns_keys"></a>}}
\if{latex}{\out{\hypertarget{method-ZarrAnnData-uns_keys}{}}}
\subsection{Method \code{uns_keys()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{ZarrAnnData$uns_keys()}\if{html}{\out{</div>}}
}

}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ReticulateAnnData.R
\name{as_ReticulateAnnData}
\alias{as_ReticulateAnnData}
\title{Convert an \code{AnnData} to a \code{ReticulateAnnData}}
\usage{
as_ReticulateAnnData(adata)
}
\arguments{
\item{adata}{An \code{AnnData} object to be converted to \code{\link{ReticulateAnnData}}}
}
\value{
A \code{\link{ReticulateAnnData}} object with the same data as the input
\code{AnnData} object
}
\description{
Convert another \code{AnnData} object to a \code{\link{ReticulateAnnData}} object
}
\examples{
\donttest{
# Requires Python anndata to be installed
if (requireNamespace("reticulate", quietly = TRUE) &&
      reticulate::py_module_available("anndata")) {
  ad <- AnnData(
    X = matrix(1:5, 3L, 5L),
    layers = list(
      A = matrix(5:1, 3L, 5L),
      B = matrix(letters[1:5], 3L, 5L)
    ),
    obs = data.frame(row.names = LETTERS[1:3], cell = 1:3),
    var = data.frame(row.names = letters[1:5], gene = 1:5)
  )
  ad$as_ReticulateAnnData()
}
}
}
\seealso{
Other object converters: 
\code{\link{as_AnnData}()},
\code{\link{as_HDF5AnnData}()},
\code{\link{as_InMemoryAnnData}()},
\code{\link{as_Seurat}()},
\code{\link{as_SingleCellExperiment}()},
\code{\link{as_ZarrAnnData}()},
\code{\link{reticulate-helpers}}
}
\concept{object converters}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AnnDataView.R
\name{AnnDataView}
\alias{AnnDataView}
\title{A View of an AnnData Object}
\value{
A \code{AnnDataView} object
}
\description{
A lazy view of an AnnData object that allows applying subsetting operations
without immediately executing them. Subsetting is applied when converting to
a concrete AnnData implementation (InMemoryAnnData, HDF5AnnData) or other
formats (SingleCellExperiment, Seurat).
}
\examples{
# Create a base AnnData object
ad <- AnnData(
  X = matrix(1:15, 3L, 5L),
  obs = data.frame(row.names = LETTERS[1:3], cell_type = c("A", "B", "A")),
  var = data.frame(row.names = letters[1:5], gene_type = c("X", "Y", "X", "Y", "Z"))
)

# Create a view with lazy subsetting using S3 [ method
view <- ad[ad$obs$cell_type == "A", ad$var$gene_type \%in\% c("X", "Y")]

# Apply subsetting by converting to a concrete implementation
result <- view$as_InMemoryAnnData()

}
\seealso{
\link{AnnData-usage} for details on creating and using \code{AnnData} objects

Other AnnData classes: 
\code{\link{AbstractAnnData}},
\code{\link{HDF5AnnData}},
\code{\link{InMemoryAnnData}},
\code{\link{ReticulateAnnData}},
\code{\link{ZarrAnnData}}
}
\concept{AnnData classes}
\section{Super class}{
\code{\link[anndataR:AbstractAnnData]{anndataR::AbstractAnnData}} -> \code{AnnDataView}
}
\section{Active bindings}{
\if{html}{\out{<div class="r6-active-bindings">}}
\describe{
\item{\code{X}}{See \link{AnnData-usage}}

\item{\code{layers}}{See \link{AnnData-usage}}

\item{\code{obs}}{See \link{AnnData-usage}}

\item{\code{var}}{See \link{AnnData-usage}}

\item{\code{obs_names}}{See \link{AnnData-usage}}

\item{\code{var_names}}{See \link{AnnData-usage}}

\item{\code{obsm}}{See \link{AnnData-usage}}

\item{\code{varm}}{See \link{AnnData-usage}}

\item{\code{obsp}}{See \link{AnnData-usage}}

\item{\code{varp}}{See \link{AnnData-usage}}

\item{\code{uns}}{See \link{AnnData-usage}}
}
\if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-AnnDataView-new}{\code{AnnDataView$new()}}
\item \href{#method-AnnDataView-subset}{\code{AnnDataView$subset()}}
\item \href{#method-AnnDataView-clone}{\code{AnnDataView$clone()}}
}
}
\if{html}{\out{
<details><summary>Inherited methods</summary>
<ul>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_HDF5AnnData"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_HDF5AnnData'><code>anndataR::AbstractAnnData$as_HDF5AnnData()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_InMemoryAnnData"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_InMemoryAnnData'><code>anndataR::AbstractAnnData$as_InMemoryAnnData()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_ReticulateAnnData"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_ReticulateAnnData'><code>anndataR::AbstractAnnData$as_ReticulateAnnData()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_Seurat"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_Seurat'><code>anndataR::AbstractAnnData$as_Seurat()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_SingleCellExperiment"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_SingleCellExperiment'><code>anndataR::AbstractAnnData$as_SingleCellExperiment()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_ZarrAnnData"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_ZarrAnnData'><code>anndataR::AbstractAnnData$as_ZarrAnnData()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="layers_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-layers_keys'><code>anndataR::AbstractAnnData$layers_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="n_obs"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-n_obs'><code>anndataR::AbstractAnnData$n_obs()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="n_vars"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-n_vars'><code>anndataR::AbstractAnnData$n_vars()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="obs_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-obs_keys'><code>anndataR::AbstractAnnData$obs_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="obsm_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-obsm_keys'><code>anndataR::AbstractAnnData$obsm_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="obsp_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-obsp_keys'><code>anndataR::AbstractAnnData$obsp_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="print"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-print'><code>anndataR::AbstractAnnData$print()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="shape"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-shape'><code>anndataR::AbstractAnnData$shape()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="uns_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-uns_keys'><code>anndataR::AbstractAnnData$uns_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="var_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-var_keys'><code>anndataR::AbstractAnnData$var_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="varm_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-varm_keys'><code>anndataR::AbstractAnnData$varm_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="varp_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-varp_keys'><code>anndataR::AbstractAnnData$varp_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="write_h5ad"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-write_h5ad'><code>anndataR::AbstractAnnData$write_h5ad()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="write_zarr"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-write_zarr'><code>anndataR::AbstractAnnData$write_zarr()</code></a></span></li>
</ul>
</details>
}}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AnnDataView-new"></a>}}
\if{latex}{\out{\hypertarget{method-AnnDataView-new}{}}}
\subsection{Method \code{new()}}{
Create a new AnnDataView object
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AnnDataView$new(base_adata, i, j)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{base_adata}}{An existing AnnData object to create a view of}

\item{\code{i}}{Optional initial obs subset (logical, integer, or character vector)}

\item{\code{j}}{Optional initial var subset (logical, integer, or character vector)}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A new \code{AnnDataView} object
Subset the AnnDataView
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AnnDataView-subset"></a>}}
\if{latex}{\out{\hypertarget{method-AnnDataView-subset}{}}}
\subsection{Method \code{subset()}}{
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AnnDataView$subset(i, j)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{i}}{Row indices (observations). Can be numeric, logical, or character.}

\item{\code{j}}{Column indices (variables). Can be numeric, logical, or character.}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A new \code{AnnDataView} object
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AnnDataView-clone"></a>}}
\if{latex}{\out{\hypertarget{method-AnnDataView-clone}{}}}
\subsection{Method \code{clone()}}{
The objects of this class are cloneable with this method.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AnnDataView$clone(deep = FALSE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{deep}}{Whether to make a deep clone.}
}
\if{html}{\out{</div>}}
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AbstractAnnData.R
\name{AbstractAnnData}
\alias{AbstractAnnData}
\title{Abstract AnnData class}
\value{
An \code{AbstractAnnData} object
}
\description{
This class is an abstract representation of an \code{AnnData} object. It is
intended to be used as a base class for concrete implementations of
\code{AnnData} objects, such as \link{InMemoryAnnData} or \link{HDF5AnnData}.

See \link{AnnData-usage} for details on creating and using \code{AnnData} objects.
}
\seealso{
\link{AnnData-usage} for details on creating and using \code{AnnData} objects

Other AnnData classes: 
\code{\link{AnnDataView}},
\code{\link{HDF5AnnData}},
\code{\link{InMemoryAnnData}},
\code{\link{ReticulateAnnData}},
\code{\link{ZarrAnnData}}
}
\concept{AnnData classes}
\section{Active bindings}{
\if{html}{\out{<div class="r6-active-bindings">}}
\describe{
\item{\code{X}}{See \link{AnnData-usage}}

\item{\code{layers}}{See \link{AnnData-usage}}

\item{\code{obs}}{See \link{AnnData-usage}}

\item{\code{var}}{See \link{AnnData-usage}}

\item{\code{obs_names}}{See \link{AnnData-usage}}

\item{\code{var_names}}{See \link{AnnData-usage}}

\item{\code{obsm}}{See \link{AnnData-usage}}

\item{\code{varm}}{See \link{AnnData-usage}}

\item{\code{obsp}}{See \link{AnnData-usage}}

\item{\code{varp}}{See \link{AnnData-usage}}

\item{\code{uns}}{See \link{AnnData-usage}}
}
\if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-AbstractAnnData-print}{\code{AbstractAnnData$print()}}
\item \href{#method-AbstractAnnData-shape}{\code{AbstractAnnData$shape()}}
\item \href{#method-AbstractAnnData-n_obs}{\code{AbstractAnnData$n_obs()}}
\item \href{#method-AbstractAnnData-n_vars}{\code{AbstractAnnData$n_vars()}}
\item \href{#method-AbstractAnnData-obs_keys}{\code{AbstractAnnData$obs_keys()}}
\item \href{#method-AbstractAnnData-var_keys}{\code{AbstractAnnData$var_keys()}}
\item \href{#method-AbstractAnnData-layers_keys}{\code{AbstractAnnData$layers_keys()}}
\item \href{#method-AbstractAnnData-obsm_keys}{\code{AbstractAnnData$obsm_keys()}}
\item \href{#method-AbstractAnnData-varm_keys}{\code{AbstractAnnData$varm_keys()}}
\item \href{#method-AbstractAnnData-obsp_keys}{\code{AbstractAnnData$obsp_keys()}}
\item \href{#method-AbstractAnnData-varp_keys}{\code{AbstractAnnData$varp_keys()}}
\item \href{#method-AbstractAnnData-uns_keys}{\code{AbstractAnnData$uns_keys()}}
\item \href{#method-AbstractAnnData-as_SingleCellExperiment}{\code{AbstractAnnData$as_SingleCellExperiment()}}
\item \href{#method-AbstractAnnData-as_Seurat}{\code{AbstractAnnData$as_Seurat()}}
\item \href{#method-AbstractAnnData-as_InMemoryAnnData}{\code{AbstractAnnData$as_InMemoryAnnData()}}
\item \href{#method-AbstractAnnData-as_ReticulateAnnData}{\code{AbstractAnnData$as_ReticulateAnnData()}}
\item \href{#method-AbstractAnnData-as_HDF5AnnData}{\code{AbstractAnnData$as_HDF5AnnData()}}
\item \href{#method-AbstractAnnData-as_ZarrAnnData}{\code{AbstractAnnData$as_ZarrAnnData()}}
\item \href{#method-AbstractAnnData-write_h5ad}{\code{AbstractAnnData$write_h5ad()}}
\item \href{#method-AbstractAnnData-write_zarr}{\code{AbstractAnnData$write_zarr()}}
\item \href{#method-AbstractAnnData-clone}{\code{AbstractAnnData$clone()}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-print"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-print}{}}}
\subsection{Method \code{print()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$print(...)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{...}}{Optional arguments to print method}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-shape"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-shape}{}}}
\subsection{Method \code{shape()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$shape()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-n_obs"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-n_obs}{}}}
\subsection{Method \code{n_obs()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$n_obs()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-n_vars"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-n_vars}{}}}
\subsection{Method \code{n_vars()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$n_vars()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-obs_keys"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-obs_keys}{}}}
\subsection{Method \code{obs_keys()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$obs_keys()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-var_keys"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-var_keys}{}}}
\subsection{Method \code{var_keys()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$var_keys()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-layers_keys"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-layers_keys}{}}}
\subsection{Method \code{layers_keys()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$layers_keys()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-obsm_keys"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-obsm_keys}{}}}
\subsection{Method \code{obsm_keys()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$obsm_keys()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-varm_keys"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-varm_keys}{}}}
\subsection{Method \code{varm_keys()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$varm_keys()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-obsp_keys"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-obsp_keys}{}}}
\subsection{Method \code{obsp_keys()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$obsp_keys()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-varp_keys"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-varp_keys}{}}}
\subsection{Method \code{varp_keys()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$varp_keys()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-uns_keys"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-uns_keys}{}}}
\subsection{Method \code{uns_keys()}}{
See \link{AnnData-usage}
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$uns_keys()}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-as_SingleCellExperiment"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-as_SingleCellExperiment}{}}}
\subsection{Method \code{as_SingleCellExperiment()}}{
Convert to \code{SingleCellExperiment}

See \code{\link[=as_SingleCellExperiment]{as_SingleCellExperiment()}} for more details on the conversion
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$as_SingleCellExperiment(
  x_mapping = NULL,
  assays_mapping = TRUE,
  colData_mapping = TRUE,
  rowData_mapping = TRUE,
  reducedDims_mapping = TRUE,
  colPairs_mapping = TRUE,
  rowPairs_mapping = TRUE,
  metadata_mapping = TRUE
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{x_mapping}}{See \code{\link[=as_SingleCellExperiment]{as_SingleCellExperiment()}}}

\item{\code{assays_mapping}}{See \code{\link[=as_SingleCellExperiment]{as_SingleCellExperiment()}}}

\item{\code{colData_mapping}}{See \code{\link[=as_SingleCellExperiment]{as_SingleCellExperiment()}}}

\item{\code{rowData_mapping}}{See \code{\link[=as_SingleCellExperiment]{as_SingleCellExperiment()}}}

\item{\code{reducedDims_mapping}}{See \code{\link[=as_SingleCellExperiment]{as_SingleCellExperiment()}}}

\item{\code{colPairs_mapping}}{See \code{\link[=as_SingleCellExperiment]{as_SingleCellExperiment()}}}

\item{\code{rowPairs_mapping}}{See \code{\link[=as_SingleCellExperiment]{as_SingleCellExperiment()}}}

\item{\code{metadata_mapping}}{See \code{\link[=as_SingleCellExperiment]{as_SingleCellExperiment()}}}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A \code{SingleCellExperiment} object
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-as_Seurat"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-as_Seurat}{}}}
\subsection{Method \code{as_Seurat()}}{
Convert to \code{Seurat}

See \code{\link[=as_Seurat]{as_Seurat()}} for more details on the conversion
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$as_Seurat(
  assay_name = "RNA",
  x_mapping = NULL,
  layers_mapping = TRUE,
  object_metadata_mapping = TRUE,
  assay_metadata_mapping = TRUE,
  reduction_mapping = TRUE,
  graph_mapping = TRUE,
  misc_mapping = TRUE
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{assay_name}}{See \code{\link[=as_Seurat]{as_Seurat()}}}

\item{\code{x_mapping}}{See \code{\link[=as_Seurat]{as_Seurat()}}}

\item{\code{layers_mapping}}{See \code{\link[=as_Seurat]{as_Seurat()}}}

\item{\code{object_metadata_mapping}}{See \code{\link[=as_Seurat]{as_Seurat()}}}

\item{\code{assay_metadata_mapping}}{See \code{\link[=as_Seurat]{as_Seurat()}}}

\item{\code{reduction_mapping}}{See \code{\link[=as_Seurat]{as_Seurat()}}}

\item{\code{graph_mapping}}{See \code{\link[=as_Seurat]{as_Seurat()}}}

\item{\code{misc_mapping}}{See \code{\link[=as_Seurat]{as_Seurat()}}}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A \code{Seurat} object
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-as_InMemoryAnnData"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-as_InMemoryAnnData}{}}}
\subsection{Method \code{as_InMemoryAnnData()}}{
Convert to an \code{\link{InMemoryAnnData}}

See \code{\link[=as_InMemoryAnnData]{as_InMemoryAnnData()}} for more details on the conversion
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$as_InMemoryAnnData()}\if{html}{\out{</div>}}
}

\subsection{Returns}{
An \link{InMemoryAnnData} object
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-as_ReticulateAnnData"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-as_ReticulateAnnData}{}}}
\subsection{Method \code{as_ReticulateAnnData()}}{
Convert to a \code{\link{ReticulateAnnData}}

See \code{\link[=as_ReticulateAnnData]{as_ReticulateAnnData()}} for more details on the conversion
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$as_ReticulateAnnData()}\if{html}{\out{</div>}}
}

\subsection{Returns}{
A \link{ReticulateAnnData} object
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-as_HDF5AnnData"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-as_HDF5AnnData}{}}}
\subsection{Method \code{as_HDF5AnnData()}}{
Convert to an \code{\link{HDF5AnnData}}

See \code{\link[=as_HDF5AnnData]{as_HDF5AnnData()}} for more details on the conversion
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$as_HDF5AnnData(
  file,
  compression = c("none", "gzip", "lzf"),
  chunk_size = "auto",
  mode = c("w-", "r", "r+", "a", "w", "x")
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{file}}{See \code{\link[=as_HDF5AnnData]{as_HDF5AnnData()}}}

\item{\code{compression}}{See \code{\link[=as_HDF5AnnData]{as_HDF5AnnData()}}}

\item{\code{chunk_size}}{See \code{\link[=as_HDF5AnnData]{as_HDF5AnnData()}}}

\item{\code{mode}}{See \code{\link[=as_HDF5AnnData]{as_HDF5AnnData()}}}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
An \code{\link{HDF5AnnData}} object
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-as_ZarrAnnData"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-as_ZarrAnnData}{}}}
\subsection{Method \code{as_ZarrAnnData()}}{
Convert to a \code{\link{ZarrAnnData}}

See \code{\link[=as_ZarrAnnData]{as_ZarrAnnData()}} for more details on the conversion
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$as_ZarrAnnData(
  file,
  compression = c("none", "gzip", "blosc", "zstd", "lzma", "bz2", "zlib", "lz4"),
  mode = c("w-", "r", "r+", "a", "w", "x")
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{file}}{See \code{\link[=as_ZarrAnnData]{as_ZarrAnnData()}}}

\item{\code{compression}}{See \code{\link[=as_ZarrAnnData]{as_ZarrAnnData()}}}

\item{\code{mode}}{See \code{\link[=as_ZarrAnnData]{as_ZarrAnnData()}}}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
A \code{\link{ZarrAnnData}} object
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-write_h5ad"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-write_h5ad}{}}}
\subsection{Method \code{write_h5ad()}}{
Write the \code{AnnData} object to an H5AD file

See \code{\link[=write_h5ad]{write_h5ad()}} for details
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$write_h5ad(
  path,
  compression = c("none", "gzip", "lzf"),
  chunk_size = "auto",
  mode = c("w-", "r", "r+", "a", "w", "x")
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{path}}{See \code{\link[=write_h5ad]{write_h5ad()}}}

\item{\code{compression}}{See \code{\link[=write_h5ad]{write_h5ad()}}}

\item{\code{chunk_size}}{See \code{\link[=write_h5ad]{write_h5ad()}}}

\item{\code{mode}}{See \code{\link[=write_h5ad]{write_h5ad()}}}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
\code{path} invisibly
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-write_zarr"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-write_zarr}{}}}
\subsection{Method \code{write_zarr()}}{
Write the \code{AnnData} object to a Zarr file

See \code{\link[=write_zarr]{write_zarr()}} for details
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$write_zarr(
  path,
  compression = c("none", "gzip", "blosc", "zstd", "lzma", "bz2", "zlib", "lz4"),
  mode = c("w-", "r", "r+", "a", "w", "x")
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{path}}{See \code{\link[=write_zarr]{write_zarr()}}}

\item{\code{compression}}{See \code{\link[=write_zarr]{write_zarr()}}}

\item{\code{mode}}{See \code{\link[=write_zarr]{write_zarr()}}}
}
\if{html}{\out{</div>}}
}
\subsection{Returns}{
\code{path} invisibly
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-AbstractAnnData-clone"></a>}}
\if{latex}{\out{\hypertarget{method-AbstractAnnData-clone}{}}}
\subsection{Method \code{clone()}}{
The objects of this class are cloneable with this method.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{AbstractAnnData$clone(deep = FALSE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{deep}}{Whether to make a deep clone.}
}
\if{html}{\out{</div>}}
}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/InMemoryAnnData.R
\name{InMemoryAnnData}
\alias{InMemoryAnnData}
\title{InMemoryAnnData}
\value{
An \code{InMemoryAnnData} object
}
\description{
Implementation of an in-memory \code{AnnData} object where data is stored within
the R session. This is the simplest back end and will be most familiar to
users. It is want you will want to use in most cases where you want to
interact with an \code{AnnData} object.

See \link{AnnData-usage} for details on creating and using \code{AnnData} objects.
}
\examples{
## complete example
ad <- AnnData(
  X = matrix(1:15, 3L, 5L),
  layers = list(
    A = matrix(5:1, 3L, 5L),
    B = matrix(letters[1:5], 3L, 5L)
  ),
  obs = data.frame(row.names = LETTERS[1:3], cell = 1:3),
  var = data.frame(row.names = letters[1:5], gene = 1:5)
)
ad

## minimum example
AnnData(
  obs = data.frame(row.names = letters[1:10]),
  var = data.frame(row.names = LETTERS[1:5])
)

}
\seealso{
\link{AnnData-usage} for details on creating and using \code{AnnData} objects

Other AnnData classes: 
\code{\link{AbstractAnnData}},
\code{\link{AnnDataView}},
\code{\link{HDF5AnnData}},
\code{\link{ReticulateAnnData}},
\code{\link{ZarrAnnData}}
}
\concept{AnnData classes}
\section{Super class}{
\code{\link[anndataR:AbstractAnnData]{anndataR::AbstractAnnData}} -> \code{InMemoryAnnData}
}
\section{Active bindings}{
\if{html}{\out{<div class="r6-active-bindings">}}
\describe{
\item{\code{X}}{See \link{AnnData-usage}}

\item{\code{layers}}{See \link{AnnData-usage}}

\item{\code{obs}}{See \link{AnnData-usage}}

\item{\code{var}}{See \link{AnnData-usage}}

\item{\code{obs_names}}{See \link{AnnData-usage}}

\item{\code{var_names}}{See \link{AnnData-usage}}

\item{\code{obsm}}{See \link{AnnData-usage}}

\item{\code{varm}}{See \link{AnnData-usage}}

\item{\code{obsp}}{See \link{AnnData-usage}}

\item{\code{varp}}{See \link{AnnData-usage}}

\item{\code{uns}}{See \link{AnnData-usage}}
}
\if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-InMemoryAnnData-new}{\code{InMemoryAnnData$new()}}
\item \href{#method-InMemoryAnnData-clone}{\code{InMemoryAnnData$clone()}}
}
}
\if{html}{\out{
<details><summary>Inherited methods</summary>
<ul>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_HDF5AnnData"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_HDF5AnnData'><code>anndataR::AbstractAnnData$as_HDF5AnnData()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_InMemoryAnnData"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_InMemoryAnnData'><code>anndataR::AbstractAnnData$as_InMemoryAnnData()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_ReticulateAnnData"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_ReticulateAnnData'><code>anndataR::AbstractAnnData$as_ReticulateAnnData()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_Seurat"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_Seurat'><code>anndataR::AbstractAnnData$as_Seurat()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_SingleCellExperiment"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_SingleCellExperiment'><code>anndataR::AbstractAnnData$as_SingleCellExperiment()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="as_ZarrAnnData"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-as_ZarrAnnData'><code>anndataR::AbstractAnnData$as_ZarrAnnData()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="layers_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-layers_keys'><code>anndataR::AbstractAnnData$layers_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="n_obs"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-n_obs'><code>anndataR::AbstractAnnData$n_obs()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="n_vars"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-n_vars'><code>anndataR::AbstractAnnData$n_vars()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="obs_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-obs_keys'><code>anndataR::AbstractAnnData$obs_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="obsm_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-obsm_keys'><code>anndataR::AbstractAnnData$obsm_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="obsp_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-obsp_keys'><code>anndataR::AbstractAnnData$obsp_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="print"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-print'><code>anndataR::AbstractAnnData$print()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="shape"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-shape'><code>anndataR::AbstractAnnData$shape()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="uns_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-uns_keys'><code>anndataR::AbstractAnnData$uns_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="var_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-var_keys'><code>anndataR::AbstractAnnData$var_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="varm_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-varm_keys'><code>anndataR::AbstractAnnData$varm_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="varp_keys"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-varp_keys'><code>anndataR::AbstractAnnData$varp_keys()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="write_h5ad"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-write_h5ad'><code>anndataR::AbstractAnnData$write_h5ad()</code></a></span></li>
<li><span class="pkg-link" data-pkg="anndataR" data-topic="AbstractAnnData" data-id="write_zarr"><a href='../../anndataR/html/AbstractAnnData.html#method-AbstractAnnData-write_zarr'><code>anndataR::AbstractAnnData$write_zarr()</code></a></span></li>
</ul>
</details>
}}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-InMemoryAnnData-new"></a>}}
\if{latex}{\out{\hypertarget{method-InMemoryAnnData-new}{}}}
\subsection{Method \code{new()}}{
Creates a new instance of an in-memory \code{AnnData} object.
Inherits from \link{AbstractAnnData}.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{InMemoryAnnData$new(
  X = NULL,
  obs = NULL,
  var = NULL,
  layers = NULL,
  obsm = NULL,
  varm = NULL,
  obsp = NULL,
  varp = NULL,
  uns = NULL,
  shape = NULL
)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{X}}{See the \code{X} slot in \link{AnnData-usage}}

\item{\code{obs}}{See the \code{obs} slot in \link{AnnData-usage}}

\item{\code{var}}{See the \code{var} slot in \link{AnnData-usage}}

\item{\code{layers}}{See the \code{layers} slot in \link{AnnData-usage}}

\item{\code{obsm}}{See the \code{obsm} slot in \link{AnnData-usage}}

\item{\code{varm}}{See the \code{varm} slot in \link{AnnData-usage}}

\item{\code{obsp}}{See the \code{obsp} slot in \link{AnnData-usage}}

\item{\code{varp}}{See the \code{varp} slot in \link{AnnData-usage}}

\item{\code{uns}}{See the \code{uns} slot in \link{AnnData-usage}}

\item{\code{shape}}{Shape tuple (e.g. \code{c(n_obs, n_vars)}). Can be provided if
both \code{X} or \code{obs} and \code{var} are not provided.}
}
\if{html}{\out{</div>}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-InMemoryAnnData-clone"></a>}}
\if{latex}{\out{\hypertarget{method-InMemoryAnnData-clone}{}}}
\subsection{Method \code{clone()}}{
The objects of this class are cloneable with this method.
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{InMemoryAnnData$clone(deep = FALSE)}\if{html}{\out{</div>}}
}

\subsection{Arguments}{
\if{html}{\out{<div class="arguments">}}
\describe{
\item{\code{deep}}{Whether to make a deep clone.}
}
\if{html}{\out{</div>}}
}
}
}
